#ifndef PROCESS_H
#define PROCESS_H

#include "Event.h"
#include <string>
#include <vector>
#include <cmath>
#include <complex>
#include "Vec4.h"

namespace SANC {

class Info;

class Process {
public:
   Process(Info & _info);
   void VariablesLOOP(int nDim, double *Xarg, double *Z, double *Jac);
   bool CutsPrelim(double *Z);
   void GetFourMomenta(double *Z, Vec4 *P);
   bool Cuts(Vec4 *P);
   void PdfConv(double *Z, double *AA);
   void Loop(double *Z, double *Loop);
   double fpol1(double x1);
   double fpol2(double x2);
   double Lx1x2(double x1, double x2);
   double fEPA1(double x);
   double fEPA2(double x);
   int idProc;
   double xl1[100],xu1[100],fp1[100];
   double xl2[100],xu2[100],fp2[100];
   double fa12[10000];
   double Mf1,Mf2,Mf3,Mf4;
   double Mf1_2,Mf2_2,Mf3_2,Mf4_2;
   double dm,sm;
   double S, sqS, E1, E2;
   double scale;
   std::vector<int> idup;
   std::string procName,arXiv;
   Event event;
   int nup; // Number of particles
private:
   Info & info;
};

}

#endif // PROCESS_H
