# Source this script to set up the RENESANCE build that this script is part of.

SOURCE=${BASH_ARGV[0]}
if [ "x$SOURCE" = "x" ]; then
    SOURCE=${(%):-%N} # for zsh
fi

if [ "x${SOURCE}" = "x" ]; then
    if [ -f bin/init.sh ]; then
        RENESANCE_ROOT="$PWD"; export RENESANCE_ROOT
    elif [ -f ./init.sh ]; then
        RENESANCE_ROOT=$(cd ..  > /dev/null; pwd); export RENESANCE_ROOT
    else
        echo ERROR: must "cd renesance_dir" before calling "source bin/init.sh" for this version of bash!
        RENESANCE_ROOT=; export RENESANCE_ROOT
        return 1
    fi
else
    # get param to "."
    thisdir=$(dirname ${SOURCE})
    RENESANCE_ROOT=$(cd ${thisdir}/.. > /dev/null;pwd); export RENESANCE_ROOT
fi


if [ -z "${PATH}" ]; then
   PATH=$RENESANCE_ROOT/bin; export PATH
else
   PATH=$RENESANCE_ROOT/bin:$PATH; export PATH
fi

if [ -z "${LD_LIBRARY_PATH}" ]; then
   LD_LIBRARY_PATH=$RENESANCE_ROOT/lib64; export LD_LIBRARY_PATH       # Linux, ELF HP-UX
else
   LD_LIBRARY_PATH=$RENESANCE_ROOT/lib64:$LD_LIBRARY_PATH; export LD_LIBRARY_PATH
fi

unset thisdir
