************************************************************************
* File (bbbb_ha_11_11.f) created on Thu Nov 19 18:34:35 MSK 2009.
************************************************************************
* This is the FORTRAN module (bbbb_ha_11_11) to calculate EW
* cross-section (width) by using the helicity amplitudes
* for the a + a -> a + a process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine bbbb_ha_11_11_amp (s,t,u,amp)
      implicit none!
#include "s2n_declare.h"

      integer i,j,k,l,m,n,lu,lm,ii,jj
      character ipm*(2),itl*(1)
      real*8 nsig,ewcoeff,qedcoeff,awc,rts,rus
      complex*16 b0fqsww,b0ftsww,b0fusww
      complex*16 c0ccqswww,c0cctswww,c0ccuswww
      complex*16 d0ccccqstswwww,d0ccccqsuswwww,d0ccccustswwww
      complex*16 b0fqsff,b0ftsff,b0fusff
      complex*16 c0ccqsfff,c0cctsfff,c0ccusfff,d0404m,b0f2m
      complex*16 d0ccccqstsffff,d0ccccqsusffff,d0ccccustsffff
      complex*16 ewamp(2,2,2,2),qedamp(2,2,2,2),amp(2,2,2,2)
      real*8 mgen2,mars(9),cqfa(9),cqfactor
      complex*16 mgen2i,marsi(9)
      common /hflags/ipm,itl

      nsig=1000d0*conhc/128/pi/s ! pb goes to fb
      ewcoeff = 12d0*alpha**2
      qedcoeff = -8d0*alpha**2
***************************
*  EW helicity amplitudes *
***************************
*{{{
      ewamp(1,1,1,1) = 0d0
      ewamp(1,1,1,2) = 0d0
      ewamp(1,1,2,2) = 0d0
      ewamp(1,2,1,2) = 0d0
      ewamp(1,2,2,1) = 0d0

      if (iew.eq.1) then

      b0fqsww = b0f2m(s,wm2)
      b0ftsww = b0f2m(t,wm2)
      b0fusww = b0f2m(u,wm2)
      c0ccqswww = -c01(0d0,0d0,-s,wm2,wm2,wm2)
      c0cctswww = -c01(0d0,0d0,-t,wm2,wm2,wm2)
      c0ccuswww = -c01(0d0,0d0,-u,wm2,wm2,wm2)
      d0ccccqstswwww = d0404M(s,t,wm2)
      d0ccccqsuswwww = d0404M(s,u,wm2)
      d0ccccustswwww = d0404M(u,t,wm2)
 
      ewamp(1,1,2,2) = 
     & +1d0-2d0*rwm2**2*(d0ccccqstswwww+d0ccccqsuswwww+d0ccccustswwww)

      ewamp(1,1,1,2) = 
     & +1d0-rwm2*(s**2+t**2+u**2)*( 1d0/u/t*c0ccqswww
     &                             +1d0/s/u*c0cctswww
     &                             +1d0/s/t*c0ccuswww)
     & -rwm2*((2d0*rwm2+s*t/u)*d0ccccqstswwww
     &       +(2d0*rwm2+s*u/t)*d0ccccqsuswwww
     &       +(2d0*rwm2+t*u/s)*d0ccccustswwww)

      ewamp(1,1,1,1) = 
     & -1d0+(u-t)/s*(b0fusww-b0ftsww)
     & +(4d0*rwm2/s+2d0*(t*u/s**2-4d0/3))*(u*c0ccuswww+t*c0cctswww)
     & -(2d0*rwm2*s*(rwm2/s-4d0/3)+2d0/3*s**2)*
     &                        ( d0ccccqstswwww
     &                         +d0ccccqsuswwww
     &                         +d0ccccustswwww )
     & -t*u*(4d0*rwm2/s+t*u/s**2-4d0/3)*d0ccccustswwww

      ewamp(1,2,2,1) = 
     & -1d0+(s-t)/u*(b0fqsww-b0ftsww)
     & +(4d0*rwm2/u+2d0*(t*s/u**2-4d0/3))*(s*c0ccqswww+t*c0cctswww)
     & -(2d0*rwm2*u*(rwm2/u-4d0/3)+2d0/3*u**2)*
     &                        ( d0ccccqstswwww
     &                         +d0ccccqsuswwww
     &                         +d0ccccustswwww )
     & -t*s*(4d0*rwm2/u+t*s/u**2-4d0/3)*d0ccccqstswwww

      ewamp(1,2,1,2) = 
     & -1d0+(u-s)/t*(b0fusww-b0fqsww)
     & +(4d0*rwm2/t+2d0*(s*u/t**2-4d0/3))*(u*c0ccuswww+s*c0ccqswww)
     & -(2d0*rwm2*t*(rwm2/t-4d0/3)+2d0/3*t**2)*
     &                        ( d0ccccqstswwww
     &                         +d0ccccqsuswwww
     &                         +d0ccccustswwww )
     & -s*u*(4d0*rwm2/t+s*u/t**2-4d0/3)*d0ccccqsuswwww

      endif

      ewamp(1,1,2,1) = ewamp(1,1,1,2)
      ewamp(1,2,1,1) = ewamp(1,1,1,2)
      ewamp(1,2,2,2) = ewamp(1,1,1,2)
      ewamp(2,1,1,1) = ewamp(1,2,2,2)
      ewamp(2,1,1,2) = ewamp(1,2,2,1)
      ewamp(2,1,2,1) = ewamp(1,2,1,2)
      ewamp(2,1,2,2) = ewamp(1,2,1,1)
      ewamp(2,2,1,1) = ewamp(1,1,2,2)
      ewamp(2,2,1,2) = ewamp(1,1,2,1)
      ewamp(2,2,2,1) = ewamp(1,1,1,2)
      ewamp(2,2,2,2) = ewamp(1,1,1,1)
*}}}
***************************
* QED helicity amplitudes *
***************************
*{{{
      qedamp(1,1,1,1) = 0d0
      qedamp(1,1,1,2) = 0d0
      qedamp(1,1,2,2) = 0d0
      qedamp(1,2,1,2) = 0d0
      qedamp(1,2,2,1) = 0d0

      if (iqed.eq.1) then

      mars(1)   = relm2
      marsi(1)  = elm2
      cqfa(1)   = qel**4
      mars(2)   = rupm2
      marsi(2)  = upm2
      cqfa(2)   = 3d0*qup**4
      mars(3)   = rdnm2
      marsi(3)  = dnm2
      cqfa(3)   = 3d0*qdn**4
      mars(4)   = rmom2
      marsi(4)  = mom2
      cqfa(4)   = qmo**4
      mars(5)   = rchm2
      marsi(5)  = chm2
      cqfa(5)   = 3d0*qch**4
      mars(6)   = rstm2
      marsi(6)  = stm2
      cqfa(6)   = 3d0*qst**4
      mars(7)   = rtam2
      marsi(7)  = tam2
      cqfa(7)   = qta**4
      mars(8)   = rtpm2
      marsi(8)  = tpm2
      cqfa(8)   = 3d0*qtp**4
      mars(9)   = rbtm2
      marsi(9)  = btm2
      cqfa(9)   = 3d0*qbt**4

      do i=1,9 ! number of fermion loop particles
c      do i=1,1 ! number of fermion loop particles

      mgen2 = mars(i)
      mgen2i = marsi(i)
      cqfactor = cqfa(i)

      if (mgen2.eq.0) then

      qedamp(1,1,2,2) = qedamp(1,1,2,2) + cqfactor

      qedamp(1,1,1,2) = qedamp(1,1,1,2) + cqfactor

      qedamp(1,1,1,1) = qedamp(1,1,1,1) + cqfactor*(
     d -1d0 + (t-u)/s*(LOG(-u/s) - LOG(-t/s))
     & -(1d0/2 - u*t/s**2)*((LOG(-u/s)-LOG(-t/s))**2 + pi**2))

      qedamp(1,2,2,1) = qedamp(1,2,2,1) + cqfactor*(
     & -1d0 - i_*pi*(t-s)/u
     & -((1d0 + i_*pi)*(t-s)/u + 2d0*i_*pi*(t/u)**2)*LOG(-t/s)
     & -(1d0/2 - s*t/u**2)*LOG(-t/s)**2)

      qedamp(1,2,1,2) = qedamp(1,2,1,2) + cqfactor*(
     & -1d0 - i_*pi*(u-s)/t
     & -((1d0 + i_*pi)*(u-s)/t + 2d0*i_*pi*(u/t)**2)*LOG(-u/s)
     & -(1d0/2 - s*u/t**2)*LOG(-u/s)**2) 

      else

      b0fqsff = b0f2m(s,mgen2i)
      b0ftsff = b0f2m(t,mgen2i)
      b0fusff = b0f2m(u,mgen2i)
      c0ccqsfff = -c01(0d0,0d0,-s,mgen2i,mgen2i,mgen2i)
      c0cctsfff = -c01(0d0,0d0,-t,mgen2i,mgen2i,mgen2i)
      c0ccusfff = -c01(0d0,0d0,-u,mgen2i,mgen2i,mgen2i)
      d0ccccqstsffff = d0404M(s,t,mgen2i)
      d0ccccqsusffff = d0404M(s,u,mgen2i)
      d0ccccustsffff = d0404M(u,t,mgen2i)
 
      qedamp(1,1,2,2) = qedamp(1,1,2,2) + cqfactor*(
     & +1d0-2d0*mgen2**2*(d0ccccqstsffff+d0ccccqsusffff+d0ccccustsffff))

      qedamp(1,1,1,2) = qedamp(1,1,1,2) + cqfactor*(
     & +1d0-mgen2*(s**2+t**2+u**2)*(c0ccqsfff/u/t
     &                              +c0cctsfff/s/u+c0ccusfff/s/t)
     & -mgen2*((2d0*mgen2+s*t/u)*d0ccccqstsffff
     &         +(2d0*mgen2+s*u/t)*d0ccccqsusffff
     &         +(2d0*mgen2+t*u/s)*d0ccccustsffff))

      qedamp(1,1,1,1) = qedamp(1,1,1,1) + cqfactor*(
     & -1d0+(u-t)/s*(b0fusff-b0ftsff)
     & +(4d0*mgen2/s+2d0*(t*u/s**2-1d0/2))*(u*c0ccusfff+t*c0cctsfff)
     & -2d0*mgen2*s*(mgen2/s-1d0/2)*(d0ccccqstsffff
     &                               +d0ccccqsusffff+d0ccccustsffff)
     & -t*u*(4d0*mgen2/s+t*u/s**2-1d0/2)*d0ccccustsffff)

      qedamp(1,2,2,1) = qedamp(1,2,2,1) + cqfactor*(
     & -1d0+(s-t)/u*(b0fqsff-b0ftsff)
     & +(4d0*mgen2/u+2d0*(t*s/u**2-1d0/2))*(s*c0ccqsfff+t*c0cctsfff)
     & -2d0*mgen2*u*(mgen2/u-1d0/2)*(d0ccccqstsffff
     &                        +d0ccccqsusffff+d0ccccustsffff)
     & -t*s*(4d0*mgen2/u+t*s/u**2-1d0/2)*d0ccccqstsffff)

      qedamp(1,2,1,2) = qedamp(1,2,1,2) + cqfactor*(
     & -1d0+(u-s)/t*(b0fusff-b0fqsff)
     & +(4d0*mgen2/t+2d0*(s*u/t**2-1d0/2))*(u*c0ccusfff+s*c0ccqsfff)
     & -2d0*mgen2*t*(mgen2/t-1d0/2)*(d0ccccqstsffff
     &                        +d0ccccqsusffff+d0ccccustsffff)
     & -s*u*(4d0*mgen2/t+s*u/t**2-1d0/2)*d0ccccqsusffff)

      endif
      enddo
      endif

      qedamp(1,1,2,1) = qedamp(1,1,1,2)
      qedamp(1,2,1,1) = qedamp(1,1,1,2)
      qedamp(1,2,2,2) = qedamp(1,1,1,2)
      qedamp(2,1,1,1) = qedamp(1,2,2,2)
      qedamp(2,1,1,2) = qedamp(1,2,2,1)
      qedamp(2,1,2,1) = qedamp(1,2,1,2)
      qedamp(2,1,2,2) = qedamp(1,2,1,1)
      qedamp(2,2,1,1) = qedamp(1,1,2,2)
      qedamp(2,2,1,2) = qedamp(1,1,2,1)
      qedamp(2,2,2,1) = qedamp(1,1,1,2)
      qedamp(2,2,2,2) = qedamp(1,1,1,1)

      do i = 1,2
        do j = 1,2
          do k = 1,2
            do l = 1,2
              if ((iew.eq.0).and.(iqed.eq.0)) then
                amp(i,j,k,l) = 0d0
              endif
              if ((iew.eq.1).and.(iqed.eq.0)) then
                amp(i,j,k,l) = ewcoeff*ewamp(i,j,k,l)
              endif
              if ((iew.eq.0).and.(iqed.eq.1)) then
                amp(i,j,k,l) = qedcoeff*qedamp(i,j,k,l)
              endif
              if ((iew.eq.1).and.(iqed.eq.1)) then
                amp(i,j,k,l) = ewcoeff*ewamp(i,j,k,l)+qedcoeff*qedamp(i,j,k,l)
              endif
            enddo
          enddo
        enddo
      enddo

      return
      end
