#include "Info.h"
#include "Settings.h"

using namespace SANC;

Info::Info(Settings & _cfg):
    Pid(_cfg.get_i("pid")),
    Scheme(_cfg.get_i("gfscheme")),
    Ecm(_cfg.get_d("ecm")),
    Alphai(_cfg.get_d("alphai")),
    Alphas(_cfg.get_d("alphas")),
    AlphaMZi(_cfg.get_d("alphamzi")),
    Polcirc1(_cfg.get_d("polcirc1")),
    Pollin1(_cfg.get_d("pollin1")),
    Polphi1(_cfg.get_d("polphi1")),
    Polcirc2(_cfg.get_d("polcirc2")),
    Pollin2(_cfg.get_d("pollin2")),
    Polphi2(_cfg.get_d("polphi2")),
    Pe1(_cfg.get_d("pe1")),
    Pg1(_cfg.get_d("pg1")),
    Pt1(_cfg.get_d("pt1")),
    Phi1(_cfg.get_d("phi1")),
    Pe2(_cfg.get_d("pe2")),
    Pg2(_cfg.get_d("pg2")),
    Pt2(_cfg.get_d("pt2")),
    Phi2(_cfg.get_d("phi2")),
    x0(_cfg.get_d("x0")),
    A(_cfg.get_d("a")),
    Rho(_cfg.get_d("rho")),
    Eamax(_cfg.get_d("eamax")),
    Lumee(_cfg.get_d("lumee")),
    theta3cut(_cfg.get_b("theta3cut")),
    theta3min(_cfg.get_d("theta3min")),
    theta3max(_cfg.get_d("theta3max")),
    theta4cut(_cfg.get_b("theta4cut")),
    theta4min(_cfg.get_d("theta4min")),
    theta4max(_cfg.get_d("theta4max")),
    cost3cut(_cfg.get_b("cost3cut")),
    cost3min(_cfg.get_d("cost3min")),
    cost3max(_cfg.get_d("cost3max")),
    cost4cut(_cfg.get_b("cost4cut")),
    cost4min(_cfg.get_d("cost4min")),
    cost4max(_cfg.get_d("cost4max")),
    eta3cut(_cfg.get_b("eta3cut")),
    eta3min(_cfg.get_d("eta3min")),
    eta3max(_cfg.get_d("eta3max")),
    eta4cut(_cfg.get_b("eta4cut")),
    eta4min(_cfg.get_d("eta4min")),
    eta4max(_cfg.get_d("eta4max")),
    pt3cut(_cfg.get_b("pt3cut")),
    pt3min(_cfg.get_d("pt3min")),
    pt3max(_cfg.get_d("pt3max")),
    pt4cut(_cfg.get_b("pt4cut")),
    pt4min(_cfg.get_d("pt4min")),
    pt4max(_cfg.get_d("pt4max")),
    m34cut(_cfg.get_b("m34cut")),
    m34min(_cfg.get_d("m34min")),
    m34max(_cfg.get_d("m34max")),
    Ivar(_cfg.get_i("ivar")),
    Ipdf(_cfg.get_i("ipdf")),
    Iqed(_cfg.get_i("iqed")),
    Iew(_cfg.get_i("iew")),
    Men(_cfg.get_d("men")),
    Mel(_cfg.get_d("mel")),
    Mup(_cfg.get_d("mup")),
    Mdn(_cfg.get_d("mdn")),
    Mmn(_cfg.get_d("mmn")),
    Mmo(_cfg.get_d("mmo")),
    Mch(_cfg.get_d("mch")),
    Mst(_cfg.get_d("mst")),
    Mtn(_cfg.get_d("mtn")),
    Mta(_cfg.get_d("mta")),
    Mtp(_cfg.get_d("mtp")),
    Mbt(_cfg.get_d("mbt")),
    MW(_cfg.get_d("mw")),
    MZ(_cfg.get_d("mz")),
    MH(_cfg.get_d("mh")),
    Wz(_cfg.get_d("wz")),
    Ww(_cfg.get_d("ww")),
    Wh(_cfg.get_d("wh")),
    Wtp(_cfg.get_d("wtp")),
    Vud(_cfg.get_d("vud")),
    Vus(_cfg.get_d("vus")),
    Vcd(_cfg.get_d("vcd")),
    Vcs(_cfg.get_d("vcs")),
    RanSeed(_cfg.get_l("RanSeed")),
    NevLoop(_cfg.get_l("NevLoop")),
    kDimLoop(_cfg.get_i("kDimLoop")),
    nCellsLoop(_cfg.get_i("nCellsLoop")),
    nSamplLoop(_cfg.get_i("nSamplLoop")),
    nBinLoop(_cfg.get_i("nBinLoop")),
    EvPerBinLoop(_cfg.get_i("EvPerBinLoop")),
    MaxWtRejLoop(_cfg.get_d("MaxWtRejLoop")),
    OptRej(_cfg.get_i("OptRej")),
    OptDrive(_cfg.get_i("OptDrive")),
    OptEdge(_cfg.get_i("OptEdge")),
    OptOrd(_cfg.get_i("OptOrd")),
    OptPeek(_cfg.get_i("OptPeek")),
    OptMCell(_cfg.get_i("OptMCell")),
    Chat(_cfg.get_i("Chat")),
    IEXPLLOOP(_cfg.get_b("exploreLoop")),
    PrintLHE(_cfg.get_b("printLHE")),
    PrintHEPEVT(_cfg.get_b("printHEPEVT")),
    PrintHepMC(_cfg.get_b("printHepMC")),
    HepMCFormat(_cfg.get_s("HepMCFormat")),
    PrintROOT(_cfg.get_b("printROOT")),
    PrintDEBUG(_cfg.get_b("printDEBUG")),
    verMajor(1), verMinor(3), verPatch(8), cfg(_cfg) {
    outputDir = cfg.get_s("outputDir");
    Sigma = 0.;
    SigmaErr = 0.;
#ifndef HEPMC
  if (PrintHepMC) {
    std::cerr << "Error in configuration!\n";
    std::cerr << "HepMC output enabled, but ReneSANCe compiled without HepMC support.\n";
    std::cerr << "Please, recompile it with HepMC3 library." << std::endl;
    exit(1);
  }
#endif
    }

std::string Info::version() {
  return std::to_string(verMajor) + "." + std::to_string(verMinor) + "." + std::to_string(verPatch);
}
