************************************************************************
* File (bbbb_ha_11_12.f)
************************************************************************
* This is the FORTRAN module (bbbb_ha_11_12) to calculate EW
* cross-section (width) by using the helicity amplitudes
* for the a + a -> a + z process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine bbbb_ha_11_12_amp (s,t,u,amp)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      integer i,j,k,l,m,n,lu,lm,ii,jj
      character ipm*(2),itl*(1)
      real*8 sum,nsig,ewcoeff,qedcoeff
      complex*16 b0fqsww,b0ftsww,b0fusww,b0fmzww,b0f2m
      complex*16 c0ccqswww,c0cctswww,c0ccuswww
      complex*16 c0cmzqswww,c0cmztswww,c0cmzuswww
      complex*16 d0cccmzqstswwww,d0ccmzcqsuswwww,d0cccmztsuswwww
      complex*16 b0fqsff,b0ftsff,b0fusff,b0fmzff
      complex*16 c0ccqsfff,c0cctsfff,c0ccusfff
      complex*16 c0cmzqsfff,c0cmztsfff,c0cmzusfff
      complex*16 d0cccmzqstsffff,d0ccmzcqsusffff,d0cccmztsusffff
      complex*16 ewamp(2,2,2,3),qedamp(2,2,2,3),amp(2,2,2,3)
      real*8 mgen2,cqfactor
      complex*16 mgen2i,rfm2(12),cfm2(12),cfa(12)
      common /hflags/ipm,itl

c!!!      nsig=1000d0*conhc/32/pi/s*(1-rzm2/s) ! pb goes to fb
      nsig=1000d0*conhc/32/pi/s*(1-rzm2/s)/2d0 ! pb goes to fb
      ewcoeff = 1d0*alpha**2*ctw/stw
      qedcoeff = 1d0*alpha**2

c!!!      ewcoeff = 1d0*alpha**2
c!!!      qedcoeff = 1d0*alpha**2

***************************
*  EW helicity amplitudes *
***************************
* {{{

      ewamp(1,1,1,1) = 0d0
      ewamp(1,1,1,2) = 0d0
      ewamp(1,1,1,3) = 0d0
      ewamp(1,1,2,1) = 0d0
      ewamp(1,1,2,2) = 0d0
      ewamp(1,1,2,3) = 0d0
      ewamp(1,2,1,1) = 0d0
      ewamp(1,2,1,2) = 0d0
      ewamp(1,2,1,3) = 0d0
      ewamp(1,2,2,1) = 0d0
      ewamp(1,2,2,2) = 0d0
      ewamp(1,2,2,3) = 0d0

      if (iew.eq.1) then

      b0fqsww = b0f(-s,thmu2,wm2,wm2)
      b0ftsww = b0f(-t,thmu2,wm2,wm2)
      b0fusww = b0f(-u,thmu2,wm2,wm2)
      b0fmzww = b0f(-rzm2,thmu2,wm2,wm2)
      c0ccqswww = -c0(0d0,0d0,s,rwm2,rwm2,rwm2)
      c0cctswww = -c0(0d0,0d0,t,rwm2,rwm2,rwm2)
      c0ccuswww = -c0(0d0,0d0,u,rwm2,rwm2,rwm2)
      c0cmzqswww = -c0(0d0,rzm2,s,rwm2,rwm2,rwm2)
      c0cmztswww = -c0(0d0,rzm2,t,rwm2,rwm2,rwm2)
      c0cmzuswww = -c0(0d0,rzm2,u,rwm2,rwm2,rwm2)
      d0cccmzqstswwww = d0(0d0,0d0,0d0,rzm2,s,t,rwm2,rwm2,rwm2,rwm2)
      d0ccmzcqsuswwww = d0(0d0,0d0,rzm2,0d0,s,u,rwm2,rwm2,rwm2,rwm2)
      d0cccmztsuswwww = d0(0d0,0d0,0d0,rzm2,t,u,rwm2,rwm2,rwm2,rwm2)
C*{{{ GL
C      ewamp(1,1,1,1) =
C     &  - 12.D0 + 2.D0*rwm2**(-1)*rzm2 - 4.D0*rwm2*rzm2*d0cccmztsuswwww
C     &     - 4.D0*rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*rzm2*
C     &    d0cccmzqstswwww + 24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*
C     &    rwm2**2*d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww + 2.D0
C     &    /(u + t)*s**(-1)*rzm2**3*c0cmzuswww + 2.D0/(u + t)*s**(-1)*
C     &    rzm2**3*c0cmztswww - 12.D0/(u + t)*s**(-1)*rwm2*rzm2**2*
C     &    c0cmzuswww - 12.D0/(u + t)*s**(-1)*rwm2*rzm2**2*c0cmztswww - 
C     &    2.D0/(u + t)*s**(-1)*u*rzm2**2*c0cmzuswww - 2.D0/(u + t)*
C     &    s**(-1)*u*rzm2**2*c0ccuswww + 12.D0/(u + t)*s**(-1)*u*rwm2*
C     &    rzm2*c0cmzuswww + 12.D0/(u + t)*s**(-1)*u*rwm2*rzm2*c0ccuswww
C     &     - 2.D0/(u + t)*s**(-1)*t*rzm2**2*c0cmztswww - 2.D0/(u + t)*
C     &    s**(-1)*t*rzm2**2*c0cctswww + 12.D0/(u + t)*s**(-1)*t*rwm2*
C     &    rzm2*c0cmztswww + 12.D0/(u + t)*s**(-1)*t*rwm2*rzm2*c0cctswww
C     &     - 2.D0/(u + t)*s**(-1)*t*u*rzm2**2*d0cccmztsuswwww + 12.D0/(
C     &    u + t)*s**(-1)*t*u*rwm2*rzm2*d0cccmztsuswwww - 4.D0/(u + t)*
C     &    rzm2**2*c0ccqswww + 24.D0/(u + t)*rwm2*rzm2*c0ccqswww
C
C      ewamp(1,1,1,2) =
C     &  - 12.D0 + 2.D0*t**(-1)*u**(-1)*rzm2**3*c0cmzqswww - 12.D0*
C     &    t**(-1)*u**(-1)*rwm2*rzm2**2*c0cmzqswww - 2.D0*t**(-1)*
C     &    rzm2**2*c0ccuswww + 12.D0*t**(-1)*rwm2*rzm2*c0ccuswww - 2.D0*
C     &    u**(-1)*rzm2**2*c0cctswww + 12.D0*u**(-1)*rwm2*rzm2*c0cctswww
C     &     + 2.D0*rwm2**(-1)*rzm2 - 4.D0*rwm2*rzm2*d0cccmztsuswwww - 4.D
C     &    0*rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*rzm2*d0cccmzqstswwww
C     &     + 24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*rwm2**2*
C     &    d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww - 4.D0*s*
C     &    t**(-1)*u**(-1)*rzm2**2*c0cmzqswww + 24.D0*s*t**(-1)*u**(-1)*
C     &    rwm2*rzm2*c0cmzqswww + 2.D0*s*t**(-1)*rzm2*c0ccuswww - 12.D0*
C     &    s*t**(-1)*rwm2*c0ccuswww - 2.D0*s*t**(-1)*u*rzm2*
C     &    d0ccmzcqsuswwww + 12.D0*s*t**(-1)*u*rwm2*d0ccmzcqsuswwww + 2.D
C     &    0*s*u**(-1)*rzm2*c0cctswww - 12.D0*s*u**(-1)*rwm2*c0cctswww
C     &     - 2.D0*s*t*u**(-1)*rzm2*d0cccmzqstswwww + 12.D0*s*t*u**(-1)*
C     &    rwm2*d0cccmzqstswwww + 2.D0*s**2*t**(-1)*u**(-1)*rzm2*
C     &    c0cmzqswww - 12.D0*s**2*t**(-1)*u**(-1)*rwm2*c0cmzqswww + 2.D0
C     &    /(u + t)*t**(-1)*u*rzm2**2*c0cmzuswww - 12.D0/(u + t)*t**(-1)
C     &    *u*rwm2*rzm2*c0cmzuswww - 2.D0/(u + t)*t**(-1)*u**2*rzm2*
C     &    c0cmzuswww + 12.D0/(u + t)*t**(-1)*u**2*rwm2*c0cmzuswww - 2.D0
C     &    /(u + t)*u*rzm2*c0cctswww + 12.D0/(u + t)*u*rwm2*c0cctswww + 
C     &    2.D0/(u + t)*t*u**(-1)*rzm2**2*c0cmztswww - 12.D0/(u + t)*t*
C     &    u**(-1)*rwm2*rzm2*c0cmztswww - 2.D0/(u + t)*t*rzm2*c0ccuswww
C     &     + 12.D0/(u + t)*t*rwm2*c0ccuswww + 2.D0/(u + t)*t*u*rzm2*
C     &    d0cccmztsuswwww - 12.D0/(u + t)*t*u*rwm2*d0cccmztsuswwww - 2.D
C     &    0/(u + t)*t**2*u**(-1)*rzm2*c0cmztswww + 12.D0/(u + t)*t**2*
C     &    u**(-1)*rwm2*c0cmztswww - 2.D0/(u + t)*s*t**(-1)*u*rzm2*
C     &    c0ccqswww + 12.D0/(u + t)*s*t**(-1)*u*rwm2*c0ccqswww - 2.D0/(
C     &    u + t)*s*t*u**(-1)*rzm2*c0ccqswww + 12.D0/(u + t)*s*t*u**(-1)
C     &    *rwm2*c0ccqswww
C
C      ewamp(1,1,1,3) =
C     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz * ( 2.D0*t**(-1)*rzm2*
C     &    d0ccmzcqsuswwww - 12.D0*t**(-1)*rwm2*d0ccmzcqsuswwww - 2.D0*
C     &    u**(-1)*rzm2*d0cccmzqstswwww + 12.D0*u**(-1)*rwm2*
C     &    d0cccmzqstswwww - 4.D0/(u + t)*s**(-1)*t**(-1)*rzm2**2*
C     &    c0cmzuswww + 24.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2*
C     &    c0cmzuswww + 4.D0/(u + t)*s**(-1)*t**(-1)*u*rzm2*c0cmzuswww
C     &     - 24.D0/(u + t)*s**(-1)*t**(-1)*u*rwm2*c0cmzuswww + 4.D0/(u
C     &     + t)*s**(-1)*u**(-1)*rzm2**2*c0cmztswww - 24.D0/(u + t)*
C     &    s**(-1)*u**(-1)*rwm2*rzm2*c0cmztswww - 4.D0/(u + t)*s**(-1)*
C     &    rzm2*c0ccuswww + 4.D0/(u + t)*s**(-1)*rzm2*c0cctswww + 24.D0
C     &    /(u + t)*s**(-1)*rwm2*c0ccuswww - 24.D0/(u + t)*s**(-1)*rwm2*
C     &    c0cctswww + 2.D0/(u + t)*s**(-1)*u*rzm2*d0cccmztsuswwww - 12.D
C     &    0/(u + t)*s**(-1)*u*rwm2*d0cccmztsuswwww - 4.D0/(u + t)*
C     &    s**(-1)*t*u**(-1)*rzm2*c0cmztswww + 24.D0/(u + t)*s**(-1)*t*
C     &    u**(-1)*rwm2*c0cmztswww - 2.D0/(u + t)*s**(-1)*t*rzm2*
C     &    d0cccmztsuswwww + 12.D0/(u + t)*s**(-1)*t*rwm2*
C     &    d0cccmztsuswwww + 4.D0/(u + t)*t**(-1)*rzm2*c0ccqswww - 24.D0
C     &    /(u + t)*t**(-1)*rwm2*c0ccqswww - 4.D0/(u + t)*u**(-1)*rzm2*
C     &    c0ccqswww + 24.D0/(u + t)*u**(-1)*rwm2*c0ccqswww )
C
C      ewamp(1,1,2,1) =
C     &  + 2.D0*t**(-1)*u**(-1)*rzm2**3*c0cmzqswww - 12.D0*t**(-1)*
C     &    u**(-1)*rwm2*rzm2**2*c0cmzqswww - 4.D0*rwm2*rzm2*
C     &    d0cccmztsuswwww - 4.D0*rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*
C     &    rzm2*d0cccmzqstswwww + 24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*
C     &    rwm2**2*d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww - 4.D0
C     &    *s*t**(-1)*u**(-1)*rzm2**2*c0cmzqswww + 24.D0*s*t**(-1)*
C     &    u**(-1)*rwm2*rzm2*c0cmzqswww - 2.D0*s*t**(-1)*u*rzm2*
C     &    d0ccmzcqsuswwww + 12.D0*s*t**(-1)*u*rwm2*d0ccmzcqsuswwww - 2.D
C     &    0*s*t*u**(-1)*rzm2*d0cccmzqstswwww + 12.D0*s*t*u**(-1)*rwm2*
C     &    d0cccmzqstswwww + 2.D0*s**2*t**(-1)*u**(-1)*rzm2*c0cmzqswww
C     &     - 12.D0*s**2*t**(-1)*u**(-1)*rwm2*c0cmzqswww + 2.D0/(u + t)*
C     &    s**(-2)*t*u*rwm2**(-1)*rzm2**3*c0cmzuswww + 2.D0/(u + t)*
C     &    s**(-2)*t*u*rwm2**(-1)*rzm2**3*c0cmztswww - 12.D0/(u + t)*
C     &    s**(-2)*t*u*rzm2**2*c0cmzuswww - 12.D0/(u + t)*s**(-2)*t*u*
C     &    rzm2**2*c0cmztswww - 2.D0/(u + t)*s**(-2)*t*u**2*rwm2**(-1)*
C     &    rzm2**2*c0cmzuswww - 2.D0/(u + t)*s**(-2)*t*u**2*rwm2**(-1)*
C     &    rzm2**2*c0ccuswww + 12.D0/(u + t)*s**(-2)*t*u**2*rzm2*
C     &    c0cmzuswww + 12.D0/(u + t)*s**(-2)*t*u**2*rzm2*c0ccuswww - 2.D
C     &    0/(u + t)*s**(-2)*t**2*u*rwm2**(-1)*rzm2**2*c0cmztswww - 2.D0
C     &    /(u + t)*s**(-2)*t**2*u*rwm2**(-1)*rzm2**2*c0cctswww + 12.D0
C     &    /(u + t)*s**(-2)*t**2*u*rzm2*c0cmztswww + 12.D0/(u + t)*
C     &    s**(-2)*t**2*u*rzm2*c0cctswww - 2.D0/(u + t)*s**(-2)*t**2*
C     &    u**2*rwm2**(-1)*rzm2**2*d0cccmztsuswwww + 12.D0/(u + t)*
C     &    s**(-2)*t**2*u**2*rzm2*d0cccmztsuswwww + 4.D0/(u + t)*s**(-1)
C     &    *u*rzm2**2*c0cmztswww - 4.D0/(u + t)*s**(-1)*u*rzm2**2*
C     &    c0ccuswww - 24.D0/(u + t)*s**(-1)*u*rwm2*rzm2*c0cmztswww + 24.
C     &    D0/(u + t)*s**(-1)*u*rwm2*rzm2*c0ccuswww + 4.D0/(u + t)*
C     &    s**(-1)*t*rzm2**2*c0cmzuswww - 4.D0/(u + t)*s**(-1)*t*rzm2**2
C     &    *c0cctswww - 24.D0/(u + t)*s**(-1)*t*rwm2*rzm2*c0cmzuswww + 
C     &    24.D0/(u + t)*s**(-1)*t*rwm2*rzm2*c0cctswww - 8.D0/(u + t)*
C     &    s**(-1)*t*u*rzm2**2*d0cccmztsuswwww + 48.D0/(u + t)*s**(-1)*t
C     &    *u*rwm2*rzm2*d0cccmztsuswwww - 2.D0/(u + t)*t**(-1)*u**2*rzm2
C     &    *c0ccuswww + 12.D0/(u + t)*t**(-1)*u**2*rwm2*c0ccuswww + 2.D0
C     &    /(u + t)*rzm2**2*c0cmzuswww + 2.D0/(u + t)*rzm2**2*c0cmztswww
C     &     - 12.D0/(u + t)*rwm2*rzm2*c0cmzuswww - 12.D0/(u + t)*rwm2*
C     &    rzm2*c0cmztswww - 2.D0/(u + t)*u*rzm2*c0cmztswww + 12.D0/(u
C     &     + t)*u*rwm2*c0cmztswww - 2.D0/(u + t)*t*rzm2*c0cmzuswww + 12.
C     &    D0/(u + t)*t*rwm2*c0cmzuswww + 2.D0/(u + t)*t*u*rzm2*
C     &    d0cccmztsuswwww - 12.D0/(u + t)*t*u*rwm2*d0cccmztsuswwww - 2.D
C     &    0/(u + t)*t**2*u**(-1)*rzm2*c0cctswww + 12.D0/(u + t)*t**2*
C     &    u**(-1)*rwm2*c0cctswww - 2.D0/(u + t)*s*t**(-1)*u*rzm2*
C     &    c0ccqswww + 12.D0/(u + t)*s*t**(-1)*u*rwm2*c0ccqswww - 2.D0/(
C     &    u + t)*s*t*u**(-1)*rzm2*c0ccqswww + 12.D0/(u + t)*s*t*u**(-1)
C     &    *rwm2*c0ccqswww - 4.D0/(u + t)/(u + s)*s**(-1)*t*u*rwm2**(-1)
C     &    *rzm2**2*b0fmzww + 4.D0/(u + t)/(u + s)*s**(-1)*t*u*
C     &    rwm2**(-1)*rzm2**2*b0ftsww + 24.D0/(u + t)/(u + s)*s**(-1)*t*
C     &    u*rzm2*b0fmzww - 24.D0/(u + t)/(u + s)*s**(-1)*t*u*rzm2*
C     &    b0ftsww - 2.D0/(u + t)/(u + s)*s*rzm2**2*c0cmztswww + 12.D0/(
C     &    u + t)/(u + s)*s*rwm2*rzm2*c0cmztswww + 2.D0/(u + t)/(u + s)*
C     &    s**2*t*u**(-1)*rzm2*c0cmztswww - 12.D0/(u + t)/(u + s)*s**2*t
C     &    *u**(-1)*rwm2*c0cmztswww - 2.D0/(u + t)/(u + s)/(u + s)*t*u*
C     &    rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + t)/(u + s)/(u + s)*t*u
C     &    *rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + t)/(u + s)/(u + s)*t
C     &    *u*rzm2*b0fmzww - 12.D0/(u + t)/(u + s)/(u + s)*t*u*rzm2*
C     &    b0ftsww - 2.D0/(u + t)/(u + s)/(t + s)*t*u*rwm2**(-1)*rzm2**2
C     &     + 12.D0/(u + t)/(u + s)/(t + s)*t*u*rzm2 - 2.D0/(u + t)/(u
C     &     + s)/(t + s)*s*t*u*rwm2**(-1)*rzm2 + 12.D0/(u + t)/(u + s)/(
C     &    t + s)*s*t*u - 4.D0/(u + t)/(t + s)*s**(-1)*t*u*rwm2**(-1)*
C     &    rzm2**2*b0fmzww + 4.D0/(u + t)/(t + s)*s**(-1)*t*u*rwm2**(-1)
C     &    *rzm2**2*b0fusww + 24.D0/(u + t)/(t + s)*s**(-1)*t*u*rzm2*
C     &    b0fmzww - 24.D0/(u + t)/(t + s)*s**(-1)*t*u*rzm2*b0fusww - 2.D
C     &    0/(u + t)/(t + s)*s*rzm2**2*c0cmzuswww + 12.D0/(u + t)/(t + s
C     &    )*s*rwm2*rzm2*c0cmzuswww + 2.D0/(u + t)/(t + s)*s**2*t**(-1)*
C     &    u*rzm2*c0cmzuswww - 12.D0/(u + t)/(t + s)*s**2*t**(-1)*u*rwm2
C     &    *c0cmzuswww - 2.D0/(u + t)/(t + s)/(t + s)*t*u*rwm2**(-1)*
C     &    rzm2**2*b0fmzww + 2.D0/(u + t)/(t + s)/(t + s)*t*u*rwm2**(-1)
C     &    *rzm2**2*b0fusww + 12.D0/(u + t)/(t + s)/(t + s)*t*u*rzm2*
C     &    b0fmzww - 12.D0/(u + t)/(t + s)/(t + s)*t*u*rzm2*b0fusww
C
C      ewamp(1,1,2,2) =
C     &  - 14.D0*s**(-1)*rzm2**2*c0cmzuswww - 14.D0*s**(-1)*rzm2**2*
C     &    c0cmztswww - 12.D0*s**(-1)*rwm2*rzm2*c0cmzuswww - 12.D0*
C     &    s**(-1)*rwm2*rzm2*c0cmztswww + 14.D0*s**(-1)*u*rzm2*
C     &    c0cmzuswww + 14.D0*s**(-1)*u*rzm2*c0ccuswww + 12.D0*s**(-1)*u
C     &    *rwm2*c0cmzuswww + 12.D0*s**(-1)*u*rwm2*c0ccuswww + 14.D0*
C     &    s**(-1)*t*rzm2*c0cmztswww + 14.D0*s**(-1)*t*rzm2*c0cctswww + 
C     &    12.D0*s**(-1)*t*rwm2*c0cmztswww + 12.D0*s**(-1)*t*rwm2*
C     &    c0cctswww + 14.D0*s**(-1)*t*u*rzm2*d0cccmztsuswwww + 12.D0*
C     &    s**(-1)*t*u*rwm2*d0cccmztsuswwww + 16.D0*rzm2*c0cmzuswww + 16.
C     &    D0*rzm2*c0cmztswww + 28.D0*rwm2*rzm2*d0cccmztsuswwww + 28.D0*
C     &    rwm2*rzm2*d0ccmzcqsuswwww + 28.D0*rwm2*rzm2*d0cccmzqstswwww
C     &     + 24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*rwm2**2*
C     &    d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww - 16.D0*u*
C     &    c0cmzuswww - 16.D0*u*c0ccuswww - 16.D0*t*c0cmztswww - 16.D0*t
C     &    *c0cctswww - 16.D0*t*u*d0cccmztsuswwww - 8.D0*s*rzm2*
C     &    d0cccmztsuswwww - 8.D0*s*rzm2*d0ccmzcqsuswwww - 8.D0*s*rzm2*
C     &    d0cccmzqstswwww - 32.D0*s*rwm2*d0cccmztsuswwww - 32.D0*s*rwm2
C     &    *d0ccmzcqsuswwww - 32.D0*s*rwm2*d0cccmzqstswwww + 8.D0*s**2*
C     &    d0cccmztsuswwww + 8.D0*s**2*d0ccmzcqsuswwww + 8.D0*s**2*
C     &    d0cccmzqstswwww - 2.D0/(u + t)*s**(-1)*t*u*rwm2**(-1)*rzm2**2
C     &    *c0cmzuswww - 2.D0/(u + t)*s**(-1)*t*u*rwm2**(-1)*rzm2**2*
C     &    c0cmztswww + 12.D0/(u + t)*s**(-1)*t*u*rzm2*c0cmzuswww + 12.D0
C     &    /(u + t)*s**(-1)*t*u*rzm2*c0cmztswww + 2.D0/(u + t)*s**(-1)*t
C     &    *u**2*rwm2**(-1)*rzm2*c0cmzuswww + 2.D0/(u + t)*s**(-1)*t*
C     &    u**2*rwm2**(-1)*rzm2*c0ccuswww - 12.D0/(u + t)*s**(-1)*t*u**2
C     &    *c0cmzuswww - 12.D0/(u + t)*s**(-1)*t*u**2*c0ccuswww + 2.D0/(
C     &    u + t)*s**(-1)*t**2*u*rwm2**(-1)*rzm2*c0cmztswww + 2.D0/(u + 
C     &    t)*s**(-1)*t**2*u*rwm2**(-1)*rzm2*c0cctswww - 12.D0/(u + t)*
C     &    s**(-1)*t**2*u*c0cmztswww - 12.D0/(u + t)*s**(-1)*t**2*u*
C     &    c0cctswww + 2.D0/(u + t)*s**(-1)*t**2*u**2*rwm2**(-1)*rzm2*
C     &    d0cccmztsuswwww - 12.D0/(u + t)*s**(-1)*t**2*u**2*
C     &    d0cccmztsuswwww - 2.D0/(u + t)*rzm2**2*c0cmzuswww - 2.D0/(u
C     &     + t)*rzm2**2*c0cmztswww - 4.D0/(u + t)*rzm2**2*c0ccqswww + 
C     &    12.D0/(u + t)*rwm2*rzm2*c0cmzuswww + 12.D0/(u + t)*rwm2*rzm2*
C     &    c0cmztswww + 24.D0/(u + t)*rwm2*rzm2*c0ccqswww + 4.D0/(u + t)
C     &    *u*rwm2**(-1)*rzm2*b0fmzww - 4.D0/(u + t)*u*rwm2**(-1)*rzm2*
C     &    b0fusww - 24.D0/(u + t)*u*b0fmzww + 24.D0/(u + t)*u*b0fusww
C     &     + 2.D0/(u + t)*u*rzm2*c0cmzuswww + 2.D0/(u + t)*u*rzm2*
C     &    c0ccuswww - 12.D0/(u + t)*u*rwm2*c0cmzuswww - 12.D0/(u + t)*u
C     &    *rwm2*c0ccuswww + 4.D0/(u + t)*t*rwm2**(-1)*rzm2*b0fmzww - 4.D
C     &    0/(u + t)*t*rwm2**(-1)*rzm2*b0ftsww - 24.D0/(u + t)*t*b0fmzww
C     &     + 24.D0/(u + t)*t*b0ftsww + 2.D0/(u + t)*t*rzm2*c0cmztswww
C     &     + 2.D0/(u + t)*t*rzm2*c0cctswww - 12.D0/(u + t)*t*rwm2*
C     &    c0cmztswww - 12.D0/(u + t)*t*rwm2*c0cctswww + 6.D0/(u + t)*t*
C     &    u*rzm2*d0cccmztsuswwww - 36.D0/(u + t)*t*u*rwm2*
C     &    d0cccmztsuswwww + 4.D0/(u + t)*s*rwm2**(-1)*rzm2*b0fmzww - 2.D
C     &    0/(u + t)*s*rwm2**(-1)*rzm2*b0fusww - 2.D0/(u + t)*s*
C     &    rwm2**(-1)*rzm2*b0ftsww - 24.D0/(u + t)*s*b0fmzww + 12.D0/(u
C     &     + t)*s*b0fusww + 12.D0/(u + t)*s*b0ftsww + 4.D0/(u + t)/(u
C     &     + s)*s*rzm2**2*c0cmztswww - 24.D0/(u + t)/(u + s)*s*rwm2*
C     &    rzm2*c0cmztswww - 2.D0/(u + t)/(u + s)/(u + s)*s*rwm2**(-1)*
C     &    rzm2**3*b0fmzww + 2.D0/(u + t)/(u + s)/(u + s)*s*rwm2**(-1)*
C     &    rzm2**3*b0ftsww + 12.D0/(u + t)/(u + s)/(u + s)*s*rzm2**2*
C     &    b0fmzww - 12.D0/(u + t)/(u + s)/(u + s)*s*rzm2**2*b0ftsww + 2.
C     &    D0/(u + t)/(u + s)/(t + s)*t*u*rwm2**(-1)*rzm2**2 - 12.D0/(u
C     &     + t)/(u + s)/(t + s)*t*u*rzm2 + 2.D0/(u + t)/(u + s)/(t + s)
C     &    *s*t*u*rwm2**(-1)*rzm2 - 12.D0/(u + t)/(u + s)/(t + s)*s*t*u
C     &     + 4.D0/(u + t)/(t + s)*s*rzm2**2*c0cmzuswww - 24.D0/(u + t)
C     &    /(t + s)*s*rwm2*rzm2*c0cmzuswww - 2.D0/(u + t)/(t + s)/(t + s
C     &    )*s*rwm2**(-1)*rzm2**3*b0fmzww + 2.D0/(u + t)/(t + s)/(t + s)
C     &    *s*rwm2**(-1)*rzm2**3*b0fusww + 12.D0/(u + t)/(t + s)/(t + s)
C     &    *s*rzm2**2*b0fmzww - 12.D0/(u + t)/(t + s)/(t + s)*s*rzm2**2*
C     &    b0fusww
C
C      ewamp(1,1,2,3) =
C     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz * (  - 2.D0*t**(-1)*rzm2*
C     &    d0ccmzcqsuswwww + 12.D0*t**(-1)*rwm2*d0ccmzcqsuswwww + 2.D0*
C     &    u**(-1)*rzm2*d0cccmzqstswwww - 12.D0*u**(-1)*rwm2*
C     &    d0cccmzqstswwww - 2.D0/(u + t)*s**(-2)*u*rwm2**(-1)*rzm2**2*
C     &    c0cmzuswww - 2.D0/(u + t)*s**(-2)*u*rwm2**(-1)*rzm2**2*
C     &    c0cmztswww + 12.D0/(u + t)*s**(-2)*u*rzm2*c0cmzuswww + 12.D0
C     &    /(u + t)*s**(-2)*u*rzm2*c0cmztswww + 2.D0/(u + t)*s**(-2)*
C     &    u**2*rwm2**(-1)*rzm2*c0cmzuswww + 2.D0/(u + t)*s**(-2)*u**2*
C     &    rwm2**(-1)*rzm2*c0ccuswww - 12.D0/(u + t)*s**(-2)*u**2*
C     &    c0cmzuswww - 12.D0/(u + t)*s**(-2)*u**2*c0ccuswww + 2.D0/(u
C     &     + t)*s**(-2)*t*rwm2**(-1)*rzm2**2*c0cmzuswww + 2.D0/(u + t)*
C     &    s**(-2)*t*rwm2**(-1)*rzm2**2*c0cmztswww - 12.D0/(u + t)*
C     &    s**(-2)*t*rzm2*c0cmzuswww - 12.D0/(u + t)*s**(-2)*t*rzm2*
C     &    c0cmztswww - 2.D0/(u + t)*s**(-2)*t*u*rwm2**(-1)*rzm2*
C     &    c0cmzuswww + 2.D0/(u + t)*s**(-2)*t*u*rwm2**(-1)*rzm2*
C     &    c0cmztswww - 2.D0/(u + t)*s**(-2)*t*u*rwm2**(-1)*rzm2*
C     &    c0ccuswww + 2.D0/(u + t)*s**(-2)*t*u*rwm2**(-1)*rzm2*
C     &    c0cctswww + 12.D0/(u + t)*s**(-2)*t*u*c0cmzuswww - 12.D0/(u
C     &     + t)*s**(-2)*t*u*c0cmztswww + 12.D0/(u + t)*s**(-2)*t*u*
C     &    c0ccuswww - 12.D0/(u + t)*s**(-2)*t*u*c0cctswww + 2.D0/(u + t
C     &    )*s**(-2)*t*u**2*rwm2**(-1)*rzm2*d0cccmztsuswwww - 12.D0/(u
C     &     + t)*s**(-2)*t*u**2*d0cccmztsuswwww - 2.D0/(u + t)*s**(-2)*
C     &    t**2*rwm2**(-1)*rzm2*c0cmztswww - 2.D0/(u + t)*s**(-2)*t**2*
C     &    rwm2**(-1)*rzm2*c0cctswww + 12.D0/(u + t)*s**(-2)*t**2*
C     &    c0cmztswww + 12.D0/(u + t)*s**(-2)*t**2*c0cctswww - 2.D0/(u
C     &     + t)*s**(-2)*t**2*u*rwm2**(-1)*rzm2*d0cccmztsuswwww + 12.D0
C     &    /(u + t)*s**(-2)*t**2*u*d0cccmztsuswwww - 4.D0/(u + t)*
C     &    s**(-1)*t**(-1)*rzm2**2*c0cmzuswww + 24.D0/(u + t)*s**(-1)*
C     &    t**(-1)*rwm2*rzm2*c0cmzuswww + 4.D0/(u + t)*s**(-1)*t**(-1)*u
C     &    *rzm2*c0cmzuswww - 24.D0/(u + t)*s**(-1)*t**(-1)*u*rwm2*
C     &    c0cmzuswww + 4.D0/(u + t)*s**(-1)*u**(-1)*rzm2**2*c0cmztswww
C     &     - 24.D0/(u + t)*s**(-1)*u**(-1)*rwm2*rzm2*c0cmztswww - 4.D0
C     &    /(u + t)*s**(-1)*rzm2*c0ccuswww + 4.D0/(u + t)*s**(-1)*rzm2*
C     &    c0cctswww + 24.D0/(u + t)*s**(-1)*rwm2*c0ccuswww - 24.D0/(u
C     &     + t)*s**(-1)*rwm2*c0cctswww + 6.D0/(u + t)*s**(-1)*u*rzm2*
C     &    d0cccmztsuswwww - 36.D0/(u + t)*s**(-1)*u*rwm2*
C     &    d0cccmztsuswwww - 4.D0/(u + t)*s**(-1)*t*u**(-1)*rzm2*
C     &    c0cmztswww + 24.D0/(u + t)*s**(-1)*t*u**(-1)*rwm2*c0cmztswww
C     &     - 6.D0/(u + t)*s**(-1)*t*rzm2*d0cccmztsuswwww + 36.D0/(u + t
C     &    )*s**(-1)*t*rwm2*d0cccmztsuswwww - 4.D0/(u + t)*t**(-1)*rzm2*
C     &    c0ccqswww + 24.D0/(u + t)*t**(-1)*rwm2*c0ccqswww + 4.D0/(u + 
C     &    t)*u**(-1)*rzm2*c0ccqswww - 24.D0/(u + t)*u**(-1)*rwm2*
C     &    c0ccqswww - 8.D0/(u + t)/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2*
C     &    b0fmzww + 8.D0/(u + t)/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2*
C     &    b0ftsww + 48.D0/(u + t)/(u + s)*s**(-1)*t*b0fmzww - 48.D0/(u
C     &     + t)/(u + s)*s**(-1)*t*b0ftsww - 8.D0/(u + t)/(u + s)*s*
C     &    u**(-1)*rzm2*c0cmztswww + 48.D0/(u + t)/(u + s)*s*u**(-1)*
C     &    rwm2*c0cmztswww + 4.D0/(u + t)/(u + s)/(u + s)*s**(-1)*u*
C     &    rwm2**(-1)*rzm2**2*b0fmzww - 4.D0/(u + t)/(u + s)/(u + s)*
C     &    s**(-1)*u*rwm2**(-1)*rzm2**2*b0ftsww - 24.D0/(u + t)/(u + s)
C     &    /(u + s)*s**(-1)*u*rzm2*b0fmzww + 24.D0/(u + t)/(u + s)/(u + 
C     &    s)*s**(-1)*u*rzm2*b0ftsww + 4.D0/(u + t)/(u + s)/(t + s)*u*
C     &    rwm2**(-1)*rzm2 - 24.D0/(u + t)/(u + s)/(t + s)*u - 4.D0/(u
C     &     + t)/(u + s)/(t + s)*t*rwm2**(-1)*rzm2 + 24.D0/(u + t)/(u + 
C     &    s)/(t + s)*t + 8.D0/(u + t)/(t + s)*s**(-1)*u*rwm2**(-1)*rzm2
C     &    *b0fmzww - 8.D0/(u + t)/(t + s)*s**(-1)*u*rwm2**(-1)*rzm2*
C     &    b0fusww - 48.D0/(u + t)/(t + s)*s**(-1)*u*b0fmzww + 48.D0/(u
C     &     + t)/(t + s)*s**(-1)*u*b0fusww + 8.D0/(u + t)/(t + s)*s*
C     &    t**(-1)*rzm2*c0cmzuswww - 48.D0/(u + t)/(t + s)*s*t**(-1)*
C     &    rwm2*c0cmzuswww - 4.D0/(u + t)/(t + s)/(t + s)*s**(-1)*t*
C     &    rwm2**(-1)*rzm2**2*b0fmzww + 4.D0/(u + t)/(t + s)/(t + s)*
C     &    s**(-1)*t*rwm2**(-1)*rzm2**2*b0fusww + 24.D0/(u + t)/(t + s)
C     &    /(t + s)*s**(-1)*t*rzm2*b0fmzww - 24.D0/(u + t)/(t + s)/(t + 
C     &    s)*s**(-1)*t*rzm2*b0fusww )
C
C      ewamp(1,2,1,1) =
C     &  - 2.D0*t**(-1)*rzm2**2*c0ccuswww + 12.D0*t**(-1)*rwm2*rzm2*
C     &    c0ccuswww + 2.D0*t**(-1)*u*rzm2*c0cmzqswww - 12.D0*t**(-1)*u*
C     &    rwm2*c0cmzqswww - 4.D0*rwm2*rzm2*d0cccmztsuswwww - 4.D0*rwm2*
C     &    rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*rzm2*d0cccmzqstswwww + 24.D0
C     &    *rwm2**2*d0cccmztsuswwww + 24.D0*rwm2**2*d0ccmzcqsuswwww + 24.
C     &    D0*rwm2**2*d0cccmzqstswwww - 14.D0*t*u**(-1)*rzm2*c0cmzqswww
C     &     - 12.D0*t*u**(-1)*rwm2*c0cmzqswww - 2.D0*s*t**(-1)*u**(-1)*
C     &    rzm2**2*c0ccqswww + 12.D0*s*t**(-1)*u**(-1)*rwm2*rzm2*
C     &    c0ccqswww + 2.D0*s*t**(-1)*rzm2*c0ccuswww - 12.D0*s*t**(-1)*
C     &    rwm2*c0ccuswww - 2.D0*s*t**(-1)*u*rzm2*d0ccmzcqsuswwww + 12.D0
C     &    *s*t**(-1)*u*rwm2*d0ccmzcqsuswwww + 2.D0*s*u**(-1)*rzm2*
C     &    c0cmztswww - 12.D0*s*u**(-1)*rwm2*c0cmztswww - 2.D0*s*t*
C     &    u**(-1)*rzm2*d0cccmzqstswwww + 12.D0*s*t*u**(-1)*rwm2*
C     &    d0cccmzqstswwww + 2.D0*s**2*t**(-1)*u**(-1)*rzm2*c0ccqswww - 
C     &    12.D0*s**2*t**(-1)*u**(-1)*rwm2*c0ccqswww + 2.D0/(u + t)*
C     &    t**(-1)*u*rzm2**2*c0cmzuswww - 12.D0/(u + t)*t**(-1)*u*rwm2*
C     &    rzm2*c0cmzuswww - 2.D0/(u + t)*t**(-1)*u**2*rzm2*c0cmzuswww
C     &     + 12.D0/(u + t)*t**(-1)*u**2*rwm2*c0cmzuswww + 2.D0/(u + t)*
C     &    rzm2**2*c0cmztswww - 12.D0/(u + t)*rwm2*rzm2*c0cmztswww - 2.D0
C     &    /(u + t)*u*rzm2*c0cmztswww + 12.D0/(u + t)*u*rwm2*c0cmztswww
C     &     - 16.D0/(u + t)*t*u**(-1)*rzm2**2*c0cmztswww - 2.D0/(u + t)*
C     &    t*rzm2*c0ccuswww + 12.D0/(u + t)*t*rwm2*c0ccuswww + 32.D0/(u
C     &     + t)*t*rwm2*rzm2*d0cccmztsuswwww + 32.D0/(u + t)*t*rwm2*rzm2
C     &    *d0ccmzcqsuswwww + 32.D0/(u + t)*t*rwm2*rzm2*d0cccmzqstswwww
C     &     - 6.D0/(u + t)*t*u*rzm2*d0cccmztsuswwww - 8.D0/(u + t)*t*u*
C     &    rzm2*d0ccmzcqsuswwww - 8.D0/(u + t)*t*u*rzm2*d0cccmzqstswwww
C     &     - 12.D0/(u + t)*t*u*rwm2*d0cccmztsuswwww + 16.D0/(u + t)*
C     &    t**2*u**(-1)*rzm2*c0cmztswww + 14.D0/(u + t)*t**2*u**(-1)*
C     &    rzm2*c0cctswww + 12.D0/(u + t)*t**2*u**(-1)*rwm2*c0cctswww + 
C     &    16.D0/(u + t)*s*t*u**(-1)*rzm2*c0ccqswww + 16.D0/(u + t)*s*
C     &    t**2*u**(-1)*rzm2*d0cccmzqstswwww + 4.D0/(u + t)/(u + s)*u*
C     &    rzm2**2*c0cmztswww - 24.D0/(u + t)/(u + s)*u*rwm2*rzm2*
C     &    c0cmztswww + 2.D0/(u + t)/(u + s)*s*t*rwm2**(-1)*rzm2 - 12.D0
C     &    /(u + t)/(u + s)*s*t - 2.D0/(u + t)/(u + s)/(u + s)*t*u*
C     &    rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + t)/(u + s)/(u + s)*t*u
C     &    *rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + t)/(u + s)/(u + s)*t
C     &    *u*rzm2*b0fmzww - 12.D0/(u + t)/(u + s)/(u + s)*t*u*rzm2*
C     &    b0ftsww
C
C      ewamp(1,2,1,2) =
C     &  + 4.D0*u**(-1)*rzm2**2*c0cmztswww + 4.D0*u**(-1)*rzm2**2*
C     &    c0cmzqswww - 24.D0*u**(-1)*rwm2*rzm2*c0cmztswww - 24.D0*
C     &    u**(-1)*rwm2*rzm2*c0cmzqswww - 4.D0*rwm2*rzm2*d0cccmztsuswwww
C     &     - 4.D0*rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*rzm2*
C     &    d0cccmzqstswwww + 24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*
C     &    rwm2**2*d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww - 4.D0
C     &    *t*u**(-1)*rzm2*c0cmztswww - 4.D0*t*u**(-1)*rzm2*c0cctswww + 
C     &    24.D0*t*u**(-1)*rwm2*c0cmztswww + 24.D0*t*u**(-1)*rwm2*
C     &    c0cctswww - 2.D0*s*u**(-1)*rwm2**(-1)*rzm2*b0fmzww + 2.D0*s*
C     &    u**(-1)*rwm2**(-1)*rzm2*b0fqsww + 12.D0*s*u**(-1)*b0fmzww - 
C     &    12.D0*s*u**(-1)*b0fqsww - 4.D0*s*u**(-1)*rzm2*c0cmzqswww - 4.D
C     &    0*s*u**(-1)*rzm2*c0ccqswww + 24.D0*s*u**(-1)*rwm2*c0cmzqswww
C     &     + 24.D0*s*u**(-1)*rwm2*c0ccqswww - 16.D0*s*c0cmzqswww + 2.D0
C     &    *s*t*u**(-2)*rwm2**(-1)*rzm2**2*c0cmztswww + 2.D0*s*t*u**(-2)
C     &    *rwm2**(-1)*rzm2**2*c0cmzqswww - 12.D0*s*t*u**(-2)*rzm2*
C     &    c0cmztswww - 12.D0*s*t*u**(-2)*rzm2*c0cmzqswww - 8.D0*s*t*
C     &    u**(-1)*rzm2*d0cccmzqstswwww + 48.D0*s*t*u**(-1)*rwm2*
C     &    d0cccmzqstswwww - 2.D0*s*t**2*u**(-2)*rwm2**(-1)*rzm2*
C     &    c0cmztswww - 2.D0*s*t**2*u**(-2)*rwm2**(-1)*rzm2*c0cctswww + 
C     &    12.D0*s*t**2*u**(-2)*c0cmztswww + 12.D0*s*t**2*u**(-2)*
C     &    c0cctswww - 2.D0*s**2*t*u**(-2)*rwm2**(-1)*rzm2*c0cmzqswww - 
C     &    2.D0*s**2*t*u**(-2)*rwm2**(-1)*rzm2*c0ccqswww + 12.D0*s**2*t*
C     &    u**(-2)*c0cmzqswww + 12.D0*s**2*t*u**(-2)*c0ccqswww - 2.D0*
C     &    s**2*t**2*u**(-2)*rwm2**(-1)*rzm2*d0cccmzqstswwww + 12.D0*
C     &    s**2*t**2*u**(-2)*d0cccmzqstswwww + 2.D0/(u + t)*s**(-1)*
C     &    rzm2**3*c0cmzuswww + 2.D0/(u + t)*s**(-1)*rzm2**3*c0cmztswww
C     &     - 12.D0/(u + t)*s**(-1)*rwm2*rzm2**2*c0cmzuswww - 12.D0/(u
C     &     + t)*s**(-1)*rwm2*rzm2**2*c0cmztswww - 2.D0/(u + t)*s**(-1)*
C     &    u*rzm2**2*c0cmzuswww - 2.D0/(u + t)*s**(-1)*u*rzm2**2*
C     &    c0ccuswww + 12.D0/(u + t)*s**(-1)*u*rwm2*rzm2*c0cmzuswww + 12.
C     &    D0/(u + t)*s**(-1)*u*rwm2*rzm2*c0ccuswww - 2.D0/(u + t)*
C     &    s**(-1)*t*rzm2**2*c0cmztswww - 2.D0/(u + t)*s**(-1)*t*rzm2**2
C     &    *c0cctswww + 12.D0/(u + t)*s**(-1)*t*rwm2*rzm2*c0cmztswww + 
C     &    12.D0/(u + t)*s**(-1)*t*rwm2*rzm2*c0cctswww - 2.D0/(u + t)*
C     &    s**(-1)*t*u*rzm2**2*d0cccmztsuswwww + 12.D0/(u + t)*s**(-1)*t
C     &    *u*rwm2*rzm2*d0cccmztsuswwww - 8.D0/(u + t)*rzm2**2*
C     &    c0cmztswww + 48.D0/(u + t)*rwm2*rzm2*c0cmztswww - 16.D0/(u + 
C     &    t)*s*rzm2*c0cmztswww + 32.D0/(u + t)*s*u*rwm2*d0cccmztsuswwww
C     &     + 32.D0/(u + t)*s*u*rwm2*d0ccmzcqsuswwww + 32.D0/(u + t)*s*u
C     &    *rwm2*d0cccmzqstswwww - 8.D0/(u + t)*s*u**2*d0cccmztsuswwww
C     &     - 8.D0/(u + t)*s*u**2*d0ccmzcqsuswwww - 8.D0/(u + t)*s*u**2*
C     &    d0cccmzqstswwww - 2.D0/(u + t)*s*t*u**(-1)*rwm2**(-1)*rzm2*
C     &    b0fmzww + 2.D0/(u + t)*s*t*u**(-1)*rwm2**(-1)*rzm2*b0fqsww + 
C     &    12.D0/(u + t)*s*t*u**(-1)*b0fmzww - 12.D0/(u + t)*s*t*u**(-1)
C     &    *b0fqsww + 16.D0/(u + t)*s*t*c0cmztswww + 16.D0/(u + t)*s*t*
C     &    c0cctswww + 16.D0/(u + t)*s**2*c0ccqswww + 16.D0/(u + t)*s**2
C     &    *t*d0cccmzqstswwww + 4.D0/(u + t)/(u + s)*s*rzm2**2*
C     &    c0cmztswww - 24.D0/(u + t)/(u + s)*s*rwm2*rzm2*c0cmztswww - 2.
C     &    D0/(u + t)/(u + s)*s*t*rwm2**(-1)*rzm2 + 12.D0/(u + t)/(u + s
C     &    )*s*t - 2.D0/(u + t)/(u + s)/(u + s)*s*t**2*rwm2**(-1)*rzm2*
C     &    b0fmzww + 2.D0/(u + t)/(u + s)/(u + s)*s*t**2*rwm2**(-1)*rzm2
C     &    *b0ftsww + 12.D0/(u + t)/(u + s)/(u + s)*s*t**2*b0fmzww - 12.D
C     &    0/(u + t)/(u + s)/(u + s)*s*t**2*b0ftsww - 4.D0/(u + s)*s*t*
C     &    u**(-1)*rwm2**(-1)*rzm2*b0fmzww + 4.D0/(u + s)*s*t*u**(-1)*
C     &    rwm2**(-1)*rzm2*b0ftsww + 24.D0/(u + s)*s*t*u**(-1)*b0fmzww
C     &     - 24.D0/(u + s)*s*t*u**(-1)*b0ftsww
C
C      ewamp(1,2,1,3) =
C     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz * (  - 4.D0*s**(-1)*u**(-1)*
C     &    rwm2**(-1)*rzm2*b0fmzww + 4.D0*s**(-1)*u**(-1)*rwm2**(-1)*
C     &    rzm2*b0ftsww + 24.D0*s**(-1)*u**(-1)*b0fmzww - 24.D0*s**(-1)*
C     &    u**(-1)*b0ftsww - 4.D0*t**(-1)*u**(-1)*rzm2*c0ccqswww + 24.D0
C     &    *t**(-1)*u**(-1)*rwm2*c0ccqswww - 2.D0*t**(-1)*rzm2*
C     &    d0ccmzcqsuswwww + 12.D0*t**(-1)*rwm2*d0ccmzcqsuswwww + 2.D0*
C     &    u**(-2)*rwm2**(-1)*rzm2**2*c0cmztswww + 2.D0*u**(-2)*
C     &    rwm2**(-1)*rzm2**2*c0cmzqswww - 12.D0*u**(-2)*rzm2*c0cmztswww
C     &     - 12.D0*u**(-2)*rzm2*c0cmzqswww + 32.D0*u**(-1)*c0cmzqswww
C     &     - 6.D0*u**(-1)*rzm2*d0cccmzqstswwww + 36.D0*u**(-1)*rwm2*
C     &    d0cccmzqstswwww - 2.D0*t*u**(-2)*rwm2**(-1)*rzm2*c0cmztswww
C     &     - 2.D0*t*u**(-2)*rwm2**(-1)*rzm2*c0cctswww + 12.D0*t*u**(-2)
C     &    *c0cmztswww + 12.D0*t*u**(-2)*c0cctswww - 2.D0*s*u**(-2)*
C     &    rwm2**(-1)*rzm2*c0cmzqswww - 2.D0*s*u**(-2)*rwm2**(-1)*rzm2*
C     &    c0ccqswww + 12.D0*s*u**(-2)*c0cmzqswww + 12.D0*s*u**(-2)*
C     &    c0ccqswww - 2.D0*s*t*u**(-2)*rwm2**(-1)*rzm2*d0cccmzqstswwww
C     &     + 12.D0*s*t*u**(-2)*d0cccmzqstswwww + 4.D0/(u + t)*s**(-1)*
C     &    t**(-1)*rzm2**2*c0cmzuswww - 24.D0/(u + t)*s**(-1)*t**(-1)*
C     &    rwm2*rzm2*c0cmzuswww - 4.D0/(u + t)*s**(-1)*t**(-1)*u*rzm2*
C     &    c0cmzuswww + 24.D0/(u + t)*s**(-1)*t**(-1)*u*rwm2*c0cmzuswww
C     &     + 4.D0/(u + t)*s**(-1)*u**(-1)*rzm2**2*c0cmztswww - 24.D0/(u
C     &     + t)*s**(-1)*u**(-1)*rwm2*rzm2*c0cmztswww + 4.D0/(u + t)*
C     &    s**(-1)*rzm2*c0ccuswww - 4.D0/(u + t)*s**(-1)*rzm2*c0cctswww
C     &     - 24.D0/(u + t)*s**(-1)*rwm2*c0ccuswww + 24.D0/(u + t)*
C     &    s**(-1)*rwm2*c0cctswww - 2.D0/(u + t)*s**(-1)*u*rzm2*
C     &    d0cccmztsuswwww + 12.D0/(u + t)*s**(-1)*u*rwm2*
C     &    d0cccmztsuswwww - 4.D0/(u + t)*s**(-1)*t*u**(-1)*rzm2*
C     &    c0cmztswww + 24.D0/(u + t)*s**(-1)*t*u**(-1)*rwm2*c0cmztswww
C     &     + 2.D0/(u + t)*s**(-1)*t*rzm2*d0cccmztsuswwww - 12.D0/(u + t
C     &    )*s**(-1)*t*rwm2*d0cccmztsuswwww - 4.D0/(u + t)*u**(-1)*
C     &    rwm2**(-1)*rzm2*b0fmzww + 4.D0/(u + t)*u**(-1)*rwm2**(-1)*
C     &    rzm2*b0fqsww + 24.D0/(u + t)*u**(-1)*b0fmzww - 24.D0/(u + t)*
C     &    u**(-1)*b0fqsww + 32.D0/(u + t)*u**(-1)*rzm2*c0cmztswww - 64.D
C     &    0/(u + t)*rwm2*d0cccmztsuswwww - 64.D0/(u + t)*rwm2*
C     &    d0ccmzcqsuswwww - 64.D0/(u + t)*rwm2*d0cccmzqstswwww + 16.D0
C     &    /(u + t)*u*d0cccmztsuswwww + 16.D0/(u + t)*u*d0ccmzcqsuswwww
C     &     + 16.D0/(u + t)*u*d0cccmzqstswwww - 32.D0/(u + t)*t*u**(-1)*
C     &    c0cmztswww - 32.D0/(u + t)*t*u**(-1)*c0cctswww - 32.D0/(u + t
C     &    )*s*u**(-1)*c0ccqswww - 32.D0/(u + t)*s*t*u**(-1)*
C     &    d0cccmzqstswwww + 24.D0/(u + t)/(u + s) - 8.D0/(u + t)/(u + s
C     &    )*s**(-1)*u*rzm2*c0cmztswww + 48.D0/(u + t)/(u + s)*s**(-1)*u
C     &    *rwm2*c0cmztswww - 4.D0/(u + t)/(u + s)*rwm2**(-1)*rzm2 + 4.D0
C     &    /(u + t)/(u + s)/(u + s)*s**(-1)*u*rwm2**(-1)*rzm2**2*b0fmzww
C     &     - 4.D0/(u + t)/(u + s)/(u + s)*s**(-1)*u*rwm2**(-1)*rzm2**2*
C     &    b0ftsww - 24.D0/(u + t)/(u + s)/(u + s)*s**(-1)*u*rzm2*
C     &    b0fmzww + 24.D0/(u + t)/(u + s)/(u + s)*s**(-1)*u*rzm2*
C     &    b0ftsww )
C
C      ewamp(1,2,2,1) =
C     &  + 4.D0*t**(-1)*rzm2**2*c0cmzuswww + 4.D0*t**(-1)*rzm2**2*
C     &    c0cmzqswww - 24.D0*t**(-1)*rwm2*rzm2*c0cmzuswww - 24.D0*
C     &    t**(-1)*rwm2*rzm2*c0cmzqswww - 4.D0*t**(-1)*u*rzm2*c0cmzuswww
C     &     - 4.D0*t**(-1)*u*rzm2*c0ccuswww + 24.D0*t**(-1)*u*rwm2*
C     &    c0cmzuswww + 24.D0*t**(-1)*u*rwm2*c0ccuswww - 4.D0*rwm2*rzm2*
C     &    d0cccmztsuswwww - 4.D0*rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*
C     &    rzm2*d0cccmzqstswwww + 24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*
C     &    rwm2**2*d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww + 2.D0
C     &    *s*t**(-2)*u*rwm2**(-1)*rzm2**2*c0cmzuswww + 2.D0*s*t**(-2)*u
C     &    *rwm2**(-1)*rzm2**2*c0cmzqswww - 12.D0*s*t**(-2)*u*rzm2*
C     &    c0cmzuswww - 12.D0*s*t**(-2)*u*rzm2*c0cmzqswww - 2.D0*s*
C     &    t**(-2)*u**2*rwm2**(-1)*rzm2*c0cmzuswww - 2.D0*s*t**(-2)*u**2
C     &    *rwm2**(-1)*rzm2*c0ccuswww + 12.D0*s*t**(-2)*u**2*c0cmzuswww
C     &     + 12.D0*s*t**(-2)*u**2*c0ccuswww - 2.D0*s*t**(-1)*rwm2**(-1)
C     &    *rzm2*b0fmzww + 2.D0*s*t**(-1)*rwm2**(-1)*rzm2*b0fqsww + 12.D0
C     &    *s*t**(-1)*b0fmzww - 12.D0*s*t**(-1)*b0fqsww - 4.D0*s*t**(-1)
C     &    *rzm2*c0cmzqswww - 4.D0*s*t**(-1)*rzm2*c0ccqswww + 24.D0*s*
C     &    t**(-1)*rwm2*c0cmzqswww + 24.D0*s*t**(-1)*rwm2*c0ccqswww - 8.D
C     &    0*s*t**(-1)*u*rzm2*d0ccmzcqsuswwww + 48.D0*s*t**(-1)*u*rwm2*
C     &    d0ccmzcqsuswwww - 16.D0*s*c0cmzqswww - 2.D0*s**2*t**(-2)*u*
C     &    rwm2**(-1)*rzm2*c0cmzqswww - 2.D0*s**2*t**(-2)*u*rwm2**(-1)*
C     &    rzm2*c0ccqswww + 12.D0*s**2*t**(-2)*u*c0cmzqswww + 12.D0*s**2
C     &    *t**(-2)*u*c0ccqswww - 2.D0*s**2*t**(-2)*u**2*rwm2**(-1)*rzm2
C     &    *d0ccmzcqsuswwww + 12.D0*s**2*t**(-2)*u**2*d0ccmzcqsuswwww + 
C     &    2.D0/(u + t)*s**(-1)*rzm2**3*c0cmzuswww + 2.D0/(u + t)*
C     &    s**(-1)*rzm2**3*c0cmztswww - 12.D0/(u + t)*s**(-1)*rwm2*
C     &    rzm2**2*c0cmzuswww - 12.D0/(u + t)*s**(-1)*rwm2*rzm2**2*
C     &    c0cmztswww - 2.D0/(u + t)*s**(-1)*u*rzm2**2*c0cmzuswww - 2.D0
C     &    /(u + t)*s**(-1)*u*rzm2**2*c0ccuswww + 12.D0/(u + t)*s**(-1)*
C     &    u*rwm2*rzm2*c0cmzuswww + 12.D0/(u + t)*s**(-1)*u*rwm2*rzm2*
C     &    c0ccuswww - 2.D0/(u + t)*s**(-1)*t*rzm2**2*c0cmztswww - 2.D0
C     &    /(u + t)*s**(-1)*t*rzm2**2*c0cctswww + 12.D0/(u + t)*s**(-1)*
C     &    t*rwm2*rzm2*c0cmztswww + 12.D0/(u + t)*s**(-1)*t*rwm2*rzm2*
C     &    c0cctswww - 2.D0/(u + t)*s**(-1)*t*u*rzm2**2*d0cccmztsuswwww
C     &     + 12.D0/(u + t)*s**(-1)*t*u*rwm2*rzm2*d0cccmztsuswwww - 8.D0
C     &    /(u + t)*rzm2**2*c0cmzuswww + 48.D0/(u + t)*rwm2*rzm2*
C     &    c0cmzuswww - 2.D0/(u + t)*s*t**(-1)*u*rwm2**(-1)*rzm2*b0fmzww
C     &     + 2.D0/(u + t)*s*t**(-1)*u*rwm2**(-1)*rzm2*b0fqsww + 12.D0/(
C     &    u + t)*s*t**(-1)*u*b0fmzww - 12.D0/(u + t)*s*t**(-1)*u*
C     &    b0fqsww - 16.D0/(u + t)*s*rzm2*c0cmzuswww + 16.D0/(u + t)*s*u
C     &    *c0cmzuswww + 16.D0/(u + t)*s*u*c0ccuswww + 32.D0/(u + t)*s*t
C     &    *rwm2*d0cccmztsuswwww + 32.D0/(u + t)*s*t*rwm2*
C     &    d0ccmzcqsuswwww + 32.D0/(u + t)*s*t*rwm2*d0cccmzqstswwww - 8.D
C     &    0/(u + t)*s*t**2*d0cccmztsuswwww - 8.D0/(u + t)*s*t**2*
C     &    d0ccmzcqsuswwww - 8.D0/(u + t)*s*t**2*d0cccmzqstswwww + 16.D0
C     &    /(u + t)*s**2*c0ccqswww + 16.D0/(u + t)*s**2*u*
C     &    d0ccmzcqsuswwww + 4.D0/(u + t)/(t + s)*s*rzm2**2*c0cmzuswww
C     &     - 24.D0/(u + t)/(t + s)*s*rwm2*rzm2*c0cmzuswww - 2.D0/(u + t
C     &    )/(t + s)*s*u*rwm2**(-1)*rzm2 + 12.D0/(u + t)/(t + s)*s*u - 2.
C     &    D0/(u + t)/(t + s)/(t + s)*s*u**2*rwm2**(-1)*rzm2*b0fmzww + 2.
C     &    D0/(u + t)/(t + s)/(t + s)*s*u**2*rwm2**(-1)*rzm2*b0fusww + 
C     &    12.D0/(u + t)/(t + s)/(t + s)*s*u**2*b0fmzww - 12.D0/(u + t)
C     &    /(t + s)/(t + s)*s*u**2*b0fusww - 4.D0/(t + s)*s*t**(-1)*u*
C     &    rwm2**(-1)*rzm2*b0fmzww + 4.D0/(t + s)*s*t**(-1)*u*rwm2**(-1)
C     &    *rzm2*b0fusww + 24.D0/(t + s)*s*t**(-1)*u*b0fmzww - 24.D0/(t
C     &     + s)*s*t**(-1)*u*b0fusww
C
C      ewamp(1,2,2,2) =
C     &  - 14.D0*t**(-1)*u*rzm2*c0cmzqswww - 12.D0*t**(-1)*u*rwm2*
C     &    c0cmzqswww - 2.D0*u**(-1)*rzm2**2*c0cctswww + 12.D0*u**(-1)*
C     &    rwm2*rzm2*c0cctswww - 4.D0*rwm2*rzm2*d0cccmztsuswwww - 4.D0*
C     &    rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*rzm2*d0cccmzqstswwww + 
C     &    24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*rwm2**2*d0ccmzcqsuswwww
C     &     + 24.D0*rwm2**2*d0cccmzqstswwww + 2.D0*t*u**(-1)*rzm2*
C     &    c0cmzqswww - 12.D0*t*u**(-1)*rwm2*c0cmzqswww - 2.D0*s*t**(-1)
C     &    *u**(-1)*rzm2**2*c0ccqswww + 12.D0*s*t**(-1)*u**(-1)*rwm2*
C     &    rzm2*c0ccqswww + 2.D0*s*t**(-1)*rzm2*c0cmzuswww - 12.D0*s*
C     &    t**(-1)*rwm2*c0cmzuswww - 2.D0*s*t**(-1)*u*rzm2*
C     &    d0ccmzcqsuswwww + 12.D0*s*t**(-1)*u*rwm2*d0ccmzcqsuswwww + 2.D
C     &    0*s*u**(-1)*rzm2*c0cctswww - 12.D0*s*u**(-1)*rwm2*c0cctswww
C     &     - 2.D0*s*t*u**(-1)*rzm2*d0cccmzqstswwww + 12.D0*s*t*u**(-1)*
C     &    rwm2*d0cccmzqstswwww + 2.D0*s**2*t**(-1)*u**(-1)*rzm2*
C     &    c0ccqswww - 12.D0*s**2*t**(-1)*u**(-1)*rwm2*c0ccqswww - 16.D0
C     &    /(u + t)*t**(-1)*u*rzm2**2*c0cmzuswww + 16.D0/(u + t)*t**(-1)
C     &    *u**2*rzm2*c0cmzuswww + 14.D0/(u + t)*t**(-1)*u**2*rzm2*
C     &    c0ccuswww + 12.D0/(u + t)*t**(-1)*u**2*rwm2*c0ccuswww + 2.D0
C     &    /(u + t)*rzm2**2*c0cmzuswww - 12.D0/(u + t)*rwm2*rzm2*
C     &    c0cmzuswww - 2.D0/(u + t)*u*rzm2*c0cctswww + 12.D0/(u + t)*u*
C     &    rwm2*c0cctswww + 32.D0/(u + t)*u*rwm2*rzm2*d0cccmztsuswwww + 
C     &    32.D0/(u + t)*u*rwm2*rzm2*d0ccmzcqsuswwww + 32.D0/(u + t)*u*
C     &    rwm2*rzm2*d0cccmzqstswwww + 2.D0/(u + t)*t*u**(-1)*rzm2**2*
C     &    c0cmztswww - 12.D0/(u + t)*t*u**(-1)*rwm2*rzm2*c0cmztswww - 2.
C     &    D0/(u + t)*t*rzm2*c0cmzuswww + 12.D0/(u + t)*t*rwm2*
C     &    c0cmzuswww - 6.D0/(u + t)*t*u*rzm2*d0cccmztsuswwww - 8.D0/(u
C     &     + t)*t*u*rzm2*d0ccmzcqsuswwww - 8.D0/(u + t)*t*u*rzm2*
C     &    d0cccmzqstswwww - 12.D0/(u + t)*t*u*rwm2*d0cccmztsuswwww - 2.D
C     &    0/(u + t)*t**2*u**(-1)*rzm2*c0cmztswww + 12.D0/(u + t)*t**2*
C     &    u**(-1)*rwm2*c0cmztswww + 16.D0/(u + t)*s*t**(-1)*u*rzm2*
C     &    c0ccqswww + 16.D0/(u + t)*s*t**(-1)*u**2*rzm2*d0ccmzcqsuswwww
C     &     + 4.D0/(u + t)/(t + s)*t*rzm2**2*c0cmzuswww - 24.D0/(u + t)
C     &    /(t + s)*t*rwm2*rzm2*c0cmzuswww + 2.D0/(u + t)/(t + s)*s*u*
C     &    rwm2**(-1)*rzm2 - 12.D0/(u + t)/(t + s)*s*u - 2.D0/(u + t)/(t
C     &     + s)/(t + s)*t*u*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + t)/(
C     &    t + s)/(t + s)*t*u*rwm2**(-1)*rzm2**2*b0fusww + 12.D0/(u + t)
C     &    /(t + s)/(t + s)*t*u*rzm2*b0fmzww - 12.D0/(u + t)/(t + s)/(t
C     &     + s)*t*u*rzm2*b0fusww
C
C      ewamp(1,2,2,3) =
C     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz * (  - 4.D0*s**(-1)*t**(-1)*
C     &    rwm2**(-1)*rzm2*b0fmzww + 4.D0*s**(-1)*t**(-1)*rwm2**(-1)*
C     &    rzm2*b0fusww + 24.D0*s**(-1)*t**(-1)*b0fmzww - 24.D0*s**(-1)*
C     &    t**(-1)*b0fusww + 2.D0*t**(-2)*rwm2**(-1)*rzm2**2*c0cmzuswww
C     &     + 2.D0*t**(-2)*rwm2**(-1)*rzm2**2*c0cmzqswww - 12.D0*t**(-2)
C     &    *rzm2*c0cmzuswww - 12.D0*t**(-2)*rzm2*c0cmzqswww - 2.D0*
C     &    t**(-2)*u*rwm2**(-1)*rzm2*c0cmzuswww - 2.D0*t**(-2)*u*
C     &    rwm2**(-1)*rzm2*c0ccuswww + 12.D0*t**(-2)*u*c0cmzuswww + 12.D0
C     &    *t**(-2)*u*c0ccuswww - 4.D0*t**(-1)*u**(-1)*rzm2*c0ccqswww + 
C     &    24.D0*t**(-1)*u**(-1)*rwm2*c0ccqswww + 32.D0*t**(-1)*
C     &    c0cmzqswww - 6.D0*t**(-1)*rzm2*d0ccmzcqsuswwww + 36.D0*
C     &    t**(-1)*rwm2*d0ccmzcqsuswwww - 2.D0*u**(-1)*rzm2*
C     &    d0cccmzqstswwww + 12.D0*u**(-1)*rwm2*d0cccmzqstswwww - 2.D0*s
C     &    *t**(-2)*rwm2**(-1)*rzm2*c0cmzqswww - 2.D0*s*t**(-2)*
C     &    rwm2**(-1)*rzm2*c0ccqswww + 12.D0*s*t**(-2)*c0cmzqswww + 12.D0
C     &    *s*t**(-2)*c0ccqswww - 2.D0*s*t**(-2)*u*rwm2**(-1)*rzm2*
C     &    d0ccmzcqsuswwww + 12.D0*s*t**(-2)*u*d0ccmzcqsuswwww + 4.D0/(u
C     &     + t)*s**(-1)*t**(-1)*rzm2**2*c0cmzuswww - 24.D0/(u + t)*
C     &    s**(-1)*t**(-1)*rwm2*rzm2*c0cmzuswww - 4.D0/(u + t)*s**(-1)*
C     &    t**(-1)*u*rzm2*c0cmzuswww + 24.D0/(u + t)*s**(-1)*t**(-1)*u*
C     &    rwm2*c0cmzuswww + 4.D0/(u + t)*s**(-1)*u**(-1)*rzm2**2*
C     &    c0cmztswww - 24.D0/(u + t)*s**(-1)*u**(-1)*rwm2*rzm2*
C     &    c0cmztswww - 4.D0/(u + t)*s**(-1)*rzm2*c0ccuswww + 4.D0/(u + 
C     &    t)*s**(-1)*rzm2*c0cctswww + 24.D0/(u + t)*s**(-1)*rwm2*
C     &    c0ccuswww - 24.D0/(u + t)*s**(-1)*rwm2*c0cctswww + 2.D0/(u + 
C     &    t)*s**(-1)*u*rzm2*d0cccmztsuswwww - 12.D0/(u + t)*s**(-1)*u*
C     &    rwm2*d0cccmztsuswwww - 4.D0/(u + t)*s**(-1)*t*u**(-1)*rzm2*
C     &    c0cmztswww + 24.D0/(u + t)*s**(-1)*t*u**(-1)*rwm2*c0cmztswww
C     &     - 2.D0/(u + t)*s**(-1)*t*rzm2*d0cccmztsuswwww + 12.D0/(u + t
C     &    )*s**(-1)*t*rwm2*d0cccmztsuswwww - 4.D0/(u + t)*t**(-1)*
C     &    rwm2**(-1)*rzm2*b0fmzww + 4.D0/(u + t)*t**(-1)*rwm2**(-1)*
C     &    rzm2*b0fqsww + 24.D0/(u + t)*t**(-1)*b0fmzww - 24.D0/(u + t)*
C     &    t**(-1)*b0fqsww + 32.D0/(u + t)*t**(-1)*rzm2*c0cmzuswww - 32.D
C     &    0/(u + t)*t**(-1)*u*c0cmzuswww - 32.D0/(u + t)*t**(-1)*u*
C     &    c0ccuswww - 64.D0/(u + t)*rwm2*d0cccmztsuswwww - 64.D0/(u + t
C     &    )*rwm2*d0ccmzcqsuswwww - 64.D0/(u + t)*rwm2*d0cccmzqstswwww
C     &     + 16.D0/(u + t)*t*d0cccmztsuswwww + 16.D0/(u + t)*t*
C     &    d0ccmzcqsuswwww + 16.D0/(u + t)*t*d0cccmzqstswwww - 32.D0/(u
C     &     + t)*s*t**(-1)*c0ccqswww - 32.D0/(u + t)*s*t**(-1)*u*
C     &    d0ccmzcqsuswwww + 24.D0/(u + t)/(t + s) - 8.D0/(u + t)/(t + s
C     &    )*s**(-1)*t*rzm2*c0cmzuswww + 48.D0/(u + t)/(t + s)*s**(-1)*t
C     &    *rwm2*c0cmzuswww - 4.D0/(u + t)/(t + s)*rwm2**(-1)*rzm2 + 4.D0
C     &    /(u + t)/(t + s)/(t + s)*s**(-1)*t*rwm2**(-1)*rzm2**2*b0fmzww
C     &     - 4.D0/(u + t)/(t + s)/(t + s)*s**(-1)*t*rwm2**(-1)*rzm2**2*
C     &    b0fusww - 24.D0/(u + t)/(t + s)/(t + s)*s**(-1)*t*rzm2*
C     &    b0fmzww + 24.D0/(u + t)/(t + s)/(t + s)*s**(-1)*t*rzm2*
C     &    b0fusww )
C*}}}
*{{{ SANC
      ewamp(1,1,1,1) =
     &  + 12.D0 - 6.D0*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 6.D0
     &    *s**(-2)*t**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 36.D0*s**(-2)*
     &    t**(-1)*rzm2**3*b0fmzww - 36.D0*s**(-2)*t**(-1)*rzm2**3*
     &    b0fusww + 6.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2**3*b0fmzww
     &     - 6.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2**3*b0fusww - 36.D0*
     &    s**(-2)*t**(-1)*u*rzm2**2*b0fmzww + 36.D0*s**(-2)*t**(-1)*u*
     &    rzm2**2*b0fusww - 2.D0*s**(-2)*t**(-1)*u**2*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 2.D0*s**(-2)*t**(-1)*u**2*rwm2**(-1)*
     &    rzm2**2*b0fusww + 12.D0*s**(-2)*t**(-1)*u**2*rzm2*b0fmzww - 
     &    12.D0*s**(-2)*t**(-1)*u**2*rzm2*b0fusww + 2.D0*s**(-2)*
     &    u**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 2.D0*s**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**4*b0ftsww - 12.D0*s**(-2)*u**(-1)*rzm2**3*
     &    b0fmzww + 12.D0*s**(-2)*u**(-1)*rzm2**3*b0ftsww - 4.D0*
     &    s**(-2)*t*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0*s**(-2)*t
     &    *u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 24.D0*s**(-2)*t*u**(-1)
     &    *rzm2**2*b0fmzww - 24.D0*s**(-2)*t*u**(-1)*rzm2**2*b0ftsww + 
     &    2.D0*s**(-2)*t**2*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*
     &    s**(-2)*t**2*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0*
     &    s**(-2)*t**2*u**(-1)*rzm2*b0fmzww + 12.D0*s**(-2)*t**2*
     &    u**(-1)*rzm2*b0ftsww - 6.D0*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**3 + 4.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 4.
     &    D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3*b0fusww + 36.D0*s**(-1)
     &    *t**(-1)*rzm2**2 - 24.D0*s**(-1)*t**(-1)*rzm2**2*b0fmzww + 24.
     &    D0*s**(-1)*t**(-1)*rzm2**2*b0fusww + 12.D0*s**(-1)*t**(-1)*
     &    rzm2**3*c0cmzuswww - 72.D0*s**(-1)*t**(-1)*rwm2*rzm2**2*
     &    c0cmzuswww + 6.D0*s**(-1)*t**(-1)*u*rwm2**(-1)*rzm2**2 - 2.D0
     &    *s**(-1)*t**(-1)*u*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0*s**(-1)*
     &    t**(-1)*u*rwm2**(-1)*rzm2**2*b0fusww - 36.D0*s**(-1)*t**(-1)*
     &    u*rzm2 + 12.D0*s**(-1)*t**(-1)*u*rzm2*b0fmzww - 12.D0*s**(-1)
     &    *t**(-1)*u*rzm2*b0fusww - 12.D0*s**(-1)*t**(-1)*u*rzm2**2*
     &    c0cmzuswww + 72.D0*s**(-1)*t**(-1)*u*rwm2*rzm2*c0cmzuswww - 2.
     &    D0*s**(-1)*t**(-1)*u**2*rwm2**(-1)*rzm2 + 12.D0*s**(-1)*
     &    t**(-1)*u**2 + 4.D0*s**(-1)*t**(-1)*u**2*rzm2*c0cmzuswww - 24.
     &    D0*s**(-1)*t**(-1)*u**2*rwm2*c0cmzuswww + 2.D0*s**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3 - 2.D0*s**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 2.D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0ftsww - 12.D0*s**(-1)*u**(-1)*rzm2**2 + 12.D0*s**(-1)*
     &    u**(-1)*rzm2**2*b0fmzww - 12.D0*s**(-1)*u**(-1)*rzm2**2*
     &    b0ftsww - 4.D0*s**(-1)*u**(-1)*rzm2**3*c0cmztswww + 24.D0*
     &    s**(-1)*u**(-1)*rwm2*rzm2**2*c0cmztswww - 14.D0*s**(-1)*
     &    rzm2**2*c0cmztswww + 14.D0*s**(-1)*rzm2**2*c0ccuswww - 12.D0*
     &    s**(-1)*rwm2*rzm2*c0cmztswww + 12.D0*s**(-1)*rwm2*rzm2*
     &    c0ccuswww - 4.D0*s**(-1)*t*u**(-1)*rwm2**(-1)*rzm2**2 + 2.D0*
     &    s**(-1)*t*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*s**(-1)*t
     &    *u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww + 24.D0*s**(-1)*t*u**(-1)
     &    *rzm2 - 12.D0*s**(-1)*t*u**(-1)*rzm2*b0fmzww + 12.D0*s**(-1)*
     &    t*u**(-1)*rzm2*b0ftsww + 8.D0*s**(-1)*t*u**(-1)*rzm2**2*
     &    c0cmztswww - 48.D0*s**(-1)*t*u**(-1)*rwm2*rzm2*c0cmztswww - 
     &    14.D0*s**(-1)*t*rzm2*c0cmzuswww + 14.D0*s**(-1)*t*rzm2*
     &    c0cmztswww - 14.D0*s**(-1)*t*rzm2*c0ccuswww + 14.D0*s**(-1)*t
     &    *rzm2*c0cctswww + 14.D0*s**(-1)*t*rzm2**2*d0cccmztsuswwww - 
     &    12.D0*s**(-1)*t*rwm2*c0cmzuswww + 12.D0*s**(-1)*t*rwm2*
     &    c0cmztswww - 12.D0*s**(-1)*t*rwm2*c0ccuswww + 12.D0*s**(-1)*t
     &    *rwm2*c0cctswww + 12.D0*s**(-1)*t*rwm2*rzm2*d0cccmztsuswwww
     &     + 2.D0*s**(-1)*t**2*u**(-1)*rwm2**(-1)*rzm2 - 12.D0*s**(-1)*
     &    t**2*u**(-1) - 4.D0*s**(-1)*t**2*u**(-1)*rzm2*c0cmztswww + 24.
     &    D0*s**(-1)*t**2*u**(-1)*rwm2*c0cmztswww - 14.D0*s**(-1)*t**2*
     &    rzm2*d0cccmztsuswwww - 12.D0*s**(-1)*t**2*rwm2*
     &    d0cccmztsuswwww + 4.D0*t**(-1)*rwm2**(-1)*rzm2**2 - 24.D0*
     &    t**(-1)*rzm2 - 8.D0*t**(-1)*rzm2**2*c0cmzuswww + 48.D0*
     &    t**(-1)*rwm2*rzm2*c0cmzuswww - 2.D0*t**(-1)*u*rwm2**(-1)*rzm2
     &     + 12.D0*t**(-1)*u + 4.D0*t**(-1)*u*rzm2*c0cmzuswww - 24.D0*
     &    t**(-1)*u*rwm2*c0cmzuswww - 2.D0*u**(-1)*rwm2**(-1)*rzm2**2
     &     + 12.D0*u**(-1)*rzm2 + 4.D0*u**(-1)*rzm2**2*c0cmztswww - 24.D
     &    0*u**(-1)*rwm2*rzm2*c0cmztswww - 2.D0*rwm2**(-1)*rzm2 - 2.D0*
     &    rwm2**(-1)*rzm2*b0fusww + 2.D0*rwm2**(-1)*rzm2*b0ftsww + 12.D0
     &    *b0fusww - 12.D0*b0ftsww + 8.D0*rzm2*c0cmzuswww + 12.D0*rzm2*
     &    c0cmztswww - 12.D0*rzm2*c0ccuswww - 48.D0*rwm2*c0cmzuswww + 
     &    24.D0*rwm2*c0cmztswww - 24.D0*rwm2*c0ccuswww - 4.D0*rwm2*rzm2
     &    *d0cccmztsuswwww - 4.D0*rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2
     &    *rzm2*d0cccmzqstswwww + 24.D0*rwm2**2*d0cccmztsuswwww + 24.D0
     &    *rwm2**2*d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww - 16.
     &    D0*u*c0cmzuswww - 16.D0*u*c0ccuswww - 8.D0*u*rzm2*
     &    d0cccmztsuswwww - 8.D0*u*rzm2*d0ccmzcqsuswwww - 8.D0*u*rzm2*
     &    d0cccmzqstswwww + 32.D0*u*rwm2*d0cccmztsuswwww + 32.D0*u*rwm2
     &    *d0ccmzcqsuswwww + 32.D0*u*rwm2*d0cccmzqstswwww + 8.D0*u**2*
     &    d0cccmztsuswwww + 8.D0*u**2*d0ccmzcqsuswwww + 8.D0*u**2*
     &    d0cccmzqstswwww + 2.D0*t*u**(-1)*rwm2**(-1)*rzm2 - 12.D0*t*
     &    u**(-1) - 4.D0*t*u**(-1)*rzm2*c0cmztswww + 24.D0*t*u**(-1)*
     &    rwm2*c0cmztswww - 2.D0*t*rwm2**(-1)*rzm2*c0cmzuswww - 2.D0*t*
     &    rwm2**(-1)*rzm2*c0ccuswww + 12.D0*t*c0cmzuswww - 16.D0*t*
     &    c0cmztswww + 12.D0*t*c0ccuswww - 16.D0*t*c0cctswww - 16.D0*t*
     &    rzm2*d0cccmztsuswwww - 8.D0*t*rzm2*d0ccmzcqsuswwww - 8.D0*t*
     &    rzm2*d0cccmzqstswwww - 16.D0*t*rwm2*d0cccmztsuswwww + 32.D0*t
     &    *rwm2*d0ccmzcqsuswwww + 32.D0*t*rwm2*d0cccmzqstswwww + 16.D0*
     &    t*u*d0ccmzcqsuswwww + 16.D0*t*u*d0cccmzqstswwww - 2.D0*t**2*
     &    rwm2**(-1)*rzm2*d0cccmztsuswwww + 20.D0*t**2*d0cccmztsuswwww
     &     + 8.D0*t**2*d0ccmzcqsuswwww + 8.D0*t**2*d0cccmzqstswwww + 2.D
     &    0/(u + t)*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**5*b0fmzww - 2.D0/(
     &    u + t)*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**5*b0fusww - 12.D0/(u
     &     + t)*s**(-2)*t**(-1)*rzm2**4*b0fmzww + 12.D0/(u + t)*s**(-2)
     &    *t**(-1)*rzm2**4*b0fusww + 2.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**4 - 2.D0/(u + t)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fmzww + 2.D0/(u + t)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fusww - 12.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3 + 12.D
     &    0/(u + t)*s**(-1)*t**(-1)*rzm2**3*b0fmzww - 12.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**3*b0fusww - 4.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**4*c0cmzuswww + 24.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2*rzm2**3*c0cmzuswww - 2.D0/(u + t)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**3*c0cmztswww + 2.D0/(u + t)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**3*c0ccuswww + 12.D0/(u + t)*s**(-1)*t*rzm2**2*
     &    c0cmztswww - 12.D0/(u + t)*s**(-1)*t*rzm2**2*c0ccuswww - 2.D0
     &    /(u + t)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*c0cmzuswww + 4.D0/(u
     &     + t)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*c0cmztswww - 4.D0/(u + 
     &    t)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*c0ccuswww + 2.D0/(u + t)*
     &    s**(-1)*t**2*rwm2**(-1)*rzm2**2*c0cctswww + 2.D0/(u + t)*
     &    s**(-1)*t**2*rwm2**(-1)*rzm2**3*d0cccmztsuswwww + 12.D0/(u + 
     &    t)*s**(-1)*t**2*rzm2*c0cmzuswww - 24.D0/(u + t)*s**(-1)*t**2*
     &    rzm2*c0cmztswww + 24.D0/(u + t)*s**(-1)*t**2*rzm2*c0ccuswww
     &     - 12.D0/(u + t)*s**(-1)*t**2*rzm2*c0cctswww - 12.D0/(u + t)*
     &    s**(-1)*t**2*rzm2**2*d0cccmztsuswwww + 2.D0/(u + t)*s**(-1)*
     &    t**3*rwm2**(-1)*rzm2*c0cmzuswww - 2.D0/(u + t)*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2*c0cmztswww + 2.D0/(u + t)*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2*c0ccuswww - 2.D0/(u + t)*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2*c0cctswww - 4.D0/(u + t)*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2**2*d0cccmztsuswwww - 12.D0/(u + t)*s**(-1)*
     &    t**3*c0cmzuswww + 12.D0/(u + t)*s**(-1)*t**3*c0cmztswww - 12.D
     &    0/(u + t)*s**(-1)*t**3*c0ccuswww + 12.D0/(u + t)*s**(-1)*t**3
     &    *c0cctswww + 24.D0/(u + t)*s**(-1)*t**3*rzm2*d0cccmztsuswwww
     &     + 2.D0/(u + t)*s**(-1)*t**4*rwm2**(-1)*rzm2*d0cccmztsuswwww
     &     - 12.D0/(u + t)*s**(-1)*t**4*d0cccmztsuswwww - 2.D0/(u + t)*
     &    t**(-1)*rwm2**(-1)*rzm2**3 + 12.D0/(u + t)*t**(-1)*rzm2**2 + 
     &    4.D0/(u + t)*t**(-1)*rzm2**3*c0cmzuswww - 24.D0/(u + t)*
     &    t**(-1)*rwm2*rzm2**2*c0cmzuswww + 4.D0/(u + t)*rwm2**(-1)*
     &    rzm2**2 + 4.D0/(u + t)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u
     &     + t)*rwm2**(-1)*rzm2**2*b0fusww - 2.D0/(u + t)*rwm2**(-1)*
     &    rzm2**2*b0ftsww - 24.D0/(u + t)*rzm2 - 24.D0/(u + t)*rzm2*
     &    b0fmzww + 12.D0/(u + t)*rzm2*b0fusww + 12.D0/(u + t)*rzm2*
     &    b0ftsww - 2.D0/(u + t)*rzm2**2*c0cmzuswww - 2.D0/(u + t)*
     &    rzm2**2*c0cmztswww - 4.D0/(u + t)*rzm2**2*c0ccqswww + 12.D0/(
     &    u + t)*rwm2*rzm2*c0cmzuswww + 12.D0/(u + t)*rwm2*rzm2*
     &    c0cmztswww + 24.D0/(u + t)*rwm2*rzm2*c0ccqswww + 4.D0/(u + t)
     &    *t*rwm2**(-1)*rzm2*b0fusww - 4.D0/(u + t)*t*rwm2**(-1)*rzm2*
     &    b0ftsww + 2.D0/(u + t)*t*rwm2**(-1)*rzm2**2*c0cmztswww - 2.D0
     &    /(u + t)*t*rwm2**(-1)*rzm2**2*c0ccuswww - 24.D0/(u + t)*t*
     &    b0fusww + 24.D0/(u + t)*t*b0ftsww - 2.D0/(u + t)*t*rzm2*
     &    c0cmzuswww - 10.D0/(u + t)*t*rzm2*c0cmztswww + 10.D0/(u + t)*
     &    t*rzm2*c0ccuswww + 2.D0/(u + t)*t*rzm2*c0cctswww + 12.D0/(u
     &     + t)*t*rwm2*c0cmzuswww - 12.D0/(u + t)*t*rwm2*c0cmztswww + 
     &    12.D0/(u + t)*t*rwm2*c0ccuswww - 12.D0/(u + t)*t*rwm2*
     &    c0cctswww + 4.D0/(u + t)*t**2*rwm2**(-1)*rzm2*c0cmzuswww - 2.D
     &    0/(u + t)*t**2*rwm2**(-1)*rzm2*c0cmztswww + 4.D0/(u + t)*t**2
     &    *rwm2**(-1)*rzm2*c0ccuswww - 2.D0/(u + t)*t**2*rwm2**(-1)*
     &    rzm2*c0cctswww - 2.D0/(u + t)*t**2*rwm2**(-1)*rzm2**2*
     &    d0cccmztsuswwww - 24.D0/(u + t)*t**2*c0cmzuswww + 12.D0/(u + 
     &    t)*t**2*c0cmztswww - 24.D0/(u + t)*t**2*c0ccuswww + 12.D0/(u
     &     + t)*t**2*c0cctswww + 6.D0/(u + t)*t**2*rzm2*d0cccmztsuswwww
     &     + 36.D0/(u + t)*t**2*rwm2*d0cccmztsuswwww + 4.D0/(u + t)*
     &    t**3*rwm2**(-1)*rzm2*d0cccmztsuswwww - 24.D0/(u + t)*t**3*
     &    d0cccmztsuswwww - 2.D0/(u + t)/(u + s)*rwm2**(-1)*rzm2**3 + 
     &    12.D0/(u + t)/(u + s)*rzm2**2 + 4.D0/(u + t)/(u + s)*rzm2**3*
     &    c0cmztswww - 24.D0/(u + t)/(u + s)*rwm2*rzm2**2*c0cmztswww - 
     &    2.D0/(u + t)/(u + s)/(u + s)*rwm2**(-1)*rzm2**4*b0fmzww + 2.D0
     &    /(u + t)/(u + s)/(u + s)*rwm2**(-1)*rzm2**4*b0ftsww + 12.D0/(
     &    u + t)/(u + s)/(u + s)*rzm2**3*b0fmzww - 12.D0/(u + t)/(u + s
     &    )/(u + s)*rzm2**3*b0ftsww - 2.D0/(u + t)/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**5*b0fmzww + 2.D0/(u + t)/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**5*b0fusww + 12.D0/(u + t)/(t + s)*s**(-2)*
     &    rzm2**4*b0fmzww - 12.D0/(u + t)/(t + s)*s**(-2)*rzm2**4*
     &    b0fusww - 2.D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4 + 2.
     &    D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 2.D0
     &    /(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 12.D0/(
     &    u + t)/(t + s)*s**(-1)*rzm2**3 - 12.D0/(u + t)/(t + s)*
     &    s**(-1)*rzm2**3*b0fmzww + 12.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**3*b0fusww + 4.D0/(u + t)/(t + s)*s**(-1)*rzm2**4*
     &    c0cmzuswww - 24.D0/(u + t)/(t + s)*s**(-1)*rwm2*rzm2**3*
     &    c0cmzuswww - 2.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**5*b0fmzww + 2.D0/(u + t)/(t + s)/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**5*b0fusww + 12.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-1)*rzm2**4*b0fmzww
      ewamp(1,1,1,1) = ewamp(1,1,1,1) - 12.D0/(u + t)/(t + s)/(t + 
     & s)*s**(-1)*rzm2**4*b0fusww - 2.D0/(u + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**4*b0fmzww + 2.D0/(u + s)*s**(-2)*rwm2**(-1)*rzm2**4*
     &    b0ftsww + 12.D0/(u + s)*s**(-2)*rzm2**3*b0fmzww - 12.D0/(u + 
     &    s)*s**(-2)*rzm2**3*b0ftsww + 4.D0/(u + s)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(u + s)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 24.D0/(u + s)*s**(-2)*t*rzm2**2*
     &    b0fmzww + 24.D0/(u + s)*s**(-2)*t*rzm2**2*b0ftsww - 2.D0/(u
     &     + s)*s**(-2)*t**2*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)*
     &    s**(-2)*t**2*rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + s)*
     &    s**(-2)*t**2*rzm2*b0fmzww - 12.D0/(u + s)*s**(-2)*t**2*rzm2*
     &    b0ftsww - 2.D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2**3 + 2.D0/(u
     &     + s)*s**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0/(u + s)*
     &    s**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 12.D0/(u + s)*s**(-1)*
     &    rzm2**2 - 12.D0/(u + s)*s**(-1)*rzm2**2*b0fmzww + 12.D0/(u + 
     &    s)*s**(-1)*rzm2**2*b0ftsww + 4.D0/(u + s)*s**(-1)*rzm2**3*
     &    c0cmztswww - 24.D0/(u + s)*s**(-1)*rwm2*rzm2**2*c0cmztswww + 
     &    4.D0/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2**2 - 2.D0/(u + s)*
     &    s**(-1)*t*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)*s**(-1)*t
     &    *rwm2**(-1)*rzm2**2*b0ftsww - 24.D0/(u + s)*s**(-1)*t*rzm2 + 
     &    12.D0/(u + s)*s**(-1)*t*rzm2*b0fmzww - 12.D0/(u + s)*s**(-1)*
     &    t*rzm2*b0ftsww - 8.D0/(u + s)*s**(-1)*t*rzm2**2*c0cmztswww + 
     &    48.D0/(u + s)*s**(-1)*t*rwm2*rzm2*c0cmztswww - 2.D0/(u + s)*
     &    s**(-1)*t**2*rwm2**(-1)*rzm2 + 12.D0/(u + s)*s**(-1)*t**2 + 4.
     &    D0/(u + s)*s**(-1)*t**2*rzm2*c0cmztswww - 24.D0/(u + s)*
     &    s**(-1)*t**2*rwm2*c0cmztswww + 2.D0/(u + s)*rwm2**(-1)*
     &    rzm2**2*b0fmzww - 2.D0/(u + s)*rwm2**(-1)*rzm2**2*b0ftsww - 
     &    12.D0/(u + s)*rzm2*b0fmzww + 12.D0/(u + s)*rzm2*b0ftsww + 2.D0
     &    /(u + s)*t*rwm2**(-1)*rzm2 - 12.D0/(u + s)*t - 4.D0/(u + s)*t
     &    *rzm2*c0cmztswww + 24.D0/(u + s)*t*rwm2*c0cmztswww - 2.D0/(u
     &     + s)/(u + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 2.D0/(u + 
     &    s)/(u + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0ftsww + 12.D0/(u + s)
     &    /(u + s)*s**(-1)*rzm2**3*b0fmzww - 12.D0/(u + s)/(u + s)*
     &    s**(-1)*rzm2**3*b0ftsww + 4.D0/(u + s)/(u + s)*s**(-1)*t*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(u + s)/(u + s)*s**(-1)*t*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 24.D0/(u + s)/(u + s)*s**(-1)*t*
     &    rzm2**2*b0fmzww + 24.D0/(u + s)/(u + s)*s**(-1)*t*rzm2**2*
     &    b0ftsww - 2.D0/(u + s)/(u + s)*s**(-1)*t**2*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 2.D0/(u + s)/(u + s)*s**(-1)*t**2*
     &    rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + s)/(u + s)*s**(-1)*
     &    t**2*rzm2*b0fmzww - 12.D0/(u + s)/(u + s)*s**(-1)*t**2*rzm2*
     &    b0ftsww + 2.D0/(u + s)/(u + s)*t*rwm2**(-1)*rzm2**2*b0fmzww
     &     - 2.D0/(u + s)/(u + s)*t*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0
     &    /(u + s)/(u + s)*t*rzm2*b0fmzww + 12.D0/(u + s)/(u + s)*t*
     &    rzm2*b0ftsww + 6.D0/(t + s)*s**(-2)*rwm2**(-1)*rzm2**4*
     &    b0fmzww - 6.D0/(t + s)*s**(-2)*rwm2**(-1)*rzm2**4*b0fusww - 
     &    36.D0/(t + s)*s**(-2)*rzm2**3*b0fmzww + 36.D0/(t + s)*s**(-2)
     &    *rzm2**3*b0fusww - 6.D0/(t + s)*s**(-2)*u*rwm2**(-1)*rzm2**3*
     &    b0fmzww + 6.D0/(t + s)*s**(-2)*u*rwm2**(-1)*rzm2**3*b0fusww
     &     + 36.D0/(t + s)*s**(-2)*u*rzm2**2*b0fmzww - 36.D0/(t + s)*
     &    s**(-2)*u*rzm2**2*b0fusww + 2.D0/(t + s)*s**(-2)*u**2*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(t + s)*s**(-2)*u**2*
     &    rwm2**(-1)*rzm2**2*b0fusww - 12.D0/(t + s)*s**(-2)*u**2*rzm2*
     &    b0fmzww + 12.D0/(t + s)*s**(-2)*u**2*rzm2*b0fusww + 6.D0/(t
     &     + s)*s**(-1)*rwm2**(-1)*rzm2**3 - 4.D0/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fusww - 36.D0/(t + s)*s**(-1)*rzm2**2 + 24.D0/(t + 
     &    s)*s**(-1)*rzm2**2*b0fmzww - 24.D0/(t + s)*s**(-1)*rzm2**2*
     &    b0fusww - 12.D0/(t + s)*s**(-1)*rzm2**3*c0cmzuswww + 72.D0/(t
     &     + s)*s**(-1)*rwm2*rzm2**2*c0cmzuswww - 6.D0/(t + s)*s**(-1)*
     &    u*rwm2**(-1)*rzm2**2 + 2.D0/(t + s)*s**(-1)*u*rwm2**(-1)*
     &    rzm2**2*b0fmzww - 2.D0/(t + s)*s**(-1)*u*rwm2**(-1)*rzm2**2*
     &    b0fusww + 36.D0/(t + s)*s**(-1)*u*rzm2 - 12.D0/(t + s)*
     &    s**(-1)*u*rzm2*b0fmzww + 12.D0/(t + s)*s**(-1)*u*rzm2*b0fusww
     &     + 12.D0/(t + s)*s**(-1)*u*rzm2**2*c0cmzuswww - 72.D0/(t + s)
     &    *s**(-1)*u*rwm2*rzm2*c0cmzuswww + 2.D0/(t + s)*s**(-1)*u**2*
     &    rwm2**(-1)*rzm2 - 12.D0/(t + s)*s**(-1)*u**2 - 4.D0/(t + s)*
     &    s**(-1)*u**2*rzm2*c0cmzuswww + 24.D0/(t + s)*s**(-1)*u**2*
     &    rwm2*c0cmzuswww + 4.D0/(t + s)*rwm2**(-1)*rzm2**2 - 2.D0/(t
     &     + s)*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(t + s)*rwm2**(-1)*
     &    rzm2**2*b0fusww - 24.D0/(t + s)*rzm2 + 12.D0/(t + s)*rzm2*
     &    b0fmzww - 12.D0/(t + s)*rzm2*b0fusww - 8.D0/(t + s)*rzm2**2*
     &    c0cmzuswww + 48.D0/(t + s)*rwm2*rzm2*c0cmzuswww - 2.D0/(t + s
     &    )*u*rwm2**(-1)*rzm2 + 12.D0/(t + s)*u + 4.D0/(t + s)*u*rzm2*
     &    c0cmzuswww - 24.D0/(t + s)*u*rwm2*c0cmzuswww + 6.D0/(t + s)/(
     &    t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 6.D0/(t + s)/(t
     &     + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fusww - 36.D0/(t + s)/(t
     &     + s)*s**(-1)*rzm2**3*b0fmzww + 36.D0/(t + s)/(t + s)*s**(-1)
     &    *rzm2**3*b0fusww - 6.D0/(t + s)/(t + s)*s**(-1)*u*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 6.D0/(t + s)/(t + s)*s**(-1)*u*rwm2**(-1)*
     &    rzm2**3*b0fusww + 36.D0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*
     &    b0fmzww - 36.D0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*b0fusww + 2.
     &    D0/(t + s)/(t + s)*s**(-1)*u**2*rwm2**(-1)*rzm2**2*b0fmzww - 
     &    2.D0/(t + s)/(t + s)*s**(-1)*u**2*rwm2**(-1)*rzm2**2*b0fusww
     &     - 12.D0/(t + s)/(t + s)*s**(-1)*u**2*rzm2*b0fmzww + 12.D0/(t
     &     + s)/(t + s)*s**(-1)*u**2*rzm2*b0fusww + 4.D0/(t + s)/(t + s
     &    )*rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(t + s)/(t + s)*
     &    rwm2**(-1)*rzm2**3*b0fusww - 24.D0/(t + s)/(t + s)*rzm2**2*
     &    b0fmzww + 24.D0/(t + s)/(t + s)*rzm2**2*b0fusww - 2.D0/(t + s
     &    )/(t + s)*u*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(t + s)/(t + s)
     &    *u*rwm2**(-1)*rzm2**2*b0fusww + 12.D0/(t + s)/(t + s)*u*rzm2*
     &    b0fmzww - 12.D0/(t + s)/(t + s)*u*rzm2*b0fusww

      ewamp(1,1,1,2) =
     &  + 4.D0*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 4.D0*
     &    s**(-2)*t**(-1)*rwm2**(-1)*rzm2**4*b0fusww - 24.D0*s**(-2)*
     &    t**(-1)*rzm2**3*b0fmzww + 24.D0*s**(-2)*t**(-1)*rzm2**3*
     &    b0fusww - 2.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2**3*b0fmzww
     &     + 2.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2**3*b0fusww + 12.D0*
     &    s**(-2)*t**(-1)*u*rzm2**2*b0fmzww - 12.D0*s**(-2)*t**(-1)*u*
     &    rzm2**2*b0fusww - 2.D0*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 2.D0*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*b0ftsww + 
     &    12.D0*s**(-2)*u**(-1)*rzm2**3*b0fmzww - 12.D0*s**(-2)*u**(-1)
     &    *rzm2**3*b0ftsww + 4.D0*s**(-2)*t*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 4.D0*s**(-2)*t*u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww
     &     - 24.D0*s**(-2)*t*u**(-1)*rzm2**2*b0fmzww + 24.D0*s**(-2)*t*
     &    u**(-1)*rzm2**2*b0ftsww + 2.D0*s**(-2)*t*rwm2**(-1)*rzm2**3*
     &    c0cmztswww - 2.D0*s**(-2)*t*rwm2**(-1)*rzm2**3*c0ccuswww - 12.
     &    D0*s**(-2)*t*rzm2**2*c0cmztswww + 12.D0*s**(-2)*t*rzm2**2*
     &    c0ccuswww - 2.D0*s**(-2)*t**2*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww + 2.D0*s**(-2)*t**2*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0ftsww + 12.D0*s**(-2)*t**2*u**(-1)*rzm2*b0fmzww - 12.D0*
     &    s**(-2)*t**2*u**(-1)*rzm2*b0ftsww + 2.D0*s**(-2)*t**2*
     &    rwm2**(-1)*rzm2**2*c0cmzuswww - 4.D0*s**(-2)*t**2*rwm2**(-1)*
     &    rzm2**2*c0cmztswww + 4.D0*s**(-2)*t**2*rwm2**(-1)*rzm2**2*
     &    c0ccuswww - 2.D0*s**(-2)*t**2*rwm2**(-1)*rzm2**2*c0cctswww - 
     &    2.D0*s**(-2)*t**2*rwm2**(-1)*rzm2**3*d0cccmztsuswwww - 12.D0*
     &    s**(-2)*t**2*rzm2*c0cmzuswww + 24.D0*s**(-2)*t**2*rzm2*
     &    c0cmztswww - 24.D0*s**(-2)*t**2*rzm2*c0ccuswww + 12.D0*
     &    s**(-2)*t**2*rzm2*c0cctswww + 12.D0*s**(-2)*t**2*rzm2**2*
     &    d0cccmztsuswwww - 2.D0*s**(-2)*t**3*rwm2**(-1)*rzm2*
     &    c0cmzuswww + 2.D0*s**(-2)*t**3*rwm2**(-1)*rzm2*c0cmztswww - 2.
     &    D0*s**(-2)*t**3*rwm2**(-1)*rzm2*c0ccuswww + 2.D0*s**(-2)*t**3
     &    *rwm2**(-1)*rzm2*c0cctswww + 4.D0*s**(-2)*t**3*rwm2**(-1)*
     &    rzm2**2*d0cccmztsuswwww + 12.D0*s**(-2)*t**3*c0cmzuswww - 12.D
     &    0*s**(-2)*t**3*c0cmztswww + 12.D0*s**(-2)*t**3*c0ccuswww - 12.
     &    D0*s**(-2)*t**3*c0cctswww - 24.D0*s**(-2)*t**3*rzm2*
     &    d0cccmztsuswwww - 2.D0*s**(-2)*t**4*rwm2**(-1)*rzm2*
     &    d0cccmztsuswwww + 12.D0*s**(-2)*t**4*d0cccmztsuswwww + 4.D0*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3 - 4.D0*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 4.D0*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fusww - 24.D0*s**(-1)*t**(-1)*rzm2**2 + 24.D0*
     &    s**(-1)*t**(-1)*rzm2**2*b0fmzww - 24.D0*s**(-1)*t**(-1)*
     &    rzm2**2*b0fusww - 8.D0*s**(-1)*t**(-1)*rzm2**3*c0cmzuswww + 
     &    48.D0*s**(-1)*t**(-1)*rwm2*rzm2**2*c0cmzuswww - 2.D0*s**(-1)*
     &    t**(-1)*u*rwm2**(-1)*rzm2**2 + 2.D0*s**(-1)*t**(-1)*u*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*s**(-1)*t**(-1)*u*
     &    rwm2**(-1)*rzm2**2*b0fusww + 12.D0*s**(-1)*t**(-1)*u*rzm2 - 
     &    12.D0*s**(-1)*t**(-1)*u*rzm2*b0fmzww + 12.D0*s**(-1)*t**(-1)*
     &    u*rzm2*b0fusww + 4.D0*s**(-1)*t**(-1)*u*rzm2**2*c0cmzuswww - 
     &    24.D0*s**(-1)*t**(-1)*u*rwm2*rzm2*c0cmzuswww - 2.D0*s**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3 + 12.D0*s**(-1)*u**(-1)*rzm2**2 + 
     &    4.D0*s**(-1)*u**(-1)*rzm2**3*c0cmztswww - 24.D0*s**(-1)*
     &    u**(-1)*rwm2*rzm2**2*c0cmztswww - 4.D0*s**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 4.D0*s**(-1)*rwm2**(-1)*rzm2**2*b0fusww + 
     &    24.D0*s**(-1)*rzm2*b0fmzww - 24.D0*s**(-1)*rzm2*b0fusww + 4.D0
     &    *s**(-1)*rzm2**2*c0cmztswww - 4.D0*s**(-1)*rzm2**2*c0ccuswww
     &     - 24.D0*s**(-1)*rwm2*rzm2*c0cmztswww + 24.D0*s**(-1)*rwm2*
     &    rzm2*c0ccuswww + 4.D0*s**(-1)*t*u**(-1)*rwm2**(-1)*rzm2**2 - 
     &    24.D0*s**(-1)*t*u**(-1)*rzm2 - 8.D0*s**(-1)*t*u**(-1)*rzm2**2
     &    *c0cmztswww + 48.D0*s**(-1)*t*u**(-1)*rwm2*rzm2*c0cmztswww - 
     &    4.D0*s**(-1)*t*rwm2**(-1)*rzm2*b0fusww + 4.D0*s**(-1)*t*
     &    rwm2**(-1)*rzm2*b0ftsww + 2.D0*s**(-1)*t*rwm2**(-1)*rzm2**2*
     &    c0cmzuswww - 2.D0*s**(-1)*t*rwm2**(-1)*rzm2**2*c0cmztswww + 4.
     &    D0*s**(-1)*t*rwm2**(-1)*rzm2**2*c0ccuswww + 24.D0*s**(-1)*t*
     &    b0fusww - 24.D0*s**(-1)*t*b0ftsww - 8.D0*s**(-1)*t*rzm2*
     &    c0cmzuswww + 8.D0*s**(-1)*t*rzm2*c0cmztswww - 20.D0*s**(-1)*t
     &    *rzm2*c0ccuswww - 4.D0*s**(-1)*t*rzm2*c0cctswww - 8.D0*
     &    s**(-1)*t*rzm2**2*d0cccmztsuswwww - 24.D0*s**(-1)*t*rwm2*
     &    c0cmzuswww + 24.D0*s**(-1)*t*rwm2*c0cmztswww - 24.D0*s**(-1)*
     &    t*rwm2*c0ccuswww + 24.D0*s**(-1)*t*rwm2*c0cctswww + 48.D0*
     &    s**(-1)*t*rwm2*rzm2*d0cccmztsuswwww - 2.D0*s**(-1)*t**2*
     &    u**(-1)*rwm2**(-1)*rzm2 + 12.D0*s**(-1)*t**2*u**(-1) + 4.D0*
     &    s**(-1)*t**2*u**(-1)*rzm2*c0cmztswww - 24.D0*s**(-1)*t**2*
     &    u**(-1)*rwm2*c0cmztswww - 4.D0*s**(-1)*t**2*rwm2**(-1)*rzm2*
     &    c0cmzuswww + 2.D0*s**(-1)*t**2*rwm2**(-1)*rzm2*c0cmztswww - 4.
     &    D0*s**(-1)*t**2*rwm2**(-1)*rzm2*c0ccuswww + 2.D0*s**(-1)*t**2
     &    *rwm2**(-1)*rzm2*c0cctswww + 4.D0*s**(-1)*t**2*rwm2**(-1)*
     &    rzm2**2*d0cccmztsuswwww + 24.D0*s**(-1)*t**2*c0cmzuswww - 12.D
     &    0*s**(-1)*t**2*c0cmztswww + 24.D0*s**(-1)*t**2*c0ccuswww - 12.
     &    D0*s**(-1)*t**2*c0cctswww - 16.D0*s**(-1)*t**2*rzm2*
     &    d0cccmztsuswwww - 48.D0*s**(-1)*t**2*rwm2*d0cccmztsuswwww - 4.
     &    D0*s**(-1)*t**3*rwm2**(-1)*rzm2*d0cccmztsuswwww + 24.D0*
     &    s**(-1)*t**3*d0cccmztsuswwww - 2.D0*t**(-1)*rwm2**(-1)*
     &    rzm2**2 + 2.D0*t**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*
     &    t**(-1)*rwm2**(-1)*rzm2**2*b0fusww + 12.D0*t**(-1)*rzm2 - 12.D
     &    0*t**(-1)*rzm2*b0fmzww + 12.D0*t**(-1)*rzm2*b0fusww + 6.D0*
     &    t**(-1)*rzm2**2*c0cmzuswww - 2.D0*t**(-1)*rzm2**2*c0ccqswww
     &     - 36.D0*t**(-1)*rwm2*rzm2*c0cmzuswww + 12.D0*t**(-1)*rwm2*
     &    rzm2*c0ccqswww - 2.D0*t**(-1)*u*rzm2*c0cmzuswww + 2.D0*
     &    t**(-1)*u*rzm2*c0cmzqswww - 2.D0*t**(-1)*u*rzm2*c0ccuswww + 2.
     &    D0*t**(-1)*u*rzm2*c0ccqswww - 2.D0*t**(-1)*u*rzm2**2*
     &    d0ccmzcqsuswwww + 12.D0*t**(-1)*u*rwm2*c0cmzuswww - 12.D0*
     &    t**(-1)*u*rwm2*c0cmzqswww + 12.D0*t**(-1)*u*rwm2*c0ccuswww - 
     &    12.D0*t**(-1)*u*rwm2*c0ccqswww + 12.D0*t**(-1)*u*rwm2*rzm2*
     &    d0ccmzcqsuswwww + 2.D0*t**(-1)*u**2*rzm2*d0ccmzcqsuswwww - 12.
     &    D0*t**(-1)*u**2*rwm2*d0ccmzcqsuswwww + 2.D0*u**(-1)*
     &    rwm2**(-1)*rzm2**2 + 2.D0*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww
     &     - 2.D0*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0*u**(-1)*
     &    rzm2 - 12.D0*u**(-1)*rzm2*b0fmzww + 12.D0*u**(-1)*rzm2*
     &    b0ftsww - 2.D0*u**(-1)*rzm2**2*c0cmztswww - 2.D0*u**(-1)*
     &    rzm2**2*c0ccqswww + 12.D0*u**(-1)*rwm2*rzm2*c0cmztswww + 12.D0
     &    *u**(-1)*rwm2*rzm2*c0ccqswww - 2.D0*rzm2*c0cmzuswww + 4.D0*
     &    rzm2*c0cmzqswww + 2.D0*rzm2*c0ccuswww + 12.D0*rwm2*c0cmzuswww
     &     - 24.D0*rwm2*c0cmzqswww - 12.D0*rwm2*c0ccuswww - 4.D0*rwm2*
     &    rzm2*d0cccmztsuswwww - 4.D0*rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*
     &    rwm2*rzm2*d0cccmzqstswwww + 24.D0*rwm2**2*d0cccmztsuswwww + 
     &    24.D0*rwm2**2*d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww
     &     + 2.D0*u*rzm2*d0ccmzcqsuswwww - 12.D0*u*rwm2*d0ccmzcqsuswwww
     &     - 2.D0*t*u**(-1)*rwm2**(-1)*rzm2 + 12.D0*t*u**(-1) + 2.D0*t*
     &    u**(-1)*rzm2*c0cmztswww + 2.D0*t*u**(-1)*rzm2*c0cmzqswww - 2.D
     &    0*t*u**(-1)*rzm2*c0cctswww + 2.D0*t*u**(-1)*rzm2*c0ccqswww - 
     &    2.D0*t*u**(-1)*rzm2**2*d0cccmzqstswwww - 12.D0*t*u**(-1)*rwm2
     &    *c0cmztswww - 12.D0*t*u**(-1)*rwm2*c0cmzqswww + 12.D0*t*
     &    u**(-1)*rwm2*c0cctswww - 12.D0*t*u**(-1)*rwm2*c0ccqswww + 12.D
     &    0*t*u**(-1)*rwm2*rzm2*d0cccmzqstswwww + 2.D0*t*rzm2*
     &    d0cccmztsuswwww + 2.D0*t*rzm2*d0cccmzqstswwww - 12.D0*t*rwm2*
     &    d0cccmztsuswwww - 12.D0*t*rwm2*d0cccmzqstswwww + 2.D0*t**2*
     &    u**(-1)*rzm2*d0cccmzqstswwww - 12.D0*t**2*u**(-1)*rwm2*
     &    d0cccmzqstswwww - 2.D0/(u + t)*s**(-2)*t**(-1)*rwm2**(-1)*
     &    rzm2**5*b0fmzww + 2.D0/(u + t)*s**(-2)*t**(-1)*rwm2**(-1)*
     &    rzm2**5*b0fusww + 12.D0/(u + t)*s**(-2)*t**(-1)*rzm2**4*
     &    b0fmzww - 12.D0/(u + t)*s**(-2)*t**(-1)*rzm2**4*b0fusww - 2.D0
     &    /(u + t)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4 + 2.D0/(u + t)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 2.D0/(u + t)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 12.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**3 - 12.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2**3*b0fmzww + 12.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*
     &    b0fusww + 4.D0/(u + t)*s**(-1)*t**(-1)*rzm2**4*c0cmzuswww - 
     &    24.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2**3*c0cmzuswww + 2.D0
     &    /(u + t)*s**(-1)*t*rwm2**(-1)*rzm2**3*c0cmztswww - 2.D0/(u + 
     &    t)*s**(-1)*t*rwm2**(-1)*rzm2**3*c0ccuswww - 12.D0/(u + t)*
     &    s**(-1)*t*rzm2**2*c0cmztswww + 12.D0/(u + t)*s**(-1)*t*
     &    rzm2**2*c0ccuswww + 2.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    rzm2**2*c0cmzuswww - 4.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    rzm2**2*c0cmztswww + 4.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    rzm2**2*c0ccuswww - 2.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    rzm2**2*c0cctswww - 2.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    rzm2**3*d0cccmztsuswwww - 12.D0/(u + t)*s**(-1)*t**2*rzm2*
     &    c0cmzuswww + 24.D0/(u + t)*s**(-1)*t**2*rzm2*c0cmztswww - 24.D
     &    0/(u + t)*s**(-1)*t**2*rzm2*c0ccuswww + 12.D0/(u + t)*s**(-1)
     &    *t**2*rzm2*c0cctswww + 12.D0/(u + t)*s**(-1)*t**2*rzm2**2*
     &    d0cccmztsuswwww - 2.D0/(u + t)*s**(-1)*t**3*rwm2**(-1)*rzm2*
     &    c0cmzuswww + 2.D0/(u + t)*s**(-1)*t**3*rwm2**(-1)*rzm2*
     &    c0cmztswww - 2.D0/(u + t)*s**(-1)*t**3*rwm2**(-1)*rzm2*
     &    c0ccuswww + 2.D0/(u + t)*s**(-1)*t**3*rwm2**(-1)*rzm2*
     &    c0cctswww + 4.D0/(u + t)*s**(-1)*t**3*rwm2**(-1)*rzm2**2*
     &    d0cccmztsuswwww + 12.D0/(u + t)*s**(-1)*t**3*c0cmzuswww - 12.D
     &    0/(u + t)*s**(-1)*t**3*c0cmztswww + 12.D0/(u + t)*s**(-1)*
     &    t**3*c0ccuswww - 12.D0/(u + t)*s**(-1)*t**3*c0cctswww - 24.D0
     &    /(u + t)*s**(-1)*t**3*rzm2*d0cccmztsuswwww - 2.D0/(u + t)*
     &    s**(-1)*t**4*rwm2**(-1)*rzm2*d0cccmztsuswwww + 12.D0/(u + t)*
     &    s**(-1)*t**4*d0cccmztsuswwww + 2.D0/(u + t)*t**(-1)*
     &    rwm2**(-1)*rzm2**3 - 12.D0/(u + t)*t**(-1)*rzm2**2 - 4.D0/(u
     &     + t)*t**(-1)*rzm2**3*c0cmzuswww + 24.D0/(u + t)*t**(-1)*rwm2
     &    *rzm2**2*c0cmzuswww - 4.D0/(u + t)*rwm2**(-1)*rzm2**2 - 4.D0
     &    /(u + t)*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + t)*rwm2**(-1)
     &    *rzm2**2*b0fusww + 2.D0/(u + t)*rwm2**(-1)*rzm2**2*b0ftsww + 
     &    24.D0/(u + t)*rzm2 + 24.D0/(u + t)*rzm2*b0fmzww - 12.D0/(u + 
     &    t)*rzm2*b0fusww - 12.D0/(u + t)*rzm2*b0ftsww + 2.D0/(u + t)*
     &    rzm2**2*c0cmzuswww + 2.D0/(u + t)*rzm2**2*c0cmztswww + 4.D0/(
     &    u + t)*rzm2**2*c0ccqswww - 12.D0/(u + t)*rwm2*rzm2*c0cmzuswww
     &     - 12.D0/(u + t)*rwm2*rzm2*c0cmztswww - 24.D0/(u + t)*rwm2*
     &    rzm2*c0ccqswww - 4.D0/(u + t)*t*rwm2**(-1)*rzm2*b0fusww + 4.D0
     &    /(u + t)*t*rwm2**(-1)*rzm2*b0ftsww - 2.D0/(u + t)*t*
     &    rwm2**(-1)*rzm2**2*c0cmztswww + 2.D0/(u + t)*t*rwm2**(-1)*
     &    rzm2**2*c0ccuswww + 24.D0/(u + t)*t*b0fusww - 24.D0/(u + t)*t
     &    *b0ftsww + 2.D0/(u + t)*t*rzm2*c0cmzuswww + 10.D0/(u + t)*t*
     &    rzm2*c0cmztswww - 10.D0/(u + t)*t*rzm2*c0ccuswww - 2.D0/(u + 
     &    t)*t*rzm2*c0cctswww - 12.D0/(u + t)*t*rwm2*c0cmzuswww + 12.D0
     &    /(u + t)*t*rwm2*c0cmztswww - 12.D0/(u + t)*t*rwm2*c0ccuswww
     &     + 12.D0/(u + t)*t*rwm2*c0cctswww - 4.D0/(u + t)*t**2*
     &    rwm2**(-1)*rzm2*c0cmzuswww + 2.D0/(u + t)*t**2*rwm2**(-1)*
     &    rzm2*c0cmztswww
      ewamp(1,1,1,2) = ewamp(1,1,1,2) - 4.D0/(u + t)*t**2*
     & rwm2**(-1)*rzm2*c0ccuswww + 2.D0/(u + t)*t**2*rwm2**(-1)*rzm2*
     &    c0cctswww + 2.D0/(u + t)*t**2*rwm2**(-1)*rzm2**2*
     &    d0cccmztsuswwww + 24.D0/(u + t)*t**2*c0cmzuswww - 12.D0/(u + 
     &    t)*t**2*c0cmztswww + 24.D0/(u + t)*t**2*c0ccuswww - 12.D0/(u
     &     + t)*t**2*c0cctswww - 6.D0/(u + t)*t**2*rzm2*d0cccmztsuswwww
     &     - 36.D0/(u + t)*t**2*rwm2*d0cccmztsuswwww - 4.D0/(u + t)*
     &    t**3*rwm2**(-1)*rzm2*d0cccmztsuswwww + 24.D0/(u + t)*t**3*
     &    d0cccmztsuswwww + 2.D0/(u + t)/(u + s)*rwm2**(-1)*rzm2**3 - 
     &    12.D0/(u + t)/(u + s)*rzm2**2 - 4.D0/(u + t)/(u + s)*rzm2**3*
     &    c0cmztswww + 24.D0/(u + t)/(u + s)*rwm2*rzm2**2*c0cmztswww + 
     &    2.D0/(u + t)/(u + s)/(u + s)*rwm2**(-1)*rzm2**4*b0fmzww - 2.D0
     &    /(u + t)/(u + s)/(u + s)*rwm2**(-1)*rzm2**4*b0ftsww - 12.D0/(
     &    u + t)/(u + s)/(u + s)*rzm2**3*b0fmzww + 12.D0/(u + t)/(u + s
     &    )/(u + s)*rzm2**3*b0ftsww + 2.D0/(u + t)/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**5*b0fmzww - 2.D0/(u + t)/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**5*b0fusww - 12.D0/(u + t)/(t + s)*s**(-2)*
     &    rzm2**4*b0fmzww + 12.D0/(u + t)/(t + s)*s**(-2)*rzm2**4*
     &    b0fusww + 2.D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4 - 2.
     &    D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 2.D0
     &    /(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fusww - 12.D0/(
     &    u + t)/(t + s)*s**(-1)*rzm2**3 + 12.D0/(u + t)/(t + s)*
     &    s**(-1)*rzm2**3*b0fmzww - 12.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**3*b0fusww - 4.D0/(u + t)/(t + s)*s**(-1)*rzm2**4*
     &    c0cmzuswww + 24.D0/(u + t)/(t + s)*s**(-1)*rwm2*rzm2**3*
     &    c0cmzuswww + 2.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**5*b0fmzww - 2.D0/(u + t)/(t + s)/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**5*b0fusww - 12.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-1)*rzm2**4*b0fmzww + 12.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-1)*rzm2**4*b0fusww + 2.D0/(u + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**4*b0fmzww - 2.D0/(u + s)*s**(-2)*rwm2**(-1)*rzm2**4*
     &    b0ftsww - 12.D0/(u + s)*s**(-2)*rzm2**3*b0fmzww + 12.D0/(u + 
     &    s)*s**(-2)*rzm2**3*b0ftsww - 4.D0/(u + s)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(u + s)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*b0ftsww + 24.D0/(u + s)*s**(-2)*t*rzm2**2*
     &    b0fmzww - 24.D0/(u + s)*s**(-2)*t*rzm2**2*b0ftsww + 2.D0/(u
     &     + s)*s**(-2)*t**2*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u + s)*
     &    s**(-2)*t**2*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0/(u + s)*
     &    s**(-2)*t**2*rzm2*b0fmzww + 12.D0/(u + s)*s**(-2)*t**2*rzm2*
     &    b0ftsww + 2.D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2**3 - 12.D0/(u
     &     + s)*s**(-1)*rzm2**2 - 4.D0/(u + s)*s**(-1)*rzm2**3*
     &    c0cmztswww + 24.D0/(u + s)*s**(-1)*rwm2*rzm2**2*c0cmztswww - 
     &    4.D0/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2**2 + 24.D0/(u + s)*
     &    s**(-1)*t*rzm2 + 8.D0/(u + s)*s**(-1)*t*rzm2**2*c0cmztswww - 
     &    48.D0/(u + s)*s**(-1)*t*rwm2*rzm2*c0cmztswww + 2.D0/(u + s)*
     &    s**(-1)*t**2*rwm2**(-1)*rzm2 - 12.D0/(u + s)*s**(-1)*t**2 - 4.
     &    D0/(u + s)*s**(-1)*t**2*rzm2*c0cmztswww + 24.D0/(u + s)*
     &    s**(-1)*t**2*rwm2*c0cmztswww - 2.D0/(u + s)*t*rwm2**(-1)*rzm2
     &     + 12.D0/(u + s)*t + 4.D0/(u + s)*t*rzm2*c0cmztswww - 24.D0/(
     &    u + s)*t*rwm2*c0cmztswww + 2.D0/(u + s)/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**4*b0fmzww - 2.D0/(u + s)/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**4*b0ftsww - 12.D0/(u + s)/(u + s)*s**(-1)*
     &    rzm2**3*b0fmzww + 12.D0/(u + s)/(u + s)*s**(-1)*rzm2**3*
     &    b0ftsww - 4.D0/(u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2**3*
     &    b0fmzww + 4.D0/(u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2**3*
     &    b0ftsww + 24.D0/(u + s)/(u + s)*s**(-1)*t*rzm2**2*b0fmzww - 
     &    24.D0/(u + s)/(u + s)*s**(-1)*t*rzm2**2*b0ftsww + 2.D0/(u + s
     &    )/(u + s)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u
     &     + s)/(u + s)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0
     &    /(u + s)/(u + s)*s**(-1)*t**2*rzm2*b0fmzww + 12.D0/(u + s)/(u
     &     + s)*s**(-1)*t**2*rzm2*b0ftsww - 2.D0/(u + s)/(u + s)*t*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)/(u + s)*t*
     &    rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + s)/(u + s)*t*rzm2*
     &    b0fmzww - 12.D0/(u + s)/(u + s)*t*rzm2*b0ftsww - 4.D0/(t + s)
     &    *s**(-2)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D0/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**4*b0fusww + 24.D0/(t + s)*s**(-2)*rzm2**3*
     &    b0fmzww - 24.D0/(t + s)*s**(-2)*rzm2**3*b0fusww + 2.D0/(t + s
     &    )*s**(-2)*u*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0/(t + s)*s**(-2)
     &    *u*rwm2**(-1)*rzm2**3*b0fusww - 12.D0/(t + s)*s**(-2)*u*
     &    rzm2**2*b0fmzww + 12.D0/(t + s)*s**(-2)*u*rzm2**2*b0fusww - 4.
     &    D0/(t + s)*s**(-1)*rwm2**(-1)*rzm2**3 + 4.D0/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fusww + 24.D0/(t + s)*s**(-1)*rzm2**2 - 24.D0/(t + 
     &    s)*s**(-1)*rzm2**2*b0fmzww + 24.D0/(t + s)*s**(-1)*rzm2**2*
     &    b0fusww + 8.D0/(t + s)*s**(-1)*rzm2**3*c0cmzuswww - 48.D0/(t
     &     + s)*s**(-1)*rwm2*rzm2**2*c0cmzuswww + 2.D0/(t + s)*s**(-1)*
     &    u*rwm2**(-1)*rzm2**2 - 2.D0/(t + s)*s**(-1)*u*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 2.D0/(t + s)*s**(-1)*u*rwm2**(-1)*rzm2**2*
     &    b0fusww - 12.D0/(t + s)*s**(-1)*u*rzm2 + 12.D0/(t + s)*
     &    s**(-1)*u*rzm2*b0fmzww - 12.D0/(t + s)*s**(-1)*u*rzm2*b0fusww
     &     - 4.D0/(t + s)*s**(-1)*u*rzm2**2*c0cmzuswww + 24.D0/(t + s)*
     &    s**(-1)*u*rwm2*rzm2*c0cmzuswww - 2.D0/(t + s)*rwm2**(-1)*
     &    rzm2**2 + 2.D0/(t + s)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(t
     &     + s)*rwm2**(-1)*rzm2**2*b0fusww + 12.D0/(t + s)*rzm2 - 12.D0
     &    /(t + s)*rzm2*b0fmzww + 12.D0/(t + s)*rzm2*b0fusww + 4.D0/(t
     &     + s)*rzm2**2*c0cmzuswww - 24.D0/(t + s)*rwm2*rzm2*c0cmzuswww
     &     - 4.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 
     &    4.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 24.D
     &    0/(t + s)/(t + s)*s**(-1)*rzm2**3*b0fmzww - 24.D0/(t + s)/(t
     &     + s)*s**(-1)*rzm2**3*b0fusww + 2.D0/(t + s)/(t + s)*s**(-1)*
     &    u*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0/(t + s)/(t + s)*s**(-1)*u
     &    *rwm2**(-1)*rzm2**3*b0fusww - 12.D0/(t + s)/(t + s)*s**(-1)*u
     &    *rzm2**2*b0fmzww + 12.D0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*
     &    b0fusww - 2.D0/(t + s)/(t + s)*rwm2**(-1)*rzm2**3*b0fmzww + 2.
     &    D0/(t + s)/(t + s)*rwm2**(-1)*rzm2**3*b0fusww + 12.D0/(t + s)
     &    /(t + s)*rzm2**2*b0fmzww - 12.D0/(t + s)/(t + s)*rzm2**2*
     &    b0fusww

      ewamp(1,1,1,3) =
     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz**(-1) * (  - 12.D0*s**(-2)*
     &    t**2*u**(-1) + 24.D0*s**(-2)*t**2*u**(-1)*rwm2*c0cmztswww - 
     &    12.D0*s**(-1)*t**(-1)*u + 24.D0*s**(-1)*t**(-1)*u*rwm2*
     &    c0cmzuswww - 24.D0*s**(-1)*rwm2*c0cmzuswww + 24.D0*s**(-1)*
     &    rwm2*c0cmztswww - 24.D0*s**(-1)*rwm2*c0ccuswww + 24.D0*
     &    s**(-1)*rwm2*c0cctswww + 12.D0*s**(-1)*t*u**(-1) - 24.D0*
     &    s**(-1)*t*u**(-1)*rwm2*c0cmztswww - 24.D0*s**(-1)*t*rwm2*
     &    d0cccmztsuswwww + 12.D0*s**(-1)*t**2*u**(-2) - 24.D0*s**(-1)*
     &    t**2*u**(-2)*rwm2*c0cmztswww - 12.D0*t**(-1) + 24.D0*t**(-1)*
     &    rwm2*c0cmzuswww + 24.D0*u**(-1)*rwm2*c0cmzuswww - 24.D0*
     &    u**(-1)*rwm2*c0cmztswww + 12.D0*t*u**(-2) - 24.D0*t*u**(-2)*
     &    rwm2*c0cmztswww - 24.D0/(u + t)*rwm2*c0cmzuswww + 24.D0/(u + 
     &    t)*rwm2*c0cmztswww - 24.D0/(u + t)*rwm2*c0ccuswww + 24.D0/(u
     &     + t)*rwm2*c0cctswww - 24.D0/(u + t)*t*rwm2*d0cccmztsuswwww
     &     + 12.D0/(u + s)*s**(-2)*t**2 - 24.D0/(u + s)*s**(-2)*t**2*
     &    rwm2*c0cmztswww - 12.D0/(u + s)*s**(-1)*t + 24.D0/(u + s)*
     &    s**(-1)*t*rwm2*c0cmztswww - 12.D0/(t + s) + 12.D0/(t + s)*
     &    s**(-1)*u - 24.D0/(t + s)*s**(-1)*u*rwm2*c0cmzuswww + 24.D0/(
     &    t + s)*rwm2*c0cmzuswww )
      ewamp(1,1,1,3) = ewamp(1,1,1,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * ( 4.D0*s**(-3)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*b0fmzww
     &     - 4.D0*s**(-3)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*b0fusww - 
     &    24.D0*s**(-3)*t**(-1)*u**(-1)*rzm2**3*b0fmzww + 24.D0*s**(-3)
     &    *t**(-1)*u**(-1)*rzm2**3*b0fusww + 8.D0*s**(-3)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 8.D0*s**(-3)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fusww - 48.D0*s**(-3)*t**(-1)*rzm2**2*b0fmzww + 48.D
     &    0*s**(-3)*t**(-1)*rzm2**2*b0fusww - 4.D0*s**(-3)*t**(-1)*u*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 4.D0*s**(-3)*t**(-1)*u*
     &    rwm2**(-1)*rzm2**2*b0fusww + 24.D0*s**(-3)*t**(-1)*u*rzm2*
     &    b0fmzww - 24.D0*s**(-3)*t**(-1)*u*rzm2*b0fusww + 4.D0*s**(-3)
     &    *u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 4.D0*s**(-3)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 24.D0*s**(-3)*u**(-1)*rzm2**2*
     &    b0fmzww + 24.D0*s**(-3)*u**(-1)*rzm2**2*b0ftsww - 8.D0*
     &    s**(-3)*t*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww + 8.D0*s**(-3)*t
     &    *u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww + 48.D0*s**(-3)*t*u**(-1)
     &    *rzm2*b0fmzww - 48.D0*s**(-3)*t*u**(-1)*rzm2*b0ftsww + 4.D0*
     &    s**(-3)*t**2*u**(-1)*rwm2**(-1)*rzm2*b0fmzww - 4.D0*s**(-3)*
     &    t**2*u**(-1)*rwm2**(-1)*rzm2*b0ftsww - 24.D0*s**(-3)*t**2*
     &    u**(-1)*b0fmzww + 24.D0*s**(-3)*t**2*u**(-1)*b0ftsww - 2.D0*
     &    s**(-2)*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 2.D0*
     &    s**(-2)*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 12.D0*
     &    s**(-2)*t**(-2)*u**(-1)*rzm2**3*b0fmzww - 12.D0*s**(-2)*
     &    t**(-2)*u**(-1)*rzm2**3*b0fusww - 4.D0*s**(-2)*t**(-2)*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 4.D0*s**(-2)*t**(-2)*rwm2**(-1)*
     &    rzm2**3*b0fusww + 24.D0*s**(-2)*t**(-2)*rzm2**2*b0fmzww - 24.D
     &    0*s**(-2)*t**(-2)*rzm2**2*b0fusww + 2.D0*s**(-2)*t**(-2)*u*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*s**(-2)*t**(-2)*u*
     &    rwm2**(-1)*rzm2**2*b0fusww - 12.D0*s**(-2)*t**(-2)*u*rzm2*
     &    b0fmzww + 12.D0*s**(-2)*t**(-2)*u*rzm2*b0fusww + 2.D0*s**(-2)
     &    *t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3 + 6.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0fusww - 4.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww - 12.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rzm2**2 - 36.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*
     &    b0fmzww + 12.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*b0fusww + 24.D
     &    0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*b0ftsww - 4.D0*s**(-2)*
     &    t**(-1)*u**(-1)*rzm2**3*c0cmzuswww + 24.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rwm2*rzm2**2*c0cmzuswww + 4.D0*s**(-2)*t**(-1)*
     &    rwm2**(-1)*rzm2**2 - 4.D0*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww + 4.D0*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**2*b0fusww - 
     &    24.D0*s**(-2)*t**(-1)*rzm2 + 24.D0*s**(-2)*t**(-1)*rzm2*
     &    b0fmzww - 24.D0*s**(-2)*t**(-1)*rzm2*b0fusww - 8.D0*s**(-2)*
     &    t**(-1)*rzm2**2*c0cmzuswww + 48.D0*s**(-2)*t**(-1)*rwm2*rzm2*
     &    c0cmzuswww - 2.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2 + 2.D0*
     &    s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2*b0fmzww - 2.D0*s**(-2)*
     &    t**(-1)*u*rwm2**(-1)*rzm2*b0fusww + 12.D0*s**(-2)*t**(-1)*u
     &     - 12.D0*s**(-2)*t**(-1)*u*b0fmzww + 12.D0*s**(-2)*t**(-1)*u*
     &    b0fusww + 4.D0*s**(-2)*t**(-1)*u*rzm2*c0cmzuswww - 24.D0*
     &    s**(-2)*t**(-1)*u*rwm2*c0cmzuswww - 2.D0*s**(-2)*u**(-2)*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 2.D0*s**(-2)*u**(-2)*rwm2**(-1)*
     &    rzm2**3*b0ftsww + 12.D0*s**(-2)*u**(-2)*rzm2**2*b0fmzww - 12.D
     &    0*s**(-2)*u**(-2)*rzm2**2*b0ftsww + 2.D0*s**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**2 - 4.D0*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww + 4.D0*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 
     &    12.D0*s**(-2)*u**(-1)*rzm2 + 24.D0*s**(-2)*u**(-1)*rzm2*
     &    b0fmzww - 24.D0*s**(-2)*u**(-1)*rzm2*b0ftsww - 4.D0*s**(-2)*
     &    u**(-1)*rzm2**2*c0cmztswww + 24.D0*s**(-2)*u**(-1)*rwm2*rzm2*
     &    c0cmztswww + 2.D0*s**(-2)*rwm2**(-1)*rzm2**2*c0cmztswww - 2.D0
     &    *s**(-2)*rwm2**(-1)*rzm2**2*c0ccuswww - 12.D0*s**(-2)*rzm2*
     &    c0cmztswww + 12.D0*s**(-2)*rzm2*c0ccuswww + 4.D0*s**(-2)*t*
     &    u**(-2)*rwm2**(-1)*rzm2**2*b0fmzww - 4.D0*s**(-2)*t*u**(-2)*
     &    rwm2**(-1)*rzm2**2*b0ftsww - 24.D0*s**(-2)*t*u**(-2)*rzm2*
     &    b0fmzww + 24.D0*s**(-2)*t*u**(-2)*rzm2*b0ftsww - 4.D0*s**(-2)
     &    *t*u**(-1)*rwm2**(-1)*rzm2 + 24.D0*s**(-2)*t*u**(-1) + 8.D0*
     &    s**(-2)*t*u**(-1)*rzm2*c0cmztswww - 48.D0*s**(-2)*t*u**(-1)*
     &    rwm2*c0cmztswww + 2.D0*s**(-2)*t*rwm2**(-1)*rzm2*c0cmzuswww
     &     - 2.D0*s**(-2)*t*rwm2**(-1)*rzm2*c0cmztswww + 2.D0*s**(-2)*t
     &    *rwm2**(-1)*rzm2*c0ccuswww - 2.D0*s**(-2)*t*rwm2**(-1)*rzm2*
     &    c0cctswww - 2.D0*s**(-2)*t*rwm2**(-1)*rzm2**2*d0cccmztsuswwww
     &     - 12.D0*s**(-2)*t*c0cmzuswww + 12.D0*s**(-2)*t*c0cmztswww - 
     &    12.D0*s**(-2)*t*c0ccuswww + 12.D0*s**(-2)*t*c0cctswww + 12.D0
     &    *s**(-2)*t*rzm2*d0cccmztsuswwww - 2.D0*s**(-2)*t**2*u**(-2)*
     &    rwm2**(-1)*rzm2*b0fmzww + 2.D0*s**(-2)*t**2*u**(-2)*
     &    rwm2**(-1)*rzm2*b0ftsww + 12.D0*s**(-2)*t**2*u**(-2)*b0fmzww
     &     - 12.D0*s**(-2)*t**2*u**(-2)*b0ftsww + 2.D0*s**(-2)*t**2*
     &    u**(-1)*rwm2**(-1) - 4.D0*s**(-2)*t**2*u**(-1)*c0cmztswww + 2.
     &    D0*s**(-2)*t**2*rwm2**(-1)*rzm2*d0cccmztsuswwww - 12.D0*
     &    s**(-2)*t**2*d0cccmztsuswwww - 2.D0*s**(-1)*t**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**3 + 2.D0*s**(-1)*t**(-2)*u**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 2.D0*s**(-1)*t**(-2)*u**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fusww + 12.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**2 - 12.D
     &    0*s**(-1)*t**(-2)*u**(-1)*rzm2**2*b0fmzww + 12.D0*s**(-1)*
     &    t**(-2)*u**(-1)*rzm2**2*b0fusww + 4.D0*s**(-1)*t**(-2)*
     &    u**(-1)*rzm2**3*c0cmzuswww - 24.D0*s**(-1)*t**(-2)*u**(-1)*
     &    rwm2*rzm2**2*c0cmzuswww - 4.D0*s**(-1)*t**(-2)*rwm2**(-1)*
     &    rzm2**2 + 2.D0*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**2*b0fmzww - 2.
     &    D0*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**2*b0fusww + 24.D0*s**(-1)
     &    *t**(-2)*rzm2 - 12.D0*s**(-1)*t**(-2)*rzm2*b0fmzww + 12.D0*
     &    s**(-1)*t**(-2)*rzm2*b0fusww + 8.D0*s**(-1)*t**(-2)*rzm2**2*
     &    c0cmzuswww - 48.D0*s**(-1)*t**(-2)*rwm2*rzm2*c0cmzuswww + 2.D0
     &    *s**(-1)*t**(-2)*u*rwm2**(-1)*rzm2 - 12.D0*s**(-1)*t**(-2)*u
     &     - 4.D0*s**(-1)*t**(-2)*u*rzm2*c0cmzuswww + 24.D0*s**(-1)*
     &    t**(-2)*u*rwm2*c0cmzuswww + 8.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**2 - 4.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 4.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fusww - 48.D0*s**(-1)*t**(-1)*u**(-1)*rzm2 + 24.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2*b0fmzww - 24.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rzm2*b0fusww - 8.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2*
     &    c0cmzuswww - 8.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2*c0cmztswww
     &     + 48.D0*s**(-1)*t**(-1)*u**(-1)*rwm2*rzm2*c0cmzuswww + 48.D0
     &    *s**(-1)*t**(-1)*u**(-1)*rwm2*rzm2*c0cmztswww - 2.D0*s**(-1)*
     &    t**(-1)*rwm2**(-1)*rzm2 - 2.D0*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2*b0fmzww + 2.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2*b0fusww
     &     + 12.D0*s**(-1)*t**(-1) + 12.D0*s**(-1)*t**(-1)*b0fmzww - 12.
     &    D0*s**(-1)*t**(-1)*b0fusww + 4.D0*s**(-1)*t**(-1)*rzm2*
     &    c0cmzuswww + 8.D0*s**(-1)*t**(-1)*rzm2*c0cmztswww - 8.D0*
     &    s**(-1)*t**(-1)*rzm2*c0ccuswww - 24.D0*s**(-1)*t**(-1)*rwm2*
     &    c0cmzuswww - 48.D0*s**(-1)*t**(-1)*rwm2*c0cmztswww + 48.D0*
     &    s**(-1)*t**(-1)*rwm2*c0ccuswww + 2.D0*s**(-1)*t**(-1)*u*
     &    rwm2**(-1) - 4.D0*s**(-1)*t**(-1)*u*c0cmzuswww - 2.D0*s**(-1)
     &    *u**(-2)*rwm2**(-1)*rzm2**2 + 2.D0*s**(-1)*u**(-2)*rwm2**(-1)
     &    *rzm2**2*b0fmzww - 2.D0*s**(-1)*u**(-2)*rwm2**(-1)*rzm2**2*
     &    b0ftsww + 12.D0*s**(-1)*u**(-2)*rzm2 - 12.D0*s**(-1)*u**(-2)*
     &    rzm2*b0fmzww + 12.D0*s**(-1)*u**(-2)*rzm2*b0ftsww + 4.D0*
     &    s**(-1)*u**(-2)*rzm2**2*c0cmztswww - 24.D0*s**(-1)*u**(-2)*
     &    rwm2*rzm2*c0cmztswww - 2.D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2
     &     - 6.D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2*b0fmzww + 6.D0*
     &    s**(-1)*u**(-1)*rwm2**(-1)*rzm2*b0ftsww + 12.D0*s**(-1)*
     &    u**(-1) + 36.D0*s**(-1)*u**(-1)*b0fmzww - 36.D0*s**(-1)*
     &    u**(-1)*b0ftsww + 4.D0*s**(-1)*u**(-1)*rzm2*c0cmztswww - 24.D0
     &    *s**(-1)*u**(-1)*rwm2*c0cmztswww + 2.D0*s**(-1)*rwm2**(-1)*
     &    rzm2*c0cmzuswww + 2.D0*s**(-1)*rwm2**(-1)*rzm2*c0ccuswww - 8.D
     &    0*s**(-1)*c0cmzuswww - 4.D0*s**(-1)*c0cmztswww - 8.D0*s**(-1)
     &    *c0ccuswww - 4.D0*s**(-1)*c0cctswww - 10.D0*s**(-1)*rzm2*
     &    d0cccmztsuswwww + 60.D0*s**(-1)*rwm2*d0cccmztsuswwww + 4.D0*
     &    s**(-1)*t*u**(-2)*rwm2**(-1)*rzm2 - 2.D0*s**(-1)*t*u**(-2)*
     &    rwm2**(-1)*rzm2*b0fmzww + 2.D0*s**(-1)*t*u**(-2)*rwm2**(-1)*
     &    rzm2*b0ftsww - 24.D0*s**(-1)*t*u**(-2) + 12.D0*s**(-1)*t*
     &    u**(-2)*b0fmzww - 12.D0*s**(-1)*t*u**(-2)*b0ftsww - 8.D0*
     &    s**(-1)*t*u**(-2)*rzm2*c0cmztswww + 48.D0*s**(-1)*t*u**(-2)*
     &    rwm2*c0cmztswww - 2.D0*s**(-1)*t*u**(-1)*rwm2**(-1) + 4.D0*
     &    s**(-1)*t*u**(-1)*c0cmztswww + 2.D0*s**(-1)*t*rwm2**(-1)*rzm2
     &    *d0cccmztsuswwww - 8.D0*s**(-1)*t*d0cccmztsuswwww - 2.D0*
     &    s**(-1)*t**2*u**(-2)*rwm2**(-1) + 4.D0*s**(-1)*t**2*u**(-2)*
     &    c0cmztswww + 2.D0*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**2 - 12.D0*
     &    t**(-2)*u**(-1)*rzm2 - 4.D0*t**(-2)*u**(-1)*rzm2**2*
     &    c0cmzuswww + 24.D0*t**(-2)*u**(-1)*rwm2*rzm2*c0cmzuswww + 2.D0
     &    *t**(-2)*rwm2**(-1)*rzm2 - 12.D0*t**(-2) - 4.D0*t**(-2)*rzm2*
     &    c0cmzuswww + 24.D0*t**(-2)*rwm2*c0cmzuswww - 8.D0*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2 - 4.D0*t**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2*b0fmzww + 4.D0*t**(-1)*u**(-1)*rwm2**(-1)*rzm2*b0ftsww
     &     + 48.D0*t**(-1)*u**(-1) + 24.D0*t**(-1)*u**(-1)*b0fmzww - 24.
     &    D0*t**(-1)*u**(-1)*b0ftsww + 8.D0*t**(-1)*u**(-1)*rzm2*
     &    c0cmzuswww + 4.D0*t**(-1)*u**(-1)*rzm2*c0cmztswww + 4.D0*
     &    t**(-1)*u**(-1)*rzm2*c0ccqswww - 48.D0*t**(-1)*u**(-1)*rwm2*
     &    c0cmzuswww - 24.D0*t**(-1)*u**(-1)*rwm2*c0cmztswww - 24.D0*
     &    t**(-1)*u**(-1)*rwm2*c0ccqswww + 2.D0*t**(-1)*rwm2**(-1) - 4.D
     &    0*t**(-1)*c0cmzuswww - 2.D0*t**(-1)*rzm2*d0ccmzcqsuswwww + 12.
     &    D0*t**(-1)*rwm2*d0ccmzcqsuswwww + 2.D0*u**(-2)*rwm2**(-1)*
     &    rzm2 - 12.D0*u**(-2) - 4.D0*u**(-2)*rzm2*c0cmztswww + 24.D0*
     &    u**(-2)*rwm2*c0cmztswww - 4.D0*u**(-1)*c0cmzuswww + 4.D0*
     &    u**(-1)*c0cmztswww + 2.D0*u**(-1)*rzm2*d0cccmzqstswwww - 12.D0
     &    *u**(-1)*rwm2*d0cccmzqstswwww - 2.D0*t*u**(-2)*rwm2**(-1) + 4.
     &    D0*t*u**(-2)*c0cmztswww - 8.D0/(u + t)*s**(-3)*t**(-1)*
     &    rwm2**(-1)*rzm2**4*b0fmzww + 8.D0/(u + t)*s**(-3)*t**(-1)*
     &    rwm2**(-1)*rzm2**4*b0fusww + 48.D0/(u + t)*s**(-3)*t**(-1)*
     &    rzm2**3*b0fmzww - 48.D0/(u + t)*s**(-3)*t**(-1)*rzm2**3*
     &    b0fusww + 4.D0/(u + t)*s**(-2)*t**(-2)*rwm2**(-1)*rzm2**4*
     &    b0fmzww - 4.D0/(u + t)*s**(-2)*t**(-2)*rwm2**(-1)*rzm2**4*
     &    b0fusww - 24.D0/(u + t)*s**(-2)*t**(-2)*rzm2**3*b0fmzww + 24.D
     &    0/(u + t)*s**(-2)*t**(-2)*rzm2**3*b0fusww - 4.D0/(u + t)*
     &    s**(-2)*t**(-1)*rwm2**(-1)*rzm2**3 + 4.D0/(u + t)*s**(-2)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(u + t)*s**(-2)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(u + t)*s**(-2)*
     &    t**(-1)*rzm2**2 - 24.D0/(u + t)*s**(-2)*t**(-1)*rzm2**2*
     &    b0fmzww + 24.D0/(u + t)*s**(-2)*t**(-1)*rzm2**2*b0fusww + 8.D0
     &    /(u + t)*s**(-2)*t**(-1)*rzm2**3*c0cmzuswww - 48.D0/(u + t)*
     &    s**(-2)*t**(-1)*rwm2*rzm2**2*c0cmzuswww - 4.D0/(u + t)*
     &    s**(-2)*rwm2**(-1)*rzm2**3*c0cmztswww + 4.D0/(u + t)*s**(-2)*
     &    rwm2**(-1)*rzm2**3*c0ccuswww )
      ewamp(1,1,1,3) = ewamp(1,1,1,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * ( 24.D0/(u + t)*s**(-2)*rzm2**2*c0cmztswww - 24.D0/(u + t)
     &    *s**(-2)*rzm2**2*c0ccuswww - 4.D0/(u + t)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**2*c0cmzuswww + 8.D0/(u + t)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**2*c0cmztswww - 8.D0/(u + t)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**2*c0ccuswww + 4.D0/(u + t)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**2*c0cctswww + 4.D0/(u + t)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*d0cccmztsuswwww + 24.D0/(u + t)*s**(-2)*t*
     &    rzm2*c0cmzuswww - 48.D0/(u + t)*s**(-2)*t*rzm2*c0cmztswww + 
     &    48.D0/(u + t)*s**(-2)*t*rzm2*c0ccuswww - 24.D0/(u + t)*
     &    s**(-2)*t*rzm2*c0cctswww - 24.D0/(u + t)*s**(-2)*t*rzm2**2*
     &    d0cccmztsuswwww + 4.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*rzm2*
     &    c0cmzuswww - 4.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*rzm2*
     &    c0cmztswww + 4.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*rzm2*
     &    c0ccuswww - 4.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*rzm2*
     &    c0cctswww - 8.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*rzm2**2*
     &    d0cccmztsuswwww - 24.D0/(u + t)*s**(-2)*t**2*c0cmzuswww + 24.D
     &    0/(u + t)*s**(-2)*t**2*c0cmztswww - 24.D0/(u + t)*s**(-2)*
     &    t**2*c0ccuswww + 24.D0/(u + t)*s**(-2)*t**2*c0cctswww + 48.D0
     &    /(u + t)*s**(-2)*t**2*rzm2*d0cccmztsuswwww + 4.D0/(u + t)*
     &    s**(-2)*t**3*rwm2**(-1)*rzm2*d0cccmztsuswwww - 24.D0/(u + t)*
     &    s**(-2)*t**3*d0cccmztsuswwww + 4.D0/(u + t)*s**(-1)*t**(-2)*
     &    rwm2**(-1)*rzm2**3 - 4.D0/(u + t)*s**(-1)*t**(-2)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0/(u + t)*s**(-1)*t**(-2)*rwm2**(-1)*
     &    rzm2**3*b0fusww - 24.D0/(u + t)*s**(-1)*t**(-2)*rzm2**2 + 24.D
     &    0/(u + t)*s**(-1)*t**(-2)*rzm2**2*b0fmzww - 24.D0/(u + t)*
     &    s**(-1)*t**(-2)*rzm2**2*b0fusww - 8.D0/(u + t)*s**(-1)*
     &    t**(-2)*rzm2**3*c0cmzuswww + 48.D0/(u + t)*s**(-1)*t**(-2)*
     &    rwm2*rzm2**2*c0cmzuswww + 8.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 8.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fusww - 48.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2*b0fmzww + 48.D0/(u + t)*s**(-1)*t**(-1)*rzm2*b0fusww - 8.
     &    D0/(u + t)*s**(-1)*t**(-1)*rzm2**2*c0cmztswww + 8.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**2*c0ccuswww + 48.D0/(u + t)*s**(-1)*
     &    t**(-1)*rwm2*rzm2*c0cmztswww - 48.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2*rzm2*c0ccuswww + 8.D0/(u + t)*s**(-1)*rwm2**(-1)*rzm2*
     &    b0fusww - 8.D0/(u + t)*s**(-1)*rwm2**(-1)*rzm2*b0ftsww - 4.D0
     &    /(u + t)*s**(-1)*rwm2**(-1)*rzm2**2*c0cmzuswww + 4.D0/(u + t)
     &    *s**(-1)*rwm2**(-1)*rzm2**2*c0cmztswww - 8.D0/(u + t)*s**(-1)
     &    *rwm2**(-1)*rzm2**2*c0ccuswww - 48.D0/(u + t)*s**(-1)*b0fusww
     &     + 48.D0/(u + t)*s**(-1)*b0ftsww + 16.D0/(u + t)*s**(-1)*rzm2
     &    *c0cmzuswww - 16.D0/(u + t)*s**(-1)*rzm2*c0cmztswww + 40.D0/(
     &    u + t)*s**(-1)*rzm2*c0ccuswww + 8.D0/(u + t)*s**(-1)*rzm2*
     &    c0cctswww + 16.D0/(u + t)*s**(-1)*rzm2**2*d0cccmztsuswwww + 
     &    48.D0/(u + t)*s**(-1)*rwm2*c0cmzuswww - 48.D0/(u + t)*s**(-1)
     &    *rwm2*c0cmztswww + 48.D0/(u + t)*s**(-1)*rwm2*c0ccuswww - 48.D
     &    0/(u + t)*s**(-1)*rwm2*c0cctswww - 96.D0/(u + t)*s**(-1)*rwm2
     &    *rzm2*d0cccmztsuswwww + 8.D0/(u + t)*s**(-1)*t*rwm2**(-1)*
     &    rzm2*c0cmzuswww - 4.D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2*
     &    c0cmztswww + 8.D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2*c0ccuswww
     &     - 4.D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2*c0cctswww - 8.D0/(u
     &     + t)*s**(-1)*t*rwm2**(-1)*rzm2**2*d0cccmztsuswwww - 48.D0/(u
     &     + t)*s**(-1)*t*c0cmzuswww + 24.D0/(u + t)*s**(-1)*t*
     &    c0cmztswww - 48.D0/(u + t)*s**(-1)*t*c0ccuswww + 24.D0/(u + t
     &    )*s**(-1)*t*c0cctswww + 32.D0/(u + t)*s**(-1)*t*rzm2*
     &    d0cccmztsuswwww + 96.D0/(u + t)*s**(-1)*t*rwm2*
     &    d0cccmztsuswwww + 8.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*rzm2*
     &    d0cccmztsuswwww - 48.D0/(u + t)*s**(-1)*t**2*d0cccmztsuswwww
     &     - 4.D0/(u + t)*t**(-2)*rwm2**(-1)*rzm2**2 + 24.D0/(u + t)*
     &    t**(-2)*rzm2 + 8.D0/(u + t)*t**(-2)*rzm2**2*c0cmzuswww - 48.D0
     &    /(u + t)*t**(-2)*rwm2*rzm2*c0cmzuswww + 8.D0/(u + t)*t**(-1)*
     &    rwm2**(-1)*rzm2 + 4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2*
     &    b0fusww - 4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2*b0ftsww - 48.D0
     &    /(u + t)*t**(-1) - 24.D0/(u + t)*t**(-1)*b0fusww + 24.D0/(u
     &     + t)*t**(-1)*b0ftsww - 4.D0/(u + t)*t**(-1)*rzm2*c0cmzuswww
     &     + 4.D0/(u + t)*t**(-1)*rzm2*c0cmztswww - 8.D0/(u + t)*
     &    t**(-1)*rzm2*c0ccuswww - 8.D0/(u + t)*t**(-1)*rzm2*c0ccqswww
     &     + 24.D0/(u + t)*t**(-1)*rwm2*c0cmzuswww - 24.D0/(u + t)*
     &    t**(-1)*rwm2*c0cmztswww + 48.D0/(u + t)*t**(-1)*rwm2*
     &    c0ccuswww + 48.D0/(u + t)*t**(-1)*rwm2*c0ccqswww + 4.D0/(u + 
     &    t)*rwm2**(-1)*rzm2*c0cmzuswww + 4.D0/(u + t)*rwm2**(-1)*rzm2*
     &    c0ccuswww - 20.D0/(u + t)*c0cmzuswww - 4.D0/(u + t)*
     &    c0cmztswww - 20.D0/(u + t)*c0ccuswww - 4.D0/(u + t)*c0cctswww
     &     - 16.D0/(u + t)*rzm2*d0cccmztsuswwww + 96.D0/(u + t)*rwm2*
     &    d0cccmztsuswwww + 4.D0/(u + t)*t*rwm2**(-1)*rzm2*
     &    d0cccmztsuswwww - 20.D0/(u + t)*t*d0cccmztsuswwww - 4.D0/(u
     &     + t)/(u + s)*t**(-1)*rwm2**(-1)*rzm2**2 + 24.D0/(u + t)/(u
     &     + s)*t**(-1)*rzm2 + 8.D0/(u + t)/(u + s)*t**(-1)*rzm2**2*
     &    c0cmztswww - 48.D0/(u + t)/(u + s)*t**(-1)*rwm2*rzm2*
     &    c0cmztswww - 4.D0/(u + t)/(u + s)/(u + s)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0/(u + t)/(u + s)/(u + s)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww + 24.D0/(u + t)/(u + s)/(u + s)*
     &    t**(-1)*rzm2**2*b0fmzww - 24.D0/(u + t)/(u + s)/(u + s)*
     &    t**(-1)*rzm2**2*b0ftsww + 8.D0/(u + t)/(t + s)*s**(-3)*
     &    rwm2**(-1)*rzm2**4*b0fmzww - 8.D0/(u + t)/(t + s)*s**(-3)*
     &    rwm2**(-1)*rzm2**4*b0fusww - 48.D0/(u + t)/(t + s)*s**(-3)*
     &    rzm2**3*b0fmzww + 48.D0/(u + t)/(t + s)*s**(-3)*rzm2**3*
     &    b0fusww + 4.D0/(u + t)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**3 - 4.
     &    D0/(u + t)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0
     &    /(u + t)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**3*b0fusww - 24.D0/(
     &    u + t)/(t + s)*s**(-2)*rzm2**2 + 24.D0/(u + t)/(t + s)*
     &    s**(-2)*rzm2**2*b0fmzww - 24.D0/(u + t)/(t + s)*s**(-2)*
     &    rzm2**2*b0fusww - 8.D0/(u + t)/(t + s)*s**(-2)*rzm2**3*
     &    c0cmzuswww + 48.D0/(u + t)/(t + s)*s**(-2)*rwm2*rzm2**2*
     &    c0cmzuswww + 4.D0/(u + t)/(t + s)/(t + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**4*b0fmzww - 4.D0/(u + t)/(t + s)/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**4*b0fusww - 24.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-2)*rzm2**3*b0fmzww + 24.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-2)*rzm2**3*b0fusww - 4.D0/(u + s)*s**(-3)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0/(u + s)*s**(-3)*rwm2**(-1)*rzm2**3*
     &    b0ftsww + 24.D0/(u + s)*s**(-3)*rzm2**2*b0fmzww - 24.D0/(u + 
     &    s)*s**(-3)*rzm2**2*b0ftsww + 8.D0/(u + s)*s**(-3)*t*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 8.D0/(u + s)*s**(-3)*t*
     &    rwm2**(-1)*rzm2**2*b0ftsww - 48.D0/(u + s)*s**(-3)*t*rzm2*
     &    b0fmzww + 48.D0/(u + s)*s**(-3)*t*rzm2*b0ftsww - 4.D0/(u + s)
     &    *s**(-3)*t**2*rwm2**(-1)*rzm2*b0fmzww + 4.D0/(u + s)*s**(-3)*
     &    t**2*rwm2**(-1)*rzm2*b0ftsww + 24.D0/(u + s)*s**(-3)*t**2*
     &    b0fmzww - 24.D0/(u + s)*s**(-3)*t**2*b0ftsww - 4.D0/(u + s)*
     &    s**(-2)*t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(u + s)*
     &    s**(-2)*t**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 24.D0/(u + s)*
     &    s**(-2)*t**(-1)*rzm2**2*b0fmzww - 24.D0/(u + s)*s**(-2)*
     &    t**(-1)*rzm2**2*b0ftsww - 2.D0/(u + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**2 + 4.D0/(u + s)*s**(-2)*rwm2**(-1)*rzm2**2*b0fmzww - 4.
     &    D0/(u + s)*s**(-2)*rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + s)
     &    *s**(-2)*rzm2 - 24.D0/(u + s)*s**(-2)*rzm2*b0fmzww + 24.D0/(u
     &     + s)*s**(-2)*rzm2*b0ftsww + 4.D0/(u + s)*s**(-2)*rzm2**2*
     &    c0cmztswww - 24.D0/(u + s)*s**(-2)*rwm2*rzm2*c0cmztswww + 4.D0
     &    /(u + s)*s**(-2)*t*rwm2**(-1)*rzm2 - 24.D0/(u + s)*s**(-2)*t
     &     - 8.D0/(u + s)*s**(-2)*t*rzm2*c0cmztswww + 48.D0/(u + s)*
     &    s**(-2)*t*rwm2*c0cmztswww - 2.D0/(u + s)*s**(-2)*t**2*
     &    rwm2**(-1) + 4.D0/(u + s)*s**(-2)*t**2*c0cmztswww - 4.D0/(u
     &     + s)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**2 + 24.D0/(u + s)*
     &    s**(-1)*t**(-1)*rzm2 + 8.D0/(u + s)*s**(-1)*t**(-1)*rzm2**2*
     &    c0cmztswww - 48.D0/(u + s)*s**(-1)*t**(-1)*rwm2*rzm2*
     &    c0cmztswww + 2.D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2 + 2.D0/(u
     &     + s)*s**(-1)*rwm2**(-1)*rzm2*b0fmzww - 2.D0/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2*b0ftsww - 12.D0/(u + s)*s**(-1) - 12.D0/(u + 
     &    s)*s**(-1)*b0fmzww + 12.D0/(u + s)*s**(-1)*b0ftsww - 4.D0/(u
     &     + s)*s**(-1)*rzm2*c0cmztswww + 24.D0/(u + s)*s**(-1)*rwm2*
     &    c0cmztswww + 2.D0/(u + s)*s**(-1)*t*rwm2**(-1) - 4.D0/(u + s)
     &    *s**(-1)*t*c0cmztswww - 2.D0/(u + s)/(u + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 2.D0/(u + s)/(u + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**3*b0ftsww + 12.D0/(u + s)/(u + s)*s**(-2)*
     &    rzm2**2*b0fmzww - 12.D0/(u + s)/(u + s)*s**(-2)*rzm2**2*
     &    b0ftsww + 4.D0/(u + s)/(u + s)*s**(-2)*t*rwm2**(-1)*rzm2**2*
     &    b0fmzww - 4.D0/(u + s)/(u + s)*s**(-2)*t*rwm2**(-1)*rzm2**2*
     &    b0ftsww - 24.D0/(u + s)/(u + s)*s**(-2)*t*rzm2*b0fmzww + 24.D0
     &    /(u + s)/(u + s)*s**(-2)*t*rzm2*b0ftsww - 2.D0/(u + s)/(u + s
     &    )*s**(-2)*t**2*rwm2**(-1)*rzm2*b0fmzww + 2.D0/(u + s)/(u + s)
     &    *s**(-2)*t**2*rwm2**(-1)*rzm2*b0ftsww + 12.D0/(u + s)/(u + s)
     &    *s**(-2)*t**2*b0fmzww - 12.D0/(u + s)/(u + s)*s**(-2)*t**2*
     &    b0ftsww - 4.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww + 24.D0/(u + s)/(u + s)*s**(-1)*
     &    t**(-1)*rzm2**2*b0fmzww - 24.D0/(u + s)/(u + s)*s**(-1)*
     &    t**(-1)*rzm2**2*b0ftsww + 2.D0/(u + s)/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u + s)/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**2*b0ftsww - 12.D0/(u + s)/(u + s)*s**(-1)*
     &    rzm2*b0fmzww + 12.D0/(u + s)/(u + s)*s**(-1)*rzm2*b0ftsww + 2.
     &    D0/(u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2*b0fmzww - 2.D0/(
     &    u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2*b0ftsww - 12.D0/(u
     &     + s)/(u + s)*s**(-1)*t*b0fmzww + 12.D0/(u + s)/(u + s)*
     &    s**(-1)*t*b0ftsww - 4.D0/(t + s)*s**(-3)*u**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fmzww + 4.D0/(t + s)*s**(-3)*u**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fusww + 24.D0/(t + s)*s**(-3)*u**(-1)*rzm2**3*
     &    b0fmzww - 24.D0/(t + s)*s**(-3)*u**(-1)*rzm2**3*b0fusww - 8.D0
     &    /(t + s)*s**(-3)*rwm2**(-1)*rzm2**3*b0fmzww + 8.D0/(t + s)*
     &    s**(-3)*rwm2**(-1)*rzm2**3*b0fusww + 48.D0/(t + s)*s**(-3)*
     &    rzm2**2*b0fmzww - 48.D0/(t + s)*s**(-3)*rzm2**2*b0fusww + 4.D0
     &    /(t + s)*s**(-3)*u*rwm2**(-1)*rzm2**2*b0fmzww - 4.D0/(t + s)*
     &    s**(-3)*u*rwm2**(-1)*rzm2**2*b0fusww - 24.D0/(t + s)*s**(-3)*
     &    u*rzm2*b0fmzww + 24.D0/(t + s)*s**(-3)*u*rzm2*b0fusww - 2.D0
     &    /(t + s)*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**3 - 2.D0/(t + s)*
     &    s**(-2)*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 2.D0/(t + s)*
     &    s**(-2)*u**(-1)*rwm2**(-1)*rzm2**3*b0fusww + 12.D0/(t + s)*
     &    s**(-2)*u**(-1)*rzm2**2 + 12.D0/(t + s)*s**(-2)*u**(-1)*
     &    rzm2**2*b0fmzww - 12.D0/(t + s)*s**(-2)*u**(-1)*rzm2**2*
     &    b0fusww + 4.D0/(t + s)*s**(-2)*u**(-1)*rzm2**3*c0cmzuswww - 
     &    24.D0/(t + s)*s**(-2)*u**(-1)*rwm2*rzm2**2*c0cmzuswww - 4.D0
     &    /(t + s)*s**(-2)*rwm2**(-1)*rzm2**2 + 4.D0/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**2*b0fmzww )
      ewamp(1,1,1,3) = ewamp(1,1,1,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * (  - 4.D0/(t + s)*s**(-2)*rwm2**(-1)*rzm2**2*b0fusww + 24.D
     &    0/(t + s)*s**(-2)*rzm2 - 24.D0/(t + s)*s**(-2)*rzm2*b0fmzww
     &     + 24.D0/(t + s)*s**(-2)*rzm2*b0fusww + 8.D0/(t + s)*s**(-2)*
     &    rzm2**2*c0cmzuswww - 48.D0/(t + s)*s**(-2)*rwm2*rzm2*
     &    c0cmzuswww + 2.D0/(t + s)*s**(-2)*u*rwm2**(-1)*rzm2 - 2.D0/(t
     &     + s)*s**(-2)*u*rwm2**(-1)*rzm2*b0fmzww + 2.D0/(t + s)*
     &    s**(-2)*u*rwm2**(-1)*rzm2*b0fusww - 12.D0/(t + s)*s**(-2)*u
     &     + 12.D0/(t + s)*s**(-2)*u*b0fmzww - 12.D0/(t + s)*s**(-2)*u*
     &    b0fusww - 4.D0/(t + s)*s**(-2)*u*rzm2*c0cmzuswww + 24.D0/(t
     &     + s)*s**(-2)*u*rwm2*c0cmzuswww - 4.D0/(t + s)*s**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**2 + 4.D0/(t + s)*s**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 4.D0/(t + s)*s**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fusww + 24.D0/(t + s)*s**(-1)*u**(-1)*
     &    rzm2 - 24.D0/(t + s)*s**(-1)*u**(-1)*rzm2*b0fmzww + 24.D0/(t
     &     + s)*s**(-1)*u**(-1)*rzm2*b0fusww + 8.D0/(t + s)*s**(-1)*
     &    u**(-1)*rzm2**2*c0cmzuswww - 48.D0/(t + s)*s**(-1)*u**(-1)*
     &    rwm2*rzm2*c0cmzuswww + 2.D0/(t + s)*s**(-1)*rwm2**(-1)*rzm2
     &     - 2.D0/(t + s)*s**(-1)*rwm2**(-1)*rzm2*b0fmzww + 2.D0/(t + s
     &    )*s**(-1)*rwm2**(-1)*rzm2*b0fusww - 12.D0/(t + s)*s**(-1) + 
     &    12.D0/(t + s)*s**(-1)*b0fmzww - 12.D0/(t + s)*s**(-1)*b0fusww
     &     - 4.D0/(t + s)*s**(-1)*rzm2*c0cmzuswww + 24.D0/(t + s)*
     &    s**(-1)*rwm2*c0cmzuswww - 2.D0/(t + s)*s**(-1)*u*rwm2**(-1)
     &     + 4.D0/(t + s)*s**(-1)*u*c0cmzuswww - 2.D0/(t + s)*u**(-1)*
     &    rwm2**(-1)*rzm2 + 2.D0/(t + s)*u**(-1)*rwm2**(-1)*rzm2*
     &    b0fmzww - 2.D0/(t + s)*u**(-1)*rwm2**(-1)*rzm2*b0fusww + 12.D0
     &    /(t + s)*u**(-1) - 12.D0/(t + s)*u**(-1)*b0fmzww + 12.D0/(t
     &     + s)*u**(-1)*b0fusww + 4.D0/(t + s)*u**(-1)*rzm2*c0cmzuswww
     &     - 24.D0/(t + s)*u**(-1)*rwm2*c0cmzuswww + 2.D0/(t + s)*
     &    rwm2**(-1) - 4.D0/(t + s)*c0cmzuswww - 2.D0/(t + s)/(t + s)*
     &    s**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 2.D0/(t + s)/(t
     &     + s)*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 12.D0/(t
     &     + s)/(t + s)*s**(-2)*u**(-1)*rzm2**3*b0fmzww - 12.D0/(t + s)
     &    /(t + s)*s**(-2)*u**(-1)*rzm2**3*b0fusww - 4.D0/(t + s)/(t + 
     &    s)*s**(-2)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(t + s)/(t + s)*
     &    s**(-2)*rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(t + s)/(t + s)*
     &    s**(-2)*rzm2**2*b0fmzww - 24.D0/(t + s)/(t + s)*s**(-2)*
     &    rzm2**2*b0fusww + 2.D0/(t + s)/(t + s)*s**(-2)*u*rwm2**(-1)*
     &    rzm2**2*b0fmzww - 2.D0/(t + s)/(t + s)*s**(-2)*u*rwm2**(-1)*
     &    rzm2**2*b0fusww - 12.D0/(t + s)/(t + s)*s**(-2)*u*rzm2*
     &    b0fmzww + 12.D0/(t + s)/(t + s)*s**(-2)*u*rzm2*b0fusww - 4.D0
     &    /(t + s)/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww
     &     + 4.D0/(t + s)/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fusww + 24.D0/(t + s)/(t + s)*s**(-1)*u**(-1)*rzm2**2*
     &    b0fmzww - 24.D0/(t + s)/(t + s)*s**(-1)*u**(-1)*rzm2**2*
     &    b0fusww + 2.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww - 2.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fusww - 12.D0/(t + s)/(t + s)*s**(-1)*rzm2*b0fmzww + 12.D0
     &    /(t + s)/(t + s)*s**(-1)*rzm2*b0fusww - 2.D0/(t + s)/(t + s)*
     &    s**(-1)*u*rwm2**(-1)*rzm2*b0fmzww + 2.D0/(t + s)/(t + s)*
     &    s**(-1)*u*rwm2**(-1)*rzm2*b0fusww + 12.D0/(t + s)/(t + s)*
     &    s**(-1)*u*b0fmzww - 12.D0/(t + s)/(t + s)*s**(-1)*u*b0fusww
     &     - 2.D0/(t + s)/(t + s)*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww + 
     &    2.D0/(t + s)/(t + s)*u**(-1)*rwm2**(-1)*rzm2**2*b0fusww + 12.D
     &    0/(t + s)/(t + s)*u**(-1)*rzm2*b0fmzww - 12.D0/(t + s)/(t + s
     &    )*u**(-1)*rzm2*b0fusww + 2.D0/(t + s)/(t + s)*rwm2**(-1)*rzm2
     &    *b0fmzww - 2.D0/(t + s)/(t + s)*rwm2**(-1)*rzm2*b0fusww - 12.D
     &    0/(t + s)/(t + s)*b0fmzww + 12.D0/(t + s)/(t + s)*b0fusww )

      ewamp(1,1,2,1) =
     &  - 48.D0 + 4.D0*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 4.D0
     &    *s**(-2)*t**(-1)*rwm2**(-1)*rzm2**4*b0fusww - 24.D0*s**(-2)*
     &    t**(-1)*rzm2**3*b0fmzww + 24.D0*s**(-2)*t**(-1)*rzm2**3*
     &    b0fusww - 2.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2**3*b0fmzww
     &     + 2.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2**3*b0fusww + 12.D0*
     &    s**(-2)*t**(-1)*u*rzm2**2*b0fmzww - 12.D0*s**(-2)*t**(-1)*u*
     &    rzm2**2*b0fusww - 2.D0*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 2.D0*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*b0ftsww + 
     &    12.D0*s**(-2)*u**(-1)*rzm2**3*b0fmzww - 12.D0*s**(-2)*u**(-1)
     &    *rzm2**3*b0ftsww + 4.D0*s**(-2)*t*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 4.D0*s**(-2)*t*u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww
     &     - 24.D0*s**(-2)*t*u**(-1)*rzm2**2*b0fmzww + 24.D0*s**(-2)*t*
     &    u**(-1)*rzm2**2*b0ftsww - 2.D0*s**(-2)*t**2*u**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 2.D0*s**(-2)*t**2*u**(-1)*
     &    rwm2**(-1)*rzm2**2*b0ftsww + 12.D0*s**(-2)*t**2*u**(-1)*rzm2*
     &    b0fmzww - 12.D0*s**(-2)*t**2*u**(-1)*rzm2*b0ftsww + 4.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 4.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*b0ftsww - 24.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0fmzww + 24.D0*s**(-1)*
     &    t**(-1)*u**(-1)*rzm2**3*b0ftsww + 4.D0*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**3 - 10.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3
     &    *b0fmzww + 10.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3*b0fusww
     &     - 24.D0*s**(-1)*t**(-1)*rzm2**2 + 60.D0*s**(-1)*t**(-1)*
     &    rzm2**2*b0fmzww - 60.D0*s**(-1)*t**(-1)*rzm2**2*b0fusww - 8.D0
     &    *s**(-1)*t**(-1)*rzm2**3*c0cmzuswww + 48.D0*s**(-1)*t**(-1)*
     &    rwm2*rzm2**2*c0cmzuswww - 2.D0*s**(-1)*t**(-1)*u*rwm2**(-1)*
     &    rzm2**2 + 4.D0*s**(-1)*t**(-1)*u*rwm2**(-1)*rzm2**2*b0fmzww
     &     - 4.D0*s**(-1)*t**(-1)*u*rwm2**(-1)*rzm2**2*b0fusww + 12.D0*
     &    s**(-1)*t**(-1)*u*rzm2 - 24.D0*s**(-1)*t**(-1)*u*rzm2*b0fmzww
     &     + 24.D0*s**(-1)*t**(-1)*u*rzm2*b0fusww + 4.D0*s**(-1)*
     &    t**(-1)*u*rzm2**2*c0cmzuswww - 24.D0*s**(-1)*t**(-1)*u*rwm2*
     &    rzm2*c0cmzuswww - 2.D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**3 - 6.
     &    D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 6.D0*s**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 12.D0*s**(-1)*u**(-1)*
     &    rzm2**2 + 36.D0*s**(-1)*u**(-1)*rzm2**2*b0fmzww - 36.D0*
     &    s**(-1)*u**(-1)*rzm2**2*b0ftsww + 4.D0*s**(-1)*u**(-1)*
     &    rzm2**3*c0cmztswww - 24.D0*s**(-1)*u**(-1)*rwm2*rzm2**2*
     &    c0cmztswww + 4.D0*s**(-1)*t*u**(-1)*rwm2**(-1)*rzm2**2 + 2.D0
     &    *s**(-1)*t*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*s**(-1)*
     &    t*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 24.D0*s**(-1)*t*
     &    u**(-1)*rzm2 - 12.D0*s**(-1)*t*u**(-1)*rzm2*b0fmzww + 12.D0*
     &    s**(-1)*t*u**(-1)*rzm2*b0ftsww - 8.D0*s**(-1)*t*u**(-1)*
     &    rzm2**2*c0cmztswww + 48.D0*s**(-1)*t*u**(-1)*rwm2*rzm2*
     &    c0cmztswww - 2.D0*s**(-1)*t*rwm2**(-1)*rzm2**2*c0cmztswww + 2.
     &    D0*s**(-1)*t*rwm2**(-1)*rzm2**2*c0ccuswww + 12.D0*s**(-1)*t*
     &    rzm2*c0cmztswww - 12.D0*s**(-1)*t*rzm2*c0ccuswww - 2.D0*
     &    s**(-1)*t**2*u**(-1)*rwm2**(-1)*rzm2 + 12.D0*s**(-1)*t**2*
     &    u**(-1) + 4.D0*s**(-1)*t**2*u**(-1)*rzm2*c0cmztswww - 24.D0*
     &    s**(-1)*t**2*u**(-1)*rwm2*c0cmztswww - 2.D0*s**(-1)*t**2*
     &    rwm2**(-1)*rzm2*c0cmzuswww + 4.D0/3.D0*s**(-1)*t**2*
     &    rwm2**(-1)*rzm2*c0cmztswww - 4.D0/3.D0*s**(-1)*t**2*
     &    rwm2**(-1)*rzm2*c0ccuswww + 2.D0*s**(-1)*t**2*rwm2**(-1)*rzm2
     &    *c0cctswww + 2.D0*s**(-1)*t**2*rwm2**(-1)*rzm2**2*
     &    d0cccmztsuswwww + 12.D0*s**(-1)*t**2*c0cmzuswww - 8.D0*
     &    s**(-1)*t**2*c0cmztswww + 8.D0*s**(-1)*t**2*c0ccuswww - 12.D0
     &    *s**(-1)*t**2*c0cctswww - 12.D0*s**(-1)*t**2*rzm2*
     &    d0cccmztsuswwww - 2.D0/3.D0*s**(-1)*t**3*rwm2**(-1)*
     &    c0cmzuswww + 2.D0/3.D0*s**(-1)*t**3*rwm2**(-1)*c0cmztswww - 2.
     &    D0/3.D0*s**(-1)*t**3*rwm2**(-1)*c0ccuswww + 2.D0/3.D0*s**(-1)
     &    *t**3*rwm2**(-1)*c0cctswww - 4.D0/3.D0*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2*d0cccmztsuswwww + 4.D0*s**(-1)*t**3*
     &    rzm2**(-1)*c0cmzuswww - 4.D0*s**(-1)*t**3*rzm2**(-1)*
     &    c0cmztswww + 4.D0*s**(-1)*t**3*rzm2**(-1)*c0ccuswww - 4.D0*
     &    s**(-1)*t**3*rzm2**(-1)*c0cctswww + 8.D0*s**(-1)*t**3*
     &    d0cccmztsuswwww - 2.D0/3.D0*s**(-1)*t**4*rwm2**(-1)*
     &    d0cccmztsuswwww + 4.D0*s**(-1)*t**4*rzm2**(-1)*
     &    d0cccmztsuswwww - 4.D0*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fmzww + 4.D0*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 
     &    24.D0*t**(-1)*u**(-1)*rzm2**2*b0fmzww - 24.D0*t**(-1)*u**(-1)
     &    *rzm2**2*b0ftsww - 2.D0*t**(-1)*rwm2**(-1)*rzm2**2 + 4.D0*
     &    t**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 4.D0*t**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fusww + 12.D0*t**(-1)*rzm2 - 24.D0*t**(-1)*rzm2*
     &    b0fmzww + 24.D0*t**(-1)*rzm2*b0fusww + 6.D0*t**(-1)*rzm2**2*
     &    c0cmzuswww - 2.D0*t**(-1)*rzm2**2*c0ccqswww - 36.D0*t**(-1)*
     &    rwm2*rzm2*c0cmzuswww + 12.D0*t**(-1)*rwm2*rzm2*c0ccqswww - 2.D
     &    0*t**(-1)*u*rzm2*c0cmzuswww + 2.D0*t**(-1)*u*rzm2*c0cmzqswww
     &     - 2.D0*t**(-1)*u*rzm2*c0ccuswww + 2.D0*t**(-1)*u*rzm2*
     &    c0ccqswww - 2.D0*t**(-1)*u*rzm2**2*d0ccmzcqsuswwww + 12.D0*
     &    t**(-1)*u*rwm2*c0cmzuswww - 12.D0*t**(-1)*u*rwm2*c0cmzqswww
     &     + 12.D0*t**(-1)*u*rwm2*c0ccuswww - 12.D0*t**(-1)*u*rwm2*
     &    c0ccqswww + 12.D0*t**(-1)*u*rwm2*rzm2*d0ccmzcqsuswwww + 2.D0*
     &    t**(-1)*u**2*rzm2*d0ccmzcqsuswwww - 12.D0*t**(-1)*u**2*rwm2*
     &    d0ccmzcqsuswwww + 2.D0*u**(-1)*rwm2**(-1)*rzm2**2 + 4.D0*
     &    u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 4.D0*u**(-1)*rwm2**(-1)*
     &    rzm2**2*b0ftsww - 12.D0*u**(-1)*rzm2 - 24.D0*u**(-1)*rzm2*
     &    b0fmzww + 24.D0*u**(-1)*rzm2*b0ftsww - 2.D0*u**(-1)*rzm2**2*
     &    c0cmztswww - 2.D0*u**(-1)*rzm2**2*c0ccqswww + 12.D0*u**(-1)*
     &    rwm2*rzm2*c0cmztswww + 12.D0*u**(-1)*rwm2*rzm2*c0ccqswww + 8.D
     &    0*rwm2**(-1)*rzm2 - 6.D0*rzm2*c0cmzuswww - 4.D0*rzm2*
     &    c0cmztswww + 4.D0*rzm2*c0cmzqswww - 2.D0*rzm2*c0ccuswww - 4.D0
     &    *rzm2*c0cctswww + 36.D0*rwm2*c0cmzuswww + 24.D0*rwm2*
     &    c0cmztswww - 24.D0*rwm2*c0cmzqswww + 12.D0*rwm2*c0ccuswww + 
     &    24.D0*rwm2*c0cctswww - 4.D0*rwm2*rzm2*d0cccmztsuswwww - 4.D0*
     &    rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*rzm2*d0cccmzqstswwww + 
     &    24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*rwm2**2*d0ccmzcqsuswwww
     &     + 24.D0*rwm2**2*d0cccmzqstswwww + 2.D0*u*rzm2*
     &    d0ccmzcqsuswwww - 12.D0*u*rwm2*d0ccmzcqsuswwww - 2.D0*t*
     &    u**(-1)*rwm2**(-1)*rzm2 + 12.D0*t*u**(-1) + 2.D0*t*u**(-1)*
     &    rzm2*c0cmztswww + 2.D0*t*u**(-1)*rzm2*c0cmzqswww - 2.D0*t*
     &    u**(-1)*rzm2*c0cctswww + 2.D0*t*u**(-1)*rzm2*c0ccqswww - 2.D0
     &    *t*u**(-1)*rzm2**2*d0cccmzqstswwww - 12.D0*t*u**(-1)*rwm2*
     &    c0cmztswww - 12.D0*t*u**(-1)*rwm2*c0cmzqswww + 12.D0*t*
     &    u**(-1)*rwm2*c0cctswww - 12.D0*t*u**(-1)*rwm2*c0ccqswww + 12.D
     &    0*t*u**(-1)*rwm2*rzm2*d0cccmzqstswwww + 2.D0*t*rzm2*
     &    d0cccmztsuswwww + 2.D0*t*rzm2*d0cccmzqstswwww - 12.D0*t*rwm2*
     &    d0cccmztsuswwww - 12.D0*t*rwm2*d0cccmzqstswwww + 2.D0*t**2*
     &    u**(-1)*rzm2*d0cccmzqstswwww - 12.D0*t**2*u**(-1)*rwm2*
     &    d0cccmzqstswwww - 2.D0/(u + t)*s**(-2)*t**(-1)*rwm2**(-1)*
     &    rzm2**5*b0fmzww + 2.D0/(u + t)*s**(-2)*t**(-1)*rwm2**(-1)*
     &    rzm2**5*b0fusww + 12.D0/(u + t)*s**(-2)*t**(-1)*rzm2**4*
     &    b0fmzww - 12.D0/(u + t)*s**(-2)*t**(-1)*rzm2**4*b0fusww - 2.D0
     &    /(u + t)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4 + 6.D0/(u + t)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 6.D0/(u + t)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 12.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**3 - 36.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2**3*b0fmzww + 36.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*
     &    b0fusww + 4.D0/(u + t)*s**(-1)*t**(-1)*rzm2**4*c0cmzuswww - 
     &    24.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2**3*c0cmzuswww + 2.D0
     &    /(u + t)*s**(-1)*t*rwm2**(-1)*rzm2**3*c0cmztswww - 2.D0/(u + 
     &    t)*s**(-1)*t*rwm2**(-1)*rzm2**3*c0ccuswww - 12.D0/(u + t)*
     &    s**(-1)*t*rzm2**2*c0cmztswww + 12.D0/(u + t)*s**(-1)*t*
     &    rzm2**2*c0ccuswww + 2.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    rzm2**2*c0cmzuswww - 4.D0/3.D0/(u + t)*s**(-1)*t**2*
     &    rwm2**(-1)*rzm2**2*c0cmztswww + 4.D0/3.D0/(u + t)*s**(-1)*
     &    t**2*rwm2**(-1)*rzm2**2*c0ccuswww - 2.D0/(u + t)*s**(-1)*t**2
     &    *rwm2**(-1)*rzm2**2*c0cctswww - 2.D0/(u + t)*s**(-1)*t**2*
     &    rwm2**(-1)*rzm2**3*d0cccmztsuswwww - 12.D0/(u + t)*s**(-1)*
     &    t**2*rzm2*c0cmzuswww + 8.D0/(u + t)*s**(-1)*t**2*rzm2*
     &    c0cmztswww - 8.D0/(u + t)*s**(-1)*t**2*rzm2*c0ccuswww + 12.D0
     &    /(u + t)*s**(-1)*t**2*rzm2*c0cctswww + 12.D0/(u + t)*s**(-1)*
     &    t**2*rzm2**2*d0cccmztsuswwww + 2.D0/3.D0/(u + t)*s**(-1)*t**3
     &    *rwm2**(-1)*rzm2*c0cmzuswww - 2.D0/3.D0/(u + t)*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2*c0cmztswww + 2.D0/3.D0/(u + t)*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2*c0ccuswww - 2.D0/3.D0/(u + t)*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2*c0cctswww + 4.D0/3.D0/(u + t)*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2**2*d0cccmztsuswwww - 4.D0/(u + t)*s**(-1)*
     &    t**3*c0cmzuswww + 4.D0/(u + t)*s**(-1)*t**3*c0cmztswww - 4.D0
     &    /(u + t)*s**(-1)*t**3*c0ccuswww + 4.D0/(u + t)*s**(-1)*t**3*
     &    c0cctswww - 8.D0/(u + t)*s**(-1)*t**3*rzm2*d0cccmztsuswwww + 
     &    2.D0/3.D0/(u + t)*s**(-1)*t**4*rwm2**(-1)*rzm2*
     &    d0cccmztsuswwww - 4.D0/(u + t)*s**(-1)*t**4*d0cccmztsuswwww
     &     + 2.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2**3 + 4.D0/(u + t)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fusww - 4.D0/(u + t)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 12.D0/(u + t)*t**(-1)*rzm2**2 - 
     &    24.D0/(u + t)*t**(-1)*rzm2**2*b0fusww + 24.D0/(u + t)*t**(-1)
     &    *rzm2**2*b0ftsww - 4.D0/(u + t)*t**(-1)*rzm2**3*c0cmzuswww + 
     &    24.D0/(u + t)*t**(-1)*rwm2*rzm2**2*c0cmzuswww - 4.D0/(u + t)*
     &    rwm2**(-1)*rzm2**2 + 24.D0/(u + t)*rzm2 - 2.D0/(u + t)*
     &    rzm2**2*c0cmzuswww + 6.D0/(u + t)*rzm2**2*c0cmztswww + 4.D0/(
     &    u + t)*rzm2**2*c0ccqswww + 12.D0/(u + t)*rwm2*rzm2*c0cmzuswww
     &     - 36.D0/(u + t)*rwm2*rzm2*c0cmztswww - 24.D0/(u + t)*rwm2*
     &    rzm2*c0ccqswww - 2.D0/(u + t)*t*rwm2**(-1)*rzm2**2*c0cmztswww
     &     + 2.D0/(u + t)*t*rwm2**(-1)*rzm2**2*c0ccuswww - 2.D0/(u + t)
     &    *t*rzm2*c0cmzuswww + 14.D0/(u + t)*t*rzm2*c0cmztswww - 14.D0
     &    /(u + t)*t*rzm2*c0ccuswww + 2.D0/(u + t)*t*rzm2*c0cctswww + 
     &    12.D0/(u + t)*t*rwm2*c0cmzuswww - 12.D0/(u + t)*t*rwm2*
     &    c0cmztswww + 12.D0/(u + t)*t*rwm2*c0ccuswww - 12.D0/(u + t)*t
     &    *rwm2*c0cctswww - 2.D0/(u + t)*t**2*rwm2**(-1)*rzm2*
     &    c0cmzuswww + 4.D0/3.D0/(u + t)*t**2*rwm2**(-1)*rzm2*
     &    c0cmztswww - 4.D0/3.D0/(u + t)*t**2*rwm2**(-1)*rzm2*c0ccuswww
     &     + 2.D0/(u + t)*t**2*rwm2**(-1)*rzm2*c0cctswww + 2.D0/(u + t)
     &    *t**2*rwm2**(-1)*rzm2**2*d0cccmztsuswwww + 12.D0/(u + t)*t**2
     &    *c0cmzuswww - 8.D0/(u + t)*t**2*c0cmztswww + 8.D0/(u + t)*
     &    t**2*c0ccuswww - 12.D0/(u + t)*t**2*c0cctswww - 14.D0/(u + t)
     &    *t**2*rzm2*d0cccmztsuswwww + 12.D0/(u + t)*t**2*rwm2*
     &    d0cccmztsuswwww - 2.D0/3.D0/(u + t)*t**3*rwm2**(-1)*
     &    c0cmzuswww + 2.D0/3.D0/(u + t)*t**3*rwm2**(-1)*c0cmztswww - 2.
     &    D0/3.D0/(u + t)*t**3*rwm2**(-1)*c0ccuswww + 2.D0/3.D0/(u + t)
     &    *t**3*rwm2**(-1)*c0cctswww - 4.D0/3.D0/(u + t)*t**3*
     &    rwm2**(-1)*rzm2*d0cccmztsuswwww
      ewamp(1,1,2,1) = ewamp(1,1,2,1) + 4.D0/(u + t)*t**3*
     & rzm2**(-1)*c0cmzuswww - 4.D0/(u + t)*t**3*rzm2**(-1)*c0cmztswww
     &     + 4.D0/(u + t)*t**3*rzm2**(-1)*c0ccuswww - 4.D0/(u + t)*t**3
     &    *rzm2**(-1)*c0cctswww + 8.D0/(u + t)*t**3*d0cccmztsuswwww - 2.
     &    D0/3.D0/(u + t)*t**4*rwm2**(-1)*d0cccmztsuswwww + 4.D0/(u + t
     &    )*t**4*rzm2**(-1)*d0cccmztsuswwww - 4.D0/(u + t)/(u + s)*
     &    t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D0/(u + t)/(u + s)*
     &    t**(-1)*rwm2**(-1)*rzm2**4*b0ftsww + 24.D0/(u + t)/(u + s)*
     &    t**(-1)*rzm2**3*b0fmzww - 24.D0/(u + t)/(u + s)*t**(-1)*
     &    rzm2**3*b0ftsww + 4.D0/(u + t)/(u + s)*rwm2**(-1)*rzm2**3 - 
     &    24.D0/(u + t)/(u + s)*rzm2**2 - 8.D0/(u + t)/(u + s)*rzm2**3*
     &    c0cmztswww + 48.D0/(u + t)/(u + s)*rwm2*rzm2**2*c0cmztswww - 
     &    4.D0/(u + t)/(u + s)*t*rwm2**(-1)*rzm2**2 + 24.D0/(u + t)/(u
     &     + s)*t*rzm2 + 8.D0/(u + t)/(u + s)*t*rzm2**2*c0cmztswww - 48.
     &    D0/(u + t)/(u + s)*t*rwm2*rzm2*c0cmztswww + 4.D0/(u + t)/(u
     &     + s)/(u + s)*rwm2**(-1)*rzm2**4*b0fmzww - 4.D0/(u + t)/(u + 
     &    s)/(u + s)*rwm2**(-1)*rzm2**4*b0ftsww - 24.D0/(u + t)/(u + s)
     &    /(u + s)*rzm2**3*b0fmzww + 24.D0/(u + t)/(u + s)/(u + s)*
     &    rzm2**3*b0ftsww - 4.D0/(u + t)/(u + s)/(u + s)*t*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0/(u + t)/(u + s)/(u + s)*t*rwm2**(-1)*
     &    rzm2**3*b0ftsww + 24.D0/(u + t)/(u + s)/(u + s)*t*rzm2**2*
     &    b0fmzww - 24.D0/(u + t)/(u + s)/(u + s)*t*rzm2**2*b0ftsww + 2.
     &    D0/(u + t)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**5*b0fmzww - 2.D0
     &    /(u + t)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**5*b0fusww - 12.D0/(
     &    u + t)/(t + s)*s**(-2)*rzm2**4*b0fmzww + 12.D0/(u + t)/(t + s
     &    )*s**(-2)*rzm2**4*b0fusww + 2.D0/(u + t)/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**4 - 6.D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fmzww + 6.D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fusww - 12.D0/(u + t)/(t + s)*s**(-1)*rzm2**3 + 36.D
     &    0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fmzww - 36.D0/(u + t)/(t
     &     + s)*s**(-1)*rzm2**3*b0fusww - 4.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**4*c0cmzuswww + 24.D0/(u + t)/(t + s)*s**(-1)*rwm2*
     &    rzm2**3*c0cmzuswww + 2.D0/(u + t)/(t + s)*rwm2**(-1)*rzm2**3
     &     + 4.D0/(u + t)/(t + s)*rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(u
     &     + t)/(t + s)*rwm2**(-1)*rzm2**3*b0fusww - 12.D0/(u + t)/(t
     &     + s)*rzm2**2 - 24.D0/(u + t)/(t + s)*rzm2**2*b0fmzww + 24.D0
     &    /(u + t)/(t + s)*rzm2**2*b0fusww - 4.D0/(u + t)/(t + s)*
     &    rzm2**3*c0cmzuswww + 24.D0/(u + t)/(t + s)*rwm2*rzm2**2*
     &    c0cmzuswww - 4.D0/(u + t)/(t + s)*s*rwm2**(-1)*rzm2**2 + 24.D0
     &    /(u + t)/(t + s)*s*rzm2 + 8.D0/(u + t)/(t + s)*s*rzm2**2*
     &    c0cmzuswww - 48.D0/(u + t)/(t + s)*s*rwm2*rzm2*c0cmzuswww + 2.
     &    D0/(u + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**5*b0fmzww
     &     - 2.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**5*
     &    b0fusww - 12.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**4*
     &    b0fmzww + 12.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**4*
     &    b0fusww + 2.D0/(u + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**4*
     &    b0fmzww - 2.D0/(u + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**4*
     &    b0fusww - 12.D0/(u + t)/(t + s)/(t + s)*rzm2**3*b0fmzww + 12.D
     &    0/(u + t)/(t + s)/(t + s)*rzm2**3*b0fusww - 4.D0/(u + t)/(t
     &     + s)/(t + s)*s*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(u + t)/(t
     &     + s)/(t + s)*s*rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(u + t)/(t
     &     + s)/(t + s)*s*rzm2**2*b0fmzww - 24.D0/(u + t)/(t + s)/(t + 
     &    s)*s*rzm2**2*b0fusww + 2.D0/(u + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**4*b0fmzww - 2.D0/(u + s)*s**(-2)*rwm2**(-1)*rzm2**4*
     &    b0ftsww - 12.D0/(u + s)*s**(-2)*rzm2**3*b0fmzww + 12.D0/(u + 
     &    s)*s**(-2)*rzm2**3*b0ftsww - 4.D0/(u + s)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(u + s)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*b0ftsww + 24.D0/(u + s)*s**(-2)*t*rzm2**2*
     &    b0fmzww - 24.D0/(u + s)*s**(-2)*t*rzm2**2*b0ftsww + 2.D0/(u
     &     + s)*s**(-2)*t**2*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u + s)*
     &    s**(-2)*t**2*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0/(u + s)*
     &    s**(-2)*t**2*rzm2*b0fmzww + 12.D0/(u + s)*s**(-2)*t**2*rzm2*
     &    b0ftsww - 4.D0/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 4.D0/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*
     &    b0ftsww + 24.D0/(u + s)*s**(-1)*t**(-1)*rzm2**3*b0fmzww - 24.D
     &    0/(u + s)*s**(-1)*t**(-1)*rzm2**3*b0ftsww + 2.D0/(u + s)*
     &    s**(-1)*rwm2**(-1)*rzm2**3 + 6.D0/(u + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 6.D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2**3*
     &    b0ftsww - 12.D0/(u + s)*s**(-1)*rzm2**2 - 36.D0/(u + s)*
     &    s**(-1)*rzm2**2*b0fmzww + 36.D0/(u + s)*s**(-1)*rzm2**2*
     &    b0ftsww - 4.D0/(u + s)*s**(-1)*rzm2**3*c0cmztswww + 24.D0/(u
     &     + s)*s**(-1)*rwm2*rzm2**2*c0cmztswww - 4.D0/(u + s)*s**(-1)*
     &    t*rwm2**(-1)*rzm2**2 - 2.D0/(u + s)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 2.D0/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2**2*
     &    b0ftsww + 24.D0/(u + s)*s**(-1)*t*rzm2 + 12.D0/(u + s)*
     &    s**(-1)*t*rzm2*b0fmzww - 12.D0/(u + s)*s**(-1)*t*rzm2*b0ftsww
     &     + 8.D0/(u + s)*s**(-1)*t*rzm2**2*c0cmztswww - 48.D0/(u + s)*
     &    s**(-1)*t*rwm2*rzm2*c0cmztswww + 2.D0/(u + s)*s**(-1)*t**2*
     &    rwm2**(-1)*rzm2 - 12.D0/(u + s)*s**(-1)*t**2 - 4.D0/(u + s)*
     &    s**(-1)*t**2*rzm2*c0cmztswww + 24.D0/(u + s)*s**(-1)*t**2*
     &    rwm2*c0cmztswww - 2.D0/(u + s)*rwm2**(-1)*rzm2**2 + 2.D0/(u
     &     + s)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u + s)*rwm2**(-1)*
     &    rzm2**2*b0ftsww + 12.D0/(u + s)*rzm2 - 12.D0/(u + s)*rzm2*
     &    b0fmzww + 12.D0/(u + s)*rzm2*b0ftsww + 4.D0/(u + s)*rzm2**2*
     &    c0cmztswww - 24.D0/(u + s)*rwm2*rzm2*c0cmztswww + 2.D0/(u + s
     &    )*t*rwm2**(-1)*rzm2 - 12.D0/(u + s)*t - 4.D0/(u + s)*t*rzm2*
     &    c0cmztswww + 24.D0/(u + s)*t*rwm2*c0cmztswww + 2.D0/(u + s)/(
     &    u + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 2.D0/(u + s)/(u
     &     + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0ftsww - 12.D0/(u + s)/(u
     &     + s)*s**(-1)*rzm2**3*b0fmzww + 12.D0/(u + s)/(u + s)*s**(-1)
     &    *rzm2**3*b0ftsww - 4.D0/(u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0/(u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**3*b0ftsww + 24.D0/(u + s)/(u + s)*s**(-1)*t*rzm2**2*
     &    b0fmzww - 24.D0/(u + s)/(u + s)*s**(-1)*t*rzm2**2*b0ftsww + 2.
     &    D0/(u + s)/(u + s)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*b0fmzww - 
     &    2.D0/(u + s)/(u + s)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*b0ftsww
     &     - 12.D0/(u + s)/(u + s)*s**(-1)*t**2*rzm2*b0fmzww + 12.D0/(u
     &     + s)/(u + s)*s**(-1)*t**2*rzm2*b0ftsww - 2.D0/(u + s)/(u + s
     &    )*rwm2**(-1)*rzm2**3*b0fmzww + 2.D0/(u + s)/(u + s)*
     &    rwm2**(-1)*rzm2**3*b0ftsww + 12.D0/(u + s)/(u + s)*rzm2**2*
     &    b0fmzww - 12.D0/(u + s)/(u + s)*rzm2**2*b0ftsww + 2.D0/(u + s
     &    )/(u + s)*t*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u + s)/(u + s)
     &    *t*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0/(u + s)/(u + s)*t*rzm2*
     &    b0fmzww + 12.D0/(u + s)/(u + s)*t*rzm2*b0ftsww - 4.D0/(t + s)
     &    *s**(-2)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D0/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**4*b0fusww + 24.D0/(t + s)*s**(-2)*rzm2**3*
     &    b0fmzww - 24.D0/(t + s)*s**(-2)*rzm2**3*b0fusww + 2.D0/(t + s
     &    )*s**(-2)*u*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0/(t + s)*s**(-2)
     &    *u*rwm2**(-1)*rzm2**3*b0fusww - 12.D0/(t + s)*s**(-2)*u*
     &    rzm2**2*b0fmzww + 12.D0/(t + s)*s**(-2)*u*rzm2**2*b0fusww - 4.
     &    D0/(t + s)*s**(-1)*rwm2**(-1)*rzm2**3 + 10.D0/(t + s)*s**(-1)
     &    *rwm2**(-1)*rzm2**3*b0fmzww - 10.D0/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(t + s)*s**(-1)*rzm2**2 - 
     &    60.D0/(t + s)*s**(-1)*rzm2**2*b0fmzww + 60.D0/(t + s)*s**(-1)
     &    *rzm2**2*b0fusww + 8.D0/(t + s)*s**(-1)*rzm2**3*c0cmzuswww - 
     &    48.D0/(t + s)*s**(-1)*rwm2*rzm2**2*c0cmzuswww + 2.D0/(t + s)*
     &    s**(-1)*u*rwm2**(-1)*rzm2**2 - 4.D0/(t + s)*s**(-1)*u*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 4.D0/(t + s)*s**(-1)*u*
     &    rwm2**(-1)*rzm2**2*b0fusww - 12.D0/(t + s)*s**(-1)*u*rzm2 + 
     &    24.D0/(t + s)*s**(-1)*u*rzm2*b0fmzww - 24.D0/(t + s)*s**(-1)*
     &    u*rzm2*b0fusww - 4.D0/(t + s)*s**(-1)*u*rzm2**2*c0cmzuswww + 
     &    24.D0/(t + s)*s**(-1)*u*rwm2*rzm2*c0cmzuswww - 8.D0/(t + s)*
     &    rwm2**(-1)*rzm2**2 + 4.D0/(t + s)*rwm2**(-1)*rzm2**2*b0fmzww
     &     - 4.D0/(t + s)*rwm2**(-1)*rzm2**2*b0fusww + 48.D0/(t + s)*
     &    rzm2 - 24.D0/(t + s)*rzm2*b0fmzww + 24.D0/(t + s)*rzm2*
     &    b0fusww + 16.D0/(t + s)*rzm2**2*c0cmzuswww - 96.D0/(t + s)*
     &    rwm2*rzm2*c0cmzuswww + 4.D0/(t + s)*u*rwm2**(-1)*rzm2 - 24.D0
     &    /(t + s)*u - 8.D0/(t + s)*u*rzm2*c0cmzuswww + 48.D0/(t + s)*u
     &    *rwm2*c0cmzuswww - 4.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fmzww + 4.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fusww + 24.D0/(t + s)/(t + s)*s**(-1)*rzm2**3*
     &    b0fmzww - 24.D0/(t + s)/(t + s)*s**(-1)*rzm2**3*b0fusww + 2.D0
     &    /(t + s)/(t + s)*s**(-1)*u*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0
     &    /(t + s)/(t + s)*s**(-1)*u*rwm2**(-1)*rzm2**3*b0fusww - 12.D0
     &    /(t + s)/(t + s)*s**(-1)*u*rzm2**2*b0fmzww + 12.D0/(t + s)/(t
     &     + s)*s**(-1)*u*rzm2**2*b0fusww - 8.D0/(t + s)/(t + s)*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 8.D0/(t + s)/(t + s)*rwm2**(-1)*
     &    rzm2**3*b0fusww + 48.D0/(t + s)/(t + s)*rzm2**2*b0fmzww - 48.D
     &    0/(t + s)/(t + s)*rzm2**2*b0fusww + 4.D0/(t + s)/(t + s)*u*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 4.D0/(t + s)/(t + s)*u*
     &    rwm2**(-1)*rzm2**2*b0fusww - 24.D0/(t + s)/(t + s)*u*rzm2*
     &    b0fmzww + 24.D0/(t + s)/(t + s)*u*rzm2*b0fusww

      ewamp(1,1,2,2) =
     &  + 36.D0 - 6.D0*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 6.D0
     &    *s**(-2)*t**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 36.D0*s**(-2)*
     &    t**(-1)*rzm2**3*b0fmzww - 36.D0*s**(-2)*t**(-1)*rzm2**3*
     &    b0fusww + 6.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2**3*b0fmzww
     &     - 6.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2**3*b0fusww - 36.D0*
     &    s**(-2)*t**(-1)*u*rzm2**2*b0fmzww + 36.D0*s**(-2)*t**(-1)*u*
     &    rzm2**2*b0fusww - 2.D0*s**(-2)*t**(-1)*u**2*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 2.D0*s**(-2)*t**(-1)*u**2*rwm2**(-1)*
     &    rzm2**2*b0fusww + 12.D0*s**(-2)*t**(-1)*u**2*rzm2*b0fmzww - 
     &    12.D0*s**(-2)*t**(-1)*u**2*rzm2*b0fusww + 2.D0*s**(-2)*
     &    u**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 2.D0*s**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**4*b0ftsww - 12.D0*s**(-2)*u**(-1)*rzm2**3*
     &    b0fmzww + 12.D0*s**(-2)*u**(-1)*rzm2**3*b0ftsww - 4.D0*
     &    s**(-2)*t*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0*s**(-2)*t
     &    *u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 24.D0*s**(-2)*t*u**(-1)
     &    *rzm2**2*b0fmzww - 24.D0*s**(-2)*t*u**(-1)*rzm2**2*b0ftsww + 
     &    2.D0*s**(-2)*t**2*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*
     &    s**(-2)*t**2*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0*
     &    s**(-2)*t**2*u**(-1)*rzm2*b0fmzww + 12.D0*s**(-2)*t**2*
     &    u**(-1)*rzm2*b0ftsww - 4.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**4*b0fmzww + 4.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**4*b0ftsww + 24.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rzm2**3*b0fmzww - 24.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*
     &    b0ftsww - 6.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3 + 12.D0*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 12.D0*s**(-1)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fusww + 36.D0*s**(-1)*t**(-1)*
     &    rzm2**2 - 72.D0*s**(-1)*t**(-1)*rzm2**2*b0fmzww + 72.D0*
     &    s**(-1)*t**(-1)*rzm2**2*b0fusww + 12.D0*s**(-1)*t**(-1)*
     &    rzm2**3*c0cmzuswww - 72.D0*s**(-1)*t**(-1)*rwm2*rzm2**2*
     &    c0cmzuswww + 6.D0*s**(-1)*t**(-1)*u*rwm2**(-1)*rzm2**2 - 6.D0
     &    *s**(-1)*t**(-1)*u*rwm2**(-1)*rzm2**2*b0fmzww + 6.D0*s**(-1)*
     &    t**(-1)*u*rwm2**(-1)*rzm2**2*b0fusww - 36.D0*s**(-1)*t**(-1)*
     &    u*rzm2 + 36.D0*s**(-1)*t**(-1)*u*rzm2*b0fmzww - 36.D0*s**(-1)
     &    *t**(-1)*u*rzm2*b0fusww - 12.D0*s**(-1)*t**(-1)*u*rzm2**2*
     &    c0cmzuswww + 72.D0*s**(-1)*t**(-1)*u*rwm2*rzm2*c0cmzuswww - 2.
     &    D0*s**(-1)*t**(-1)*u**2*rwm2**(-1)*rzm2 + 12.D0*s**(-1)*
     &    t**(-1)*u**2 + 4.D0*s**(-1)*t**(-1)*u**2*rzm2*c0cmzuswww - 24.
     &    D0*s**(-1)*t**(-1)*u**2*rwm2*c0cmzuswww + 2.D0*s**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3 + 6.D0*s**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 6.D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0ftsww - 12.D0*s**(-1)*u**(-1)*rzm2**2 - 36.D0*s**(-1)*
     &    u**(-1)*rzm2**2*b0fmzww + 36.D0*s**(-1)*u**(-1)*rzm2**2*
     &    b0ftsww - 4.D0*s**(-1)*u**(-1)*rzm2**3*c0cmztswww + 24.D0*
     &    s**(-1)*u**(-1)*rwm2*rzm2**2*c0cmztswww + 2.D0*s**(-1)*
     &    rzm2**2*c0cmztswww - 2.D0*s**(-1)*rzm2**2*c0ccuswww - 12.D0*
     &    s**(-1)*rwm2*rzm2*c0cmztswww + 12.D0*s**(-1)*rwm2*rzm2*
     &    c0ccuswww - 4.D0*s**(-1)*t*u**(-1)*rwm2**(-1)*rzm2**2 - 2.D0*
     &    s**(-1)*t*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0*s**(-1)*t
     &    *u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww + 24.D0*s**(-1)*t*u**(-1)
     &    *rzm2 + 12.D0*s**(-1)*t*u**(-1)*rzm2*b0fmzww - 12.D0*s**(-1)*
     &    t*u**(-1)*rzm2*b0ftsww + 8.D0*s**(-1)*t*u**(-1)*rzm2**2*
     &    c0cmztswww - 48.D0*s**(-1)*t*u**(-1)*rwm2*rzm2*c0cmztswww + 2.
     &    D0*s**(-1)*t*rwm2**(-1)*rzm2**2*c0cmztswww - 2.D0*s**(-1)*t*
     &    rwm2**(-1)*rzm2**2*c0ccuswww + 2.D0*s**(-1)*t*rzm2*c0cmzuswww
     &     - 14.D0*s**(-1)*t*rzm2*c0cmztswww + 14.D0*s**(-1)*t*rzm2*
     &    c0ccuswww - 2.D0*s**(-1)*t*rzm2*c0cctswww - 2.D0*s**(-1)*t*
     &    rzm2**2*d0cccmztsuswwww - 12.D0*s**(-1)*t*rwm2*c0cmzuswww + 
     &    12.D0*s**(-1)*t*rwm2*c0cmztswww - 12.D0*s**(-1)*t*rwm2*
     &    c0ccuswww + 12.D0*s**(-1)*t*rwm2*c0cctswww + 12.D0*s**(-1)*t*
     &    rwm2*rzm2*d0cccmztsuswwww + 2.D0*s**(-1)*t**2*u**(-1)*
     &    rwm2**(-1)*rzm2 - 12.D0*s**(-1)*t**2*u**(-1) - 4.D0*s**(-1)*
     &    t**2*u**(-1)*rzm2*c0cmztswww + 24.D0*s**(-1)*t**2*u**(-1)*
     &    rwm2*c0cmztswww + 2.D0*s**(-1)*t**2*rwm2**(-1)*rzm2*
     &    c0cmzuswww - 4.D0/3.D0*s**(-1)*t**2*rwm2**(-1)*rzm2*
     &    c0cmztswww + 4.D0/3.D0*s**(-1)*t**2*rwm2**(-1)*rzm2*c0ccuswww
     &     - 2.D0*s**(-1)*t**2*rwm2**(-1)*rzm2*c0cctswww - 2.D0*s**(-1)
     &    *t**2*rwm2**(-1)*rzm2**2*d0cccmztsuswwww - 12.D0*s**(-1)*t**2
     &    *c0cmzuswww + 8.D0*s**(-1)*t**2*c0cmztswww - 8.D0*s**(-1)*
     &    t**2*c0ccuswww + 12.D0*s**(-1)*t**2*c0cctswww + 14.D0*s**(-1)
     &    *t**2*rzm2*d0cccmztsuswwww - 12.D0*s**(-1)*t**2*rwm2*
     &    d0cccmztsuswwww + 2.D0/3.D0*s**(-1)*t**3*rwm2**(-1)*
     &    c0cmzuswww - 2.D0/3.D0*s**(-1)*t**3*rwm2**(-1)*c0cmztswww + 2.
     &    D0/3.D0*s**(-1)*t**3*rwm2**(-1)*c0ccuswww - 2.D0/3.D0*s**(-1)
     &    *t**3*rwm2**(-1)*c0cctswww + 4.D0/3.D0*s**(-1)*t**3*
     &    rwm2**(-1)*rzm2*d0cccmztsuswwww - 4.D0*s**(-1)*t**3*
     &    rzm2**(-1)*c0cmzuswww + 4.D0*s**(-1)*t**3*rzm2**(-1)*
     &    c0cmztswww - 4.D0*s**(-1)*t**3*rzm2**(-1)*c0ccuswww + 4.D0*
     &    s**(-1)*t**3*rzm2**(-1)*c0cctswww - 8.D0*s**(-1)*t**3*
     &    d0cccmztsuswwww + 2.D0/3.D0*s**(-1)*t**4*rwm2**(-1)*
     &    d0cccmztsuswwww - 4.D0*s**(-1)*t**4*rzm2**(-1)*
     &    d0cccmztsuswwww + 4.D0*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 4.D0*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww - 
     &    24.D0*t**(-1)*u**(-1)*rzm2**2*b0fmzww + 24.D0*t**(-1)*u**(-1)
     &    *rzm2**2*b0ftsww + 4.D0*t**(-1)*rwm2**(-1)*rzm2**2 - 4.D0*
     &    t**(-1)*rwm2**(-1)*rzm2**2*b0fmzww + 4.D0*t**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fusww - 24.D0*t**(-1)*rzm2 + 24.D0*t**(-1)*rzm2*
     &    b0fmzww - 24.D0*t**(-1)*rzm2*b0fusww - 8.D0*t**(-1)*rzm2**2*
     &    c0cmzuswww + 48.D0*t**(-1)*rwm2*rzm2*c0cmzuswww - 2.D0*
     &    t**(-1)*u*rwm2**(-1)*rzm2 + 12.D0*t**(-1)*u + 4.D0*t**(-1)*u*
     &    rzm2*c0cmzuswww - 24.D0*t**(-1)*u*rwm2*c0cmzuswww - 2.D0*
     &    u**(-1)*rwm2**(-1)*rzm2**2 - 4.D0*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww + 4.D0*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww + 12.D0*
     &    u**(-1)*rzm2 + 24.D0*u**(-1)*rzm2*b0fmzww - 24.D0*u**(-1)*
     &    rzm2*b0ftsww + 4.D0*u**(-1)*rzm2**2*c0cmztswww - 24.D0*
     &    u**(-1)*rwm2*rzm2*c0cmztswww - 6.D0*rwm2**(-1)*rzm2 + 12.D0*
     &    rzm2*c0cmzuswww + 4.D0*rzm2*c0cmztswww - 72.D0*rwm2*
     &    c0cmzuswww - 24.D0*rwm2*c0cmztswww - 4.D0*rwm2*rzm2*
     &    d0cccmztsuswwww - 4.D0*rwm2*rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*
     &    rzm2*d0cccmzqstswwww + 24.D0*rwm2**2*d0cccmztsuswwww + 24.D0*
     &    rwm2**2*d0ccmzcqsuswwww + 24.D0*rwm2**2*d0cccmzqstswwww + 2.D0
     &    *t*u**(-1)*rwm2**(-1)*rzm2 - 12.D0*t*u**(-1) - 4.D0*t*u**(-1)
     &    *rzm2*c0cmztswww + 24.D0*t*u**(-1)*rwm2*c0cmztswww + 2.D0/(u
     &     + t)*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**5*b0fmzww - 2.D0/(u + 
     &    t)*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**5*b0fusww - 12.D0/(u + t)
     &    *s**(-2)*t**(-1)*rzm2**4*b0fmzww + 12.D0/(u + t)*s**(-2)*
     &    t**(-1)*rzm2**4*b0fusww + 2.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**4 - 6.D0/(u + t)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fmzww + 6.D0/(u + t)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fusww - 12.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3 + 36.D
     &    0/(u + t)*s**(-1)*t**(-1)*rzm2**3*b0fmzww - 36.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**3*b0fusww - 4.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**4*c0cmzuswww + 24.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2*rzm2**3*c0cmzuswww - 2.D0/(u + t)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**3*c0cmztswww + 2.D0/(u + t)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**3*c0ccuswww + 12.D0/(u + t)*s**(-1)*t*rzm2**2*
     &    c0cmztswww - 12.D0/(u + t)*s**(-1)*t*rzm2**2*c0ccuswww - 2.D0
     &    /(u + t)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*c0cmzuswww + 4.D0/3.D
     &    0/(u + t)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*c0cmztswww - 4.D0/3.
     &    D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*c0ccuswww + 2.D0/(
     &    u + t)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*c0cctswww + 2.D0/(u + 
     &    t)*s**(-1)*t**2*rwm2**(-1)*rzm2**3*d0cccmztsuswwww + 12.D0/(u
     &     + t)*s**(-1)*t**2*rzm2*c0cmzuswww - 8.D0/(u + t)*s**(-1)*
     &    t**2*rzm2*c0cmztswww + 8.D0/(u + t)*s**(-1)*t**2*rzm2*
     &    c0ccuswww - 12.D0/(u + t)*s**(-1)*t**2*rzm2*c0cctswww - 12.D0
     &    /(u + t)*s**(-1)*t**2*rzm2**2*d0cccmztsuswwww - 2.D0/3.D0/(u
     &     + t)*s**(-1)*t**3*rwm2**(-1)*rzm2*c0cmzuswww + 2.D0/3.D0/(u
     &     + t)*s**(-1)*t**3*rwm2**(-1)*rzm2*c0cmztswww - 2.D0/3.D0/(u
     &     + t)*s**(-1)*t**3*rwm2**(-1)*rzm2*c0ccuswww + 2.D0/3.D0/(u
     &     + t)*s**(-1)*t**3*rwm2**(-1)*rzm2*c0cctswww - 4.D0/3.D0/(u
     &     + t)*s**(-1)*t**3*rwm2**(-1)*rzm2**2*d0cccmztsuswwww + 4.D0
     &    /(u + t)*s**(-1)*t**3*c0cmzuswww - 4.D0/(u + t)*s**(-1)*t**3*
     &    c0cmztswww + 4.D0/(u + t)*s**(-1)*t**3*c0ccuswww - 4.D0/(u + 
     &    t)*s**(-1)*t**3*c0cctswww + 8.D0/(u + t)*s**(-1)*t**3*rzm2*
     &    d0cccmztsuswwww - 2.D0/3.D0/(u + t)*s**(-1)*t**4*rwm2**(-1)*
     &    rzm2*d0cccmztsuswwww + 4.D0/(u + t)*s**(-1)*t**4*
     &    d0cccmztsuswwww - 2.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2**3 - 4.
     &    D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2**3*b0fusww + 4.D0/(u + t)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 12.D0/(u + t)*t**(-1)*
     &    rzm2**2 + 24.D0/(u + t)*t**(-1)*rzm2**2*b0fusww - 24.D0/(u + 
     &    t)*t**(-1)*rzm2**2*b0ftsww + 4.D0/(u + t)*t**(-1)*rzm2**3*
     &    c0cmzuswww - 24.D0/(u + t)*t**(-1)*rwm2*rzm2**2*c0cmzuswww + 
     &    4.D0/(u + t)*rwm2**(-1)*rzm2**2 - 24.D0/(u + t)*rzm2 + 2.D0/(
     &    u + t)*rzm2**2*c0cmzuswww - 6.D0/(u + t)*rzm2**2*c0cmztswww
     &     - 4.D0/(u + t)*rzm2**2*c0ccqswww - 12.D0/(u + t)*rwm2*rzm2*
     &    c0cmzuswww + 36.D0/(u + t)*rwm2*rzm2*c0cmztswww + 24.D0/(u + 
     &    t)*rwm2*rzm2*c0ccqswww + 2.D0/(u + t)*t*rwm2**(-1)*rzm2**2*
     &    c0cmztswww - 2.D0/(u + t)*t*rwm2**(-1)*rzm2**2*c0ccuswww + 2.D
     &    0/(u + t)*t*rzm2*c0cmzuswww - 14.D0/(u + t)*t*rzm2*c0cmztswww
     &     + 14.D0/(u + t)*t*rzm2*c0ccuswww - 2.D0/(u + t)*t*rzm2*
     &    c0cctswww - 12.D0/(u + t)*t*rwm2*c0cmzuswww + 12.D0/(u + t)*t
     &    *rwm2*c0cmztswww - 12.D0/(u + t)*t*rwm2*c0ccuswww + 12.D0/(u
     &     + t)*t*rwm2*c0cctswww + 2.D0/(u + t)*t**2*rwm2**(-1)*rzm2*
     &    c0cmzuswww - 4.D0/3.D0/(u + t)*t**2*rwm2**(-1)*rzm2*
     &    c0cmztswww + 4.D0/3.D0/(u + t)*t**2*rwm2**(-1)*rzm2*c0ccuswww
     &     - 2.D0/(u + t)*t**2*rwm2**(-1)*rzm2*c0cctswww - 2.D0/(u + t)
     &    *t**2*rwm2**(-1)*rzm2**2*d0cccmztsuswwww - 12.D0/(u + t)*t**2
     &    *c0cmzuswww + 8.D0/(u + t)*t**2*c0cmztswww - 8.D0/(u + t)*
     &    t**2*c0ccuswww + 12.D0/(u + t)*t**2*c0cctswww + 14.D0/(u + t)
     &    *t**2*rzm2*d0cccmztsuswwww - 12.D0/(u + t)*t**2*rwm2*
     &    d0cccmztsuswwww + 2.D0/3.D0/(u + t)*t**3*rwm2**(-1)*
     &    c0cmzuswww - 2.D0/3.D0/(u + t)*t**3*rwm2**(-1)*c0cmztswww + 2.
     &    D0/3.D0/(u + t)*t**3*rwm2**(-1)*c0ccuswww - 2.D0/3.D0/(u + t)
     &    *t**3*rwm2**(-1)*c0cctswww + 4.D0/3.D0/(u + t)*t**3*
     &    rwm2**(-1)*rzm2*d0cccmztsuswwww - 4.D0/(u + t)*t**3*
     &    rzm2**(-1)*c0cmzuswww + 4.D0/(u + t)*t**3*rzm2**(-1)*
     &    c0cmztswww - 4.D0/(u + t)*t**3*rzm2**(-1)*c0ccuswww + 4.D0/(u
     &     + t)*t**3*rzm2**(-1)*c0cctswww - 8.D0/(u + t)*t**3*
     &    d0cccmztsuswwww + 2.D0/3.D0/(u + t)*t**4*rwm2**(-1)*
     &    d0cccmztsuswwww - 4.D0/(u + t)*t**4*rzm2**(-1)*
     &    d0cccmztsuswwww
      ewamp(1,1,2,2) = ewamp(1,1,2,2) + 4.D0/(u + t)/(u + s)*
     & t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 4.D0/(u + t)/(u + s)*
     &    t**(-1)*rwm2**(-1)*rzm2**4*b0ftsww - 24.D0/(u + t)/(u + s)*
     &    t**(-1)*rzm2**3*b0fmzww + 24.D0/(u + t)/(u + s)*t**(-1)*
     &    rzm2**3*b0ftsww - 4.D0/(u + t)/(u + s)*rwm2**(-1)*rzm2**3 + 
     &    24.D0/(u + t)/(u + s)*rzm2**2 + 8.D0/(u + t)/(u + s)*rzm2**3*
     &    c0cmztswww - 48.D0/(u + t)/(u + s)*rwm2*rzm2**2*c0cmztswww + 
     &    4.D0/(u + t)/(u + s)*t*rwm2**(-1)*rzm2**2 - 24.D0/(u + t)/(u
     &     + s)*t*rzm2 - 8.D0/(u + t)/(u + s)*t*rzm2**2*c0cmztswww + 48.
     &    D0/(u + t)/(u + s)*t*rwm2*rzm2*c0cmztswww - 4.D0/(u + t)/(u
     &     + s)/(u + s)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D0/(u + t)/(u + 
     &    s)/(u + s)*rwm2**(-1)*rzm2**4*b0ftsww + 24.D0/(u + t)/(u + s)
     &    /(u + s)*rzm2**3*b0fmzww - 24.D0/(u + t)/(u + s)/(u + s)*
     &    rzm2**3*b0ftsww + 4.D0/(u + t)/(u + s)/(u + s)*t*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 4.D0/(u + t)/(u + s)/(u + s)*t*rwm2**(-1)*
     &    rzm2**3*b0ftsww - 24.D0/(u + t)/(u + s)/(u + s)*t*rzm2**2*
     &    b0fmzww + 24.D0/(u + t)/(u + s)/(u + s)*t*rzm2**2*b0ftsww - 2.
     &    D0/(u + t)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**5*b0fmzww + 2.D0
     &    /(u + t)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**5*b0fusww + 12.D0/(
     &    u + t)/(t + s)*s**(-2)*rzm2**4*b0fmzww - 12.D0/(u + t)/(t + s
     &    )*s**(-2)*rzm2**4*b0fusww - 2.D0/(u + t)/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**4 + 6.D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fmzww - 6.D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fusww + 12.D0/(u + t)/(t + s)*s**(-1)*rzm2**3 - 36.D
     &    0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fmzww + 36.D0/(u + t)/(t
     &     + s)*s**(-1)*rzm2**3*b0fusww + 4.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**4*c0cmzuswww - 24.D0/(u + t)/(t + s)*s**(-1)*rwm2*
     &    rzm2**3*c0cmzuswww - 2.D0/(u + t)/(t + s)*rwm2**(-1)*rzm2**3
     &     - 4.D0/(u + t)/(t + s)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(u
     &     + t)/(t + s)*rwm2**(-1)*rzm2**3*b0fusww + 12.D0/(u + t)/(t
     &     + s)*rzm2**2 + 24.D0/(u + t)/(t + s)*rzm2**2*b0fmzww - 24.D0
     &    /(u + t)/(t + s)*rzm2**2*b0fusww + 4.D0/(u + t)/(t + s)*
     &    rzm2**3*c0cmzuswww - 24.D0/(u + t)/(t + s)*rwm2*rzm2**2*
     &    c0cmzuswww + 4.D0/(u + t)/(t + s)*s*rwm2**(-1)*rzm2**2 - 24.D0
     &    /(u + t)/(t + s)*s*rzm2 - 8.D0/(u + t)/(t + s)*s*rzm2**2*
     &    c0cmzuswww + 48.D0/(u + t)/(t + s)*s*rwm2*rzm2*c0cmzuswww - 2.
     &    D0/(u + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**5*b0fmzww
     &     + 2.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**5*
     &    b0fusww + 12.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**4*
     &    b0fmzww - 12.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**4*
     &    b0fusww - 2.D0/(u + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 2.D0/(u + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**4*
     &    b0fusww + 12.D0/(u + t)/(t + s)/(t + s)*rzm2**3*b0fmzww - 12.D
     &    0/(u + t)/(t + s)/(t + s)*rzm2**3*b0fusww + 4.D0/(u + t)/(t
     &     + s)/(t + s)*s*rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(u + t)/(t
     &     + s)/(t + s)*s*rwm2**(-1)*rzm2**3*b0fusww - 24.D0/(u + t)/(t
     &     + s)/(t + s)*s*rzm2**2*b0fmzww + 24.D0/(u + t)/(t + s)/(t + 
     &    s)*s*rzm2**2*b0fusww - 2.D0/(u + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**4*b0fmzww + 2.D0/(u + s)*s**(-2)*rwm2**(-1)*rzm2**4*
     &    b0ftsww + 12.D0/(u + s)*s**(-2)*rzm2**3*b0fmzww - 12.D0/(u + 
     &    s)*s**(-2)*rzm2**3*b0ftsww + 4.D0/(u + s)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(u + s)*s**(-2)*t*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 24.D0/(u + s)*s**(-2)*t*rzm2**2*
     &    b0fmzww + 24.D0/(u + s)*s**(-2)*t*rzm2**2*b0ftsww - 2.D0/(u
     &     + s)*s**(-2)*t**2*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)*
     &    s**(-2)*t**2*rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + s)*
     &    s**(-2)*t**2*rzm2*b0fmzww - 12.D0/(u + s)*s**(-2)*t**2*rzm2*
     &    b0ftsww + 4.D0/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fmzww - 4.D0/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*
     &    b0ftsww - 24.D0/(u + s)*s**(-1)*t**(-1)*rzm2**3*b0fmzww + 24.D
     &    0/(u + s)*s**(-1)*t**(-1)*rzm2**3*b0ftsww - 2.D0/(u + s)*
     &    s**(-1)*rwm2**(-1)*rzm2**3 - 6.D0/(u + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 6.D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2**3*
     &    b0ftsww + 12.D0/(u + s)*s**(-1)*rzm2**2 + 36.D0/(u + s)*
     &    s**(-1)*rzm2**2*b0fmzww - 36.D0/(u + s)*s**(-1)*rzm2**2*
     &    b0ftsww + 4.D0/(u + s)*s**(-1)*rzm2**3*c0cmztswww - 24.D0/(u
     &     + s)*s**(-1)*rwm2*rzm2**2*c0cmztswww + 4.D0/(u + s)*s**(-1)*
     &    t*rwm2**(-1)*rzm2**2 + 2.D0/(u + s)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**2*b0fmzww - 2.D0/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2**2*
     &    b0ftsww - 24.D0/(u + s)*s**(-1)*t*rzm2 - 12.D0/(u + s)*
     &    s**(-1)*t*rzm2*b0fmzww + 12.D0/(u + s)*s**(-1)*t*rzm2*b0ftsww
     &     - 8.D0/(u + s)*s**(-1)*t*rzm2**2*c0cmztswww + 48.D0/(u + s)*
     &    s**(-1)*t*rwm2*rzm2*c0cmztswww - 2.D0/(u + s)*s**(-1)*t**2*
     &    rwm2**(-1)*rzm2 + 12.D0/(u + s)*s**(-1)*t**2 + 4.D0/(u + s)*
     &    s**(-1)*t**2*rzm2*c0cmztswww - 24.D0/(u + s)*s**(-1)*t**2*
     &    rwm2*c0cmztswww + 2.D0/(u + s)*rwm2**(-1)*rzm2**2 - 2.D0/(u
     &     + s)*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)*rwm2**(-1)*
     &    rzm2**2*b0ftsww - 12.D0/(u + s)*rzm2 + 12.D0/(u + s)*rzm2*
     &    b0fmzww - 12.D0/(u + s)*rzm2*b0ftsww - 4.D0/(u + s)*rzm2**2*
     &    c0cmztswww + 24.D0/(u + s)*rwm2*rzm2*c0cmztswww - 2.D0/(u + s
     &    )*t*rwm2**(-1)*rzm2 + 12.D0/(u + s)*t + 4.D0/(u + s)*t*rzm2*
     &    c0cmztswww - 24.D0/(u + s)*t*rwm2*c0cmztswww - 2.D0/(u + s)/(
     &    u + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 2.D0/(u + s)/(u
     &     + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0ftsww + 12.D0/(u + s)/(u
     &     + s)*s**(-1)*rzm2**3*b0fmzww - 12.D0/(u + s)/(u + s)*s**(-1)
     &    *rzm2**3*b0ftsww + 4.D0/(u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 4.D0/(u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*
     &    rzm2**3*b0ftsww - 24.D0/(u + s)/(u + s)*s**(-1)*t*rzm2**2*
     &    b0fmzww + 24.D0/(u + s)/(u + s)*s**(-1)*t*rzm2**2*b0ftsww - 2.
     &    D0/(u + s)/(u + s)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*b0fmzww + 
     &    2.D0/(u + s)/(u + s)*s**(-1)*t**2*rwm2**(-1)*rzm2**2*b0ftsww
     &     + 12.D0/(u + s)/(u + s)*s**(-1)*t**2*rzm2*b0fmzww - 12.D0/(u
     &     + s)/(u + s)*s**(-1)*t**2*rzm2*b0ftsww + 2.D0/(u + s)/(u + s
     &    )*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0/(u + s)/(u + s)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 12.D0/(u + s)/(u + s)*rzm2**2*
     &    b0fmzww + 12.D0/(u + s)/(u + s)*rzm2**2*b0ftsww - 2.D0/(u + s
     &    )/(u + s)*t*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)/(u + s)
     &    *t*rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + s)/(u + s)*t*rzm2*
     &    b0fmzww - 12.D0/(u + s)/(u + s)*t*rzm2*b0ftsww + 6.D0/(t + s)
     &    *s**(-2)*rwm2**(-1)*rzm2**4*b0fmzww - 6.D0/(t + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**4*b0fusww - 36.D0/(t + s)*s**(-2)*rzm2**3*
     &    b0fmzww + 36.D0/(t + s)*s**(-2)*rzm2**3*b0fusww - 6.D0/(t + s
     &    )*s**(-2)*u*rwm2**(-1)*rzm2**3*b0fmzww + 6.D0/(t + s)*s**(-2)
     &    *u*rwm2**(-1)*rzm2**3*b0fusww + 36.D0/(t + s)*s**(-2)*u*
     &    rzm2**2*b0fmzww - 36.D0/(t + s)*s**(-2)*u*rzm2**2*b0fusww + 2.
     &    D0/(t + s)*s**(-2)*u**2*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(t
     &     + s)*s**(-2)*u**2*rwm2**(-1)*rzm2**2*b0fusww - 12.D0/(t + s)
     &    *s**(-2)*u**2*rzm2*b0fmzww + 12.D0/(t + s)*s**(-2)*u**2*rzm2*
     &    b0fusww + 6.D0/(t + s)*s**(-1)*rwm2**(-1)*rzm2**3 - 12.D0/(t
     &     + s)*s**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 12.D0/(t + s)*
     &    s**(-1)*rwm2**(-1)*rzm2**3*b0fusww - 36.D0/(t + s)*s**(-1)*
     &    rzm2**2 + 72.D0/(t + s)*s**(-1)*rzm2**2*b0fmzww - 72.D0/(t + 
     &    s)*s**(-1)*rzm2**2*b0fusww - 12.D0/(t + s)*s**(-1)*rzm2**3*
     &    c0cmzuswww + 72.D0/(t + s)*s**(-1)*rwm2*rzm2**2*c0cmzuswww - 
     &    6.D0/(t + s)*s**(-1)*u*rwm2**(-1)*rzm2**2 + 6.D0/(t + s)*
     &    s**(-1)*u*rwm2**(-1)*rzm2**2*b0fmzww - 6.D0/(t + s)*s**(-1)*u
     &    *rwm2**(-1)*rzm2**2*b0fusww + 36.D0/(t + s)*s**(-1)*u*rzm2 - 
     &    36.D0/(t + s)*s**(-1)*u*rzm2*b0fmzww + 36.D0/(t + s)*s**(-1)*
     &    u*rzm2*b0fusww + 12.D0/(t + s)*s**(-1)*u*rzm2**2*c0cmzuswww
     &     - 72.D0/(t + s)*s**(-1)*u*rwm2*rzm2*c0cmzuswww + 2.D0/(t + s
     &    )*s**(-1)*u**2*rwm2**(-1)*rzm2 - 12.D0/(t + s)*s**(-1)*u**2
     &     - 4.D0/(t + s)*s**(-1)*u**2*rzm2*c0cmzuswww + 24.D0/(t + s)*
     &    s**(-1)*u**2*rwm2*c0cmzuswww + 10.D0/(t + s)*rwm2**(-1)*
     &    rzm2**2 - 6.D0/(t + s)*rwm2**(-1)*rzm2**2*b0fmzww + 6.D0/(t
     &     + s)*rwm2**(-1)*rzm2**2*b0fusww - 60.D0/(t + s)*rzm2 + 36.D0
     &    /(t + s)*rzm2*b0fmzww - 36.D0/(t + s)*rzm2*b0fusww - 20.D0/(t
     &     + s)*rzm2**2*c0cmzuswww + 120.D0/(t + s)*rwm2*rzm2*
     &    c0cmzuswww - 6.D0/(t + s)*u*rwm2**(-1)*rzm2 + 36.D0/(t + s)*u
     &     + 12.D0/(t + s)*u*rzm2*c0cmzuswww - 72.D0/(t + s)*u*rwm2*
     &    c0cmzuswww + 6.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fmzww - 6.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fusww - 36.D0/(t + s)/(t + s)*s**(-1)*rzm2**3*b0fmzww + 36.D
     &    0/(t + s)/(t + s)*s**(-1)*rzm2**3*b0fusww - 6.D0/(t + s)/(t
     &     + s)*s**(-1)*u*rwm2**(-1)*rzm2**3*b0fmzww + 6.D0/(t + s)/(t
     &     + s)*s**(-1)*u*rwm2**(-1)*rzm2**3*b0fusww + 36.D0/(t + s)/(t
     &     + s)*s**(-1)*u*rzm2**2*b0fmzww - 36.D0/(t + s)/(t + s)*
     &    s**(-1)*u*rzm2**2*b0fusww + 2.D0/(t + s)/(t + s)*s**(-1)*u**2
     &    *rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(t + s)/(t + s)*s**(-1)*
     &    u**2*rwm2**(-1)*rzm2**2*b0fusww - 12.D0/(t + s)/(t + s)*
     &    s**(-1)*u**2*rzm2*b0fmzww + 12.D0/(t + s)/(t + s)*s**(-1)*
     &    u**2*rzm2*b0fusww + 10.D0/(t + s)/(t + s)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 10.D0/(t + s)/(t + s)*rwm2**(-1)*rzm2**3*b0fusww - 
     &    60.D0/(t + s)/(t + s)*rzm2**2*b0fmzww + 60.D0/(t + s)/(t + s)
     &    *rzm2**2*b0fusww - 6.D0/(t + s)/(t + s)*u*rwm2**(-1)*rzm2**2*
     &    b0fmzww + 6.D0/(t + s)/(t + s)*u*rwm2**(-1)*rzm2**2*b0fusww
     &     + 36.D0/(t + s)/(t + s)*u*rzm2*b0fmzww - 36.D0/(t + s)/(t + 
     &    s)*u*rzm2*b0fusww

      ewamp(1,1,2,3) =
     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz**(-1) * ( 12.D0*s**(-2)*t**2*
     &    u**(-1) - 24.D0*s**(-2)*t**2*u**(-1)*rwm2*c0cmztswww + 8.D0*
     &    s**(-2)*t**2*c0cmzuswww - 8.D0*s**(-2)*t**2*c0cmztswww + 8.D0
     &    *s**(-2)*t**2*c0ccuswww - 8.D0*s**(-2)*t**2*c0cctswww + 8.D0*
     &    s**(-2)*t**3*d0cccmztsuswwww - 12.D0*s**(-1)*t**(-1)*u + 24.D0
     &    *s**(-1)*t**(-1)*u*rwm2*c0cmzuswww + 16.D0*s**(-1)*b0fusww - 
     &    16.D0*s**(-1)*b0ftsww - 24.D0*s**(-1)*rwm2*c0cmzuswww + 24.D0
     &    *s**(-1)*rwm2*c0cmztswww - 24.D0*s**(-1)*rwm2*c0ccuswww + 24.D
     &    0*s**(-1)*rwm2*c0cctswww + 12.D0*s**(-1)*t*u**(-1) - 24.D0*
     &    s**(-1)*t*u**(-1)*rwm2*c0cmztswww + 8.D0*s**(-1)*t*c0cmzuswww
     &     + 8.D0*s**(-1)*t*c0ccuswww - 40.D0*s**(-1)*t*rwm2*
     &    d0cccmztsuswwww - 12.D0*s**(-1)*t**2*u**(-2) + 24.D0*s**(-1)*
     &    t**2*u**(-2)*rwm2*c0cmztswww + 8.D0*s**(-1)*t**2*
     &    d0cccmztsuswwww - 12.D0*t**(-1) + 24.D0*t**(-1)*rwm2*
     &    c0cmzuswww + 24.D0*u**(-1) - 24.D0*u**(-1)*rwm2*c0cmzuswww - 
     &    24.D0*u**(-1)*rwm2*c0cmztswww - 12.D0*t*u**(-2) + 24.D0*t*
     &    u**(-2)*rwm2*c0cmztswww + 8.D0/(u + t)*s**(-1)*t**2*
     &    c0cmzuswww - 8.D0/(u + t)*s**(-1)*t**2*c0cmztswww + 8.D0/(u
     &     + t)*s**(-1)*t**2*c0ccuswww - 8.D0/(u + t)*s**(-1)*t**2*
     &    c0cctswww + 8.D0/(u + t)*s**(-1)*t**3*d0cccmztsuswwww + 16.D0
     &    /(u + t)*b0fusww - 16.D0/(u + t)*b0ftsww - 24.D0/(u + t)*rwm2
     &    *c0cmzuswww + 24.D0/(u + t)*rwm2*c0cmztswww - 24.D0/(u + t)*
     &    rwm2*c0ccuswww + 24.D0/(u + t)*rwm2*c0cctswww + 8.D0/(u + t)*
     &    t*c0cmzuswww + 8.D0/(u + t)*t*c0ccuswww - 40.D0/(u + t)*t*
     &    rwm2*d0cccmztsuswwww + 8.D0/(u + t)*t**2*d0cccmztsuswwww - 12.
     &    D0/(u + s)*s**(-2)*t**2 + 24.D0/(u + s)*s**(-2)*t**2*rwm2*
     &    c0cmztswww - 12.D0/(u + s)*s**(-1)*t + 24.D0/(u + s)*s**(-1)*
     &    t*rwm2*c0cmztswww + 12.D0/(t + s) + 12.D0/(t + s)*s**(-1)*u
     &     - 24.D0/(t + s)*s**(-1)*u*rwm2*c0cmzuswww - 24.D0/(t + s)*
     &    rwm2*c0cmzuswww )
      ewamp(1,1,2,3) = ewamp(1,1,2,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * (  - 4.D0*s**(-3)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 4.D0*s**(-3)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fusww + 24.D0*s**(-3)*t**(-1)*u**(-1)*rzm2**3*b0fmzww - 24.D
     &    0*s**(-3)*t**(-1)*u**(-1)*rzm2**3*b0fusww - 8.D0*s**(-3)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 8.D0*s**(-3)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fusww + 48.D0*s**(-3)*t**(-1)*rzm2**2*
     &    b0fmzww - 48.D0*s**(-3)*t**(-1)*rzm2**2*b0fusww + 4.D0*
     &    s**(-3)*t**(-1)*u*rwm2**(-1)*rzm2**2*b0fmzww - 4.D0*s**(-3)*
     &    t**(-1)*u*rwm2**(-1)*rzm2**2*b0fusww - 24.D0*s**(-3)*t**(-1)*
     &    u*rzm2*b0fmzww + 24.D0*s**(-3)*t**(-1)*u*rzm2*b0fusww - 4.D0*
     &    s**(-3)*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0*s**(-3)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 24.D0*s**(-3)*u**(-1)*
     &    rzm2**2*b0fmzww - 24.D0*s**(-3)*u**(-1)*rzm2**2*b0ftsww + 8.D0
     &    *s**(-3)*t*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 8.D0*s**(-3)*
     &    t*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 48.D0*s**(-3)*t*
     &    u**(-1)*rzm2*b0fmzww + 48.D0*s**(-3)*t*u**(-1)*rzm2*b0ftsww
     &     - 4.D0*s**(-3)*t**2*u**(-1)*rwm2**(-1)*rzm2*b0fmzww + 4.D0*
     &    s**(-3)*t**2*u**(-1)*rwm2**(-1)*rzm2*b0ftsww + 24.D0*s**(-3)*
     &    t**2*u**(-1)*b0fmzww - 24.D0*s**(-3)*t**2*u**(-1)*b0ftsww + 2.
     &    D0*s**(-2)*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 2.D0*
     &    s**(-2)*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**4*b0fusww - 12.D0*
     &    s**(-2)*t**(-2)*u**(-1)*rzm2**3*b0fmzww + 12.D0*s**(-2)*
     &    t**(-2)*u**(-1)*rzm2**3*b0fusww + 4.D0*s**(-2)*t**(-2)*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 4.D0*s**(-2)*t**(-2)*rwm2**(-1)*
     &    rzm2**3*b0fusww - 24.D0*s**(-2)*t**(-2)*rzm2**2*b0fmzww + 24.D
     &    0*s**(-2)*t**(-2)*rzm2**2*b0fusww - 2.D0*s**(-2)*t**(-2)*u*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 2.D0*s**(-2)*t**(-2)*u*
     &    rwm2**(-1)*rzm2**2*b0fusww + 12.D0*s**(-2)*t**(-2)*u*rzm2*
     &    b0fmzww - 12.D0*s**(-2)*t**(-2)*u*rzm2*b0fusww - 2.D0*s**(-2)
     &    *t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3 - 2.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 2.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 12.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rzm2**2 + 12.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*
     &    b0fmzww - 12.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*b0ftsww + 4.D0
     &    *s**(-2)*t**(-1)*u**(-1)*rzm2**3*c0cmzuswww - 24.D0*s**(-2)*
     &    t**(-1)*u**(-1)*rwm2*rzm2**2*c0cmzuswww - 4.D0*s**(-2)*
     &    t**(-1)*rwm2**(-1)*rzm2**2 + 6.D0*s**(-2)*t**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fmzww - 6.D0*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fusww + 24.D0*s**(-2)*t**(-1)*rzm2 - 36.D0*s**(-2)*t**(-1)*
     &    rzm2*b0fmzww + 36.D0*s**(-2)*t**(-1)*rzm2*b0fusww + 8.D0*
     &    s**(-2)*t**(-1)*rzm2**2*c0cmzuswww - 48.D0*s**(-2)*t**(-1)*
     &    rwm2*rzm2*c0cmzuswww + 2.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2
     &     - 2.D0*s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2*b0fmzww + 2.D0*
     &    s**(-2)*t**(-1)*u*rwm2**(-1)*rzm2*b0fusww - 12.D0*s**(-2)*
     &    t**(-1)*u + 12.D0*s**(-2)*t**(-1)*u*b0fmzww - 12.D0*s**(-2)*
     &    t**(-1)*u*b0fusww - 4.D0*s**(-2)*t**(-1)*u*rzm2*c0cmzuswww + 
     &    24.D0*s**(-2)*t**(-1)*u*rwm2*c0cmzuswww + 2.D0*s**(-2)*
     &    u**(-2)*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0*s**(-2)*u**(-2)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 12.D0*s**(-2)*u**(-2)*rzm2**2*
     &    b0fmzww + 12.D0*s**(-2)*u**(-2)*rzm2**2*b0ftsww - 2.D0*
     &    s**(-2)*u**(-1)*rwm2**(-1)*rzm2**2 + 2.D0*s**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*s**(-2)*u**(-1)*rwm2**(-1)*
     &    rzm2**2*b0ftsww + 12.D0*s**(-2)*u**(-1)*rzm2 - 12.D0*s**(-2)*
     &    u**(-1)*rzm2*b0fmzww + 12.D0*s**(-2)*u**(-1)*rzm2*b0ftsww + 4.
     &    D0*s**(-2)*u**(-1)*rzm2**2*c0cmztswww - 24.D0*s**(-2)*u**(-1)
     &    *rwm2*rzm2*c0cmztswww - 4.D0*s**(-2)*rwm2**(-1)*rzm2**2*
     &    c0cmztswww + 4.D0*s**(-2)*rwm2**(-1)*rzm2**2*c0ccuswww + 24.D0
     &    *s**(-2)*rzm2*c0cmztswww - 24.D0*s**(-2)*rzm2*c0ccuswww - 4.D0
     &    *s**(-2)*t*u**(-2)*rwm2**(-1)*rzm2**2*b0fmzww + 4.D0*s**(-2)*
     &    t*u**(-2)*rwm2**(-1)*rzm2**2*b0ftsww + 24.D0*s**(-2)*t*
     &    u**(-2)*rzm2*b0fmzww - 24.D0*s**(-2)*t*u**(-2)*rzm2*b0ftsww
     &     + 4.D0*s**(-2)*t*u**(-1)*rwm2**(-1)*rzm2 - 24.D0*s**(-2)*t*
     &    u**(-1) - 8.D0*s**(-2)*t*u**(-1)*rzm2*c0cmztswww + 48.D0*
     &    s**(-2)*t*u**(-1)*rwm2*c0cmztswww - 4.D0*s**(-2)*t*rwm2**(-1)
     &    *rzm2*c0cmzuswww + 8.D0/3.D0*s**(-2)*t*rwm2**(-1)*rzm2*
     &    c0cmztswww - 8.D0/3.D0*s**(-2)*t*rwm2**(-1)*rzm2*c0ccuswww + 
     &    4.D0*s**(-2)*t*rwm2**(-1)*rzm2*c0cctswww + 4.D0*s**(-2)*t*
     &    rwm2**(-1)*rzm2**2*d0cccmztsuswwww + 24.D0*s**(-2)*t*
     &    c0cmzuswww - 16.D0*s**(-2)*t*c0cmztswww + 16.D0*s**(-2)*t*
     &    c0ccuswww - 24.D0*s**(-2)*t*c0cctswww - 24.D0*s**(-2)*t*rzm2*
     &    d0cccmztsuswwww + 2.D0*s**(-2)*t**2*u**(-2)*rwm2**(-1)*rzm2*
     &    b0fmzww - 2.D0*s**(-2)*t**2*u**(-2)*rwm2**(-1)*rzm2*b0ftsww
     &     - 12.D0*s**(-2)*t**2*u**(-2)*b0fmzww + 12.D0*s**(-2)*t**2*
     &    u**(-2)*b0ftsww - 2.D0*s**(-2)*t**2*u**(-1)*rwm2**(-1) + 4.D0
     &    *s**(-2)*t**2*u**(-1)*c0cmztswww - 4.D0/3.D0*s**(-2)*t**2*
     &    rwm2**(-1)*c0cmzuswww + 4.D0/3.D0*s**(-2)*t**2*rwm2**(-1)*
     &    c0cmztswww - 4.D0/3.D0*s**(-2)*t**2*rwm2**(-1)*c0ccuswww + 4.D
     &    0/3.D0*s**(-2)*t**2*rwm2**(-1)*c0cctswww - 8.D0/3.D0*s**(-2)*
     &    t**2*rwm2**(-1)*rzm2*d0cccmztsuswwww + 16.D0*s**(-2)*t**2*
     &    d0cccmztsuswwww - 4.D0/3.D0*s**(-2)*t**3*rwm2**(-1)*
     &    d0cccmztsuswwww + 2.D0*s**(-1)*t**(-2)*u**(-1)*rwm2**(-1)*
     &    rzm2**3 + 2.D0*s**(-1)*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fmzww + 6.D0*s**(-1)*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fusww - 8.D0*s**(-1)*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0ftsww - 12.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**2 - 12.D0*
     &    s**(-1)*t**(-2)*u**(-1)*rzm2**2*b0fmzww - 36.D0*s**(-1)*
     &    t**(-2)*u**(-1)*rzm2**2*b0fusww + 48.D0*s**(-1)*t**(-2)*
     &    u**(-1)*rzm2**2*b0ftsww - 4.D0*s**(-1)*t**(-2)*u**(-1)*
     &    rzm2**3*c0cctswww + 24.D0*s**(-1)*t**(-2)*u**(-1)*rwm2*
     &    rzm2**2*c0cctswww + 4.D0*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**2
     &     - 10.D0*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**2*b0fmzww + 10.D0*
     &    s**(-1)*t**(-2)*rwm2**(-1)*rzm2**2*b0fusww - 24.D0*s**(-1)*
     &    t**(-2)*rzm2 + 60.D0*s**(-1)*t**(-2)*rzm2*b0fmzww - 60.D0*
     &    s**(-1)*t**(-2)*rzm2*b0fusww - 8.D0*s**(-1)*t**(-2)*rzm2**2*
     &    c0cmzuswww + 48.D0*s**(-1)*t**(-2)*rwm2*rzm2*c0cmzuswww - 2.D0
     &    *s**(-1)*t**(-2)*u*rwm2**(-1)*rzm2 + 4.D0*s**(-1)*t**(-2)*u*
     &    rwm2**(-1)*rzm2*b0fmzww - 4.D0*s**(-1)*t**(-2)*u*rwm2**(-1)*
     &    rzm2*b0fusww + 12.D0*s**(-1)*t**(-2)*u - 24.D0*s**(-1)*
     &    t**(-2)*u*b0fmzww + 24.D0*s**(-1)*t**(-2)*u*b0fusww + 4.D0*
     &    s**(-1)*t**(-2)*u*rzm2*c0cmzuswww - 24.D0*s**(-1)*t**(-2)*u*
     &    rwm2*c0cmzuswww - 4.D0*s**(-1)*t**(-1)*u**(-2)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0*s**(-1)*t**(-1)*u**(-2)*rwm2**(-1)*
     &    rzm2**3*b0ftsww + 24.D0*s**(-1)*t**(-1)*u**(-2)*rzm2**2*
     &    b0fmzww - 24.D0*s**(-1)*t**(-1)*u**(-2)*rzm2**2*b0ftsww - 4.D0
     &    *s**(-1)*t**(-1)*u**(-2)*rzm2**3*c0cmzuswww + 4.D0*s**(-1)*
     &    t**(-1)*u**(-2)*rzm2**3*c0cctswww + 24.D0*s**(-1)*t**(-1)*
     &    u**(-2)*rwm2*rzm2**2*c0cmzuswww - 24.D0*s**(-1)*t**(-1)*
     &    u**(-2)*rwm2*rzm2**2*c0cctswww - 12.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**2 - 20.D0/3.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 6.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**2*b0fusww + 38.D0/3.D0*s**(-1)*
     &    t**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww + 72.D0*s**(-1)*
     &    t**(-1)*u**(-1)*rzm2 + 40.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*
     &    b0fmzww + 36.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*b0fusww - 76.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2*b0ftsww + 28.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rzm2**2*c0cmzuswww + 8.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rzm2**2*c0cmztswww + 4.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2*
     &    c0ccuswww - 16.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2*c0cctswww
     &     + 4.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*d0cccmztsuswwww - 168.
     &    D0*s**(-1)*t**(-1)*u**(-1)*rwm2*rzm2*c0cmzuswww - 48.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rwm2*rzm2*c0cmztswww - 24.D0*s**(-1)*
     &    t**(-1)*u**(-1)*rwm2*rzm2*c0ccuswww + 96.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rwm2*rzm2*c0cctswww - 24.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rwm2*rzm2**2*d0cccmztsuswwww - 4.D0*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2 + 10.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2*
     &    b0fmzww - 10.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2*b0fusww + 24.D
     &    0*s**(-1)*t**(-1) - 60.D0*s**(-1)*t**(-1)*b0fmzww + 60.D0*
     &    s**(-1)*t**(-1)*b0fusww + 8.D0*s**(-1)*t**(-1)*rzm2*
     &    c0cmzuswww - 4.D0*s**(-1)*t**(-1)*rzm2*c0cmztswww + 4.D0*
     &    s**(-1)*t**(-1)*rzm2*c0ccuswww - 48.D0*s**(-1)*t**(-1)*rwm2*
     &    c0cmzuswww + 24.D0*s**(-1)*t**(-1)*rwm2*c0cmztswww - 24.D0*
     &    s**(-1)*t**(-1)*rwm2*c0ccuswww + 2.D0*s**(-1)*t**(-1)*u*
     &    rwm2**(-1) - 4.D0*s**(-1)*t**(-1)*u*c0cmzuswww + 2.D0*s**(-1)
     &    *u**(-2)*rwm2**(-1)*rzm2**2 + 6.D0*s**(-1)*u**(-2)*rwm2**(-1)
     &    *rzm2**2*b0fmzww - 6.D0*s**(-1)*u**(-2)*rwm2**(-1)*rzm2**2*
     &    b0ftsww - 12.D0*s**(-1)*u**(-2)*rzm2 - 36.D0*s**(-1)*u**(-2)*
     &    rzm2*b0fmzww + 36.D0*s**(-1)*u**(-2)*rzm2*b0ftsww + 4.D0*
     &    s**(-1)*u**(-2)*rzm2**2*c0cmzuswww - 4.D0*s**(-1)*u**(-2)*
     &    rzm2**2*c0cmztswww - 4.D0*s**(-1)*u**(-2)*rzm2**2*c0cctswww
     &     - 24.D0*s**(-1)*u**(-2)*rwm2*rzm2*c0cmzuswww + 24.D0*s**(-1)
     &    *u**(-2)*rwm2*rzm2*c0cmztswww + 24.D0*s**(-1)*u**(-2)*rwm2*
     &    rzm2*c0cctswww + 8.D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2 + 26.D0/
     &    3.D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2*b0fmzww - 26.D0/3.D0*
     &    s**(-1)*u**(-1)*rwm2**(-1)*rzm2*b0ftsww - 48.D0*s**(-1)*
     &    u**(-1) - 52.D0*s**(-1)*u**(-1)*b0fmzww + 52.D0*s**(-1)*
     &    u**(-1)*b0ftsww - 16.D0*s**(-1)*u**(-1)*rzm2*c0cmzuswww - 12.D
     &    0*s**(-1)*u**(-1)*rzm2*c0cmztswww - 4.D0*s**(-1)*u**(-1)*rzm2
     &    *c0ccuswww + 16.D0*s**(-1)*u**(-1)*rzm2*c0cctswww - 4.D0*
     &    s**(-1)*u**(-1)*rzm2**2*d0cccmztsuswwww + 96.D0*s**(-1)*
     &    u**(-1)*rwm2*c0cmzuswww + 72.D0*s**(-1)*u**(-1)*rwm2*
     &    c0cmztswww + 24.D0*s**(-1)*u**(-1)*rwm2*c0ccuswww - 96.D0*
     &    s**(-1)*u**(-1)*rwm2*c0cctswww + 24.D0*s**(-1)*u**(-1)*rwm2*
     &    rzm2*d0cccmztsuswwww - 8.D0/3.D0*s**(-1)*rwm2**(-1)*b0fusww
     &     + 8.D0/3.D0*s**(-1)*rwm2**(-1)*b0ftsww - 4.D0*s**(-1)*
     &    rwm2**(-1)*rzm2*c0cmzuswww - 4.D0*s**(-1)*rwm2**(-1)*rzm2*
     &    c0ccuswww + 28.D0*s**(-1)*c0cmzuswww - 4.D0*s**(-1)*
     &    c0cmztswww + 28.D0*s**(-1)*c0ccuswww - 4.D0*s**(-1)*c0cctswww
     &     + 18.D0*s**(-1)*rzm2*d0cccmztsuswwww - 108.D0*s**(-1)*rwm2*
     &    d0cccmztsuswwww - 4.D0*s**(-1)*t*u**(-2)*rwm2**(-1)*rzm2 - 2.D
     &    0*s**(-1)*t*u**(-2)*rwm2**(-1)*rzm2*b0fmzww + 2.D0*s**(-1)*t*
     &    u**(-2)*rwm2**(-1)*rzm2*b0ftsww + 24.D0*s**(-1)*t*u**(-2) + 
     &    12.D0*s**(-1)*t*u**(-2)*b0fmzww - 12.D0*s**(-1)*t*u**(-2)*
     &    b0ftsww + 8.D0*s**(-1)*t*u**(-2)*rzm2*c0cmztswww - 48.D0*
     &    s**(-1)*t*u**(-2)*rwm2*c0cmztswww - 2.D0*s**(-1)*t*u**(-1)*
     &    rwm2**(-1) + 4.D0*s**(-1)*t*u**(-1)*c0cmztswww - 4.D0/3.D0*
     &    s**(-1)*t*rwm2**(-1)*c0cmzuswww - 4.D0/3.D0*s**(-1)*t*
     &    rwm2**(-1)*c0ccuswww - 4.D0*s**(-1)*t*rwm2**(-1)*rzm2*
     &    d0cccmztsuswwww + 92.D0/3.D0*s**(-1)*t*d0cccmztsuswwww + 2.D0
     &    *s**(-1)*t**2*u**(-2)*rwm2**(-1) - 4.D0*s**(-1)*t**2*u**(-2)*
     &    c0cmztswww )
      ewamp(1,1,2,3) = ewamp(1,1,2,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * (  - 4.D0/3.D0*s**(-1)*t**2*rwm2**(-1)*d0cccmztsuswwww - 2.
     &    D0*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**2 - 4.D0*t**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 4.D0*t**(-2)*u**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fusww + 8.D0*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0ftsww + 12.D0*t**(-2)*u**(-1)*rzm2 + 24.D0*t**(-2)*u**(-1)*
     &    rzm2*b0fmzww + 24.D0*t**(-2)*u**(-1)*rzm2*b0fusww - 48.D0*
     &    t**(-2)*u**(-1)*rzm2*b0ftsww + 4.D0*t**(-2)*u**(-1)*rzm2**2*
     &    c0cctswww - 24.D0*t**(-2)*u**(-1)*rwm2*rzm2*c0cctswww - 2.D0*
     &    t**(-2)*rwm2**(-1)*rzm2 + 4.D0*t**(-2)*rwm2**(-1)*rzm2*
     &    b0fmzww - 4.D0*t**(-2)*rwm2**(-1)*rzm2*b0fusww + 12.D0*
     &    t**(-2) - 24.D0*t**(-2)*b0fmzww + 24.D0*t**(-2)*b0fusww + 4.D0
     &    *t**(-2)*rzm2*c0cmzuswww - 24.D0*t**(-2)*rwm2*c0cmzuswww + 4.D
     &    0*t**(-1)*u**(-2)*rwm2**(-1)*rzm2**2*b0fmzww - 4.D0*t**(-1)*
     &    u**(-2)*rwm2**(-1)*rzm2**2*b0ftsww - 24.D0*t**(-1)*u**(-2)*
     &    rzm2*b0fmzww + 24.D0*t**(-1)*u**(-2)*rzm2*b0ftsww + 4.D0*
     &    t**(-1)*u**(-2)*rzm2**2*c0cmzuswww - 4.D0*t**(-1)*u**(-2)*
     &    rzm2**2*c0cctswww - 24.D0*t**(-1)*u**(-2)*rwm2*rzm2*
     &    c0cmzuswww + 24.D0*t**(-1)*u**(-2)*rwm2*rzm2*c0cctswww + 12.D0
     &    *t**(-1)*u**(-1)*rwm2**(-1)*rzm2 + 32.D0/3.D0*t**(-1)*u**(-1)
     &    *rwm2**(-1)*rzm2*b0fmzww - 32.D0/3.D0*t**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2*b0ftsww - 72.D0*t**(-1)*u**(-1) - 64.D0*
     &    t**(-1)*u**(-1)*b0fmzww + 64.D0*t**(-1)*u**(-1)*b0ftsww - 28.D
     &    0*t**(-1)*u**(-1)*rzm2*c0cmzuswww - 4.D0*t**(-1)*u**(-1)*rzm2
     &    *c0cmztswww - 4.D0*t**(-1)*u**(-1)*rzm2*c0ccuswww + 16.D0*
     &    t**(-1)*u**(-1)*rzm2*c0cctswww - 4.D0*t**(-1)*u**(-1)*rzm2*
     &    c0ccqswww - 4.D0*t**(-1)*u**(-1)*rzm2**2*d0cccmztsuswwww + 
     &    168.D0*t**(-1)*u**(-1)*rwm2*c0cmzuswww + 24.D0*t**(-1)*
     &    u**(-1)*rwm2*c0cmztswww + 24.D0*t**(-1)*u**(-1)*rwm2*
     &    c0ccuswww - 96.D0*t**(-1)*u**(-1)*rwm2*c0cctswww + 24.D0*
     &    t**(-1)*u**(-1)*rwm2*c0ccqswww + 24.D0*t**(-1)*u**(-1)*rwm2*
     &    rzm2*d0cccmztsuswwww + 2.D0*t**(-1)*rwm2**(-1) - 4.D0*t**(-1)
     &    *c0cmzuswww + 2.D0*t**(-1)*rzm2*d0ccmzcqsuswwww - 12.D0*
     &    t**(-1)*rwm2*d0ccmzcqsuswwww - 2.D0*u**(-2)*rwm2**(-1)*rzm2
     &     - 4.D0*u**(-2)*rwm2**(-1)*rzm2*b0fmzww + 4.D0*u**(-2)*
     &    rwm2**(-1)*rzm2*b0ftsww + 12.D0*u**(-2) + 24.D0*u**(-2)*
     &    b0fmzww - 24.D0*u**(-2)*b0ftsww + 4.D0*u**(-2)*rzm2*
     &    c0cmztswww - 24.D0*u**(-2)*rwm2*c0cmztswww - 4.D0*u**(-1)*
     &    rwm2**(-1) + 4.D0*u**(-1)*c0cmzuswww + 4.D0*u**(-1)*
     &    c0cmztswww - 2.D0*u**(-1)*rzm2*d0cccmzqstswwww + 12.D0*
     &    u**(-1)*rwm2*d0cccmzqstswwww + 2.D0*t*u**(-2)*rwm2**(-1) - 4.D
     &    0*t*u**(-2)*c0cmztswww + 8.D0/(u + t)*s**(-3)*t**(-1)*
     &    rwm2**(-1)*rzm2**4*b0fmzww - 8.D0/(u + t)*s**(-3)*t**(-1)*
     &    rwm2**(-1)*rzm2**4*b0fusww - 48.D0/(u + t)*s**(-3)*t**(-1)*
     &    rzm2**3*b0fmzww + 48.D0/(u + t)*s**(-3)*t**(-1)*rzm2**3*
     &    b0fusww - 4.D0/(u + t)*s**(-2)*t**(-2)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 4.D0/(u + t)*s**(-2)*t**(-2)*rwm2**(-1)*rzm2**4*
     &    b0fusww + 24.D0/(u + t)*s**(-2)*t**(-2)*rzm2**3*b0fmzww - 24.D
     &    0/(u + t)*s**(-2)*t**(-2)*rzm2**3*b0fusww + 4.D0/(u + t)*
     &    s**(-2)*t**(-1)*rwm2**(-1)*rzm2**3 - 8.D0/(u + t)*s**(-2)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 8.D0/(u + t)*s**(-2)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fusww - 24.D0/(u + t)*s**(-2)*
     &    t**(-1)*rzm2**2 + 48.D0/(u + t)*s**(-2)*t**(-1)*rzm2**2*
     &    b0fmzww - 48.D0/(u + t)*s**(-2)*t**(-1)*rzm2**2*b0fusww - 8.D0
     &    /(u + t)*s**(-2)*t**(-1)*rzm2**3*c0cmzuswww + 48.D0/(u + t)*
     &    s**(-2)*t**(-1)*rwm2*rzm2**2*c0cmzuswww + 4.D0/(u + t)*
     &    s**(-2)*rwm2**(-1)*rzm2**3*c0cmztswww - 4.D0/(u + t)*s**(-2)*
     &    rwm2**(-1)*rzm2**3*c0ccuswww - 24.D0/(u + t)*s**(-2)*rzm2**2*
     &    c0cmztswww + 24.D0/(u + t)*s**(-2)*rzm2**2*c0ccuswww + 4.D0/(
     &    u + t)*s**(-2)*t*rwm2**(-1)*rzm2**2*c0cmzuswww - 8.D0/3.D0/(u
     &     + t)*s**(-2)*t*rwm2**(-1)*rzm2**2*c0cmztswww + 8.D0/3.D0/(u
     &     + t)*s**(-2)*t*rwm2**(-1)*rzm2**2*c0ccuswww - 4.D0/(u + t)*
     &    s**(-2)*t*rwm2**(-1)*rzm2**2*c0cctswww - 4.D0/(u + t)*s**(-2)
     &    *t*rwm2**(-1)*rzm2**3*d0cccmztsuswwww - 24.D0/(u + t)*s**(-2)
     &    *t*rzm2*c0cmzuswww + 16.D0/(u + t)*s**(-2)*t*rzm2*c0cmztswww
     &     - 16.D0/(u + t)*s**(-2)*t*rzm2*c0ccuswww + 24.D0/(u + t)*
     &    s**(-2)*t*rzm2*c0cctswww + 24.D0/(u + t)*s**(-2)*t*rzm2**2*
     &    d0cccmztsuswwww + 4.D0/3.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*
     &    rzm2*c0cmzuswww - 4.D0/3.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*
     &    rzm2*c0cmztswww + 4.D0/3.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*
     &    rzm2*c0ccuswww - 4.D0/3.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*
     &    rzm2*c0cctswww + 8.D0/3.D0/(u + t)*s**(-2)*t**2*rwm2**(-1)*
     &    rzm2**2*d0cccmztsuswwww - 8.D0/(u + t)*s**(-2)*t**2*
     &    c0cmzuswww + 8.D0/(u + t)*s**(-2)*t**2*c0cmztswww - 8.D0/(u
     &     + t)*s**(-2)*t**2*c0ccuswww + 8.D0/(u + t)*s**(-2)*t**2*
     &    c0cctswww - 16.D0/(u + t)*s**(-2)*t**2*rzm2*d0cccmztsuswwww
     &     + 4.D0/3.D0/(u + t)*s**(-2)*t**3*rwm2**(-1)*rzm2*
     &    d0cccmztsuswwww - 8.D0/(u + t)*s**(-2)*t**3*d0cccmztsuswwww
     &     - 4.D0/(u + t)*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**3 + 12.D0/(u
     &     + t)*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**3*b0fmzww - 12.D0/(u
     &     + t)*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(u
     &     + t)*s**(-1)*t**(-2)*rzm2**2 - 72.D0/(u + t)*s**(-1)*t**(-2)
     &    *rzm2**2*b0fmzww + 72.D0/(u + t)*s**(-1)*t**(-2)*rzm2**2*
     &    b0fusww + 4.D0/(u + t)*s**(-1)*t**(-2)*rzm2**3*c0cmzuswww + 4.
     &    D0/(u + t)*s**(-1)*t**(-2)*rzm2**3*c0cctswww - 24.D0/(u + t)*
     &    s**(-1)*t**(-2)*rwm2*rzm2**2*c0cmzuswww - 24.D0/(u + t)*
     &    s**(-1)*t**(-2)*rwm2*rzm2**2*c0cctswww + 4.D0/(u + t)*s**(-1)
     &    *t**(-1)*rwm2**(-1)*rzm2**2 + 8.D0/3.D0/(u + t)*s**(-1)*
     &    t**(-1)*rwm2**(-1)*rzm2**2*b0fmzww + 8.D0/(u + t)*s**(-1)*
     &    t**(-1)*rwm2**(-1)*rzm2**2*b0fusww - 32.D0/3.D0/(u + t)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 24.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2 - 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2*
     &    b0fmzww - 48.D0/(u + t)*s**(-1)*t**(-1)*rzm2*b0fusww + 64.D0
     &    /(u + t)*s**(-1)*t**(-1)*rzm2*b0ftsww - 24.D0/(u + t)*s**(-1)
     &    *t**(-1)*rzm2**2*c0cmzuswww + 8.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2**2*c0cmztswww - 8.D0/(u + t)*s**(-1)*t**(-1)*rzm2**2*
     &    c0ccuswww + 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2**2*c0cctswww
     &     - 4.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*d0cccmztsuswwww + 144.
     &    D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2*c0cmzuswww - 48.D0/(u + 
     &    t)*s**(-1)*t**(-1)*rwm2*rzm2*c0cmztswww + 48.D0/(u + t)*
     &    s**(-1)*t**(-1)*rwm2*rzm2*c0ccuswww - 96.D0/(u + t)*s**(-1)*
     &    t**(-1)*rwm2*rzm2*c0cctswww + 24.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2*rzm2**2*d0cccmztsuswwww + 8.D0/3.D0/(u + t)*s**(-1)*
     &    rwm2**(-1)*rzm2*b0fusww - 8.D0/3.D0/(u + t)*s**(-1)*
     &    rwm2**(-1)*rzm2*b0ftsww + 4.D0/(u + t)*s**(-1)*rwm2**(-1)*
     &    rzm2**2*c0cmzuswww - 4.D0/(u + t)*s**(-1)*rwm2**(-1)*rzm2**2*
     &    c0cmztswww + 8.D0/(u + t)*s**(-1)*rwm2**(-1)*rzm2**2*
     &    c0ccuswww - 16.D0/(u + t)*s**(-1)*b0fusww + 16.D0/(u + t)*
     &    s**(-1)*b0ftsww - 32.D0/(u + t)*s**(-1)*rzm2*c0cmzuswww + 32.D
     &    0/(u + t)*s**(-1)*rzm2*c0cmztswww - 56.D0/(u + t)*s**(-1)*
     &    rzm2*c0ccuswww + 8.D0/(u + t)*s**(-1)*rzm2*c0cctswww - 16.D0
     &    /(u + t)*s**(-1)*rzm2**2*d0cccmztsuswwww + 48.D0/(u + t)*
     &    s**(-1)*rwm2*c0cmzuswww - 48.D0/(u + t)*s**(-1)*rwm2*
     &    c0cmztswww + 48.D0/(u + t)*s**(-1)*rwm2*c0ccuswww - 48.D0/(u
     &     + t)*s**(-1)*rwm2*c0cctswww + 96.D0/(u + t)*s**(-1)*rwm2*
     &    rzm2*d0cccmztsuswwww - 8.D0/3.D0/(u + t)*s**(-1)*t*rwm2**(-1)
     &    *rzm2*c0cmzuswww + 8.D0/3.D0/(u + t)*s**(-1)*t*rwm2**(-1)*
     &    rzm2*c0cmztswww - 4.D0/3.D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2
     &    *c0ccuswww + 4.D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2*c0cctswww
     &     + 8.D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2**2*d0cccmztsuswwww
     &     + 16.D0/(u + t)*s**(-1)*t*c0cmzuswww - 16.D0/(u + t)*s**(-1)
     &    *t*c0cmztswww + 8.D0/(u + t)*s**(-1)*t*c0ccuswww - 24.D0/(u
     &     + t)*s**(-1)*t*c0cctswww - 176.D0/3.D0/(u + t)*s**(-1)*t*
     &    rzm2*d0cccmztsuswwww + 64.D0/(u + t)*s**(-1)*t*rwm2*
     &    d0cccmztsuswwww - 4.D0/3.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    c0cmzuswww + 4.D0/3.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    c0cmztswww - 4.D0/3.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    c0ccuswww + 4.D0/3.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*
     &    c0cctswww - 4.D0/3.D0/(u + t)*s**(-1)*t**2*rwm2**(-1)*rzm2*
     &    d0cccmztsuswwww + 8.D0/(u + t)*s**(-1)*t**2*d0cccmztsuswwww
     &     - 4.D0/3.D0/(u + t)*s**(-1)*t**3*rwm2**(-1)*d0cccmztsuswwww
     &     + 4.D0/(u + t)*t**(-2)*rwm2**(-1)*rzm2**2 + 8.D0/(u + t)*
     &    t**(-2)*rwm2**(-1)*rzm2**2*b0fusww - 8.D0/(u + t)*t**(-2)*
     &    rwm2**(-1)*rzm2**2*b0ftsww - 24.D0/(u + t)*t**(-2)*rzm2 - 48.D
     &    0/(u + t)*t**(-2)*rzm2*b0fusww + 48.D0/(u + t)*t**(-2)*rzm2*
     &    b0ftsww - 4.D0/(u + t)*t**(-2)*rzm2**2*c0cmzuswww - 4.D0/(u
     &     + t)*t**(-2)*rzm2**2*c0cctswww + 24.D0/(u + t)*t**(-2)*rwm2*
     &    rzm2*c0cmzuswww + 24.D0/(u + t)*t**(-2)*rwm2*rzm2*c0cctswww
     &     - 16.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2 - 8.D0/3.D0/(u + t)*
     &    t**(-1)*rwm2**(-1)*rzm2*b0fmzww - 8.D0/(u + t)*t**(-1)*
     &    rwm2**(-1)*rzm2*b0fusww + 32.D0/3.D0/(u + t)*t**(-1)*
     &    rwm2**(-1)*rzm2*b0ftsww + 96.D0/(u + t)*t**(-1) + 16.D0/(u + 
     &    t)*t**(-1)*b0fmzww + 48.D0/(u + t)*t**(-1)*b0fusww - 64.D0/(u
     &     + t)*t**(-1)*b0ftsww + 28.D0/(u + t)*t**(-1)*rzm2*c0cmzuswww
     &     + 4.D0/(u + t)*t**(-1)*rzm2*c0cmztswww + 8.D0/(u + t)*
     &    t**(-1)*rzm2*c0ccuswww - 16.D0/(u + t)*t**(-1)*rzm2*c0cctswww
     &     + 8.D0/(u + t)*t**(-1)*rzm2*c0ccqswww + 4.D0/(u + t)*t**(-1)
     &    *rzm2**2*d0cccmztsuswwww - 168.D0/(u + t)*t**(-1)*rwm2*
     &    c0cmzuswww - 24.D0/(u + t)*t**(-1)*rwm2*c0cmztswww - 48.D0/(u
     &     + t)*t**(-1)*rwm2*c0ccuswww + 96.D0/(u + t)*t**(-1)*rwm2*
     &    c0cctswww - 48.D0/(u + t)*t**(-1)*rwm2*c0ccqswww - 24.D0/(u
     &     + t)*t**(-1)*rwm2*rzm2*d0cccmztsuswwww - 8.D0/3.D0/(u + t)*
     &    rwm2**(-1)*b0fusww + 8.D0/3.D0/(u + t)*rwm2**(-1)*b0ftsww - 4.
     &    D0/(u + t)*rwm2**(-1)*rzm2*c0cmzuswww - 4.D0/(u + t)*
     &    rwm2**(-1)*rzm2*c0ccuswww + 28.D0/(u + t)*c0cmzuswww - 4.D0/(
     &    u + t)*c0cmztswww + 28.D0/(u + t)*c0ccuswww - 4.D0/(u + t)*
     &    c0cctswww + 16.D0/(u + t)*rzm2*d0cccmztsuswwww - 96.D0/(u + t
     &    )*rwm2*d0cccmztsuswwww - 4.D0/3.D0/(u + t)*t*rwm2**(-1)*
     &    c0cmzuswww - 4.D0/3.D0/(u + t)*t*rwm2**(-1)*c0ccuswww - 4.D0
     &    /(u + t)*t*rwm2**(-1)*rzm2*d0cccmztsuswwww + 92.D0/3.D0/(u + 
     &    t)*t*d0cccmztsuswwww - 4.D0/3.D0/(u + t)*t**2*rwm2**(-1)*
     &    d0cccmztsuswwww + 48.D0/(u + t)/(u + s) - 8.D0/(u + t)/(u + s
     &    )*t**(-2)*rwm2**(-1)*rzm2**3*b0fmzww + 8.D0/(u + t)/(u + s)*
     &    t**(-2)*rwm2**(-1)*rzm2**3*b0ftsww + 48.D0/(u + t)/(u + s)*
     &    t**(-2)*rzm2**2*b0fmzww - 48.D0/(u + t)/(u + s)*t**(-2)*
     &    rzm2**2*b0ftsww + 8.D0/(u + t)/(u + s)*t**(-1)*rwm2**(-1)*
     &    rzm2**2 - 48.D0/(u + t)/(u + s)*t**(-1)*rzm2 - 16.D0/(u + t)
     &    /(u + s)*t**(-1)*rzm2**2*c0cmztswww + 96.D0/(u + t)/(u + s)*
     &    t**(-1)*rwm2*rzm2*c0cmztswww - 8.D0/(u + t)/(u + s)*
     &    rwm2**(-1)*rzm2 + 16.D0/(u + t)/(u + s)*rzm2*c0cmztswww - 96.D
     &    0/(u + t)/(u + s)*rwm2*c0cmztswww )
      ewamp(1,1,2,3) = ewamp(1,1,2,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * ( 8.D0/(u + t)/(u + s)/(u + s)*t**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 8.D0/(u + t)/(u + s)/(u + s)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0ftsww - 48.D0/(u + t)/(u + s)/(u + s)*t**(-1)*
     &    rzm2**2*b0fmzww + 48.D0/(u + t)/(u + s)/(u + s)*t**(-1)*
     &    rzm2**2*b0ftsww - 8.D0/(u + t)/(u + s)/(u + s)*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 8.D0/(u + t)/(u + s)/(u + s)*rwm2**(-1)*
     &    rzm2**2*b0ftsww + 48.D0/(u + t)/(u + s)/(u + s)*rzm2*b0fmzww
     &     - 48.D0/(u + t)/(u + s)/(u + s)*rzm2*b0ftsww - 48.D0/(u + t)
     &    /(t + s) - 8.D0/(u + t)/(t + s)*s**(-3)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 8.D0/(u + t)/(t + s)*s**(-3)*rwm2**(-1)*rzm2**4*
     &    b0fusww + 48.D0/(u + t)/(t + s)*s**(-3)*rzm2**3*b0fmzww - 48.D
     &    0/(u + t)/(t + s)*s**(-3)*rzm2**3*b0fusww - 4.D0/(u + t)/(t
     &     + s)*s**(-2)*rwm2**(-1)*rzm2**3 + 8.D0/(u + t)/(t + s)*
     &    s**(-2)*rwm2**(-1)*rzm2**3*b0fmzww - 8.D0/(u + t)/(t + s)*
     &    s**(-2)*rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(u + t)/(t + s)*
     &    s**(-2)*rzm2**2 - 48.D0/(u + t)/(t + s)*s**(-2)*rzm2**2*
     &    b0fmzww + 48.D0/(u + t)/(t + s)*s**(-2)*rzm2**2*b0fusww + 8.D0
     &    /(u + t)/(t + s)*s**(-2)*rzm2**3*c0cmzuswww - 48.D0/(u + t)/(
     &    t + s)*s**(-2)*rwm2*rzm2**2*c0cmzuswww - 4.D0/(u + t)/(t + s)
     &    *s**(-1)*rwm2**(-1)*rzm2**2 + 24.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2 + 8.D0/(u + t)/(t + s)*s**(-1)*rzm2**2*c0cmzuswww - 48.D0
     &    /(u + t)/(t + s)*s**(-1)*rwm2*rzm2*c0cmzuswww + 8.D0/(u + t)
     &    /(t + s)*rwm2**(-1)*rzm2 - 16.D0/(u + t)/(t + s)*rzm2*
     &    c0cmzuswww + 96.D0/(u + t)/(t + s)*rwm2*c0cmzuswww - 4.D0/(u
     &     + t)/(t + s)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D
     &    0/(u + t)/(t + s)/(t + s)*s**(-2)*rwm2**(-1)*rzm2**4*b0fusww
     &     + 24.D0/(u + t)/(t + s)/(t + s)*s**(-2)*rzm2**3*b0fmzww - 24.
     &    D0/(u + t)/(t + s)/(t + s)*s**(-2)*rzm2**3*b0fusww - 4.D0/(u
     &     + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D
     &    0/(u + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**3*b0fusww
     &     + 24.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**2*b0fmzww - 24.
     &    D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**2*b0fusww + 8.D0/(u
     &     + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**2*b0fmzww - 8.D0/(u + 
     &    t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**2*b0fusww - 48.D0/(u + t)
     &    /(t + s)/(t + s)*rzm2*b0fmzww + 48.D0/(u + t)/(t + s)/(t + s)
     &    *rzm2*b0fusww + 4.D0/(u + s)*s**(-3)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 4.D0/(u + s)*s**(-3)*rwm2**(-1)*rzm2**3*b0ftsww - 
     &    24.D0/(u + s)*s**(-3)*rzm2**2*b0fmzww + 24.D0/(u + s)*s**(-3)
     &    *rzm2**2*b0ftsww - 8.D0/(u + s)*s**(-3)*t*rwm2**(-1)*rzm2**2*
     &    b0fmzww + 8.D0/(u + s)*s**(-3)*t*rwm2**(-1)*rzm2**2*b0ftsww
     &     + 48.D0/(u + s)*s**(-3)*t*rzm2*b0fmzww - 48.D0/(u + s)*
     &    s**(-3)*t*rzm2*b0ftsww + 4.D0/(u + s)*s**(-3)*t**2*rwm2**(-1)
     &    *rzm2*b0fmzww - 4.D0/(u + s)*s**(-3)*t**2*rwm2**(-1)*rzm2*
     &    b0ftsww - 24.D0/(u + s)*s**(-3)*t**2*b0fmzww + 24.D0/(u + s)*
     &    s**(-3)*t**2*b0ftsww + 2.D0/(u + s)*s**(-2)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 2.D0/(u + s)*s**(-2)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 12.D0/(u + s)*s**(-2)*t**(-1)*
     &    rzm2**2*b0fmzww + 12.D0/(u + s)*s**(-2)*t**(-1)*rzm2**2*
     &    b0ftsww + 2.D0/(u + s)*s**(-2)*rwm2**(-1)*rzm2**2 - 2.D0/(u
     &     + s)*s**(-2)*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)*
     &    s**(-2)*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0/(u + s)*s**(-2)*
     &    rzm2 + 12.D0/(u + s)*s**(-2)*rzm2*b0fmzww - 12.D0/(u + s)*
     &    s**(-2)*rzm2*b0ftsww - 4.D0/(u + s)*s**(-2)*rzm2**2*
     &    c0cmztswww + 24.D0/(u + s)*s**(-2)*rwm2*rzm2*c0cmztswww - 4.D0
     &    /(u + s)*s**(-2)*t*rwm2**(-1)*rzm2 + 24.D0/(u + s)*s**(-2)*t
     &     + 8.D0/(u + s)*s**(-2)*t*rzm2*c0cmztswww - 48.D0/(u + s)*
     &    s**(-2)*t*rwm2*c0cmztswww + 2.D0/(u + s)*s**(-2)*t**2*
     &    rwm2**(-1) - 4.D0/(u + s)*s**(-2)*t**2*c0cmztswww - 8.D0/(u
     &     + s)*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**3*b0fmzww + 8.D0/(u + 
     &    s)*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**3*b0ftsww + 48.D0/(u + s)
     &    *s**(-1)*t**(-2)*rzm2**2*b0fmzww - 48.D0/(u + s)*s**(-1)*
     &    t**(-2)*rzm2**2*b0ftsww + 6.D0/(u + s)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**2 + 2.D0/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fmzww - 2.D0/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**2*b0ftsww - 36.D0/(u + s)*s**(-1)*t**(-1)*rzm2 - 12.D0
     &    /(u + s)*s**(-1)*t**(-1)*rzm2*b0fmzww + 12.D0/(u + s)*s**(-1)
     &    *t**(-1)*rzm2*b0ftsww - 12.D0/(u + s)*s**(-1)*t**(-1)*rzm2**2
     &    *c0cmztswww + 72.D0/(u + s)*s**(-1)*t**(-1)*rwm2*rzm2*
     &    c0cmztswww - 8.D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2 + 2.D0/(u
     &     + s)*s**(-1)*rwm2**(-1)*rzm2*b0fmzww - 2.D0/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2*b0ftsww + 48.D0/(u + s)*s**(-1) - 12.D0/(u + 
     &    s)*s**(-1)*b0fmzww + 12.D0/(u + s)*s**(-1)*b0ftsww + 16.D0/(u
     &     + s)*s**(-1)*rzm2*c0cmztswww - 96.D0/(u + s)*s**(-1)*rwm2*
     &    c0cmztswww + 2.D0/(u + s)*s**(-1)*t*rwm2**(-1) - 4.D0/(u + s)
     &    *s**(-1)*t*c0cmztswww + 2.D0/(u + s)/(u + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 2.D0/(u + s)/(u + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 12.D0/(u + s)/(u + s)*s**(-2)*
     &    rzm2**2*b0fmzww + 12.D0/(u + s)/(u + s)*s**(-2)*rzm2**2*
     &    b0ftsww - 4.D0/(u + s)/(u + s)*s**(-2)*t*rwm2**(-1)*rzm2**2*
     &    b0fmzww + 4.D0/(u + s)/(u + s)*s**(-2)*t*rwm2**(-1)*rzm2**2*
     &    b0ftsww + 24.D0/(u + s)/(u + s)*s**(-2)*t*rzm2*b0fmzww - 24.D0
     &    /(u + s)/(u + s)*s**(-2)*t*rzm2*b0ftsww + 2.D0/(u + s)/(u + s
     &    )*s**(-2)*t**2*rwm2**(-1)*rzm2*b0fmzww - 2.D0/(u + s)/(u + s)
     &    *s**(-2)*t**2*rwm2**(-1)*rzm2*b0ftsww - 12.D0/(u + s)/(u + s)
     &    *s**(-2)*t**2*b0fmzww + 12.D0/(u + s)/(u + s)*s**(-2)*t**2*
     &    b0ftsww + 6.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 6.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 36.D0/(u + s)/(u + s)*s**(-1)*
     &    t**(-1)*rzm2**2*b0fmzww + 36.D0/(u + s)/(u + s)*s**(-1)*
     &    t**(-1)*rzm2**2*b0ftsww - 8.D0/(u + s)/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 8.D0/(u + s)/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**2*b0ftsww + 48.D0/(u + s)/(u + s)*s**(-1)*
     &    rzm2*b0fmzww - 48.D0/(u + s)/(u + s)*s**(-1)*rzm2*b0ftsww + 2.
     &    D0/(u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2*b0fmzww - 2.D0/(
     &    u + s)/(u + s)*s**(-1)*t*rwm2**(-1)*rzm2*b0ftsww - 12.D0/(u
     &     + s)/(u + s)*s**(-1)*t*b0fmzww + 12.D0/(u + s)/(u + s)*
     &    s**(-1)*t*b0ftsww + 4.D0/(t + s)*s**(-3)*u**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fmzww - 4.D0/(t + s)*s**(-3)*u**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fusww - 24.D0/(t + s)*s**(-3)*u**(-1)*rzm2**3*
     &    b0fmzww + 24.D0/(t + s)*s**(-3)*u**(-1)*rzm2**3*b0fusww + 8.D0
     &    /(t + s)*s**(-3)*rwm2**(-1)*rzm2**3*b0fmzww - 8.D0/(t + s)*
     &    s**(-3)*rwm2**(-1)*rzm2**3*b0fusww - 48.D0/(t + s)*s**(-3)*
     &    rzm2**2*b0fmzww + 48.D0/(t + s)*s**(-3)*rzm2**2*b0fusww - 4.D0
     &    /(t + s)*s**(-3)*u*rwm2**(-1)*rzm2**2*b0fmzww + 4.D0/(t + s)*
     &    s**(-3)*u*rwm2**(-1)*rzm2**2*b0fusww + 24.D0/(t + s)*s**(-3)*
     &    u*rzm2*b0fmzww - 24.D0/(t + s)*s**(-3)*u*rzm2*b0fusww + 2.D0
     &    /(t + s)*s**(-2)*u**(-1)*rwm2**(-1)*rzm2**3 - 12.D0/(t + s)*
     &    s**(-2)*u**(-1)*rzm2**2 - 4.D0/(t + s)*s**(-2)*u**(-1)*
     &    rzm2**3*c0cmzuswww + 24.D0/(t + s)*s**(-2)*u**(-1)*rwm2*
     &    rzm2**2*c0cmzuswww + 4.D0/(t + s)*s**(-2)*rwm2**(-1)*rzm2**2
     &     - 6.D0/(t + s)*s**(-2)*rwm2**(-1)*rzm2**2*b0fmzww + 6.D0/(t
     &     + s)*s**(-2)*rwm2**(-1)*rzm2**2*b0fusww - 24.D0/(t + s)*
     &    s**(-2)*rzm2 + 36.D0/(t + s)*s**(-2)*rzm2*b0fmzww - 36.D0/(t
     &     + s)*s**(-2)*rzm2*b0fusww - 8.D0/(t + s)*s**(-2)*rzm2**2*
     &    c0cmzuswww + 48.D0/(t + s)*s**(-2)*rwm2*rzm2*c0cmzuswww - 2.D0
     &    /(t + s)*s**(-2)*u*rwm2**(-1)*rzm2 + 2.D0/(t + s)*s**(-2)*u*
     &    rwm2**(-1)*rzm2*b0fmzww - 2.D0/(t + s)*s**(-2)*u*rwm2**(-1)*
     &    rzm2*b0fusww + 12.D0/(t + s)*s**(-2)*u - 12.D0/(t + s)*
     &    s**(-2)*u*b0fmzww + 12.D0/(t + s)*s**(-2)*u*b0fusww + 4.D0/(t
     &     + s)*s**(-2)*u*rzm2*c0cmzuswww - 24.D0/(t + s)*s**(-2)*u*
     &    rwm2*c0cmzuswww + 6.D0/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2**2 - 6.D0/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww + 6.D0/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fusww - 36.D0/(t + s)*s**(-1)*u**(-1)*rzm2 + 36.D0/(t + s)*
     &    s**(-1)*u**(-1)*rzm2*b0fmzww - 36.D0/(t + s)*s**(-1)*u**(-1)*
     &    rzm2*b0fusww - 12.D0/(t + s)*s**(-1)*u**(-1)*rzm2**2*
     &    c0cmzuswww + 72.D0/(t + s)*s**(-1)*u**(-1)*rwm2*rzm2*
     &    c0cmzuswww + 4.D0/(t + s)*s**(-1)*rwm2**(-1)*rzm2 - 2.D0/(t
     &     + s)*s**(-1)*rwm2**(-1)*rzm2*b0fmzww + 2.D0/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2*b0fusww - 24.D0/(t + s)*s**(-1) + 12.D0/(t + 
     &    s)*s**(-1)*b0fmzww - 12.D0/(t + s)*s**(-1)*b0fusww - 8.D0/(t
     &     + s)*s**(-1)*rzm2*c0cmzuswww + 48.D0/(t + s)*s**(-1)*rwm2*
     &    c0cmzuswww - 2.D0/(t + s)*s**(-1)*u*rwm2**(-1) + 4.D0/(t + s)
     &    *s**(-1)*u*c0cmzuswww + 2.D0/(t + s)*u**(-1)*rwm2**(-1)*rzm2
     &     - 2.D0/(t + s)*u**(-1)*rwm2**(-1)*rzm2*b0fmzww + 2.D0/(t + s
     &    )*u**(-1)*rwm2**(-1)*rzm2*b0fusww - 12.D0/(t + s)*u**(-1) + 
     &    12.D0/(t + s)*u**(-1)*b0fmzww - 12.D0/(t + s)*u**(-1)*b0fusww
     &     - 4.D0/(t + s)*u**(-1)*rzm2*c0cmzuswww + 24.D0/(t + s)*
     &    u**(-1)*rwm2*c0cmzuswww - 2.D0/(t + s)*rwm2**(-1) + 4.D0/(t
     &     + s)*c0cmzuswww + 2.D0/(t + s)/(t + s)*s**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**4*b0fmzww - 2.D0/(t + s)/(t + s)*s**(-2)*
     &    u**(-1)*rwm2**(-1)*rzm2**4*b0fusww - 12.D0/(t + s)/(t + s)*
     &    s**(-2)*u**(-1)*rzm2**3*b0fmzww + 12.D0/(t + s)/(t + s)*
     &    s**(-2)*u**(-1)*rzm2**3*b0fusww + 4.D0/(t + s)/(t + s)*
     &    s**(-2)*rwm2**(-1)*rzm2**3*b0fmzww - 4.D0/(t + s)/(t + s)*
     &    s**(-2)*rwm2**(-1)*rzm2**3*b0fusww - 24.D0/(t + s)/(t + s)*
     &    s**(-2)*rzm2**2*b0fmzww + 24.D0/(t + s)/(t + s)*s**(-2)*
     &    rzm2**2*b0fusww - 2.D0/(t + s)/(t + s)*s**(-2)*u*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 2.D0/(t + s)/(t + s)*s**(-2)*u*rwm2**(-1)*
     &    rzm2**2*b0fusww + 12.D0/(t + s)/(t + s)*s**(-2)*u*rzm2*
     &    b0fmzww - 12.D0/(t + s)/(t + s)*s**(-2)*u*rzm2*b0fusww + 6.D0
     &    /(t + s)/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww
     &     - 6.D0/(t + s)/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fusww - 36.D0/(t + s)/(t + s)*s**(-1)*u**(-1)*rzm2**2*
     &    b0fmzww + 36.D0/(t + s)/(t + s)*s**(-1)*u**(-1)*rzm2**2*
     &    b0fusww + 4.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww - 4.D0/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fusww - 24.D0/(t + s)/(t + s)*s**(-1)*rzm2*b0fmzww + 24.D0
     &    /(t + s)/(t + s)*s**(-1)*rzm2*b0fusww - 2.D0/(t + s)/(t + s)*
     &    s**(-1)*u*rwm2**(-1)*rzm2*b0fmzww + 2.D0/(t + s)/(t + s)*
     &    s**(-1)*u*rwm2**(-1)*rzm2*b0fusww + 12.D0/(t + s)/(t + s)*
     &    s**(-1)*u*b0fmzww - 12.D0/(t + s)/(t + s)*s**(-1)*u*b0fusww
     &     + 2.D0/(t + s)/(t + s)*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 
     &    2.D0/(t + s)/(t + s)*u**(-1)*rwm2**(-1)*rzm2**2*b0fusww - 12.D
     &    0/(t + s)/(t + s)*u**(-1)*rzm2*b0fmzww + 12.D0/(t + s)/(t + s
     &    )*u**(-1)*rzm2*b0fusww - 2.D0/(t + s)/(t + s)*rwm2**(-1)*rzm2
     &    *b0fmzww + 2.D0/(t + s)/(t + s)*rwm2**(-1)*rzm2*b0fusww + 12.D
     &    0/(t + s)/(t + s)*b0fmzww - 12.D0/(t + s)/(t + s)*b0fusww )

      ewamp(1,2,1,1) =
     &  - 12.D0 - 6.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 6.D0
     &    *s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3*b0fusww + 36.D0*s**(-1)*
     &    t**(-1)*rzm2**2*b0fmzww - 36.D0*s**(-1)*t**(-1)*rzm2**2*
     &    b0fusww + 2.D0*s**(-1)*t**(-1)*u*rwm2**(-1)*rzm2**2*b0fmzww
     &     - 2.D0*s**(-1)*t**(-1)*u*rwm2**(-1)*rzm2**2*b0fusww - 12.D0*
     &    s**(-1)*t**(-1)*u*rzm2*b0fmzww + 12.D0*s**(-1)*t**(-1)*u*rzm2
     &    *b0fusww + 2.D0*t**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*
     &    t**(-1)*rwm2**(-1)*rzm2**2*b0fusww - 12.D0*t**(-1)*rzm2*
     &    b0fmzww + 12.D0*t**(-1)*rzm2*b0fusww - 14.D0*t**(-1)*rzm2**2*
     &    c0cmzuswww + 14.D0*t**(-1)*rzm2**2*c0ccqswww - 12.D0*t**(-1)*
     &    rwm2*rzm2*c0cmzuswww + 12.D0*t**(-1)*rwm2*rzm2*c0ccqswww + 14.
     &    D0*t**(-1)*u*rzm2*c0cmzuswww - 14.D0*t**(-1)*u*rzm2*
     &    c0cmzqswww + 14.D0*t**(-1)*u*rzm2*c0ccuswww - 14.D0*t**(-1)*u
     &    *rzm2*c0ccqswww + 14.D0*t**(-1)*u*rzm2**2*d0ccmzcqsuswwww + 
     &    12.D0*t**(-1)*u*rwm2*c0cmzuswww - 12.D0*t**(-1)*u*rwm2*
     &    c0cmzqswww + 12.D0*t**(-1)*u*rwm2*c0ccuswww - 12.D0*t**(-1)*u
     &    *rwm2*c0ccqswww + 12.D0*t**(-1)*u*rwm2*rzm2*d0ccmzcqsuswwww
     &     - 14.D0*t**(-1)*u**2*rzm2*d0ccmzcqsuswwww - 12.D0*t**(-1)*
     &    u**2*rwm2*d0ccmzcqsuswwww + 2.D0*u**(-1)*rzm2**2*c0cmztswww
     &     - 2.D0*u**(-1)*rzm2**2*c0ccqswww - 12.D0*u**(-1)*rwm2*rzm2*
     &    c0cmztswww + 12.D0*u**(-1)*rwm2*rzm2*c0ccqswww + 2.D0*
     &    rwm2**(-1)*rzm2 - 18.D0*rzm2*c0cmzuswww - 14.D0*rzm2*
     &    c0ccuswww - 4.D0*rzm2*c0cctswww + 4.D0*rzm2*c0ccqswww - 16.D0
     &    *rzm2**2*d0ccmzcqsuswwww + 12.D0*rwm2*c0cmzuswww - 12.D0*rwm2
     &    *c0ccuswww + 24.D0*rwm2*c0cctswww - 24.D0*rwm2*c0ccqswww + 28.
     &    D0*rwm2*rzm2*d0cccmztsuswwww + 28.D0*rwm2*rzm2*
     &    d0ccmzcqsuswwww + 28.D0*rwm2*rzm2*d0cccmzqstswwww + 24.D0*
     &    rwm2**2*d0cccmztsuswwww + 24.D0*rwm2**2*d0ccmzcqsuswwww + 24.D
     &    0*rwm2**2*d0cccmzqstswwww + 2.D0*u*rzm2*d0ccmzcqsuswwww - 12.D
     &    0*u*rwm2*d0ccmzcqsuswwww - 2.D0*t*u**(-1)*rzm2*c0cmztswww + 2.
     &    D0*t*u**(-1)*rzm2*c0cmzqswww - 2.D0*t*u**(-1)*rzm2*c0cctswww
     &     + 2.D0*t*u**(-1)*rzm2*c0ccqswww - 2.D0*t*u**(-1)*rzm2**2*
     &    d0cccmzqstswwww + 12.D0*t*u**(-1)*rwm2*c0cmztswww - 12.D0*t*
     &    u**(-1)*rwm2*c0cmzqswww + 12.D0*t*u**(-1)*rwm2*c0cctswww - 12.
     &    D0*t*u**(-1)*rwm2*c0ccqswww + 12.D0*t*u**(-1)*rwm2*rzm2*
     &    d0cccmzqstswwww - 6.D0*t*rzm2*d0cccmztsuswwww - 8.D0*t*rzm2*
     &    d0ccmzcqsuswwww - 6.D0*t*rzm2*d0cccmzqstswwww - 12.D0*t*rwm2*
     &    d0cccmztsuswwww - 12.D0*t*rwm2*d0cccmzqstswwww + 2.D0*t**2*
     &    u**(-1)*rzm2*d0cccmzqstswwww - 12.D0*t**2*u**(-1)*rwm2*
     &    d0cccmzqstswwww + 4.D0/(u + t)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fmzww - 4.D0/(u + t)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**4*b0fusww - 24.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*
     &    b0fmzww + 24.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*b0fusww - 4.D0
     &    /(u + t)*t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(u + t)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(u + t)*t**(-1)*
     &    rzm2**2*b0fmzww - 24.D0/(u + t)*t**(-1)*rzm2**2*b0fusww - 2.D0
     &    /(u + t)*rwm2**(-1)*rzm2**2 + 2.D0/(u + t)*rwm2**(-1)*rzm2**2
     &    *b0fmzww - 2.D0/(u + t)*rwm2**(-1)*rzm2**2*b0fusww + 12.D0/(u
     &     + t)*rzm2 - 12.D0/(u + t)*rzm2*b0fmzww + 12.D0/(u + t)*rzm2*
     &    b0fusww + 22.D0/(u + t)*rzm2**2*c0cmzuswww - 2.D0/(u + t)*
     &    rzm2**2*c0cmztswww - 16.D0/(u + t)*rzm2**2*c0ccqswww - 36.D0
     &    /(u + t)*rwm2*rzm2*c0cmzuswww + 12.D0/(u + t)*rwm2*rzm2*
     &    c0cmztswww + 14.D0/(u + t)*t*rzm2*c0cmzuswww + 2.D0/(u + t)*t
     &    *rzm2*c0cmztswww + 14.D0/(u + t)*t*rzm2*c0ccuswww + 2.D0/(u
     &     + t)*t*rzm2*c0cctswww + 16.D0/(u + t)*t*rzm2**2*
     &    d0ccmzcqsuswwww + 12.D0/(u + t)*t*rwm2*c0cmzuswww - 12.D0/(u
     &     + t)*t*rwm2*c0cmztswww + 12.D0/(u + t)*t*rwm2*c0ccuswww - 12.
     &    D0/(u + t)*t*rwm2*c0cctswww - 32.D0/(u + t)*t*rwm2*rzm2*
     &    d0cccmztsuswwww - 32.D0/(u + t)*t*rwm2*rzm2*d0ccmzcqsuswwww
     &     - 32.D0/(u + t)*t*rwm2*rzm2*d0cccmzqstswwww + 6.D0/(u + t)*
     &    t**2*rzm2*d0cccmztsuswwww + 8.D0/(u + t)*t**2*rzm2*
     &    d0ccmzcqsuswwww + 8.D0/(u + t)*t**2*rzm2*d0cccmzqstswwww + 12.
     &    D0/(u + t)*t**2*rwm2*d0cccmztsuswwww - 4.D0/(u + t)/(t + s)*
     &    s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D0/(u + t)/(t + s)*
     &    s**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 24.D0/(u + t)/(t + s)*
     &    s**(-1)*rzm2**3*b0fmzww - 24.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**3*b0fusww + 2.D0/(u + t)/(t + s)*rwm2**(-1)*rzm2**3 - 
     &    12.D0/(u + t)/(t + s)*rzm2**2 - 4.D0/(u + t)/(t + s)*rzm2**3*
     &    c0cmzuswww + 24.D0/(u + t)/(t + s)*rwm2*rzm2**2*c0cmzuswww + 
     &    2.D0/(u + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**4*b0fmzww - 2.D0
     &    /(u + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**4*b0fusww - 12.D0/(
     &    u + t)/(t + s)/(t + s)*rzm2**3*b0fmzww + 12.D0/(u + t)/(t + s
     &    )/(t + s)*rzm2**3*b0fusww + 6.D0/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 6.D0/(t + s)*s**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fusww - 36.D0/(t + s)*s**(-1)*rzm2**2*b0fmzww + 36.D0/(t + 
     &    s)*s**(-1)*rzm2**2*b0fusww - 2.D0/(t + s)*s**(-1)*u*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(t + s)*s**(-1)*u*
     &    rwm2**(-1)*rzm2**2*b0fusww + 12.D0/(t + s)*s**(-1)*u*rzm2*
     &    b0fmzww - 12.D0/(t + s)*s**(-1)*u*rzm2*b0fusww - 2.D0/(t + s)
     &    *rwm2**(-1)*rzm2**2 + 2.D0/(t + s)*rwm2**(-1)*rzm2**2*b0fmzww
     &     - 2.D0/(t + s)*rwm2**(-1)*rzm2**2*b0fusww + 12.D0/(t + s)*
     &    rzm2 - 12.D0/(t + s)*rzm2*b0fmzww + 12.D0/(t + s)*rzm2*
     &    b0fusww + 4.D0/(t + s)*rzm2**2*c0cmzuswww - 24.D0/(t + s)*
     &    rwm2*rzm2*c0cmzuswww - 2.D0/(t + s)/(t + s)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 2.D0/(t + s)/(t + s)*rwm2**(-1)*rzm2**3*
     &    b0fusww + 12.D0/(t + s)/(t + s)*rzm2**2*b0fmzww - 12.D0/(t + 
     &    s)/(t + s)*rzm2**2*b0fusww

      ewamp(1,2,1,2) =
     &  + 12.D0 + 4.D0*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 4.D0
     &    *s**(-1)*t**(-1)*rwm2**(-1)*rzm2**3*b0fusww - 24.D0*s**(-1)*
     &    t**(-1)*rzm2**2*b0fmzww + 24.D0*s**(-1)*t**(-1)*rzm2**2*
     &    b0fusww + 2.D0*s**(-1)*rzm2**2*c0cmztswww - 2.D0*s**(-1)*
     &    rzm2**2*c0ccuswww - 12.D0*s**(-1)*rwm2*rzm2*c0cmztswww + 12.D0
     &    *s**(-1)*rwm2*rzm2*c0ccuswww + 2.D0*s**(-1)*t*rzm2*c0cmzuswww
     &     - 2.D0*s**(-1)*t*rzm2*c0cmztswww + 2.D0*s**(-1)*t*rzm2*
     &    c0ccuswww - 2.D0*s**(-1)*t*rzm2*c0cctswww - 2.D0*s**(-1)*t*
     &    rzm2**2*d0cccmztsuswwww - 12.D0*s**(-1)*t*rwm2*c0cmzuswww + 
     &    12.D0*s**(-1)*t*rwm2*c0cmztswww - 12.D0*s**(-1)*t*rwm2*
     &    c0ccuswww + 12.D0*s**(-1)*t*rwm2*c0cctswww + 12.D0*s**(-1)*t*
     &    rwm2*rzm2*d0cccmztsuswwww + 2.D0*s**(-1)*t**2*rzm2*
     &    d0cccmztsuswwww - 12.D0*s**(-1)*t**2*rwm2*d0cccmztsuswwww + 2.
     &    D0*t**(-2)*u*rwm2**(-1)*rzm2**3*c0cmzuswww - 2.D0*t**(-2)*u*
     &    rwm2**(-1)*rzm2**3*c0ccqswww - 12.D0*t**(-2)*u*rzm2**2*
     &    c0cmzuswww + 12.D0*t**(-2)*u*rzm2**2*c0ccqswww - 4.D0*t**(-2)
     &    *u**2*rwm2**(-1)*rzm2**2*c0cmzuswww + 2.D0*t**(-2)*u**2*
     &    rwm2**(-1)*rzm2**2*c0cmzqswww - 2.D0*t**(-2)*u**2*rwm2**(-1)*
     &    rzm2**2*c0ccuswww + 4.D0*t**(-2)*u**2*rwm2**(-1)*rzm2**2*
     &    c0ccqswww - 2.D0*t**(-2)*u**2*rwm2**(-1)*rzm2**3*
     &    d0ccmzcqsuswwww + 24.D0*t**(-2)*u**2*rzm2*c0cmzuswww - 12.D0*
     &    t**(-2)*u**2*rzm2*c0cmzqswww + 12.D0*t**(-2)*u**2*rzm2*
     &    c0ccuswww - 24.D0*t**(-2)*u**2*rzm2*c0ccqswww + 12.D0*t**(-2)
     &    *u**2*rzm2**2*d0ccmzcqsuswwww + 2.D0*t**(-2)*u**3*rwm2**(-1)*
     &    rzm2*c0cmzuswww - 2.D0*t**(-2)*u**3*rwm2**(-1)*rzm2*
     &    c0cmzqswww + 2.D0*t**(-2)*u**3*rwm2**(-1)*rzm2*c0ccuswww - 2.D
     &    0*t**(-2)*u**3*rwm2**(-1)*rzm2*c0ccqswww + 4.D0*t**(-2)*u**3*
     &    rwm2**(-1)*rzm2**2*d0ccmzcqsuswwww - 12.D0*t**(-2)*u**3*
     &    c0cmzuswww + 12.D0*t**(-2)*u**3*c0cmzqswww - 12.D0*t**(-2)*
     &    u**3*c0ccuswww + 12.D0*t**(-2)*u**3*c0ccqswww - 24.D0*t**(-2)
     &    *u**3*rzm2*d0ccmzcqsuswwww - 2.D0*t**(-2)*u**4*rwm2**(-1)*
     &    rzm2*d0ccmzcqsuswwww + 12.D0*t**(-2)*u**4*d0ccmzcqsuswwww - 4.
     &    D0*t**(-1)*rwm2**(-1)*rzm2**2*b0fmzww + 4.D0*t**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fqsww + 24.D0*t**(-1)*rzm2*b0fmzww - 24.D
     &    0*t**(-1)*rzm2*b0fqsww + 4.D0*t**(-1)*rzm2**2*c0cmzuswww - 4.D
     &    0*t**(-1)*rzm2**2*c0ccqswww - 24.D0*t**(-1)*rwm2*rzm2*
     &    c0cmzuswww + 24.D0*t**(-1)*rwm2*rzm2*c0ccqswww + 4.D0*t**(-1)
     &    *u*rwm2**(-1)*rzm2*b0fusww - 4.D0*t**(-1)*u*rwm2**(-1)*rzm2*
     &    b0fqsww - 2.D0*t**(-1)*u*rwm2**(-1)*rzm2**2*c0cmzuswww + 2.D0
     &    *t**(-1)*u*rwm2**(-1)*rzm2**2*c0cmzqswww + 4.D0*t**(-1)*u*
     &    rwm2**(-1)*rzm2**2*c0ccqswww - 24.D0*t**(-1)*u*b0fusww + 24.D0
     &    *t**(-1)*u*b0fqsww + 8.D0*t**(-1)*u*rzm2*c0cmzuswww - 8.D0*
     &    t**(-1)*u*rzm2*c0cmzqswww - 4.D0*t**(-1)*u*rzm2*c0ccuswww - 
     &    20.D0*t**(-1)*u*rzm2*c0ccqswww - 8.D0*t**(-1)*u*rzm2**2*
     &    d0ccmzcqsuswwww + 24.D0*t**(-1)*u*rwm2*c0cmzuswww - 24.D0*
     &    t**(-1)*u*rwm2*c0cmzqswww + 24.D0*t**(-1)*u*rwm2*c0ccuswww - 
     &    24.D0*t**(-1)*u*rwm2*c0ccqswww + 48.D0*t**(-1)*u*rwm2*rzm2*
     &    d0ccmzcqsuswwww + 2.D0*t**(-1)*u**2*rwm2**(-1)*rzm2*
     &    c0cmzuswww - 4.D0*t**(-1)*u**2*rwm2**(-1)*rzm2*c0cmzqswww + 2.
     &    D0*t**(-1)*u**2*rwm2**(-1)*rzm2*c0ccuswww - 4.D0*t**(-1)*u**2
     &    *rwm2**(-1)*rzm2*c0ccqswww + 4.D0*t**(-1)*u**2*rwm2**(-1)*
     &    rzm2**2*d0ccmzcqsuswwww - 12.D0*t**(-1)*u**2*c0cmzuswww + 24.D
     &    0*t**(-1)*u**2*c0cmzqswww - 12.D0*t**(-1)*u**2*c0ccuswww + 24.
     &    D0*t**(-1)*u**2*c0ccqswww - 16.D0*t**(-1)*u**2*rzm2*
     &    d0ccmzcqsuswwww - 48.D0*t**(-1)*u**2*rwm2*d0ccmzcqsuswwww - 4.
     &    D0*t**(-1)*u**3*rwm2**(-1)*rzm2*d0ccmzcqsuswwww + 24.D0*
     &    t**(-1)*u**3*d0ccmzcqsuswwww - 2.D0*rwm2**(-1)*rzm2 + 2.D0*
     &    rwm2**(-1)*rzm2*b0fusww - 2.D0*rwm2**(-1)*rzm2*b0fqsww - 12.D0
     &    *b0fusww + 12.D0*b0fqsww + 32.D0*rzm2*c0cmzuswww - 12.D0*rzm2
     &    *c0cmzqswww + 16.D0*rzm2*c0ccuswww - 28.D0*rzm2*c0ccqswww + 
     &    16.D0*rzm2**2*d0ccmzcqsuswwww - 24.D0*rwm2*c0cmzqswww - 24.D0
     &    *rwm2*c0ccqswww - 4.D0*rwm2*rzm2*d0cccmztsuswwww - 4.D0*rwm2*
     &    rzm2*d0ccmzcqsuswwww - 4.D0*rwm2*rzm2*d0cccmzqstswwww + 24.D0
     &    *rwm2**2*d0cccmztsuswwww + 24.D0*rwm2**2*d0ccmzcqsuswwww + 24.
     &    D0*rwm2**2*d0cccmzqstswwww - 2.D0*u*rwm2**(-1)*rzm2*
     &    c0cmzqswww - 2.D0*u*rwm2**(-1)*rzm2*c0ccqswww - 16.D0*u*
     &    c0cmzuswww + 28.D0*u*c0cmzqswww - 16.D0*u*c0ccuswww + 28.D0*u
     &    *c0ccqswww - 24.D0*u*rzm2*d0ccmzcqsuswwww - 48.D0*u*rwm2*
     &    d0ccmzcqsuswwww - 2.D0*u**2*rwm2**(-1)*rzm2*d0ccmzcqsuswwww
     &     + 28.D0*u**2*d0ccmzcqsuswwww + 16.D0*t*c0cmzqswww + 16.D0*t*
     &    c0ccqswww - 32.D0*t*rwm2*d0cccmztsuswwww - 32.D0*t*rwm2*
     &    d0ccmzcqsuswwww - 32.D0*t*rwm2*d0cccmzqstswwww + 16.D0*t*u*
     &    d0ccmzcqsuswwww + 8.D0*t**2*d0cccmztsuswwww + 8.D0*t**2*
     &    d0ccmzcqsuswwww + 8.D0*t**2*d0cccmzqstswwww - 4.D0/(u + t)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D0/(u + t)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*b0fusww + 24.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**3*b0fmzww - 24.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**3*b0fusww + 4.D0/(u + t)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fusww - 24.D0/(u + t)*t**(-1)*rzm2**2*b0fmzww + 24.D0/(u + 
     &    t)*t**(-1)*rzm2**2*b0fusww + 2.D0/(u + t)*rwm2**(-1)*rzm2**2
     &     + 2.D0/(u + t)*rwm2**(-1)*rzm2**2*b0fusww - 2.D0/(u + t)*
     &    rwm2**(-1)*rzm2**2*b0fqsww - 12.D0/(u + t)*rzm2 - 12.D0/(u + 
     &    t)*rzm2*b0fusww + 12.D0/(u + t)*rzm2*b0fqsww - 22.D0/(u + t)*
     &    rzm2**2*c0cmzuswww + 2.D0/(u + t)*rzm2**2*c0cmztswww + 16.D0
     &    /(u + t)*rzm2**2*c0ccqswww + 36.D0/(u + t)*rwm2*rzm2*
     &    c0cmzuswww - 12.D0/(u + t)*rwm2*rzm2*c0cmztswww - 14.D0/(u + 
     &    t)*t*rzm2*c0cmzuswww - 2.D0/(u + t)*t*rzm2*c0cmztswww - 14.D0
     &    /(u + t)*t*rzm2*c0ccuswww - 2.D0/(u + t)*t*rzm2*c0cctswww - 
     &    16.D0/(u + t)*t*rzm2**2*d0ccmzcqsuswwww - 12.D0/(u + t)*t*
     &    rwm2*c0cmzuswww + 12.D0/(u + t)*t*rwm2*c0cmztswww - 12.D0/(u
     &     + t)*t*rwm2*c0ccuswww + 12.D0/(u + t)*t*rwm2*c0cctswww + 32.D
     &    0/(u + t)*t*rwm2*rzm2*d0cccmztsuswwww + 32.D0/(u + t)*t*rwm2*
     &    rzm2*d0ccmzcqsuswwww + 32.D0/(u + t)*t*rwm2*rzm2*
     &    d0cccmzqstswwww - 6.D0/(u + t)*t**2*rzm2*d0cccmztsuswwww - 8.D
     &    0/(u + t)*t**2*rzm2*d0ccmzcqsuswwww - 8.D0/(u + t)*t**2*rzm2*
     &    d0cccmzqstswwww - 12.D0/(u + t)*t**2*rwm2*d0cccmztsuswwww + 4.
     &    D0/(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 4.D0
     &    /(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**4*b0fusww - 24.D0/(
     &    u + t)/(t + s)*s**(-1)*rzm2**3*b0fmzww + 24.D0/(u + t)/(t + s
     &    )*s**(-1)*rzm2**3*b0fusww - 2.D0/(u + t)/(t + s)*rwm2**(-1)*
     &    rzm2**3 + 12.D0/(u + t)/(t + s)*rzm2**2 + 4.D0/(u + t)/(t + s
     &    )*rzm2**3*c0cmzuswww - 24.D0/(u + t)/(t + s)*rwm2*rzm2**2*
     &    c0cmzuswww - 2.D0/(u + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 2.D0/(u + t)/(t + s)/(t + s)*rwm2**(-1)*rzm2**4*
     &    b0fusww + 12.D0/(u + t)/(t + s)/(t + s)*rzm2**3*b0fmzww - 12.D
     &    0/(u + t)/(t + s)/(t + s)*rzm2**3*b0fusww - 4.D0/(t + s)*
     &    s**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(t + s)*s**(-1)*rzm2**2*
     &    b0fmzww - 24.D0/(t + s)*s**(-1)*rzm2**2*b0fusww + 2.D0/(t + s
     &    )*rwm2**(-1)*rzm2**2 - 12.D0/(t + s)*rzm2 - 4.D0/(t + s)*
     &    rzm2**2*c0cmzuswww + 24.D0/(t + s)*rwm2*rzm2*c0cmzuswww + 2.D0
     &    /(t + s)/(t + s)*rwm2**(-1)*rzm2**3*b0fmzww - 2.D0/(t + s)/(t
     &     + s)*rwm2**(-1)*rzm2**3*b0fusww - 12.D0/(t + s)/(t + s)*
     &    rzm2**2*b0fmzww + 12.D0/(t + s)/(t + s)*rzm2**2*b0fusww

      ewamp(1,2,1,3) =
     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz**(-1) * (  - 4.D0*s**(-1)*t*
     &    c0cmzuswww + 4.D0*s**(-1)*t*c0cmztswww - 4.D0*s**(-1)*t*
     &    c0ccuswww + 4.D0*s**(-1)*t*c0cctswww - 4.D0*s**(-1)*t**2*
     &    d0cccmztsuswwww - 4.D0/(u + t)*t*c0cmzuswww + 4.D0/(u + t)*t*
     &    c0cmztswww - 4.D0/(u + t)*t*c0ccuswww + 4.D0/(u + t)*t*
     &    c0cctswww - 4.D0/(u + t)*t**2*d0cccmztsuswwww )
      ewamp(1,2,1,3) = ewamp(1,2,1,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * ( 2.D0*s**(-2)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww
     &     - 2.D0*s**(-2)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*b0fusww - 
     &    12.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*b0fmzww + 12.D0*s**(-2)
     &    *t**(-1)*u**(-1)*rzm2**2*b0fusww + 2.D0*s**(-2)*t**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*s**(-2)*t**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fusww - 12.D0*s**(-2)*t**(-1)*rzm2*b0fmzww + 12.D0*
     &    s**(-2)*t**(-1)*rzm2*b0fusww - 4.D0*s**(-1)*t**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 4.D0*s**(-1)*t**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fusww + 24.D0*s**(-1)*t**(-2)*u**(-1)*
     &    rzm2**2*b0fmzww - 24.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**2*
     &    b0fusww - 4.D0*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**2*b0fmzww + 4.
     &    D0*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**2*b0fusww + 24.D0*s**(-1)
     &    *t**(-2)*rzm2*b0fmzww - 24.D0*s**(-1)*t**(-2)*rzm2*b0fusww - 
     &    2.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**2 + 2.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*b0fusww + 12.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2 - 12.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rzm2*b0fmzww + 12.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*b0fusww + 4.
     &    D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2*c0cmzuswww - 24.D0*s**(-1)
     &    *t**(-1)*u**(-1)*rwm2*rzm2*c0cmzuswww - 2.D0*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2 + 12.D0*s**(-1)*t**(-1) + 4.D0*s**(-1)*
     &    t**(-1)*rzm2*c0cmzuswww + 4.D0*s**(-1)*t**(-1)*rzm2*
     &    c0cmztswww - 4.D0*s**(-1)*t**(-1)*rzm2*c0ccuswww - 24.D0*
     &    s**(-1)*t**(-1)*rwm2*c0cmzuswww - 24.D0*s**(-1)*t**(-1)*rwm2*
     &    c0cmztswww + 24.D0*s**(-1)*t**(-1)*rwm2*c0ccuswww + 2.D0/3.D0
     &    *s**(-1)*rwm2**(-1)*rzm2*c0cmztswww - 2.D0/3.D0*s**(-1)*
     &    rwm2**(-1)*rzm2*c0ccuswww - 4.D0*s**(-1)*c0cmztswww + 4.D0*
     &    s**(-1)*c0ccuswww - 2.D0*s**(-1)*rzm2*d0cccmztsuswwww + 12.D0
     &    *s**(-1)*rwm2*d0cccmztsuswwww + 2.D0/3.D0*s**(-1)*t*
     &    rwm2**(-1)*c0cmzuswww - 2.D0/3.D0*s**(-1)*t*rwm2**(-1)*
     &    c0cmztswww + 2.D0/3.D0*s**(-1)*t*rwm2**(-1)*c0ccuswww - 2.D0/
     &    3.D0*s**(-1)*t*rwm2**(-1)*c0cctswww - 2.D0/3.D0*s**(-1)*t*
     &    rwm2**(-1)*rzm2*d0cccmztsuswwww + 4.D0*s**(-1)*t*
     &    d0cccmztsuswwww + 2.D0/3.D0*s**(-1)*t**2*rwm2**(-1)*
     &    d0cccmztsuswwww + 4.D0*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww - 4.D0*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**2*b0fusww - 
     &    24.D0*t**(-2)*u**(-1)*rzm2*b0fmzww + 24.D0*t**(-2)*u**(-1)*
     &    rzm2*b0fusww + 2.D0*t**(-2)*rwm2**(-1)*rzm2**2*c0cmzuswww - 2.
     &    D0*t**(-2)*rwm2**(-1)*rzm2**2*c0ccqswww - 12.D0*t**(-2)*rzm2*
     &    c0cmzuswww + 12.D0*t**(-2)*rzm2*c0ccqswww - 2.D0*t**(-2)*u*
     &    rwm2**(-1)*rzm2*c0cmzuswww + 2.D0*t**(-2)*u*rwm2**(-1)*rzm2*
     &    c0cmzqswww - 2.D0*t**(-2)*u*rwm2**(-1)*rzm2*c0ccuswww + 2.D0*
     &    t**(-2)*u*rwm2**(-1)*rzm2*c0ccqswww - 2.D0*t**(-2)*u*
     &    rwm2**(-1)*rzm2**2*d0ccmzcqsuswwww + 12.D0*t**(-2)*u*
     &    c0cmzuswww - 12.D0*t**(-2)*u*c0cmzqswww + 12.D0*t**(-2)*u*
     &    c0ccuswww - 12.D0*t**(-2)*u*c0ccqswww + 12.D0*t**(-2)*u*rzm2*
     &    d0ccmzcqsuswwww + 2.D0*t**(-2)*u**2*rwm2**(-1)*rzm2*
     &    d0ccmzcqsuswwww - 12.D0*t**(-2)*u**2*d0ccmzcqsuswwww + 2.D0*
     &    t**(-1)*u**(-1)*rwm2**(-1)*rzm2 - 12.D0*t**(-1)*u**(-1) - 4.D0
     &    *t**(-1)*u**(-1)*rzm2*c0cmzuswww + 4.D0*t**(-1)*u**(-1)*rzm2*
     &    c0cmztswww - 4.D0*t**(-1)*u**(-1)*rzm2*c0ccqswww + 24.D0*
     &    t**(-1)*u**(-1)*rwm2*c0cmzuswww - 24.D0*t**(-1)*u**(-1)*rwm2*
     &    c0cmztswww + 24.D0*t**(-1)*u**(-1)*rwm2*c0ccqswww + 2.D0*
     &    t**(-1)*rwm2**(-1)*rzm2*c0cmzqswww + 2.D0*t**(-1)*rwm2**(-1)*
     &    rzm2*c0ccqswww - 32.D0*t**(-1)*c0cmzuswww + 20.D0*t**(-1)*
     &    c0cmzqswww - 32.D0*t**(-1)*c0ccuswww + 20.D0*t**(-1)*
     &    c0ccqswww - 38.D0*t**(-1)*rzm2*d0ccmzcqsuswwww + 36.D0*
     &    t**(-1)*rwm2*d0ccmzcqsuswwww + 2.D0*t**(-1)*u*rwm2**(-1)*rzm2
     &    *d0ccmzcqsuswwww + 20.D0*t**(-1)*u*d0ccmzcqsuswwww - 2.D0*
     &    u**(-1)*rzm2*d0cccmzqstswwww + 12.D0*u**(-1)*rwm2*
     &    d0cccmzqstswwww - 4.D0/(u + t)*s**(-2)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0/(u + t)*s**(-2)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fusww + 24.D0/(u + t)*s**(-2)*t**(-1)*rzm2**2*
     &    b0fmzww - 24.D0/(u + t)*s**(-2)*t**(-1)*rzm2**2*b0fusww + 8.D0
     &    /(u + t)*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**3*b0fmzww - 8.D0/(u
     &     + t)*s**(-1)*t**(-2)*rwm2**(-1)*rzm2**3*b0fusww - 48.D0/(u
     &     + t)*s**(-1)*t**(-2)*rzm2**2*b0fmzww + 48.D0/(u + t)*s**(-1)
     &    *t**(-2)*rzm2**2*b0fusww + 4.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**2 - 24.D0/(u + t)*s**(-1)*t**(-1)*rzm2 - 8.D0
     &    /(u + t)*s**(-1)*t**(-1)*rzm2**2*c0cmzuswww - 4.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**2*c0cmztswww + 4.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**2*c0ccuswww + 48.D0/(u + t)*s**(-1)*t**(-1)*
     &    rwm2*rzm2*c0cmzuswww + 24.D0/(u + t)*s**(-1)*t**(-1)*rwm2*
     &    rzm2*c0cmztswww - 24.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2*
     &    c0ccuswww - 2.D0/3.D0/(u + t)*s**(-1)*rwm2**(-1)*rzm2**2*
     &    c0cmztswww + 2.D0/3.D0/(u + t)*s**(-1)*rwm2**(-1)*rzm2**2*
     &    c0ccuswww - 4.D0/(u + t)*s**(-1)*rzm2*c0cmzuswww + 8.D0/(u + 
     &    t)*s**(-1)*rzm2*c0cmztswww - 8.D0/(u + t)*s**(-1)*rzm2*
     &    c0ccuswww + 4.D0/(u + t)*s**(-1)*rzm2*c0cctswww + 4.D0/(u + t
     &    )*s**(-1)*rzm2**2*d0cccmztsuswwww + 24.D0/(u + t)*s**(-1)*
     &    rwm2*c0cmzuswww - 24.D0/(u + t)*s**(-1)*rwm2*c0cmztswww + 24.D
     &    0/(u + t)*s**(-1)*rwm2*c0ccuswww - 24.D0/(u + t)*s**(-1)*rwm2
     &    *c0cctswww - 24.D0/(u + t)*s**(-1)*rwm2*rzm2*d0cccmztsuswwww
     &     - 2.D0/3.D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2*c0cmzuswww + 2.
     &    D0/3.D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2*c0cmztswww - 2.D0/3.
     &    D0/(u + t)*s**(-1)*t*rwm2**(-1)*rzm2*c0ccuswww + 2.D0/3.D0/(u
     &     + t)*s**(-1)*t*rwm2**(-1)*rzm2*c0cctswww + 2.D0/3.D0/(u + t)
     &    *s**(-1)*t*rwm2**(-1)*rzm2**2*d0cccmztsuswwww + 4.D0/(u + t)*
     &    s**(-1)*t*c0cmzuswww - 4.D0/(u + t)*s**(-1)*t*c0cmztswww + 4.D
     &    0/(u + t)*s**(-1)*t*c0ccuswww - 4.D0/(u + t)*s**(-1)*t*
     &    c0cctswww - 8.D0/(u + t)*s**(-1)*t*rzm2*d0cccmztsuswwww + 24.D
     &    0/(u + t)*s**(-1)*t*rwm2*d0cccmztsuswwww - 2.D0/3.D0/(u + t)*
     &    s**(-1)*t**2*rwm2**(-1)*rzm2*d0cccmztsuswwww + 4.D0/(u + t)*
     &    s**(-1)*t**2*d0cccmztsuswwww - 8.D0/(u + t)*t**(-2)*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 8.D0/(u + t)*t**(-2)*rwm2**(-1)*
     &    rzm2**2*b0fusww + 48.D0/(u + t)*t**(-2)*rzm2*b0fmzww - 48.D0
     &    /(u + t)*t**(-2)*rzm2*b0fusww - 4.D0/(u + t)*t**(-1)*
     &    rwm2**(-1)*rzm2 - 4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2*
     &    b0fusww + 4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2*b0fqsww + 24.D0
     &    /(u + t)*t**(-1) + 24.D0/(u + t)*t**(-1)*b0fusww - 24.D0/(u
     &     + t)*t**(-1)*b0fqsww + 44.D0/(u + t)*t**(-1)*rzm2*c0cmzuswww
     &     - 4.D0/(u + t)*t**(-1)*rzm2*c0ccuswww - 32.D0/(u + t)*
     &    t**(-1)*rzm2*c0ccqswww - 72.D0/(u + t)*t**(-1)*rwm2*
     &    c0cmzuswww + 24.D0/(u + t)*t**(-1)*rwm2*c0ccuswww + 2.D0/3.D0
     &    /(u + t)*rwm2**(-1)*rzm2*c0cmztswww - 2.D0/3.D0/(u + t)*
     &    rwm2**(-1)*rzm2*c0ccuswww + 32.D0/(u + t)*c0cmzuswww - 4.D0/(
     &    u + t)*c0cmztswww + 36.D0/(u + t)*c0ccuswww - 4.D0/(u + t)*
     &    rzm2*d0cccmztsuswwww + 32.D0/(u + t)*rzm2*d0ccmzcqsuswwww - 
     &    40.D0/(u + t)*rwm2*d0cccmztsuswwww - 64.D0/(u + t)*rwm2*
     &    d0ccmzcqsuswwww - 64.D0/(u + t)*rwm2*d0cccmzqstswwww + 2.D0/3.
     &    D0/(u + t)*t*rwm2**(-1)*c0cmzuswww - 2.D0/3.D0/(u + t)*t*
     &    rwm2**(-1)*c0cmztswww + 2.D0/3.D0/(u + t)*t*rwm2**(-1)*
     &    c0ccuswww - 2.D0/3.D0/(u + t)*t*rwm2**(-1)*c0cctswww - 2.D0/3.
     &    D0/(u + t)*t*rwm2**(-1)*rzm2*d0cccmztsuswwww + 20.D0/(u + t)*
     &    t*d0cccmztsuswwww + 16.D0/(u + t)*t*d0ccmzcqsuswwww + 16.D0/(
     &    u + t)*t*d0cccmzqstswwww + 2.D0/3.D0/(u + t)*t**2*rwm2**(-1)*
     &    d0cccmztsuswwww + 4.D0/(u + t)/(t + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 4.D0/(u + t)/(t + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**3*b0fusww - 24.D0/(u + t)/(t + s)*s**(-2)*rzm2**2*
     &    b0fmzww + 24.D0/(u + t)/(t + s)*s**(-2)*rzm2**2*b0fusww - 4.D0
     &    /(u + t)/(t + s)*s**(-1)*rwm2**(-1)*rzm2**2 + 24.D0/(u + t)/(
     &    t + s)*s**(-1)*rzm2 + 8.D0/(u + t)/(t + s)*s**(-1)*rzm2**2*
     &    c0cmzuswww - 48.D0/(u + t)/(t + s)*s**(-1)*rwm2*rzm2*
     &    c0cmzuswww - 4.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 4.D0/(u + t)/(t + s)/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fusww + 24.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-1)*rzm2**2*b0fmzww - 24.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-1)*rzm2**2*b0fusww - 2.D0/(t + s)*s**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fmzww + 2.D0/(t + s)*s**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fusww + 12.D0/(t + s)*s**(-2)*u**(-1)*
     &    rzm2**2*b0fmzww - 12.D0/(t + s)*s**(-2)*u**(-1)*rzm2**2*
     &    b0fusww - 2.D0/(t + s)*s**(-2)*rwm2**(-1)*rzm2**2*b0fmzww + 2.
     &    D0/(t + s)*s**(-2)*rwm2**(-1)*rzm2**2*b0fusww + 12.D0/(t + s)
     &    *s**(-2)*rzm2*b0fmzww - 12.D0/(t + s)*s**(-2)*rzm2*b0fusww + 
     &    2.D0/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**2 - 2.D0/(t + s
     &    )*s**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(t + s)*
     &    s**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*b0fusww - 12.D0/(t + s)*
     &    s**(-1)*u**(-1)*rzm2 + 12.D0/(t + s)*s**(-1)*u**(-1)*rzm2*
     &    b0fmzww - 12.D0/(t + s)*s**(-1)*u**(-1)*rzm2*b0fusww - 4.D0/(
     &    t + s)*s**(-1)*u**(-1)*rzm2**2*c0cmzuswww + 24.D0/(t + s)*
     &    s**(-1)*u**(-1)*rwm2*rzm2*c0cmzuswww + 2.D0/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2 - 12.D0/(t + s)*s**(-1) - 4.D0/(t + s)*
     &    s**(-1)*rzm2*c0cmzuswww + 24.D0/(t + s)*s**(-1)*rwm2*
     &    c0cmzuswww + 2.D0/(t + s)/(t + s)*s**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 2.D0/(t + s)/(t + s)*s**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fusww - 12.D0/(t + s)/(t + s)*s**(-1)*
     &    u**(-1)*rzm2**2*b0fmzww + 12.D0/(t + s)/(t + s)*s**(-1)*
     &    u**(-1)*rzm2**2*b0fusww + 2.D0/(t + s)/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(t + s)/(t + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fusww - 12.D0/(t + s)/(t + s)*s**(-1)*
     &    rzm2*b0fmzww + 12.D0/(t + s)/(t + s)*s**(-1)*rzm2*b0fusww )

      ewamp(1,2,2,1) =
     &  + 12.D0 - 4.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fmzww + 4.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*
     &    b0ftsww + 24.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0fmzww - 24.D
     &    0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0ftsww + 4.D0*s**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 4.D0*s**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 24.D0*s**(-1)*u**(-1)*rzm2**2*
     &    b0fmzww + 24.D0*s**(-1)*u**(-1)*rzm2**2*b0ftsww + 2.D0*
     &    s**(-1)*rzm2**2*c0cmztswww - 2.D0*s**(-1)*rzm2**2*c0ccuswww
     &     - 12.D0*s**(-1)*rwm2*rzm2*c0cmztswww + 12.D0*s**(-1)*rwm2*
     &    rzm2*c0ccuswww + 2.D0*s**(-1)*t*rzm2*c0cmzuswww - 2.D0*
     &    s**(-1)*t*rzm2*c0cmztswww + 2.D0*s**(-1)*t*rzm2*c0ccuswww - 2.
     &    D0*s**(-1)*t*rzm2*c0cctswww - 2.D0*s**(-1)*t*rzm2**2*
     &    d0cccmztsuswwww - 12.D0*s**(-1)*t*rwm2*c0cmzuswww + 12.D0*
     &    s**(-1)*t*rwm2*c0cmztswww - 12.D0*s**(-1)*t*rwm2*c0ccuswww + 
     &    12.D0*s**(-1)*t*rwm2*c0cctswww + 12.D0*s**(-1)*t*rwm2*rzm2*
     &    d0cccmztsuswwww + 2.D0*s**(-1)*t**2*rzm2*d0cccmztsuswwww - 12.
     &    D0*s**(-1)*t**2*rwm2*d0cccmztsuswwww + 4.D0*t**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 4.D0*t**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2**3*b0ftsww - 24.D0*t**(-1)*u**(-1)*rzm2**2*b0fmzww + 24.D
     &    0*t**(-1)*u**(-1)*rzm2**2*b0ftsww - 4.D0*u**(-1)*rwm2**(-1)*
     &    rzm2**2*b0fmzww + 4.D0*u**(-1)*rwm2**(-1)*rzm2**2*b0fqsww + 
     &    24.D0*u**(-1)*rzm2*b0fmzww - 24.D0*u**(-1)*rzm2*b0fqsww + 4.D0
     &    *u**(-1)*rzm2**2*c0cmztswww - 4.D0*u**(-1)*rzm2**2*c0ccqswww
     &     - 24.D0*u**(-1)*rwm2*rzm2*c0cmztswww + 24.D0*u**(-1)*rwm2*
     &    rzm2*c0ccqswww - 2.D0*rwm2**(-1)*rzm2 + 2.D0*rwm2**(-1)*rzm2*
     &    b0ftsww - 2.D0*rwm2**(-1)*rzm2*b0fqsww - 12.D0*b0ftsww + 12.D0
     &    *b0fqsww + 16.D0*rzm2*c0cmztswww - 12.D0*rzm2*c0cmzqswww - 28.
     &    D0*rzm2*c0ccqswww - 24.D0*rwm2*c0cmzqswww - 24.D0*rwm2*
     &    c0ccqswww + 28.D0*rwm2*rzm2*d0cccmztsuswwww + 28.D0*rwm2*rzm2
     &    *d0ccmzcqsuswwww + 28.D0*rwm2*rzm2*d0cccmzqstswwww + 24.D0*
     &    rwm2**2*d0cccmztsuswwww + 24.D0*rwm2**2*d0ccmzcqsuswwww + 24.D
     &    0*rwm2**2*d0cccmzqstswwww + 16.D0*u*c0cmzqswww + 16.D0*u*
     &    c0ccqswww - 8.D0*u*rzm2*d0cccmztsuswwww - 8.D0*u*rzm2*
     &    d0ccmzcqsuswwww - 8.D0*u*rzm2*d0cccmzqstswwww - 32.D0*u*rwm2*
     &    d0cccmztsuswwww - 32.D0*u*rwm2*d0ccmzcqsuswwww - 32.D0*u*rwm2
     &    *d0cccmzqstswwww + 8.D0*u**2*d0cccmztsuswwww + 8.D0*u**2*
     &    d0ccmzcqsuswwww + 8.D0*u**2*d0cccmzqstswwww + 2.D0*t*u**(-2)*
     &    rwm2**(-1)*rzm2**3*c0cmztswww - 2.D0*t*u**(-2)*rwm2**(-1)*
     &    rzm2**3*c0ccqswww - 12.D0*t*u**(-2)*rzm2**2*c0cmztswww + 12.D0
     &    *t*u**(-2)*rzm2**2*c0ccqswww + 4.D0*t*u**(-1)*rwm2**(-1)*rzm2
     &    *b0ftsww - 4.D0*t*u**(-1)*rwm2**(-1)*rzm2*b0fqsww - 2.D0*t*
     &    u**(-1)*rwm2**(-1)*rzm2**2*c0cmztswww + 2.D0*t*u**(-1)*
     &    rwm2**(-1)*rzm2**2*c0cmzqswww + 4.D0*t*u**(-1)*rwm2**(-1)*
     &    rzm2**2*c0ccqswww - 24.D0*t*u**(-1)*b0ftsww + 24.D0*t*u**(-1)
     &    *b0fqsww + 8.D0*t*u**(-1)*rzm2*c0cmztswww - 8.D0*t*u**(-1)*
     &    rzm2*c0cmzqswww - 4.D0*t*u**(-1)*rzm2*c0cctswww - 20.D0*t*
     &    u**(-1)*rzm2*c0ccqswww - 8.D0*t*u**(-1)*rzm2**2*
     &    d0cccmzqstswwww + 24.D0*t*u**(-1)*rwm2*c0cmztswww - 24.D0*t*
     &    u**(-1)*rwm2*c0cmzqswww + 24.D0*t*u**(-1)*rwm2*c0cctswww - 24.
     &    D0*t*u**(-1)*rwm2*c0ccqswww + 48.D0*t*u**(-1)*rwm2*rzm2*
     &    d0cccmzqstswwww - 2.D0*t*rwm2**(-1)*rzm2*c0cmzqswww - 2.D0*t*
     &    rwm2**(-1)*rzm2*c0ccqswww - 16.D0*t*c0cmztswww + 28.D0*t*
     &    c0cmzqswww - 16.D0*t*c0cctswww + 28.D0*t*c0ccqswww + 8.D0*t*
     &    rzm2*d0cccmztsuswwww + 8.D0*t*rzm2*d0ccmzcqsuswwww - 16.D0*t*
     &    rzm2*d0cccmzqstswwww - 48.D0*t*rwm2*d0cccmzqstswwww + 16.D0*t
     &    *u*d0cccmzqstswwww - 4.D0*t**2*u**(-2)*rwm2**(-1)*rzm2**2*
     &    c0cmztswww + 2.D0*t**2*u**(-2)*rwm2**(-1)*rzm2**2*c0cmzqswww
     &     - 2.D0*t**2*u**(-2)*rwm2**(-1)*rzm2**2*c0cctswww + 4.D0*t**2
     &    *u**(-2)*rwm2**(-1)*rzm2**2*c0ccqswww - 2.D0*t**2*u**(-2)*
     &    rwm2**(-1)*rzm2**3*d0cccmzqstswwww + 24.D0*t**2*u**(-2)*rzm2*
     &    c0cmztswww - 12.D0*t**2*u**(-2)*rzm2*c0cmzqswww + 12.D0*t**2*
     &    u**(-2)*rzm2*c0cctswww - 24.D0*t**2*u**(-2)*rzm2*c0ccqswww + 
     &    12.D0*t**2*u**(-2)*rzm2**2*d0cccmzqstswwww + 2.D0*t**2*
     &    u**(-1)*rwm2**(-1)*rzm2*c0cmztswww - 4.D0*t**2*u**(-1)*
     &    rwm2**(-1)*rzm2*c0cmzqswww + 2.D0*t**2*u**(-1)*rwm2**(-1)*
     &    rzm2*c0cctswww - 4.D0*t**2*u**(-1)*rwm2**(-1)*rzm2*c0ccqswww
     &     + 4.D0*t**2*u**(-1)*rwm2**(-1)*rzm2**2*d0cccmzqstswwww - 12.D
     &    0*t**2*u**(-1)*c0cmztswww + 24.D0*t**2*u**(-1)*c0cmzqswww - 
     &    12.D0*t**2*u**(-1)*c0cctswww + 24.D0*t**2*u**(-1)*c0ccqswww
     &     - 16.D0*t**2*u**(-1)*rzm2*d0cccmzqstswwww - 48.D0*t**2*
     &    u**(-1)*rwm2*d0cccmzqstswwww - 2.D0*t**2*rwm2**(-1)*rzm2*
     &    d0cccmzqstswwww + 28.D0*t**2*d0cccmzqstswwww + 2.D0*t**3*
     &    u**(-2)*rwm2**(-1)*rzm2*c0cmztswww - 2.D0*t**3*u**(-2)*
     &    rwm2**(-1)*rzm2*c0cmzqswww + 2.D0*t**3*u**(-2)*rwm2**(-1)*
     &    rzm2*c0cctswww - 2.D0*t**3*u**(-2)*rwm2**(-1)*rzm2*c0ccqswww
     &     + 4.D0*t**3*u**(-2)*rwm2**(-1)*rzm2**2*d0cccmzqstswwww - 12.D
     &    0*t**3*u**(-2)*c0cmztswww + 12.D0*t**3*u**(-2)*c0cmzqswww - 
     &    12.D0*t**3*u**(-2)*c0cctswww + 12.D0*t**3*u**(-2)*c0ccqswww
     &     - 24.D0*t**3*u**(-2)*rzm2*d0cccmzqstswwww - 4.D0*t**3*
     &    u**(-1)*rwm2**(-1)*rzm2*d0cccmzqstswwww + 24.D0*t**3*u**(-1)*
     &    d0cccmzqstswwww - 2.D0*t**4*u**(-2)*rwm2**(-1)*rzm2*
     &    d0cccmzqstswwww + 12.D0*t**4*u**(-2)*d0cccmzqstswwww - 4.D0/(
     &    u + t)*t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(u + t)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 24.D0/(u + t)*t**(-1)*
     &    rzm2**2*b0fmzww - 24.D0/(u + t)*t**(-1)*rzm2**2*b0ftsww + 2.D0
     &    /(u + t)*rwm2**(-1)*rzm2**2 + 2.D0/(u + t)*rwm2**(-1)*rzm2**2
     &    *b0ftsww - 2.D0/(u + t)*rwm2**(-1)*rzm2**2*b0fqsww - 12.D0/(u
     &     + t)*rzm2 - 12.D0/(u + t)*rzm2*b0ftsww + 12.D0/(u + t)*rzm2*
     &    b0fqsww + 2.D0/(u + t)*rzm2**2*c0cmzuswww - 22.D0/(u + t)*
     &    rzm2**2*c0cmztswww + 16.D0/(u + t)*rzm2**2*c0ccqswww - 12.D0
     &    /(u + t)*rwm2*rzm2*c0cmzuswww + 36.D0/(u + t)*rwm2*rzm2*
     &    c0cmztswww + 2.D0/(u + t)*t*rzm2*c0cmzuswww + 14.D0/(u + t)*t
     &    *rzm2*c0cmztswww + 2.D0/(u + t)*t*rzm2*c0ccuswww + 14.D0/(u
     &     + t)*t*rzm2*c0cctswww + 16.D0/(u + t)*t*rzm2**2*
     &    d0cccmzqstswwww - 12.D0/(u + t)*t*rwm2*c0cmzuswww + 12.D0/(u
     &     + t)*t*rwm2*c0cmztswww - 12.D0/(u + t)*t*rwm2*c0ccuswww + 12.
     &    D0/(u + t)*t*rwm2*c0cctswww - 32.D0/(u + t)*t*rwm2*rzm2*
     &    d0cccmztsuswwww - 32.D0/(u + t)*t*rwm2*rzm2*d0ccmzcqsuswwww
     &     - 32.D0/(u + t)*t*rwm2*rzm2*d0cccmzqstswwww - 6.D0/(u + t)*
     &    t**2*rzm2*d0cccmztsuswwww - 8.D0/(u + t)*t**2*rzm2*
     &    d0ccmzcqsuswwww - 8.D0/(u + t)*t**2*rzm2*d0cccmzqstswwww - 12.
     &    D0/(u + t)*t**2*rwm2*d0cccmztsuswwww + 4.D0/(u + t)/(u + s)*
     &    t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww - 4.D0/(u + t)/(u + s)*
     &    t**(-1)*rwm2**(-1)*rzm2**4*b0ftsww - 24.D0/(u + t)/(u + s)*
     &    t**(-1)*rzm2**3*b0fmzww + 24.D0/(u + t)/(u + s)*t**(-1)*
     &    rzm2**3*b0ftsww - 2.D0/(u + t)/(u + s)*rwm2**(-1)*rzm2**3 + 
     &    12.D0/(u + t)/(u + s)*rzm2**2 + 4.D0/(u + t)/(u + s)*rzm2**3*
     &    c0cmztswww - 24.D0/(u + t)/(u + s)*rwm2*rzm2**2*c0cmztswww - 
     &    2.D0/(u + t)/(u + s)/(u + s)*rwm2**(-1)*rzm2**4*b0fmzww + 2.D0
     &    /(u + t)/(u + s)/(u + s)*rwm2**(-1)*rzm2**4*b0ftsww + 12.D0/(
     &    u + t)/(u + s)/(u + s)*rzm2**3*b0fmzww - 12.D0/(u + t)/(u + s
     &    )/(u + s)*rzm2**3*b0ftsww + 4.D0/(u + s)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**4*b0fmzww - 4.D0/(u + s)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**4*b0ftsww - 24.D0/(u + s)*s**(-1)*t**(-1)*
     &    rzm2**3*b0fmzww + 24.D0/(u + s)*s**(-1)*t**(-1)*rzm2**3*
     &    b0ftsww - 4.D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.
     &    D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 24.D0/(u + s)
     &    *s**(-1)*rzm2**2*b0fmzww - 24.D0/(u + s)*s**(-1)*rzm2**2*
     &    b0ftsww + 2.D0/(u + s)*rwm2**(-1)*rzm2**2 - 12.D0/(u + s)*
     &    rzm2 - 4.D0/(u + s)*rzm2**2*c0cmztswww + 24.D0/(u + s)*rwm2*
     &    rzm2*c0cmztswww + 2.D0/(u + s)/(u + s)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 2.D0/(u + s)/(u + s)*rwm2**(-1)*rzm2**3*b0ftsww - 
     &    12.D0/(u + s)/(u + s)*rzm2**2*b0fmzww + 12.D0/(u + s)/(u + s)
     &    *rzm2**2*b0ftsww

      ewamp(1,2,2,2) =
     &  - 12.D0 + 4.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*
     &    b0fmzww - 4.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**4*
     &    b0ftsww - 24.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0fmzww + 24.D
     &    0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0ftsww - 6.D0*s**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 6.D0*s**(-1)*u**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww + 36.D0*s**(-1)*u**(-1)*rzm2**2*
     &    b0fmzww - 36.D0*s**(-1)*u**(-1)*rzm2**2*b0ftsww + 2.D0*
     &    s**(-1)*t*u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*s**(-1)*t
     &    *u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 12.D0*s**(-1)*t*u**(-1)
     &    *rzm2*b0fmzww + 12.D0*s**(-1)*t*u**(-1)*rzm2*b0ftsww - 4.D0*
     &    t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 24.D0*t**(-1)*u**(-1)*
     &    rzm2**2*b0fmzww - 24.D0*t**(-1)*u**(-1)*rzm2**2*b0ftsww + 2.D0
     &    *t**(-1)*rzm2**2*c0cmzuswww - 2.D0*t**(-1)*rzm2**2*c0ccqswww
     &     - 12.D0*t**(-1)*rwm2*rzm2*c0cmzuswww + 12.D0*t**(-1)*rwm2*
     &    rzm2*c0ccqswww - 2.D0*t**(-1)*u*rzm2*c0cmzuswww + 2.D0*
     &    t**(-1)*u*rzm2*c0cmzqswww - 2.D0*t**(-1)*u*rzm2*c0ccuswww + 2.
     &    D0*t**(-1)*u*rzm2*c0ccqswww - 2.D0*t**(-1)*u*rzm2**2*
     &    d0ccmzcqsuswwww + 12.D0*t**(-1)*u*rwm2*c0cmzuswww - 12.D0*
     &    t**(-1)*u*rwm2*c0cmzqswww + 12.D0*t**(-1)*u*rwm2*c0ccuswww - 
     &    12.D0*t**(-1)*u*rwm2*c0ccqswww + 12.D0*t**(-1)*u*rwm2*rzm2*
     &    d0ccmzcqsuswwww + 2.D0*t**(-1)*u**2*rzm2*d0ccmzcqsuswwww - 12.
     &    D0*t**(-1)*u**2*rwm2*d0ccmzcqsuswwww + 2.D0*u**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0ftsww - 12.D0*u**(-1)*rzm2*b0fmzww + 12.D0*u**(-1)*rzm2*
     &    b0ftsww - 14.D0*u**(-1)*rzm2**2*c0cmztswww + 14.D0*u**(-1)*
     &    rzm2**2*c0ccqswww - 12.D0*u**(-1)*rwm2*rzm2*c0cmztswww + 12.D0
     &    *u**(-1)*rwm2*rzm2*c0ccqswww + 2.D0*rwm2**(-1)*rzm2 + 2.D0*
     &    rzm2*c0cmzuswww - 4.D0*rzm2*c0cmztswww - 2.D0*rzm2*c0ccuswww
     &     + 4.D0*rzm2*c0ccqswww - 12.D0*rwm2*c0cmzuswww + 24.D0*rwm2*
     &    c0cmztswww + 12.D0*rwm2*c0ccuswww - 24.D0*rwm2*c0ccqswww - 4.D
     &    0*rwm2*rzm2*d0cccmztsuswwww - 4.D0*rwm2*rzm2*d0ccmzcqsuswwww
     &     - 4.D0*rwm2*rzm2*d0cccmzqstswwww + 24.D0*rwm2**2*
     &    d0cccmztsuswwww + 24.D0*rwm2**2*d0ccmzcqsuswwww + 24.D0*
     &    rwm2**2*d0cccmzqstswwww + 2.D0*u*rzm2*d0ccmzcqsuswwww - 12.D0
     &    *u*rwm2*d0ccmzcqsuswwww + 14.D0*t*u**(-1)*rzm2*c0cmztswww - 
     &    14.D0*t*u**(-1)*rzm2*c0cmzqswww + 14.D0*t*u**(-1)*rzm2*
     &    c0cctswww - 14.D0*t*u**(-1)*rzm2*c0ccqswww + 14.D0*t*u**(-1)*
     &    rzm2**2*d0cccmzqstswwww + 12.D0*t*u**(-1)*rwm2*c0cmztswww - 
     &    12.D0*t*u**(-1)*rwm2*c0cmzqswww + 12.D0*t*u**(-1)*rwm2*
     &    c0cctswww - 12.D0*t*u**(-1)*rwm2*c0ccqswww + 12.D0*t*u**(-1)*
     &    rwm2*rzm2*d0cccmzqstswwww - 6.D0*t*rzm2*d0cccmztsuswwww - 8.D0
     &    *t*rzm2*d0ccmzcqsuswwww - 6.D0*t*rzm2*d0cccmzqstswwww - 12.D0
     &    *t*rwm2*d0cccmztsuswwww - 12.D0*t*rwm2*d0cccmzqstswwww - 14.D0
     &    *t**2*u**(-1)*rzm2*d0cccmzqstswwww - 12.D0*t**2*u**(-1)*rwm2*
     &    d0cccmzqstswwww + 4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2**3*b0ftsww - 
     &    24.D0/(u + t)*t**(-1)*rzm2**2*b0fmzww + 24.D0/(u + t)*t**(-1)
     &    *rzm2**2*b0ftsww - 2.D0/(u + t)*rwm2**(-1)*rzm2**2 + 2.D0/(u
     &     + t)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u + t)*rwm2**(-1)*
     &    rzm2**2*b0ftsww + 12.D0/(u + t)*rzm2 - 12.D0/(u + t)*rzm2*
     &    b0fmzww + 12.D0/(u + t)*rzm2*b0ftsww - 2.D0/(u + t)*rzm2**2*
     &    c0cmzuswww + 22.D0/(u + t)*rzm2**2*c0cmztswww - 16.D0/(u + t)
     &    *rzm2**2*c0ccqswww + 12.D0/(u + t)*rwm2*rzm2*c0cmzuswww - 36.D
     &    0/(u + t)*rwm2*rzm2*c0cmztswww - 2.D0/(u + t)*t*rzm2*
     &    c0cmzuswww - 14.D0/(u + t)*t*rzm2*c0cmztswww - 2.D0/(u + t)*t
     &    *rzm2*c0ccuswww - 14.D0/(u + t)*t*rzm2*c0cctswww - 16.D0/(u
     &     + t)*t*rzm2**2*d0cccmzqstswwww + 12.D0/(u + t)*t*rwm2*
     &    c0cmzuswww - 12.D0/(u + t)*t*rwm2*c0cmztswww + 12.D0/(u + t)*
     &    t*rwm2*c0ccuswww - 12.D0/(u + t)*t*rwm2*c0cctswww + 32.D0/(u
     &     + t)*t*rwm2*rzm2*d0cccmztsuswwww + 32.D0/(u + t)*t*rwm2*rzm2
     &    *d0ccmzcqsuswwww + 32.D0/(u + t)*t*rwm2*rzm2*d0cccmzqstswwww
     &     + 6.D0/(u + t)*t**2*rzm2*d0cccmztsuswwww + 8.D0/(u + t)*t**2
     &    *rzm2*d0ccmzcqsuswwww + 8.D0/(u + t)*t**2*rzm2*
     &    d0cccmzqstswwww + 12.D0/(u + t)*t**2*rwm2*d0cccmztsuswwww - 4.
     &    D0/(u + t)/(u + s)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D0
     &    /(u + t)/(u + s)*t**(-1)*rwm2**(-1)*rzm2**4*b0ftsww + 24.D0/(
     &    u + t)/(u + s)*t**(-1)*rzm2**3*b0fmzww - 24.D0/(u + t)/(u + s
     &    )*t**(-1)*rzm2**3*b0ftsww + 2.D0/(u + t)/(u + s)*rwm2**(-1)*
     &    rzm2**3 - 12.D0/(u + t)/(u + s)*rzm2**2 - 4.D0/(u + t)/(u + s
     &    )*rzm2**3*c0cmztswww + 24.D0/(u + t)/(u + s)*rwm2*rzm2**2*
     &    c0cmztswww + 2.D0/(u + t)/(u + s)/(u + s)*rwm2**(-1)*rzm2**4*
     &    b0fmzww - 2.D0/(u + t)/(u + s)/(u + s)*rwm2**(-1)*rzm2**4*
     &    b0ftsww - 12.D0/(u + t)/(u + s)/(u + s)*rzm2**3*b0fmzww + 12.D
     &    0/(u + t)/(u + s)/(u + s)*rzm2**3*b0ftsww - 4.D0/(u + s)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*b0fmzww + 4.D0/(u + s)*
     &    s**(-1)*t**(-1)*rwm2**(-1)*rzm2**4*b0ftsww + 24.D0/(u + s)*
     &    s**(-1)*t**(-1)*rzm2**3*b0fmzww - 24.D0/(u + s)*s**(-1)*
     &    t**(-1)*rzm2**3*b0ftsww + 6.D0/(u + s)*s**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww - 6.D0/(u + s)*s**(-1)*rwm2**(-1)*rzm2**3*
     &    b0ftsww - 36.D0/(u + s)*s**(-1)*rzm2**2*b0fmzww + 36.D0/(u + 
     &    s)*s**(-1)*rzm2**2*b0ftsww - 2.D0/(u + s)*s**(-1)*t*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)*s**(-1)*t*
     &    rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + s)*s**(-1)*t*rzm2*
     &    b0fmzww - 12.D0/(u + s)*s**(-1)*t*rzm2*b0ftsww - 2.D0/(u + s)
     &    *rwm2**(-1)*rzm2**2 + 2.D0/(u + s)*rwm2**(-1)*rzm2**2*b0fmzww
     &     - 2.D0/(u + s)*rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(u + s)*
     &    rzm2 - 12.D0/(u + s)*rzm2*b0fmzww + 12.D0/(u + s)*rzm2*
     &    b0ftsww + 4.D0/(u + s)*rzm2**2*c0cmztswww - 24.D0/(u + s)*
     &    rwm2*rzm2*c0cmztswww - 2.D0/(u + s)/(u + s)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 2.D0/(u + s)/(u + s)*rwm2**(-1)*rzm2**3*
     &    b0ftsww + 12.D0/(u + s)/(u + s)*rzm2**2*b0fmzww - 12.D0/(u + 
     &    s)/(u + s)*rzm2**2*b0ftsww

      ewamp(1,2,2,3) =
     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz**(-1) * ( 4.D0*s**(-1)*t*
     &    c0cmzuswww - 4.D0*s**(-1)*t*c0cmztswww + 4.D0*s**(-1)*t*
     &    c0ccuswww - 4.D0*s**(-1)*t*c0cctswww + 4.D0*s**(-1)*t**2*
     &    d0cccmztsuswwww + 4.D0/(u + t)*t*c0cmzuswww - 4.D0/(u + t)*t*
     &    c0cmztswww + 4.D0/(u + t)*t*c0ccuswww - 4.D0/(u + t)*t*
     &    c0cctswww + 4.D0/(u + t)*t**2*d0cccmztsuswwww )
      ewamp(1,2,2,3) = ewamp(1,2,2,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * (  - 2.D0*s**(-2)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0fmzww + 2.D0*s**(-2)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**3*
     &    b0ftsww + 12.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*b0fmzww - 12.D
     &    0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*b0ftsww + 2.D0*s**(-2)*
     &    u**(-1)*rwm2**(-1)*rzm2**2*b0fmzww - 2.D0*s**(-2)*u**(-1)*
     &    rwm2**(-1)*rzm2**2*b0ftsww - 12.D0*s**(-2)*u**(-1)*rzm2*
     &    b0fmzww + 12.D0*s**(-2)*u**(-1)*rzm2*b0ftsww - 8.D0*s**(-1)*
     &    t**(-2)*u**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 8.D0*s**(-1)*
     &    t**(-2)*u**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 48.D0*s**(-1)*
     &    t**(-2)*u**(-1)*rzm2**2*b0fmzww - 48.D0*s**(-1)*t**(-2)*
     &    u**(-1)*rzm2**2*b0ftsww - 4.D0*s**(-1)*t**(-2)*u**(-1)*
     &    rzm2**3*c0cmzuswww + 4.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**3*
     &    c0cctswww + 24.D0*s**(-1)*t**(-2)*u**(-1)*rwm2*rzm2**2*
     &    c0cmzuswww - 24.D0*s**(-1)*t**(-2)*u**(-1)*rwm2*rzm2**2*
     &    c0cctswww + 4.D0*s**(-1)*t**(-1)*u**(-2)*rwm2**(-1)*rzm2**3*
     &    b0fmzww - 4.D0*s**(-1)*t**(-1)*u**(-2)*rwm2**(-1)*rzm2**3*
     &    b0ftsww - 24.D0*s**(-1)*t**(-1)*u**(-2)*rzm2**2*b0fmzww + 24.D
     &    0*s**(-1)*t**(-1)*u**(-2)*rzm2**2*b0ftsww + 4.D0*s**(-1)*
     &    t**(-1)*u**(-2)*rzm2**3*c0cmzuswww - 4.D0*s**(-1)*t**(-1)*
     &    u**(-2)*rzm2**3*c0cctswww - 24.D0*s**(-1)*t**(-1)*u**(-2)*
     &    rwm2*rzm2**2*c0cmzuswww + 24.D0*s**(-1)*t**(-1)*u**(-2)*rwm2*
     &    rzm2**2*c0cctswww + 2.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*
     &    rzm2**2 + 2.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww - 2.D0*s**(-1)*t**(-1)*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0ftsww - 12.D0*s**(-1)*t**(-1)*u**(-1)*rzm2 - 12.D0*s**(-1)*
     &    t**(-1)*u**(-1)*rzm2*b0fmzww + 12.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rzm2*b0ftsww - 8.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2*
     &    c0cmzuswww - 4.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2*c0ccuswww
     &     + 8.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2*c0cctswww - 4.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2**3*d0cccmztsuswwww + 48.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rwm2*rzm2*c0cmzuswww + 24.D0*s**(-1)*
     &    t**(-1)*u**(-1)*rwm2*rzm2*c0ccuswww - 48.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rwm2*rzm2*c0cctswww + 24.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rwm2*rzm2**2*d0cccmztsuswwww - 4.D0*s**(-1)*u**(-2)*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 4.D0*s**(-1)*u**(-2)*rwm2**(-1)*
     &    rzm2**2*b0ftsww + 24.D0*s**(-1)*u**(-2)*rzm2*b0fmzww - 24.D0*
     &    s**(-1)*u**(-2)*rzm2*b0ftsww - 4.D0*s**(-1)*u**(-2)*rzm2**2*
     &    c0cmzuswww + 4.D0*s**(-1)*u**(-2)*rzm2**2*c0cctswww + 24.D0*
     &    s**(-1)*u**(-2)*rwm2*rzm2*c0cmzuswww - 24.D0*s**(-1)*u**(-2)*
     &    rwm2*rzm2*c0cctswww - 2.D0*s**(-1)*u**(-1)*rwm2**(-1)*rzm2 + 
     &    12.D0*s**(-1)*u**(-1) + 8.D0*s**(-1)*u**(-1)*rzm2*c0cmzuswww
     &     + 4.D0*s**(-1)*u**(-1)*rzm2*c0ccuswww - 8.D0*s**(-1)*u**(-1)
     &    *rzm2*c0cctswww + 4.D0*s**(-1)*u**(-1)*rzm2**2*
     &    d0cccmztsuswwww - 48.D0*s**(-1)*u**(-1)*rwm2*c0cmzuswww - 24.D
     &    0*s**(-1)*u**(-1)*rwm2*c0ccuswww + 48.D0*s**(-1)*u**(-1)*rwm2
     &    *c0cctswww - 24.D0*s**(-1)*u**(-1)*rwm2*rzm2*d0cccmztsuswwww
     &     - 2.D0/3.D0*s**(-1)*rwm2**(-1)*rzm2*c0cmztswww + 2.D0/3.D0*
     &    s**(-1)*rwm2**(-1)*rzm2*c0ccuswww + 4.D0*s**(-1)*c0cmztswww
     &     - 4.D0*s**(-1)*c0ccuswww - 6.D0*s**(-1)*rzm2*d0cccmztsuswwww
     &     + 36.D0*s**(-1)*rwm2*d0cccmztsuswwww - 2.D0/3.D0*s**(-1)*t*
     &    rwm2**(-1)*c0cmzuswww + 2.D0/3.D0*s**(-1)*t*rwm2**(-1)*
     &    c0cmztswww - 2.D0/3.D0*s**(-1)*t*rwm2**(-1)*c0ccuswww + 2.D0/
     &    3.D0*s**(-1)*t*rwm2**(-1)*c0cctswww + 2.D0/3.D0*s**(-1)*t*
     &    rwm2**(-1)*rzm2*d0cccmztsuswwww - 4.D0*s**(-1)*t*
     &    d0cccmztsuswwww - 2.D0/3.D0*s**(-1)*t**2*rwm2**(-1)*
     &    d0cccmztsuswwww + 8.D0*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**2*
     &    b0fmzww - 8.D0*t**(-2)*u**(-1)*rwm2**(-1)*rzm2**2*b0ftsww - 
     &    48.D0*t**(-2)*u**(-1)*rzm2*b0fmzww + 48.D0*t**(-2)*u**(-1)*
     &    rzm2*b0ftsww + 4.D0*t**(-2)*u**(-1)*rzm2**2*c0cmzuswww - 4.D0
     &    *t**(-2)*u**(-1)*rzm2**2*c0cctswww - 24.D0*t**(-2)*u**(-1)*
     &    rwm2*rzm2*c0cmzuswww + 24.D0*t**(-2)*u**(-1)*rwm2*rzm2*
     &    c0cctswww - 4.D0*t**(-1)*u**(-2)*rwm2**(-1)*rzm2**2*b0fmzww
     &     + 4.D0*t**(-1)*u**(-2)*rwm2**(-1)*rzm2**2*b0ftsww + 24.D0*
     &    t**(-1)*u**(-2)*rzm2*b0fmzww - 24.D0*t**(-1)*u**(-2)*rzm2*
     &    b0ftsww - 4.D0*t**(-1)*u**(-2)*rzm2**2*c0cmzuswww + 4.D0*
     &    t**(-1)*u**(-2)*rzm2**2*c0cctswww + 24.D0*t**(-1)*u**(-2)*
     &    rwm2*rzm2*c0cmzuswww - 24.D0*t**(-1)*u**(-2)*rwm2*rzm2*
     &    c0cctswww - 2.D0*t**(-1)*u**(-1)*rwm2**(-1)*rzm2 - 4.D0*
     &    t**(-1)*u**(-1)*rwm2**(-1)*rzm2*b0ftsww + 4.D0*t**(-1)*
     &    u**(-1)*rwm2**(-1)*rzm2*b0fqsww + 12.D0*t**(-1)*u**(-1) + 24.D
     &    0*t**(-1)*u**(-1)*b0ftsww - 24.D0*t**(-1)*u**(-1)*b0fqsww + 8.
     &    D0*t**(-1)*u**(-1)*rzm2*c0cmzuswww + 36.D0*t**(-1)*u**(-1)*
     &    rzm2*c0cmztswww + 4.D0*t**(-1)*u**(-1)*rzm2*c0ccuswww - 8.D0*
     &    t**(-1)*u**(-1)*rzm2*c0cctswww - 36.D0*t**(-1)*u**(-1)*rzm2*
     &    c0ccqswww + 4.D0*t**(-1)*u**(-1)*rzm2**2*d0cccmztsuswwww - 48.
     &    D0*t**(-1)*u**(-1)*rwm2*c0cmzuswww - 24.D0*t**(-1)*u**(-1)*
     &    rwm2*c0cmztswww - 24.D0*t**(-1)*u**(-1)*rwm2*c0ccuswww + 48.D0
     &    *t**(-1)*u**(-1)*rwm2*c0cctswww + 24.D0*t**(-1)*u**(-1)*rwm2*
     &    c0ccqswww - 24.D0*t**(-1)*u**(-1)*rwm2*rzm2*d0cccmztsuswwww
     &     - 2.D0*t**(-1)*rzm2*d0ccmzcqsuswwww + 12.D0*t**(-1)*rwm2*
     &    d0ccmzcqsuswwww + 2.D0*u**(-2)*rwm2**(-1)*rzm2**2*c0cmztswww
     &     - 2.D0*u**(-2)*rwm2**(-1)*rzm2**2*c0ccqswww - 12.D0*u**(-2)*
     &    rzm2*c0cmztswww + 12.D0*u**(-2)*rzm2*c0ccqswww + 2.D0*u**(-1)
     &    *rwm2**(-1)*rzm2*c0cmzqswww + 2.D0*u**(-1)*rwm2**(-1)*rzm2*
     &    c0ccqswww - 32.D0*u**(-1)*c0cmztswww + 20.D0*u**(-1)*
     &    c0cmzqswww - 32.D0*u**(-1)*c0cctswww + 20.D0*u**(-1)*
     &    c0ccqswww - 38.D0*u**(-1)*rzm2*d0cccmzqstswwww + 36.D0*
     &    u**(-1)*rwm2*d0cccmzqstswwww + 16.D0*d0cccmztsuswwww + 16.D0*
     &    d0ccmzcqsuswwww + 16.D0*d0cccmzqstswwww - 2.D0*t*u**(-2)*
     &    rwm2**(-1)*rzm2*c0cmztswww + 2.D0*t*u**(-2)*rwm2**(-1)*rzm2*
     &    c0cmzqswww - 2.D0*t*u**(-2)*rwm2**(-1)*rzm2*c0cctswww + 2.D0*
     &    t*u**(-2)*rwm2**(-1)*rzm2*c0ccqswww - 2.D0*t*u**(-2)*
     &    rwm2**(-1)*rzm2**2*d0cccmzqstswwww + 12.D0*t*u**(-2)*
     &    c0cmztswww - 12.D0*t*u**(-2)*c0cmzqswww + 12.D0*t*u**(-2)*
     &    c0cctswww - 12.D0*t*u**(-2)*c0ccqswww + 12.D0*t*u**(-2)*rzm2*
     &    d0cccmzqstswwww + 2.D0*t*u**(-1)*rwm2**(-1)*rzm2*
     &    d0cccmzqstswwww + 20.D0*t*u**(-1)*d0cccmzqstswwww + 2.D0*t**2
     &    *u**(-2)*rwm2**(-1)*rzm2*d0cccmzqstswwww - 12.D0*t**2*u**(-2)
     &    *d0cccmzqstswwww + 4.D0/(u + t)*s**(-1)*t**(-2)*rzm2**3*
     &    c0cmzuswww - 4.D0/(u + t)*s**(-1)*t**(-2)*rzm2**3*c0cctswww
     &     - 24.D0/(u + t)*s**(-1)*t**(-2)*rwm2*rzm2**2*c0cmzuswww + 24.
     &    D0/(u + t)*s**(-1)*t**(-2)*rwm2*rzm2**2*c0cctswww + 8.D0/(u
     &     + t)*s**(-1)*t**(-1)*rzm2**2*c0cmzuswww - 4.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**2*c0cmztswww + 4.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**2*c0ccuswww - 8.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2**2*c0cctswww + 4.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*
     &    d0cccmztsuswwww - 48.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2*
     &    c0cmzuswww + 24.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2*
     &    c0cmztswww - 24.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2*
     &    c0ccuswww + 48.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2*c0cctswww
     &     - 24.D0/(u + t)*s**(-1)*t**(-1)*rwm2*rzm2**2*d0cccmztsuswwww
     &     + 2.D0/3.D0/(u + t)*s**(-1)*rwm2**(-1)*rzm2**2*c0cmztswww - 
     &    2.D0/3.D0/(u + t)*s**(-1)*rwm2**(-1)*rzm2**2*c0ccuswww + 4.D0
     &    /(u + t)*s**(-1)*rzm2*c0cmzuswww - 8.D0/(u + t)*s**(-1)*rzm2*
     &    c0cmztswww + 8.D0/(u + t)*s**(-1)*rzm2*c0ccuswww - 4.D0/(u + 
     &    t)*s**(-1)*rzm2*c0cctswww + 4.D0/(u + t)*s**(-1)*rzm2**2*
     &    d0cccmztsuswwww - 24.D0/(u + t)*s**(-1)*rwm2*c0cmzuswww + 24.D
     &    0/(u + t)*s**(-1)*rwm2*c0cmztswww - 24.D0/(u + t)*s**(-1)*
     &    rwm2*c0ccuswww + 24.D0/(u + t)*s**(-1)*rwm2*c0cctswww - 24.D0
     &    /(u + t)*s**(-1)*rwm2*rzm2*d0cccmztsuswwww + 2.D0/3.D0/(u + t
     &    )*s**(-1)*t*rwm2**(-1)*rzm2*c0cmzuswww - 2.D0/3.D0/(u + t)*
     &    s**(-1)*t*rwm2**(-1)*rzm2*c0cmztswww + 2.D0/3.D0/(u + t)*
     &    s**(-1)*t*rwm2**(-1)*rzm2*c0ccuswww - 2.D0/3.D0/(u + t)*
     &    s**(-1)*t*rwm2**(-1)*rzm2*c0cctswww - 2.D0/3.D0/(u + t)*
     &    s**(-1)*t*rwm2**(-1)*rzm2**2*d0cccmztsuswwww - 4.D0/(u + t)*
     &    s**(-1)*t*c0cmzuswww + 4.D0/(u + t)*s**(-1)*t*c0cmztswww - 4.D
     &    0/(u + t)*s**(-1)*t*c0ccuswww + 4.D0/(u + t)*s**(-1)*t*
     &    c0cctswww + 8.D0/(u + t)*s**(-1)*t*rzm2*d0cccmztsuswwww - 24.D
     &    0/(u + t)*s**(-1)*t*rwm2*d0cccmztsuswwww + 2.D0/3.D0/(u + t)*
     &    s**(-1)*t**2*rwm2**(-1)*rzm2*d0cccmztsuswwww - 4.D0/(u + t)*
     &    s**(-1)*t**2*d0cccmztsuswwww - 8.D0/(u + t)*t**(-2)*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 8.D0/(u + t)*t**(-2)*rwm2**(-1)*
     &    rzm2**2*b0ftsww + 48.D0/(u + t)*t**(-2)*rzm2*b0fmzww - 48.D0
     &    /(u + t)*t**(-2)*rzm2*b0ftsww - 4.D0/(u + t)*t**(-2)*rzm2**2*
     &    c0cmzuswww + 4.D0/(u + t)*t**(-2)*rzm2**2*c0cctswww + 24.D0/(
     &    u + t)*t**(-2)*rwm2*rzm2*c0cmzuswww - 24.D0/(u + t)*t**(-2)*
     &    rwm2*rzm2*c0cctswww + 4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2 + 
     &    4.D0/(u + t)*t**(-1)*rwm2**(-1)*rzm2*b0ftsww - 4.D0/(u + t)*
     &    t**(-1)*rwm2**(-1)*rzm2*b0fqsww - 24.D0/(u + t)*t**(-1) - 24.D
     &    0/(u + t)*t**(-1)*b0ftsww + 24.D0/(u + t)*t**(-1)*b0fqsww - 4.
     &    D0/(u + t)*t**(-1)*rzm2*c0cmzuswww - 40.D0/(u + t)*t**(-1)*
     &    rzm2*c0cmztswww - 4.D0/(u + t)*t**(-1)*rzm2*c0ccuswww + 8.D0
     &    /(u + t)*t**(-1)*rzm2*c0cctswww + 32.D0/(u + t)*t**(-1)*rzm2*
     &    c0ccqswww - 4.D0/(u + t)*t**(-1)*rzm2**2*d0cccmztsuswwww + 24.
     &    D0/(u + t)*t**(-1)*rwm2*c0cmzuswww + 48.D0/(u + t)*t**(-1)*
     &    rwm2*c0cmztswww + 24.D0/(u + t)*t**(-1)*rwm2*c0ccuswww - 48.D0
     &    /(u + t)*t**(-1)*rwm2*c0cctswww + 24.D0/(u + t)*t**(-1)*rwm2*
     &    rzm2*d0cccmztsuswwww - 2.D0/3.D0/(u + t)*rwm2**(-1)*rzm2*
     &    c0cmztswww + 2.D0/3.D0/(u + t)*rwm2**(-1)*rzm2*c0ccuswww + 36.
     &    D0/(u + t)*c0cmztswww - 4.D0/(u + t)*c0ccuswww + 32.D0/(u + t
     &    )*c0cctswww - 4.D0/(u + t)*rzm2*d0cccmztsuswwww + 32.D0/(u + 
     &    t)*rzm2*d0cccmzqstswwww - 40.D0/(u + t)*rwm2*d0cccmztsuswwww
     &     - 64.D0/(u + t)*rwm2*d0ccmzcqsuswwww - 64.D0/(u + t)*rwm2*
     &    d0cccmzqstswwww - 2.D0/3.D0/(u + t)*t*rwm2**(-1)*c0cmzuswww
     &     + 2.D0/3.D0/(u + t)*t*rwm2**(-1)*c0cmztswww - 2.D0/3.D0/(u
     &     + t)*t*rwm2**(-1)*c0ccuswww + 2.D0/3.D0/(u + t)*t*rwm2**(-1)
     &    *c0cctswww + 2.D0/3.D0/(u + t)*t*rwm2**(-1)*rzm2*
     &    d0cccmztsuswwww - 20.D0/(u + t)*t*d0cccmztsuswwww - 16.D0/(u
     &     + t)*t*d0ccmzcqsuswwww - 16.D0/(u + t)*t*d0cccmzqstswwww - 2.
     &    D0/3.D0/(u + t)*t**2*rwm2**(-1)*d0cccmztsuswwww + 8.D0/(u + t
     &    )/(u + s)*t**(-2)*rwm2**(-1)*rzm2**3*b0fmzww - 8.D0/(u + t)/(
     &    u + s)*t**(-2)*rwm2**(-1)*rzm2**3*b0ftsww - 48.D0/(u + t)/(u
     &     + s)*t**(-2)*rzm2**2*b0fmzww + 48.D0/(u + t)/(u + s)*t**(-2)
     &    *rzm2**2*b0ftsww - 4.D0/(u + t)/(u + s)*t**(-1)*rwm2**(-1)*
     &    rzm2**2 + 24.D0/(u + t)/(u + s)*t**(-1)*rzm2 + 8.D0/(u + t)/(
     &    u + s)*t**(-1)*rzm2**2*c0cmztswww - 48.D0/(u + t)/(u + s)*
     &    t**(-1)*rwm2*rzm2*c0cmztswww - 4.D0/(u + t)/(u + s)/(u + s)*
     &    t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww + 4.D0/(u + t)/(u + s)/(u
     &     + s)*t**(-1)*rwm2**(-1)*rzm2**3*b0ftsww + 24.D0/(u + t)/(u
     &     + s)/(u + s)*t**(-1)*rzm2**2*b0fmzww )
      ewamp(1,2,2,3) = ewamp(1,2,2,3) + sqrt(s)*sqrt(t*u)*sr2**(-1)
     & *mz * (  - 24.D0/(u + t)/(u + s)/(u + s)*t**(-1)*rzm2**2*b0ftsww
     &     + 2.D0/(u + s)*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**3*b0fmzww - 
     &    2.D0/(u + s)*s**(-2)*t**(-1)*rwm2**(-1)*rzm2**3*b0ftsww - 12.D
     &    0/(u + s)*s**(-2)*t**(-1)*rzm2**2*b0fmzww + 12.D0/(u + s)*
     &    s**(-2)*t**(-1)*rzm2**2*b0ftsww - 2.D0/(u + s)*s**(-2)*
     &    rwm2**(-1)*rzm2**2*b0fmzww + 2.D0/(u + s)*s**(-2)*rwm2**(-1)*
     &    rzm2**2*b0ftsww + 12.D0/(u + s)*s**(-2)*rzm2*b0fmzww - 12.D0
     &    /(u + s)*s**(-2)*rzm2*b0ftsww + 8.D0/(u + s)*s**(-1)*t**(-2)*
     &    rwm2**(-1)*rzm2**3*b0fmzww - 8.D0/(u + s)*s**(-1)*t**(-2)*
     &    rwm2**(-1)*rzm2**3*b0ftsww - 48.D0/(u + s)*s**(-1)*t**(-2)*
     &    rzm2**2*b0fmzww + 48.D0/(u + s)*s**(-1)*t**(-2)*rzm2**2*
     &    b0ftsww - 2.D0/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**2 - 2.
     &    D0/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**2*b0fmzww + 2.D0
     &    /(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*rzm2**2*b0ftsww + 12.D0/(
     &    u + s)*s**(-1)*t**(-1)*rzm2 + 12.D0/(u + s)*s**(-1)*t**(-1)*
     &    rzm2*b0fmzww - 12.D0/(u + s)*s**(-1)*t**(-1)*rzm2*b0ftsww + 4.
     &    D0/(u + s)*s**(-1)*t**(-1)*rzm2**2*c0cmztswww - 24.D0/(u + s)
     &    *s**(-1)*t**(-1)*rwm2*rzm2*c0cmztswww + 2.D0/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2 - 12.D0/(u + s)*s**(-1) - 4.D0/(u + s)*
     &    s**(-1)*rzm2*c0cmztswww + 24.D0/(u + s)*s**(-1)*rwm2*
     &    c0cmztswww - 2.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*rwm2**(-1)*
     &    rzm2**3*b0fmzww + 2.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*
     &    rwm2**(-1)*rzm2**3*b0ftsww + 12.D0/(u + s)/(u + s)*s**(-1)*
     &    t**(-1)*rzm2**2*b0fmzww - 12.D0/(u + s)/(u + s)*s**(-1)*
     &    t**(-1)*rzm2**2*b0ftsww + 2.D0/(u + s)/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**2*b0fmzww - 2.D0/(u + s)/(u + s)*s**(-1)*
     &    rwm2**(-1)*rzm2**2*b0ftsww - 12.D0/(u + s)/(u + s)*s**(-1)*
     &    rzm2*b0fmzww + 12.D0/(u + s)/(u + s)*s**(-1)*rzm2*b0ftsww )
*}}}
      endif

      ewamp(2,1,1,1) = ewamp(1,1,1,1)
      ewamp(2,1,1,2) = ewamp(1,1,1,2)
      ewamp(2,1,1,3) = -ewamp(1,1,1,3)
      ewamp(2,1,2,1) = ewamp(1,1,2,1)
      ewamp(2,1,2,2) = ewamp(1,1,2,2)
      ewamp(2,1,2,3) = -ewamp(1,1,2,3)
      ewamp(2,2,1,1) = ewamp(1,2,1,1)
      ewamp(2,2,1,2) = ewamp(1,2,1,2)
      ewamp(2,2,1,3) = -ewamp(1,2,1,3)
      ewamp(2,2,2,1) = ewamp(1,2,2,1)
      ewamp(2,2,2,2) = ewamp(1,2,2,2)
      ewamp(2,2,2,3) = -ewamp(1,2,2,3)
*}}}
***************************
* QED helicity amplitudes *
***************************
* {{{

      qedamp(1,1,1,1) = 0d0
      qedamp(1,1,1,2) = 0d0
      qedamp(1,1,1,3) = 0d0
      qedamp(1,1,2,1) = 0d0
      qedamp(1,1,2,2) = 0d0
      qedamp(1,1,2,3) = 0d0
      qedamp(1,2,1,1) = 0d0
      qedamp(1,2,1,2) = 0d0
      qedamp(1,2,1,3) = 0d0
      qedamp(1,2,2,1) = 0d0
      qedamp(1,2,2,2) = 0d0
      qedamp(1,2,2,3) = 0d0

      if (iqed.eq.1) then

      do i=1,5 ! type count of fermion loop particles
*like electron
      if (i.eq.1) then
      mgen2 = relm2
      mgen2i = elm2
      cqfactor = 3d0*qf(2)**3*(i3f(2)-2d0*qf(2)*stw2)/2/ctw/stw
      endif
*like up-quark (only up and charm)
      if (i.eq.2) then
      mgen2 = rupm2
      mgen2i = upm2
      cqfactor = 2d0*3d0*qf(7)**3*(i3f(7)-2d0*qf(7)*stw2)/2/ctw/stw
      endif
*like down-quark (only down and strange)
      if (i.eq.3) then
      mgen2 = rdnm2
      mgen2i = dnm2
      cqfactor = 2d0*3d0*qf(8)**3*(i3f(8)-2d0*qf(8)*stw2)/2/ctw/stw
      endif
*like bottom-quark (other mass)
      if (i.eq.4) then
      mgen2 = rbtm2
      mgen2i = btm2
      cqfactor = 3d0*qf(12)**3*(i3f(12)-2d0*qf(12)*stw2)/2/ctw/stw
      endif
*like top-quark (other mass)
      if (i.eq.5) then
      mgen2 = rtpm2
      mgen2i = tpm2
      cqfactor = 3d0*qf(11)**3*(i3f(11)-2d0*qf(11)*stw2)/2/ctw/stw
      endif

      b0fqsff = b0f(-s,thmu2,mgen2i,mgen2i)
      b0ftsff = b0f(-t,thmu2,mgen2i,mgen2i)
      b0fusff = b0f(-u,thmu2,mgen2i,mgen2i)
      b0fmzff = b0f(-rzm2,thmu2,mgen2i,mgen2i)
      c0ccqsfff = -c0(0d0,0d0,s,mgen2,mgen2,mgen2)
      c0cctsfff = -c0(0d0,0d0,t,mgen2,mgen2,mgen2)
      c0ccusfff = -c0(0d0,0d0,u,mgen2,mgen2,mgen2)
      c0cmzqsfff = -c0(0d0,rzm2,s,mgen2,mgen2,mgen2)
      c0cmztsfff = -c0(0d0,rzm2,t,mgen2,mgen2,mgen2)
      c0cmzusfff = -c0(0d0,rzm2,u,mgen2,mgen2,mgen2)
      d0cccmzqstsffff = d0(0d0,0d0,0d0,rzm2,s,t,mgen2,mgen2,mgen2,mgen2)
      d0ccmzcqsusffff = d0(0d0,0d0,rzm2,0d0,s,u,mgen2,mgen2,mgen2,mgen2)
      d0cccmztsusffff = d0(0d0,0d0,0d0,rzm2,t,u,mgen2,mgen2,mgen2,mgen2)
C*{{{ GL
C      qedamp(1,1,1,1) = qedamp(1,1,1,1)
C     &  + cqfactor * ( 8.D0 - 16.D0*mgen2**2*d0cccmztsusffff - 16.D0*
C     &    mgen2**2*d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff + 8.
C     &    D0/(u + t)*s**(-1)*rzm2**2*mgen2*c0cmzusfff + 8.D0/(u + t)*
C     &    s**(-1)*rzm2**2*mgen2*c0cmztsfff - 8.D0/(u + t)*s**(-1)*u*
C     &    rzm2*mgen2*c0cmzusfff - 8.D0/(u + t)*s**(-1)*u*rzm2*mgen2*
C     &    c0ccusfff - 8.D0/(u + t)*s**(-1)*t*rzm2*mgen2*c0cmztsfff - 8.D
C     &    0/(u + t)*s**(-1)*t*rzm2*mgen2*c0cctsfff - 8.D0/(u + t)*
C     &    s**(-1)*t*u*rzm2*mgen2*d0cccmztsusffff - 16.D0/(u + t)*rzm2*
C     &    mgen2*c0ccqsfff )
C
C      qedamp(1,1,1,2) = qedamp(1,1,1,2)
C     &  + cqfactor * ( 8.D0 + 8.D0*t**(-1)*u**(-1)*rzm2**2*mgen2*
C     &    c0cmzqsfff - 8.D0*t**(-1)*rzm2*mgen2*c0ccusfff - 8.D0*u**(-1)
C     &    *rzm2*mgen2*c0cctsfff - 16.D0*mgen2**2*d0cccmztsusffff - 16.D0
C     &    *mgen2**2*d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff - 
C     &    16.D0*s*t**(-1)*u**(-1)*rzm2*mgen2*c0cmzqsfff + 8.D0*s*
C     &    t**(-1)*mgen2*c0ccusfff - 8.D0*s*t**(-1)*u*mgen2*
C     &    d0ccmzcqsusffff + 8.D0*s*u**(-1)*mgen2*c0cctsfff - 8.D0*s*t*
C     &    u**(-1)*mgen2*d0cccmzqstsffff + 8.D0*s**2*t**(-1)*u**(-1)*
C     &    mgen2*c0cmzqsfff + 8.D0/(u + t)*t**(-1)*u*rzm2*mgen2*
C     &    c0cmzusfff - 8.D0/(u + t)*t**(-1)*u**2*mgen2*c0cmzusfff - 8.D0
C     &    /(u + t)*u*mgen2*c0cctsfff + 8.D0/(u + t)*t*u**(-1)*rzm2*
C     &    mgen2*c0cmztsfff - 8.D0/(u + t)*t*mgen2*c0ccusfff + 8.D0/(u
C     &     + t)*t*u*mgen2*d0cccmztsusffff - 8.D0/(u + t)*t**2*u**(-1)*
C     &    mgen2*c0cmztsfff - 8.D0/(u + t)*s*t**(-1)*u*mgen2*c0ccqsfff
C     &     - 8.D0/(u + t)*s*t*u**(-1)*mgen2*c0ccqsfff )
C
C      qedamp(1,1,1,3) = qedamp(1,1,1,3)
C     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz*cqfactor * ( 8.D0*t**(-1)*
C     &    mgen2*d0ccmzcqsusffff - 8.D0*u**(-1)*mgen2*d0cccmzqstsffff - 
C     &    16.D0/(u + t)*s**(-1)*t**(-1)*rzm2*mgen2*c0cmzusfff + 16.D0/(
C     &    u + t)*s**(-1)*t**(-1)*u*mgen2*c0cmzusfff + 16.D0/(u + t)*
C     &    s**(-1)*u**(-1)*rzm2*mgen2*c0cmztsfff - 16.D0/(u + t)*s**(-1)
C     &    *mgen2*c0ccusfff + 16.D0/(u + t)*s**(-1)*mgen2*c0cctsfff + 8.D
C     &    0/(u + t)*s**(-1)*u*mgen2*d0cccmztsusffff - 16.D0/(u + t)*
C     &    s**(-1)*t*u**(-1)*mgen2*c0cmztsfff - 8.D0/(u + t)*s**(-1)*t*
C     &    mgen2*d0cccmztsusffff + 16.D0/(u + t)*t**(-1)*mgen2*c0ccqsfff
C     &     - 16.D0/(u + t)*u**(-1)*mgen2*c0ccqsfff )
C
C      qedamp(1,1,2,1) = qedamp(1,1,2,1)
C     &  + cqfactor * ( 8.D0*t**(-1)*u**(-1)*rzm2**2*mgen2*c0cmzqsfff - 
C     &    16.D0*mgen2**2*d0cccmztsusffff - 16.D0*mgen2**2*
C     &    d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff - 16.D0*s*
C     &    t**(-1)*u**(-1)*rzm2*mgen2*c0cmzqsfff - 8.D0*s*t**(-1)*u*
C     &    mgen2*d0ccmzcqsusffff - 8.D0*s*t*u**(-1)*mgen2*
C     &    d0cccmzqstsffff + 8.D0*s**2*t**(-1)*u**(-1)*mgen2*c0cmzqsfff
C     &     + 8.D0/(u + t)*s**(-2)*t*u*rzm2**2*c0cmzusfff + 8.D0/(u + t)
C     &    *s**(-2)*t*u*rzm2**2*c0cmztsfff - 8.D0/(u + t)*s**(-2)*t*u**2
C     &    *rzm2*c0cmzusfff - 8.D0/(u + t)*s**(-2)*t*u**2*rzm2*c0ccusfff
C     &     - 8.D0/(u + t)*s**(-2)*t**2*u*rzm2*c0cmztsfff - 8.D0/(u + t)
C     &    *s**(-2)*t**2*u*rzm2*c0cctsfff - 8.D0/(u + t)*s**(-2)*t**2*
C     &    u**2*rzm2*d0cccmztsusffff + 16.D0/(u + t)*s**(-1)*u*rzm2*
C     &    mgen2*c0cmztsfff - 16.D0/(u + t)*s**(-1)*u*rzm2*mgen2*
C     &    c0ccusfff + 16.D0/(u + t)*s**(-1)*t*rzm2*mgen2*c0cmzusfff - 
C     &    16.D0/(u + t)*s**(-1)*t*rzm2*mgen2*c0cctsfff - 32.D0/(u + t)*
C     &    s**(-1)*t*u*rzm2*mgen2*d0cccmztsusffff - 8.D0/(u + t)*t**(-1)
C     &    *u**2*mgen2*c0ccusfff + 8.D0/(u + t)*rzm2*mgen2*c0cmzusfff + 
C     &    8.D0/(u + t)*rzm2*mgen2*c0cmztsfff - 8.D0/(u + t)*u*mgen2*
C     &    c0cmztsfff - 8.D0/(u + t)*t*mgen2*c0cmzusfff + 8.D0/(u + t)*t
C     &    *u*mgen2*d0cccmztsusffff - 8.D0/(u + t)*t**2*u**(-1)*mgen2*
C     &    c0cctsfff - 8.D0/(u + t)*s*t**(-1)*u*mgen2*c0ccqsfff - 8.D0/(
C     &    u + t)*s*t*u**(-1)*mgen2*c0ccqsfff - 16.D0/(u + t)/(u + s)*
C     &    s**(-1)*t*u*rzm2*b0fmzff + 16.D0/(u + t)/(u + s)*s**(-1)*t*u*
C     &    rzm2*b0ftsff - 8.D0/(u + t)/(u + s)*s*rzm2*mgen2*c0cmztsfff
C     &     + 8.D0/(u + t)/(u + s)*s**2*t*u**(-1)*mgen2*c0cmztsfff - 8.D0
C     &    /(u + t)/(u + s)/(u + s)*t*u*rzm2*b0fmzff + 8.D0/(u + t)/(u
C     &     + s)/(u + s)*t*u*rzm2*b0ftsff - 8.D0/(u + t)/(u + s)/(t + s)
C     &    *t*u*rzm2 - 8.D0/(u + t)/(u + s)/(t + s)*s*t*u - 16.D0/(u + t
C     &    )/(t + s)*s**(-1)*t*u*rzm2*b0fmzff + 16.D0/(u + t)/(t + s)*
C     &    s**(-1)*t*u*rzm2*b0fusff - 8.D0/(u + t)/(t + s)*s*rzm2*mgen2*
C     &    c0cmzusfff + 8.D0/(u + t)/(t + s)*s**2*t**(-1)*u*mgen2*
C     &    c0cmzusfff - 8.D0/(u + t)/(t + s)/(t + s)*t*u*rzm2*b0fmzff + 
C     &    8.D0/(u + t)/(t + s)/(t + s)*t*u*rzm2*b0fusff )
C
C      qedamp(1,1,2,2) = qedamp(1,1,2,2)
C     &  + cqfactor * ( 8.D0*s**(-1)*rzm2*mgen2*c0cmzusfff + 8.D0*
C     &    s**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0*s**(-1)*u*mgen2*
C     &    c0cmzusfff - 8.D0*s**(-1)*u*mgen2*c0ccusfff - 8.D0*s**(-1)*t*
C     &    mgen2*c0cmztsfff - 8.D0*s**(-1)*t*mgen2*c0cctsfff - 8.D0*
C     &    s**(-1)*t*u*mgen2*d0cccmztsusffff - 16.D0*mgen2**2*
C     &    d0cccmztsusffff - 16.D0*mgen2**2*d0ccmzcqsusffff - 16.D0*
C     &    mgen2**2*d0cccmzqstsffff - 24.D0/( - 6.D0*mgen2 + rzm2)*
C     &    s**(-1)*rzm2**2*mgen2*c0cmzusfff - 24.D0/( - 6.D0*mgen2 + 
C     &    rzm2)*s**(-1)*rzm2**2*mgen2*c0cmztsfff + 4.D0/( - 6.D0*mgen2
C     &     + rzm2)*s**(-1)*rzm2**3*c0cmzusfff + 4.D0/( - 6.D0*mgen2 + 
C     &    rzm2)*s**(-1)*rzm2**3*c0cmztsfff + 24.D0/( - 6.D0*mgen2 + 
C     &    rzm2)*s**(-1)*u*rzm2*mgen2*c0cmzusfff + 24.D0/( - 6.D0*mgen2
C     &     + rzm2)*s**(-1)*u*rzm2*mgen2*c0ccusfff - 4.D0/( - 6.D0*mgen2
C     &     + rzm2)*s**(-1)*u*rzm2**2*c0cmzusfff - 4.D0/( - 6.D0*mgen2
C     &     + rzm2)*s**(-1)*u*rzm2**2*c0ccusfff + 24.D0/( - 6.D0*mgen2
C     &     + rzm2)*s**(-1)*t*rzm2*mgen2*c0cmztsfff + 24.D0/( - 6.D0*
C     &    mgen2 + rzm2)*s**(-1)*t*rzm2*mgen2*c0cctsfff - 4.D0/( - 6.D0*
C     &    mgen2 + rzm2)*s**(-1)*t*rzm2**2*c0cmztsfff - 4.D0/( - 6.D0*
C     &    mgen2 + rzm2)*s**(-1)*t*rzm2**2*c0cctsfff + 24.D0/( - 6.D0*
C     &    mgen2 + rzm2)*s**(-1)*t*u*rzm2*mgen2*d0cccmztsusffff - 4.D0/(
C     &     - 6.D0*mgen2 + rzm2)*s**(-1)*t*u*rzm2**2*d0cccmztsusffff + 
C     &    24.D0/( - 6.D0*mgen2 + rzm2)*rzm2*mgen2*c0cmzusfff + 24.D0/(
C     &     - 6.D0*mgen2 + rzm2)*rzm2*mgen2*c0cmztsfff + 48.D0/( - 6.D0*
C     &    mgen2 + rzm2)*rzm2*mgen2**2*d0cccmztsusffff + 48.D0/( - 6.D0*
C     &    mgen2 + rzm2)*rzm2*mgen2**2*d0ccmzcqsusffff + 48.D0/( - 6.D0*
C     &    mgen2 + rzm2)*rzm2*mgen2**2*d0cccmzqstsffff - 4.D0/( - 6.D0*
C     &    mgen2 + rzm2)*rzm2**2*c0cmzusfff - 4.D0/( - 6.D0*mgen2 + rzm2
C     &    )*rzm2**2*c0cmztsfff - 8.D0/( - 6.D0*mgen2 + rzm2)*rzm2**2*
C     &    mgen2*d0cccmztsusffff - 8.D0/( - 6.D0*mgen2 + rzm2)*rzm2**2*
C     &    mgen2*d0ccmzcqsusffff - 8.D0/( - 6.D0*mgen2 + rzm2)*rzm2**2*
C     &    mgen2*d0cccmzqstsffff - 24.D0/( - 6.D0*mgen2 + rzm2)*u*mgen2*
C     &    c0cmzusfff - 24.D0/( - 6.D0*mgen2 + rzm2)*u*mgen2*c0ccusfff
C     &     + 4.D0/( - 6.D0*mgen2 + rzm2)*u*rzm2*c0cmzusfff + 4.D0/( - 6.
C     &    D0*mgen2 + rzm2)*u*rzm2*c0ccusfff - 24.D0/( - 6.D0*mgen2 + 
C     &    rzm2)*t*mgen2*c0cmztsfff - 24.D0/( - 6.D0*mgen2 + rzm2)*t*
C     &    mgen2*c0cctsfff + 4.D0/( - 6.D0*mgen2 + rzm2)*t*rzm2*
C     &    c0cmztsfff + 4.D0/( - 6.D0*mgen2 + rzm2)*t*rzm2*c0cctsfff - 
C     &    24.D0/( - 6.D0*mgen2 + rzm2)*t*u*mgen2*d0cccmztsusffff + 4.D0
C     &    /( - 6.D0*mgen2 + rzm2)*t*u*rzm2*d0cccmztsusffff - 48.D0/( - 
C     &    6.D0*mgen2 + rzm2)*s*mgen2**2*d0cccmztsusffff - 48.D0/( - 6.D0
C     &    *mgen2 + rzm2)*s*mgen2**2*d0ccmzcqsusffff - 48.D0/( - 6.D0*
C     &    mgen2 + rzm2)*s*mgen2**2*d0cccmzqstsffff + 8.D0/( - 6.D0*
C     &    mgen2 + rzm2)*s*rzm2*mgen2*d0cccmztsusffff + 8.D0/( - 6.D0*
C     &    mgen2 + rzm2)*s*rzm2*mgen2*d0ccmzcqsusffff + 8.D0/( - 6.D0*
C     &    mgen2 + rzm2)*s*rzm2*mgen2*d0cccmzqstsffff - 8.D0/(u + t)*
C     &    s**(-1)*t*u*rzm2*c0cmzusfff - 8.D0/(u + t)*s**(-1)*t*u*rzm2*
C     &    c0cmztsfff + 8.D0/(u + t)*s**(-1)*t*u**2*c0cmzusfff + 8.D0/(u
C     &     + t)*s**(-1)*t*u**2*c0ccusfff + 8.D0/(u + t)*s**(-1)*t**2*u*
C     &    c0cmztsfff + 8.D0/(u + t)*s**(-1)*t**2*u*c0cctsfff + 8.D0/(u
C     &     + t)*s**(-1)*t**2*u**2*d0cccmztsusffff - 8.D0/(u + t)*rzm2*
C     &    mgen2*c0cmzusfff - 8.D0/(u + t)*rzm2*mgen2*c0cmztsfff - 16.D0
C     &    /(u + t)*rzm2*mgen2*c0ccqsfff + 16.D0/(u + t)*u*b0fmzff - 16.D
C     &    0/(u + t)*u*b0fusff + 8.D0/(u + t)*u*mgen2*c0cmzusfff + 8.D0
C     &    /(u + t)*u*mgen2*c0ccusfff + 16.D0/(u + t)*t*b0fmzff - 16.D0
C     &    /(u + t)*t*b0ftsff + 8.D0/(u + t)*t*mgen2*c0cmztsfff + 8.D0/(
C     &    u + t)*t*mgen2*c0cctsfff + 24.D0/(u + t)*t*u*mgen2*
C     &    d0cccmztsusffff + 16.D0/(u + t)*s*b0fmzff - 8.D0/(u + t)*s*
C     &    b0fusff - 8.D0/(u + t)*s*b0ftsff + 16.D0/(u + t)/(u + s)*s*
C     &    rzm2*mgen2*c0cmztsfff - 8.D0/(u + t)/(u + s)/(u + s)*s*
C     &    rzm2**2*b0fmzff + 8.D0/(u + t)/(u + s)/(u + s)*s*rzm2**2*
C     &    b0ftsff + 8.D0/(u + t)/(u + s)/(t + s)*t*u*rzm2 + 8.D0/(u + t
C     &    )/(u + s)/(t + s)*s*t*u + 16.D0/(u + t)/(t + s)*s*rzm2*mgen2*
C     &    c0cmzusfff - 8.D0/(u + t)/(t + s)/(t + s)*s*rzm2**2*b0fmzff
C     &     + 8.D0/(u + t)/(t + s)/(t + s)*s*rzm2**2*b0fusff )
C
C      qedamp(1,1,2,3) = qedamp(1,1,2,3)
C     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz*cqfactor * (  - 8.D0*t**(-1)*
C     &    mgen2*d0ccmzcqsusffff + 8.D0*u**(-1)*mgen2*d0cccmzqstsffff - 
C     &    8.D0/(u + t)*s**(-2)*u*rzm2*c0cmzusfff - 8.D0/(u + t)*s**(-2)
C     &    *u*rzm2*c0cmztsfff + 8.D0/(u + t)*s**(-2)*u**2*c0cmzusfff + 8.
C     &    D0/(u + t)*s**(-2)*u**2*c0ccusfff + 8.D0/(u + t)*s**(-2)*t*
C     &    rzm2*c0cmzusfff + 8.D0/(u + t)*s**(-2)*t*rzm2*c0cmztsfff - 8.D
C     &    0/(u + t)*s**(-2)*t*u*c0cmzusfff + 8.D0/(u + t)*s**(-2)*t*u*
C     &    c0cmztsfff - 8.D0/(u + t)*s**(-2)*t*u*c0ccusfff + 8.D0/(u + t
C     &    )*s**(-2)*t*u*c0cctsfff + 8.D0/(u + t)*s**(-2)*t*u**2*
C     &    d0cccmztsusffff - 8.D0/(u + t)*s**(-2)*t**2*c0cmztsfff - 8.D0
C     &    /(u + t)*s**(-2)*t**2*c0cctsfff - 8.D0/(u + t)*s**(-2)*t**2*u
C     &    *d0cccmztsusffff - 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2*mgen2*
C     &    c0cmzusfff + 16.D0/(u + t)*s**(-1)*t**(-1)*u*mgen2*c0cmzusfff
C     &     + 16.D0/(u + t)*s**(-1)*u**(-1)*rzm2*mgen2*c0cmztsfff - 16.D0
C     &    /(u + t)*s**(-1)*mgen2*c0ccusfff + 16.D0/(u + t)*s**(-1)*
C     &    mgen2*c0cctsfff + 24.D0/(u + t)*s**(-1)*u*mgen2*
C     &    d0cccmztsusffff - 16.D0/(u + t)*s**(-1)*t*u**(-1)*mgen2*
C     &    c0cmztsfff - 24.D0/(u + t)*s**(-1)*t*mgen2*d0cccmztsusffff - 
C     &    16.D0/(u + t)*t**(-1)*mgen2*c0ccqsfff + 16.D0/(u + t)*u**(-1)
C     &    *mgen2*c0ccqsfff - 32.D0/(u + t)/(u + s)*s**(-1)*t*b0fmzff + 
C     &    32.D0/(u + t)/(u + s)*s**(-1)*t*b0ftsff - 32.D0/(u + t)/(u + 
C     &    s)*s*u**(-1)*mgen2*c0cmztsfff + 16.D0/(u + t)/(u + s)/(u + s)
C     &    *s**(-1)*u*rzm2*b0fmzff - 16.D0/(u + t)/(u + s)/(u + s)*
C     &    s**(-1)*u*rzm2*b0ftsff + 16.D0/(u + t)/(u + s)/(t + s)*u - 16.
C     &    D0/(u + t)/(u + s)/(t + s)*t + 32.D0/(u + t)/(t + s)*s**(-1)*
C     &    u*b0fmzff - 32.D0/(u + t)/(t + s)*s**(-1)*u*b0fusff + 32.D0/(
C     &    u + t)/(t + s)*s*t**(-1)*mgen2*c0cmzusfff - 16.D0/(u + t)/(t
C     &     + s)/(t + s)*s**(-1)*t*rzm2*b0fmzff + 16.D0/(u + t)/(t + s)
C     &    /(t + s)*s**(-1)*t*rzm2*b0fusff )
C
C      qedamp(1,2,1,1) = qedamp(1,2,1,1)
C     &  + cqfactor * (  - 8.D0*t**(-1)*rzm2*mgen2*c0ccusfff + 8.D0*
C     &    t**(-1)*u*mgen2*c0cmzqsfff - 16.D0*mgen2**2*d0cccmztsusffff
C     &     - 16.D0*mgen2**2*d0ccmzcqsusffff - 16.D0*mgen2**2*
C     &    d0cccmzqstsffff + 8.D0*t*u**(-1)*mgen2*c0cmzqsfff - 8.D0*s*
C     &    t**(-1)*u**(-1)*rzm2*mgen2*c0ccqsfff + 8.D0*s*t**(-1)*mgen2*
C     &    c0ccusfff - 8.D0*s*t**(-1)*u*mgen2*d0ccmzcqsusffff + 8.D0*s*
C     &    u**(-1)*mgen2*c0cmztsfff - 8.D0*s*t*u**(-1)*mgen2*
C     &    d0cccmzqstsffff + 8.D0*s**2*t**(-1)*u**(-1)*mgen2*c0ccqsfff
C     &     - 24.D0/( - 6.D0*mgen2 + rzm2)*t*u**(-1)*rzm2*mgen2*
C     &    c0cmzqsfff + 4.D0/( - 6.D0*mgen2 + rzm2)*t*u**(-1)*rzm2**2*
C     &    c0cmzqsfff + 8.D0/(u + t)*t**(-1)*u*rzm2*mgen2*c0cmzusfff - 8.
C     &    D0/(u + t)*t**(-1)*u**2*mgen2*c0cmzusfff + 8.D0/(u + t)*rzm2*
C     &    mgen2*c0cmztsfff - 8.D0/(u + t)*u*mgen2*c0cmztsfff - 8.D0/(u
C     &     + t)*t*mgen2*c0ccusfff + 8.D0/(u + t)*t*u*mgen2*
C     &    d0cccmztsusffff - 8.D0/(u + t)*t**2*u**(-1)*mgen2*c0cctsfff
C     &     - 24.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t*u**(-1)*rzm2**2*
C     &    mgen2*c0cmztsfff + 4.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t*
C     &    u**(-1)*rzm2**3*c0cmztsfff + 48.D0/(u + t)/( - 6.D0*mgen2 + 
C     &    rzm2)*t*rzm2*mgen2**2*d0cccmztsusffff + 48.D0/(u + t)/( - 6.D0
C     &    *mgen2 + rzm2)*t*rzm2*mgen2**2*d0ccmzcqsusffff + 48.D0/(u + t
C     &    )/( - 6.D0*mgen2 + rzm2)*t*rzm2*mgen2**2*d0cccmzqstsffff - 8.D
C     &    0/(u + t)/( - 6.D0*mgen2 + rzm2)*t*rzm2**2*mgen2*
C     &    d0cccmztsusffff - 8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t*
C     &    rzm2**2*mgen2*d0ccmzcqsusffff - 8.D0/(u + t)/( - 6.D0*mgen2
C     &     + rzm2)*t*rzm2**2*mgen2*d0cccmzqstsffff + 24.D0/(u + t)/( - 
C     &    6.D0*mgen2 + rzm2)*t**2*u**(-1)*rzm2*mgen2*c0cmztsfff + 24.D0
C     &    /(u + t)/( - 6.D0*mgen2 + rzm2)*t**2*u**(-1)*rzm2*mgen2*
C     &    c0cctsfff - 4.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t**2*u**(-1)*
C     &    rzm2**2*c0cmztsfff - 4.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t**2
C     &    *u**(-1)*rzm2**2*c0cctsfff + 24.D0/(u + t)/( - 6.D0*mgen2 + 
C     &    rzm2)*s*t*u**(-1)*rzm2*mgen2*c0ccqsfff - 4.D0/(u + t)/( - 6.D0
C     &    *mgen2 + rzm2)*s*t*u**(-1)*rzm2**2*c0ccqsfff + 24.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*s*t**2*u**(-1)*rzm2*mgen2*
C     &    d0cccmzqstsffff - 4.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*t**2*
C     &    u**(-1)*rzm2**2*d0cccmzqstsffff + 16.D0/(u + t)/(u + s)*u*
C     &    rzm2*mgen2*c0cmztsfff + 8.D0/(u + t)/(u + s)*s*t - 8.D0/(u + 
C     &    t)/(u + s)/(u + s)*t*u*rzm2*b0fmzff + 8.D0/(u + t)/(u + s)/(u
C     &     + s)*t*u*rzm2*b0ftsff )
C
C      qedamp(1,2,1,2) = qedamp(1,2,1,2)
C     &  + cqfactor * ( 16.D0*u**(-1)*rzm2*mgen2*c0cmztsfff + 16.D0*
C     &    u**(-1)*rzm2*mgen2*c0cmzqsfff - 16.D0*mgen2**2*
C     &    d0cccmztsusffff - 16.D0*mgen2**2*d0ccmzcqsusffff - 16.D0*
C     &    mgen2**2*d0cccmzqstsffff - 16.D0*t*u**(-1)*mgen2*c0cmztsfff
C     &     - 16.D0*t*u**(-1)*mgen2*c0cctsfff - 8.D0*s*u**(-1)*b0fmzff
C     &     + 8.D0*s*u**(-1)*b0fqsff - 16.D0*s*u**(-1)*mgen2*c0cmzqsfff
C     &     - 16.D0*s*u**(-1)*mgen2*c0ccqsfff + 8.D0*s*t*u**(-2)*rzm2*
C     &    c0cmztsfff + 8.D0*s*t*u**(-2)*rzm2*c0cmzqsfff - 32.D0*s*t*
C     &    u**(-1)*mgen2*d0cccmzqstsffff - 8.D0*s*t**2*u**(-2)*
C     &    c0cmztsfff - 8.D0*s*t**2*u**(-2)*c0cctsfff - 8.D0*s**2*t*
C     &    u**(-2)*c0cmzqsfff - 8.D0*s**2*t*u**(-2)*c0ccqsfff - 8.D0*
C     &    s**2*t**2*u**(-2)*d0cccmzqstsffff - 24.D0/( - 6.D0*mgen2 + 
C     &    rzm2)*s*mgen2*c0cmzqsfff + 4.D0/( - 6.D0*mgen2 + rzm2)*s*rzm2
C     &    *c0cmzqsfff + 8.D0/(u + t)*s**(-1)*rzm2**2*mgen2*c0cmzusfff
C     &     + 8.D0/(u + t)*s**(-1)*rzm2**2*mgen2*c0cmztsfff - 8.D0/(u + 
C     &    t)*s**(-1)*u*rzm2*mgen2*c0cmzusfff - 8.D0/(u + t)*s**(-1)*u*
C     &    rzm2*mgen2*c0ccusfff - 8.D0/(u + t)*s**(-1)*t*rzm2*mgen2*
C     &    c0cmztsfff - 8.D0/(u + t)*s**(-1)*t*rzm2*mgen2*c0cctsfff - 8.D
C     &    0/(u + t)*s**(-1)*t*u*rzm2*mgen2*d0cccmztsusffff - 32.D0/(u
C     &     + t)*rzm2*mgen2*c0cmztsfff - 8.D0/(u + t)*s*t*u**(-1)*
C     &    b0fmzff + 8.D0/(u + t)*s*t*u**(-1)*b0fqsff - 24.D0/(u + t)/(
C     &     - 6.D0*mgen2 + rzm2)*s*rzm2*mgen2*c0cmztsfff + 4.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*s*rzm2**2*c0cmztsfff + 48.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*s*u*mgen2**2*d0cccmztsusffff + 48.D0
C     &    /(u + t)/( - 6.D0*mgen2 + rzm2)*s*u*mgen2**2*d0ccmzcqsusffff
C     &     + 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*u*mgen2**2*
C     &    d0cccmzqstsffff - 8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*u*
C     &    rzm2*mgen2*d0cccmztsusffff - 8.D0/(u + t)/( - 6.D0*mgen2 + 
C     &    rzm2)*s*u*rzm2*mgen2*d0ccmzcqsusffff - 8.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*s*u*rzm2*mgen2*d0cccmzqstsffff + 24.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*s*t*mgen2*c0cmztsfff + 24.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*s*t*mgen2*c0cctsfff - 4.D0/(u + t)/(
C     &     - 6.D0*mgen2 + rzm2)*s*t*rzm2*c0cmztsfff - 4.D0/(u + t)/( - 
C     &    6.D0*mgen2 + rzm2)*s*t*rzm2*c0cctsfff + 24.D0/(u + t)/( - 6.D0
C     &    *mgen2 + rzm2)*s**2*mgen2*c0ccqsfff - 4.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*s**2*rzm2*c0ccqsfff + 24.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*s**2*t*mgen2*d0cccmzqstsffff - 4.D0/(u + t)/(
C     &     - 6.D0*mgen2 + rzm2)*s**2*t*rzm2*d0cccmzqstsffff + 16.D0/(u
C     &     + t)/(u + s)*s*rzm2*mgen2*c0cmztsfff - 8.D0/(u + t)/(u + s)*
C     &    s*t - 8.D0/(u + t)/(u + s)/(u + s)*s*t**2*b0fmzff + 8.D0/(u
C     &     + t)/(u + s)/(u + s)*s*t**2*b0ftsff - 16.D0/(u + s)*s*t*
C     &    u**(-1)*b0fmzff + 16.D0/(u + s)*s*t*u**(-1)*b0ftsff )
C
C      qedamp(1,2,1,3) = qedamp(1,2,1,3)
C     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz*cqfactor * (  - 16.D0*s**(-1)*
C     &    u**(-1)*b0fmzff + 16.D0*s**(-1)*u**(-1)*b0ftsff - 16.D0*
C     &    t**(-1)*u**(-1)*mgen2*c0ccqsfff - 8.D0*t**(-1)*mgen2*
C     &    d0ccmzcqsusffff + 8.D0*u**(-2)*rzm2*c0cmztsfff + 8.D0*u**(-2)
C     &    *rzm2*c0cmzqsfff - 24.D0*u**(-1)*mgen2*d0cccmzqstsffff - 8.D0
C     &    *t*u**(-2)*c0cmztsfff - 8.D0*t*u**(-2)*c0cctsfff - 8.D0*s*
C     &    u**(-2)*c0cmzqsfff - 8.D0*s*u**(-2)*c0ccqsfff - 8.D0*s*t*
C     &    u**(-2)*d0cccmzqstsffff + 48.D0/( - 6.D0*mgen2 + rzm2)*
C     &    u**(-1)*mgen2*c0cmzqsfff - 8.D0/( - 6.D0*mgen2 + rzm2)*
C     &    u**(-1)*rzm2*c0cmzqsfff + 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2*
C     &    mgen2*c0cmzusfff - 16.D0/(u + t)*s**(-1)*t**(-1)*u*mgen2*
C     &    c0cmzusfff + 16.D0/(u + t)*s**(-1)*u**(-1)*rzm2*mgen2*
C     &    c0cmztsfff + 16.D0/(u + t)*s**(-1)*mgen2*c0ccusfff - 16.D0/(u
C     &     + t)*s**(-1)*mgen2*c0cctsfff - 8.D0/(u + t)*s**(-1)*u*mgen2*
C     &    d0cccmztsusffff - 16.D0/(u + t)*s**(-1)*t*u**(-1)*mgen2*
C     &    c0cmztsfff + 8.D0/(u + t)*s**(-1)*t*mgen2*d0cccmztsusffff - 
C     &    16.D0/(u + t)*u**(-1)*b0fmzff + 16.D0/(u + t)*u**(-1)*b0fqsff
C     &     + 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*u**(-1)*rzm2*mgen2*
C     &    c0cmztsfff - 8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*u**(-1)*
C     &    rzm2**2*c0cmztsfff - 96.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*
C     &    mgen2**2*d0cccmztsusffff - 96.D0/(u + t)/( - 6.D0*mgen2 + 
C     &    rzm2)*mgen2**2*d0ccmzcqsusffff - 96.D0/(u + t)/( - 6.D0*mgen2
C     &     + rzm2)*mgen2**2*d0cccmzqstsffff + 16.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*rzm2*mgen2*d0cccmztsusffff + 16.D0/(u + t)/( - 
C     &    6.D0*mgen2 + rzm2)*rzm2*mgen2*d0ccmzcqsusffff + 16.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*rzm2*mgen2*d0cccmzqstsffff - 48.D0/(u
C     &     + t)/( - 6.D0*mgen2 + rzm2)*t*u**(-1)*mgen2*c0cmztsfff - 48.D
C     &    0/(u + t)/( - 6.D0*mgen2 + rzm2)*t*u**(-1)*mgen2*c0cctsfff + 
C     &    8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t*u**(-1)*rzm2*c0cmztsfff
C     &     + 8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t*u**(-1)*rzm2*
C     &    c0cctsfff - 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*u**(-1)*
C     &    mgen2*c0ccqsfff + 8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*
C     &    u**(-1)*rzm2*c0ccqsfff - 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)
C     &    *s*t*u**(-1)*mgen2*d0cccmzqstsffff + 8.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*s*t*u**(-1)*rzm2*d0cccmzqstsffff - 16.D0/(u + t
C     &    )/(u + s) - 32.D0/(u + t)/(u + s)*s**(-1)*u*mgen2*c0cmztsfff
C     &     + 16.D0/(u + t)/(u + s)/(u + s)*s**(-1)*u*rzm2*b0fmzff - 16.D
C     &    0/(u + t)/(u + s)/(u + s)*s**(-1)*u*rzm2*b0ftsff )
C
C      qedamp(1,2,2,1) = qedamp(1,2,2,1)
C     &  + cqfactor * ( 16.D0*t**(-1)*rzm2*mgen2*c0cmzusfff + 16.D0*
C     &    t**(-1)*rzm2*mgen2*c0cmzqsfff - 16.D0*t**(-1)*u*mgen2*
C     &    c0cmzusfff - 16.D0*t**(-1)*u*mgen2*c0ccusfff - 16.D0*mgen2**2
C     &    *d0cccmztsusffff - 16.D0*mgen2**2*d0ccmzcqsusffff - 16.D0*
C     &    mgen2**2*d0cccmzqstsffff + 8.D0*s*t**(-2)*u*rzm2*c0cmzusfff
C     &     + 8.D0*s*t**(-2)*u*rzm2*c0cmzqsfff - 8.D0*s*t**(-2)*u**2*
C     &    c0cmzusfff - 8.D0*s*t**(-2)*u**2*c0ccusfff - 8.D0*s*t**(-1)*
C     &    b0fmzff + 8.D0*s*t**(-1)*b0fqsff - 16.D0*s*t**(-1)*mgen2*
C     &    c0cmzqsfff - 16.D0*s*t**(-1)*mgen2*c0ccqsfff - 32.D0*s*
C     &    t**(-1)*u*mgen2*d0ccmzcqsusffff - 8.D0*s**2*t**(-2)*u*
C     &    c0cmzqsfff - 8.D0*s**2*t**(-2)*u*c0ccqsfff - 8.D0*s**2*
C     &    t**(-2)*u**2*d0ccmzcqsusffff - 24.D0/( - 6.D0*mgen2 + rzm2)*s
C     &    *mgen2*c0cmzqsfff + 4.D0/( - 6.D0*mgen2 + rzm2)*s*rzm2*
C     &    c0cmzqsfff + 8.D0/(u + t)*s**(-1)*rzm2**2*mgen2*c0cmzusfff + 
C     &    8.D0/(u + t)*s**(-1)*rzm2**2*mgen2*c0cmztsfff - 8.D0/(u + t)*
C     &    s**(-1)*u*rzm2*mgen2*c0cmzusfff - 8.D0/(u + t)*s**(-1)*u*rzm2
C     &    *mgen2*c0ccusfff - 8.D0/(u + t)*s**(-1)*t*rzm2*mgen2*
C     &    c0cmztsfff - 8.D0/(u + t)*s**(-1)*t*rzm2*mgen2*c0cctsfff - 8.D
C     &    0/(u + t)*s**(-1)*t*u*rzm2*mgen2*d0cccmztsusffff - 32.D0/(u
C     &     + t)*rzm2*mgen2*c0cmzusfff - 8.D0/(u + t)*s*t**(-1)*u*
C     &    b0fmzff + 8.D0/(u + t)*s*t**(-1)*u*b0fqsff - 24.D0/(u + t)/(
C     &     - 6.D0*mgen2 + rzm2)*s*rzm2*mgen2*c0cmzusfff + 4.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*s*rzm2**2*c0cmzusfff + 24.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*s*u*mgen2*c0cmzusfff + 24.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*s*u*mgen2*c0ccusfff - 4.D0/(u + t)/(
C     &     - 6.D0*mgen2 + rzm2)*s*u*rzm2*c0cmzusfff - 4.D0/(u + t)/( - 
C     &    6.D0*mgen2 + rzm2)*s*u*rzm2*c0ccusfff + 48.D0/(u + t)/( - 6.D0
C     &    *mgen2 + rzm2)*s*t*mgen2**2*d0cccmztsusffff + 48.D0/(u + t)/(
C     &     - 6.D0*mgen2 + rzm2)*s*t*mgen2**2*d0ccmzcqsusffff + 48.D0/(u
C     &     + t)/( - 6.D0*mgen2 + rzm2)*s*t*mgen2**2*d0cccmzqstsffff - 8.
C     &    D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*t*rzm2*mgen2*
C     &    d0cccmztsusffff - 8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*t*
C     &    rzm2*mgen2*d0ccmzcqsusffff - 8.D0/(u + t)/( - 6.D0*mgen2 + 
C     &    rzm2)*s*t*rzm2*mgen2*d0cccmzqstsffff + 24.D0/(u + t)/( - 6.D0
C     &    *mgen2 + rzm2)*s**2*mgen2*c0ccqsfff - 4.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*s**2*rzm2*c0ccqsfff + 24.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*s**2*u*mgen2*d0ccmzcqsusffff - 4.D0/(u + t)/(
C     &     - 6.D0*mgen2 + rzm2)*s**2*u*rzm2*d0ccmzcqsusffff + 16.D0/(u
C     &     + t)/(t + s)*s*rzm2*mgen2*c0cmzusfff - 8.D0/(u + t)/(t + s)*
C     &    s*u - 8.D0/(u + t)/(t + s)/(t + s)*s*u**2*b0fmzff + 8.D0/(u
C     &     + t)/(t + s)/(t + s)*s*u**2*b0fusff - 16.D0/(t + s)*s*
C     &    t**(-1)*u*b0fmzff + 16.D0/(t + s)*s*t**(-1)*u*b0fusff )
C
C      qedamp(1,2,2,2) = qedamp(1,2,2,2)
C     &  + cqfactor * ( 8.D0*t**(-1)*u*mgen2*c0cmzqsfff - 8.D0*u**(-1)*
C     &    rzm2*mgen2*c0cctsfff - 16.D0*mgen2**2*d0cccmztsusffff - 16.D0
C     &    *mgen2**2*d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff + 
C     &    8.D0*t*u**(-1)*mgen2*c0cmzqsfff - 8.D0*s*t**(-1)*u**(-1)*rzm2
C     &    *mgen2*c0ccqsfff + 8.D0*s*t**(-1)*mgen2*c0cmzusfff - 8.D0*s*
C     &    t**(-1)*u*mgen2*d0ccmzcqsusffff + 8.D0*s*u**(-1)*mgen2*
C     &    c0cctsfff - 8.D0*s*t*u**(-1)*mgen2*d0cccmzqstsffff + 8.D0*
C     &    s**2*t**(-1)*u**(-1)*mgen2*c0ccqsfff - 24.D0/( - 6.D0*mgen2
C     &     + rzm2)*t**(-1)*u*rzm2*mgen2*c0cmzqsfff + 4.D0/( - 6.D0*
C     &    mgen2 + rzm2)*t**(-1)*u*rzm2**2*c0cmzqsfff - 8.D0/(u + t)*
C     &    t**(-1)*u**2*mgen2*c0ccusfff + 8.D0/(u + t)*rzm2*mgen2*
C     &    c0cmzusfff - 8.D0/(u + t)*u*mgen2*c0cctsfff + 8.D0/(u + t)*t*
C     &    u**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0/(u + t)*t*mgen2*
C     &    c0cmzusfff + 8.D0/(u + t)*t*u*mgen2*d0cccmztsusffff - 8.D0/(u
C     &     + t)*t**2*u**(-1)*mgen2*c0cmztsfff - 24.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*t**(-1)*u*rzm2**2*mgen2*c0cmzusfff + 4.D0/(u + 
C     &    t)/( - 6.D0*mgen2 + rzm2)*t**(-1)*u*rzm2**3*c0cmzusfff + 24.D0
C     &    /(u + t)/( - 6.D0*mgen2 + rzm2)*t**(-1)*u**2*rzm2*mgen2*
C     &    c0cmzusfff + 24.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t**(-1)*
C     &    u**2*rzm2*mgen2*c0ccusfff - 4.D0/(u + t)/( - 6.D0*mgen2 + 
C     &    rzm2)*t**(-1)*u**2*rzm2**2*c0cmzusfff - 4.D0/(u + t)/( - 6.D0
C     &    *mgen2 + rzm2)*t**(-1)*u**2*rzm2**2*c0ccusfff + 48.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*u*rzm2*mgen2**2*d0cccmztsusffff + 48.D
C     &    0/(u + t)/( - 6.D0*mgen2 + rzm2)*u*rzm2*mgen2**2*
C     &    d0ccmzcqsusffff + 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*u*rzm2
C     &    *mgen2**2*d0cccmzqstsffff - 8.D0/(u + t)/( - 6.D0*mgen2 + 
C     &    rzm2)*u*rzm2**2*mgen2*d0cccmztsusffff - 8.D0/(u + t)/( - 6.D0
C     &    *mgen2 + rzm2)*u*rzm2**2*mgen2*d0ccmzcqsusffff - 8.D0/(u + t)
C     &    /( - 6.D0*mgen2 + rzm2)*u*rzm2**2*mgen2*d0cccmzqstsffff + 24.D
C     &    0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*t**(-1)*u*rzm2*mgen2*
C     &    c0ccqsfff - 4.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*t**(-1)*u*
C     &    rzm2**2*c0ccqsfff + 24.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*
C     &    t**(-1)*u**2*rzm2*mgen2*d0ccmzcqsusffff - 4.D0/(u + t)/( - 6.D
C     &    0*mgen2 + rzm2)*s*t**(-1)*u**2*rzm2**2*d0ccmzcqsusffff + 16.D0
C     &    /(u + t)/(t + s)*t*rzm2*mgen2*c0cmzusfff + 8.D0/(u + t)/(t + 
C     &    s)*s*u - 8.D0/(u + t)/(t + s)/(t + s)*t*u*rzm2*b0fmzff + 8.D0
C     &    /(u + t)/(t + s)/(t + s)*t*u*rzm2*b0fusff )
C
C      qedamp(1,2,2,3) = qedamp(1,2,2,3)
C     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz*cqfactor * (  - 16.D0*s**(-1)*
C     &    t**(-1)*b0fmzff + 16.D0*s**(-1)*t**(-1)*b0fusff + 8.D0*
C     &    t**(-2)*rzm2*c0cmzusfff + 8.D0*t**(-2)*rzm2*c0cmzqsfff - 8.D0
C     &    *t**(-2)*u*c0cmzusfff - 8.D0*t**(-2)*u*c0ccusfff - 16.D0*
C     &    t**(-1)*u**(-1)*mgen2*c0ccqsfff - 24.D0*t**(-1)*mgen2*
C     &    d0ccmzcqsusffff - 8.D0*u**(-1)*mgen2*d0cccmzqstsffff - 8.D0*s
C     &    *t**(-2)*c0cmzqsfff - 8.D0*s*t**(-2)*c0ccqsfff - 8.D0*s*
C     &    t**(-2)*u*d0ccmzcqsusffff + 48.D0/( - 6.D0*mgen2 + rzm2)*
C     &    t**(-1)*mgen2*c0cmzqsfff - 8.D0/( - 6.D0*mgen2 + rzm2)*
C     &    t**(-1)*rzm2*c0cmzqsfff + 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2*
C     &    mgen2*c0cmzusfff - 16.D0/(u + t)*s**(-1)*t**(-1)*u*mgen2*
C     &    c0cmzusfff + 16.D0/(u + t)*s**(-1)*u**(-1)*rzm2*mgen2*
C     &    c0cmztsfff - 16.D0/(u + t)*s**(-1)*mgen2*c0ccusfff + 16.D0/(u
C     &     + t)*s**(-1)*mgen2*c0cctsfff + 8.D0/(u + t)*s**(-1)*u*mgen2*
C     &    d0cccmztsusffff - 16.D0/(u + t)*s**(-1)*t*u**(-1)*mgen2*
C     &    c0cmztsfff - 8.D0/(u + t)*s**(-1)*t*mgen2*d0cccmztsusffff - 
C     &    16.D0/(u + t)*t**(-1)*b0fmzff + 16.D0/(u + t)*t**(-1)*b0fqsff
C     &     + 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t**(-1)*rzm2*mgen2*
C     &    c0cmzusfff - 8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*t**(-1)*
C     &    rzm2**2*c0cmzusfff - 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*
C     &    t**(-1)*u*mgen2*c0cmzusfff - 48.D0/(u + t)/( - 6.D0*mgen2 + 
C     &    rzm2)*t**(-1)*u*mgen2*c0ccusfff + 8.D0/(u + t)/( - 6.D0*mgen2
C     &     + rzm2)*t**(-1)*u*rzm2*c0cmzusfff + 8.D0/(u + t)/( - 6.D0*
C     &    mgen2 + rzm2)*t**(-1)*u*rzm2*c0ccusfff - 96.D0/(u + t)/( - 6.D
C     &    0*mgen2 + rzm2)*mgen2**2*d0cccmztsusffff - 96.D0/(u + t)/( - 
C     &    6.D0*mgen2 + rzm2)*mgen2**2*d0ccmzcqsusffff - 96.D0/(u + t)/(
C     &     - 6.D0*mgen2 + rzm2)*mgen2**2*d0cccmzqstsffff + 16.D0/(u + t
C     &    )/( - 6.D0*mgen2 + rzm2)*rzm2*mgen2*d0cccmztsusffff + 16.D0/(
C     &    u + t)/( - 6.D0*mgen2 + rzm2)*rzm2*mgen2*d0ccmzcqsusffff + 16.
C     &    D0/(u + t)/( - 6.D0*mgen2 + rzm2)*rzm2*mgen2*d0cccmzqstsffff
C     &     - 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*t**(-1)*mgen2*
C     &    c0ccqsfff + 8.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*t**(-1)*
C     &    rzm2*c0ccqsfff - 48.D0/(u + t)/( - 6.D0*mgen2 + rzm2)*s*
C     &    t**(-1)*u*mgen2*d0ccmzcqsusffff + 8.D0/(u + t)/( - 6.D0*mgen2
C     &     + rzm2)*s*t**(-1)*u*rzm2*d0ccmzcqsusffff - 16.D0/(u + t)/(t
C     &     + s) - 32.D0/(u + t)/(t + s)*s**(-1)*t*mgen2*c0cmzusfff + 16.
C     &    D0/(u + t)/(t + s)/(t + s)*s**(-1)*t*rzm2*b0fmzff - 16.D0/(u
C     &     + t)/(t + s)/(t + s)*s**(-1)*t*rzm2*b0fusff )
C*}}}
*{{{ SANC
      qedamp(1,1,1,1) = qedamp(1,1,1,1)
     &  + cqfactor * (  - 8.D0 - 24.D0*s**(-2)*t**(-1)*rzm2**3*b0fmzff
     &     + 24.D0*s**(-2)*t**(-1)*rzm2**3*b0fusff + 24.D0*s**(-2)*
     &    t**(-1)*u*rzm2**2*b0fmzff - 24.D0*s**(-2)*t**(-1)*u*rzm2**2*
     &    b0fusff - 8.D0*s**(-2)*t**(-1)*u**2*rzm2*b0fmzff + 8.D0*
     &    s**(-2)*t**(-1)*u**2*rzm2*b0fusff + 8.D0*s**(-2)*u**(-1)*
     &    rzm2**3*b0fmzff - 8.D0*s**(-2)*u**(-1)*rzm2**3*b0ftsff - 16.D0
     &    *s**(-2)*t*u**(-1)*rzm2**2*b0fmzff + 16.D0*s**(-2)*t*u**(-1)*
     &    rzm2**2*b0ftsff + 8.D0*s**(-2)*t**2*u**(-1)*rzm2*b0fmzff - 8.D
     &    0*s**(-2)*t**2*u**(-1)*rzm2*b0ftsff - 24.D0*s**(-1)*t**(-1)*
     &    rzm2**2 + 16.D0*s**(-1)*t**(-1)*rzm2**2*b0fmzff - 16.D0*
     &    s**(-1)*t**(-1)*rzm2**2*b0fusff + 48.D0*s**(-1)*t**(-1)*
     &    rzm2**2*mgen2*c0cmzusfff + 24.D0*s**(-1)*t**(-1)*u*rzm2 - 8.D0
     &    *s**(-1)*t**(-1)*u*rzm2*b0fmzff + 8.D0*s**(-1)*t**(-1)*u*rzm2
     &    *b0fusff - 48.D0*s**(-1)*t**(-1)*u*rzm2*mgen2*c0cmzusfff - 8.D
     &    0*s**(-1)*t**(-1)*u**2 + 16.D0*s**(-1)*t**(-1)*u**2*mgen2*
     &    c0cmzusfff + 8.D0*s**(-1)*u**(-1)*rzm2**2 - 8.D0*s**(-1)*
     &    u**(-1)*rzm2**2*b0fmzff + 8.D0*s**(-1)*u**(-1)*rzm2**2*
     &    b0ftsff - 16.D0*s**(-1)*u**(-1)*rzm2**2*mgen2*c0cmztsfff + 8.D
     &    0*s**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0*s**(-1)*rzm2*mgen2*
     &    c0ccusfff + 4.D0*s**(-1)*rzm2**2*c0cmztsfff - 4.D0*s**(-1)*
     &    rzm2**2*c0ccusfff - 16.D0*s**(-1)*t*u**(-1)*rzm2 + 8.D0*
     &    s**(-1)*t*u**(-1)*rzm2*b0fmzff - 8.D0*s**(-1)*t*u**(-1)*rzm2*
     &    b0ftsff + 32.D0*s**(-1)*t*u**(-1)*rzm2*mgen2*c0cmztsfff + 8.D0
     &    *s**(-1)*t*mgen2*c0cmzusfff - 8.D0*s**(-1)*t*mgen2*c0cmztsfff
     &     + 8.D0*s**(-1)*t*mgen2*c0ccusfff - 8.D0*s**(-1)*t*mgen2*
     &    c0cctsfff + 4.D0*s**(-1)*t*rzm2*c0cmzusfff - 4.D0*s**(-1)*t*
     &    rzm2*c0cmztsfff + 4.D0*s**(-1)*t*rzm2*c0ccusfff - 4.D0*
     &    s**(-1)*t*rzm2*c0cctsfff - 8.D0*s**(-1)*t*rzm2*mgen2*
     &    d0cccmztsusffff - 4.D0*s**(-1)*t*rzm2**2*d0cccmztsusffff + 8.D
     &    0*s**(-1)*t**2*u**(-1) - 16.D0*s**(-1)*t**2*u**(-1)*mgen2*
     &    c0cmztsfff + 8.D0*s**(-1)*t**2*mgen2*d0cccmztsusffff + 4.D0*
     &    s**(-1)*t**2*rzm2*d0cccmztsusffff + 16.D0*t**(-1)*rzm2 - 32.D0
     &    *t**(-1)*rzm2*mgen2*c0cmzusfff - 8.D0*t**(-1)*u + 16.D0*
     &    t**(-1)*u*mgen2*c0cmzusfff - 8.D0*u**(-1)*rzm2 + 16.D0*
     &    u**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0*b0fusff + 8.D0*b0ftsff
     &     + 32.D0*mgen2*c0cmzusfff - 16.D0*mgen2*c0cmztsfff + 16.D0*
     &    mgen2*c0ccusfff - 16.D0*mgen2**2*d0cccmztsusffff - 16.D0*
     &    mgen2**2*d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff - 4.
     &    D0*rzm2*c0cmztsfff + 4.D0*rzm2*c0ccusfff + 4.D0*u*c0cmzusfff
     &     + 4.D0*u*c0ccusfff - 8.D0*u*mgen2*d0cccmztsusffff - 8.D0*u*
     &    mgen2*d0ccmzcqsusffff - 8.D0*u*mgen2*d0cccmzqstsffff + 8.D0*t
     &    *u**(-1) - 16.D0*t*u**(-1)*mgen2*c0cmztsfff - 8.D0*t*
     &    c0cmzusfff + 4.D0*t*c0cmztsfff - 8.D0*t*c0ccusfff + 4.D0*t*
     &    c0cctsfff + 24.D0*t*mgen2*d0cccmztsusffff - 8.D0*t*mgen2*
     &    d0ccmzcqsusffff - 8.D0*t*mgen2*d0cccmzqstsffff + 4.D0*t*rzm2*
     &    d0cccmztsusffff + 4.D0*t*u*d0cccmztsusffff - 8.D0*t**2*
     &    d0cccmztsusffff + 8.D0/(u + t)*s**(-2)*t**(-1)*rzm2**4*
     &    b0fmzff - 8.D0/(u + t)*s**(-2)*t**(-1)*rzm2**4*b0fusff + 8.D0
     &    /(u + t)*s**(-1)*t**(-1)*rzm2**3 - 8.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**3*b0fmzff + 8.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2**3*b0fusff - 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*mgen2
     &    *c0cmzusfff - 8.D0/(u + t)*s**(-1)*t*rzm2**2*c0cmztsfff + 8.D0
     &    /(u + t)*s**(-1)*t*rzm2**2*c0ccusfff - 8.D0/(u + t)*s**(-1)*
     &    t**2*rzm2*c0cmzusfff + 16.D0/(u + t)*s**(-1)*t**2*rzm2*
     &    c0cmztsfff - 16.D0/(u + t)*s**(-1)*t**2*rzm2*c0ccusfff + 8.D0
     &    /(u + t)*s**(-1)*t**2*rzm2*c0cctsfff + 8.D0/(u + t)*s**(-1)*
     &    t**2*rzm2**2*d0cccmztsusffff + 8.D0/(u + t)*s**(-1)*t**3*
     &    c0cmzusfff - 8.D0/(u + t)*s**(-1)*t**3*c0cmztsfff + 8.D0/(u
     &     + t)*s**(-1)*t**3*c0ccusfff - 8.D0/(u + t)*s**(-1)*t**3*
     &    c0cctsfff - 16.D0/(u + t)*s**(-1)*t**3*rzm2*d0cccmztsusffff
     &     + 8.D0/(u + t)*s**(-1)*t**4*d0cccmztsusffff - 8.D0/(u + t)*
     &    t**(-1)*rzm2**2 + 16.D0/(u + t)*t**(-1)*rzm2**2*mgen2*
     &    c0cmzusfff + 16.D0/(u + t)*rzm2 + 16.D0/(u + t)*rzm2*b0fmzff
     &     - 8.D0/(u + t)*rzm2*b0fusff - 8.D0/(u + t)*rzm2*b0ftsff - 8.D
     &    0/(u + t)*rzm2*mgen2*c0cmzusfff - 8.D0/(u + t)*rzm2*mgen2*
     &    c0cmztsfff - 16.D0/(u + t)*rzm2*mgen2*c0ccqsfff + 16.D0/(u + 
     &    t)*t*b0fusff - 16.D0/(u + t)*t*b0ftsff - 8.D0/(u + t)*t*mgen2
     &    *c0cmzusfff + 8.D0/(u + t)*t*mgen2*c0cmztsfff - 8.D0/(u + t)*
     &    t*mgen2*c0ccusfff + 8.D0/(u + t)*t*mgen2*c0cctsfff + 8.D0/(u
     &     + t)*t*rzm2*c0cmztsfff - 8.D0/(u + t)*t*rzm2*c0ccusfff + 16.D
     &    0/(u + t)*t**2*c0cmzusfff - 8.D0/(u + t)*t**2*c0cmztsfff + 16.
     &    D0/(u + t)*t**2*c0ccusfff - 8.D0/(u + t)*t**2*c0cctsfff - 24.D
     &    0/(u + t)*t**2*mgen2*d0cccmztsusffff - 8.D0/(u + t)*t**2*rzm2
     &    *d0cccmztsusffff + 16.D0/(u + t)*t**3*d0cccmztsusffff - 8.D0
     &    /(u + t)/(u + s)*rzm2**2 + 16.D0/(u + t)/(u + s)*rzm2**2*
     &    mgen2*c0cmztsfff - 8.D0/(u + t)/(u + s)/(u + s)*rzm2**3*
     &    b0fmzff + 8.D0/(u + t)/(u + s)/(u + s)*rzm2**3*b0ftsff - 8.D0
     &    /(u + t)/(t + s)*s**(-2)*rzm2**4*b0fmzff + 8.D0/(u + t)/(t + 
     &    s)*s**(-2)*rzm2**4*b0fusff - 8.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**3 + 8.D0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fmzff - 8.D0
     &    /(u + t)/(t + s)*s**(-1)*rzm2**3*b0fusff + 16.D0/(u + t)/(t
     &     + s)*s**(-1)*rzm2**3*mgen2*c0cmzusfff - 8.D0/(u + t)/(t + s)
     &    /(t + s)*s**(-1)*rzm2**4*b0fmzff + 8.D0/(u + t)/(t + s)/(t + 
     &    s)*s**(-1)*rzm2**4*b0fusff - 8.D0/(u + s)*s**(-2)*rzm2**3*
     &    b0fmzff + 8.D0/(u + s)*s**(-2)*rzm2**3*b0ftsff + 16.D0/(u + s
     &    )*s**(-2)*t*rzm2**2*b0fmzff - 16.D0/(u + s)*s**(-2)*t*rzm2**2
     &    *b0ftsff - 8.D0/(u + s)*s**(-2)*t**2*rzm2*b0fmzff + 8.D0/(u
     &     + s)*s**(-2)*t**2*rzm2*b0ftsff - 8.D0/(u + s)*s**(-1)*
     &    rzm2**2 + 8.D0/(u + s)*s**(-1)*rzm2**2*b0fmzff - 8.D0/(u + s)
     &    *s**(-1)*rzm2**2*b0ftsff + 16.D0/(u + s)*s**(-1)*rzm2**2*
     &    mgen2*c0cmztsfff + 16.D0/(u + s)*s**(-1)*t*rzm2 - 8.D0/(u + s
     &    )*s**(-1)*t*rzm2*b0fmzff + 8.D0/(u + s)*s**(-1)*t*rzm2*
     &    b0ftsff - 32.D0/(u + s)*s**(-1)*t*rzm2*mgen2*c0cmztsfff - 8.D0
     &    /(u + s)*s**(-1)*t**2 + 16.D0/(u + s)*s**(-1)*t**2*mgen2*
     &    c0cmztsfff + 8.D0/(u + s)*rzm2*b0fmzff - 8.D0/(u + s)*rzm2*
     &    b0ftsff + 8.D0/(u + s)*t - 16.D0/(u + s)*t*mgen2*c0cmztsfff
     &     - 8.D0/(u + s)/(u + s)*s**(-1)*rzm2**3*b0fmzff + 8.D0/(u + s
     &    )/(u + s)*s**(-1)*rzm2**3*b0ftsff + 16.D0/(u + s)/(u + s)*
     &    s**(-1)*t*rzm2**2*b0fmzff - 16.D0/(u + s)/(u + s)*s**(-1)*t*
     &    rzm2**2*b0ftsff - 8.D0/(u + s)/(u + s)*s**(-1)*t**2*rzm2*
     &    b0fmzff + 8.D0/(u + s)/(u + s)*s**(-1)*t**2*rzm2*b0ftsff + 8.D
     &    0/(u + s)/(u + s)*t*rzm2*b0fmzff - 8.D0/(u + s)/(u + s)*t*
     &    rzm2*b0ftsff + 24.D0/(t + s)*s**(-2)*rzm2**3*b0fmzff - 24.D0
     &    /(t + s)*s**(-2)*rzm2**3*b0fusff - 24.D0/(t + s)*s**(-2)*u*
     &    rzm2**2*b0fmzff + 24.D0/(t + s)*s**(-2)*u*rzm2**2*b0fusff + 8.
     &    D0/(t + s)*s**(-2)*u**2*rzm2*b0fmzff - 8.D0/(t + s)*s**(-2)*
     &    u**2*rzm2*b0fusff + 24.D0/(t + s)*s**(-1)*rzm2**2 - 16.D0/(t
     &     + s)*s**(-1)*rzm2**2*b0fmzff + 16.D0/(t + s)*s**(-1)*rzm2**2
     &    *b0fusff - 48.D0/(t + s)*s**(-1)*rzm2**2*mgen2*c0cmzusfff - 
     &    24.D0/(t + s)*s**(-1)*u*rzm2 + 8.D0/(t + s)*s**(-1)*u*rzm2*
     &    b0fmzff - 8.D0/(t + s)*s**(-1)*u*rzm2*b0fusff + 48.D0/(t + s)
     &    *s**(-1)*u*rzm2*mgen2*c0cmzusfff + 8.D0/(t + s)*s**(-1)*u**2
     &     - 16.D0/(t + s)*s**(-1)*u**2*mgen2*c0cmzusfff + 16.D0/(t + s
     &    )*rzm2 - 8.D0/(t + s)*rzm2*b0fmzff + 8.D0/(t + s)*rzm2*
     &    b0fusff - 32.D0/(t + s)*rzm2*mgen2*c0cmzusfff - 8.D0/(t + s)*
     &    u + 16.D0/(t + s)*u*mgen2*c0cmzusfff + 24.D0/(t + s)/(t + s)*
     &    s**(-1)*rzm2**3*b0fmzff - 24.D0/(t + s)/(t + s)*s**(-1)*
     &    rzm2**3*b0fusff - 24.D0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*
     &    b0fmzff + 24.D0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*b0fusff + 8.
     &    D0/(t + s)/(t + s)*s**(-1)*u**2*rzm2*b0fmzff - 8.D0/(t + s)/(
     &    t + s)*s**(-1)*u**2*rzm2*b0fusff + 16.D0/(t + s)/(t + s)*
     &    rzm2**2*b0fmzff - 16.D0/(t + s)/(t + s)*rzm2**2*b0fusff - 8.D0
     &    /(t + s)/(t + s)*u*rzm2*b0fmzff + 8.D0/(t + s)/(t + s)*u*rzm2
     &    *b0fusff )

      qedamp(1,1,1,2) = qedamp(1,1,1,2)
     &  + cqfactor * ( 16.D0*s**(-2)*t**(-1)*rzm2**3*b0fmzff - 16.D0*
     &    s**(-2)*t**(-1)*rzm2**3*b0fusff - 8.D0*s**(-2)*t**(-1)*u*
     &    rzm2**2*b0fmzff + 8.D0*s**(-2)*t**(-1)*u*rzm2**2*b0fusff - 8.D
     &    0*s**(-2)*u**(-1)*rzm2**3*b0fmzff + 8.D0*s**(-2)*u**(-1)*
     &    rzm2**3*b0ftsff + 16.D0*s**(-2)*t*u**(-1)*rzm2**2*b0fmzff - 
     &    16.D0*s**(-2)*t*u**(-1)*rzm2**2*b0ftsff + 8.D0*s**(-2)*t*
     &    rzm2**2*c0cmztsfff - 8.D0*s**(-2)*t*rzm2**2*c0ccusfff - 8.D0*
     &    s**(-2)*t**2*u**(-1)*rzm2*b0fmzff + 8.D0*s**(-2)*t**2*u**(-1)
     &    *rzm2*b0ftsff + 8.D0*s**(-2)*t**2*rzm2*c0cmzusfff - 16.D0*
     &    s**(-2)*t**2*rzm2*c0cmztsfff + 16.D0*s**(-2)*t**2*rzm2*
     &    c0ccusfff - 8.D0*s**(-2)*t**2*rzm2*c0cctsfff - 8.D0*s**(-2)*
     &    t**2*rzm2**2*d0cccmztsusffff - 8.D0*s**(-2)*t**3*c0cmzusfff
     &     + 8.D0*s**(-2)*t**3*c0cmztsfff - 8.D0*s**(-2)*t**3*c0ccusfff
     &     + 8.D0*s**(-2)*t**3*c0cctsfff + 16.D0*s**(-2)*t**3*rzm2*
     &    d0cccmztsusffff - 8.D0*s**(-2)*t**4*d0cccmztsusffff + 16.D0*
     &    s**(-1)*t**(-1)*rzm2**2 - 16.D0*s**(-1)*t**(-1)*rzm2**2*
     &    b0fmzff + 16.D0*s**(-1)*t**(-1)*rzm2**2*b0fusff - 32.D0*
     &    s**(-1)*t**(-1)*rzm2**2*mgen2*c0cmzusfff - 8.D0*s**(-1)*
     &    t**(-1)*u*rzm2 + 8.D0*s**(-1)*t**(-1)*u*rzm2*b0fmzff - 8.D0*
     &    s**(-1)*t**(-1)*u*rzm2*b0fusff + 16.D0*s**(-1)*t**(-1)*u*rzm2
     &    *mgen2*c0cmzusfff - 8.D0*s**(-1)*u**(-1)*rzm2**2 + 16.D0*
     &    s**(-1)*u**(-1)*rzm2**2*mgen2*c0cmztsfff - 16.D0*s**(-1)*rzm2
     &    *b0fmzff + 16.D0*s**(-1)*rzm2*b0fusff + 16.D0*s**(-1)*rzm2*
     &    mgen2*c0cmztsfff - 16.D0*s**(-1)*rzm2*mgen2*c0ccusfff + 16.D0
     &    *s**(-1)*t*u**(-1)*rzm2 - 32.D0*s**(-1)*t*u**(-1)*rzm2*mgen2*
     &    c0cmztsfff - 16.D0*s**(-1)*t*b0fusff + 16.D0*s**(-1)*t*
     &    b0ftsff + 16.D0*s**(-1)*t*mgen2*c0cmzusfff - 16.D0*s**(-1)*t*
     &    mgen2*c0cmztsfff + 16.D0*s**(-1)*t*mgen2*c0ccusfff - 16.D0*
     &    s**(-1)*t*mgen2*c0cctsfff + 8.D0*s**(-1)*t*rzm2*c0cmzusfff - 
     &    8.D0*s**(-1)*t*rzm2*c0cmztsfff + 16.D0*s**(-1)*t*rzm2*
     &    c0ccusfff - 32.D0*s**(-1)*t*rzm2*mgen2*d0cccmztsusffff - 8.D0
     &    *s**(-1)*t**2*u**(-1) + 16.D0*s**(-1)*t**2*u**(-1)*mgen2*
     &    c0cmztsfff - 16.D0*s**(-1)*t**2*c0cmzusfff + 8.D0*s**(-1)*
     &    t**2*c0cmztsfff - 16.D0*s**(-1)*t**2*c0ccusfff + 8.D0*s**(-1)
     &    *t**2*c0cctsfff + 32.D0*s**(-1)*t**2*mgen2*d0cccmztsusffff + 
     &    16.D0*s**(-1)*t**2*rzm2*d0cccmztsusffff - 16.D0*s**(-1)*t**3*
     &    d0cccmztsusffff - 8.D0*t**(-1)*rzm2 + 8.D0*t**(-1)*rzm2*
     &    b0fmzff - 8.D0*t**(-1)*rzm2*b0fusff + 24.D0*t**(-1)*rzm2*
     &    mgen2*c0cmzusfff - 8.D0*t**(-1)*rzm2*mgen2*c0ccqsfff - 8.D0*
     &    t**(-1)*u*mgen2*c0cmzusfff + 8.D0*t**(-1)*u*mgen2*c0cmzqsfff
     &     - 8.D0*t**(-1)*u*mgen2*c0ccusfff + 8.D0*t**(-1)*u*mgen2*
     &    c0ccqsfff - 8.D0*t**(-1)*u*rzm2*mgen2*d0ccmzcqsusffff + 8.D0*
     &    t**(-1)*u**2*mgen2*d0ccmzcqsusffff + 8.D0*u**(-1)*rzm2 + 8.D0
     &    *u**(-1)*rzm2*b0fmzff - 8.D0*u**(-1)*rzm2*b0ftsff - 8.D0*
     &    u**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0*u**(-1)*rzm2*mgen2*
     &    c0ccqsfff - 8.D0*mgen2*c0cmzusfff + 16.D0*mgen2*c0cmzqsfff + 
     &    8.D0*mgen2*c0ccusfff - 16.D0*mgen2**2*d0cccmztsusffff - 16.D0
     &    *mgen2**2*d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff + 
     &    8.D0*u*mgen2*d0ccmzcqsusffff - 8.D0*t*u**(-1) + 8.D0*t*
     &    u**(-1)*mgen2*c0cmztsfff + 8.D0*t*u**(-1)*mgen2*c0cmzqsfff - 
     &    8.D0*t*u**(-1)*mgen2*c0cctsfff + 8.D0*t*u**(-1)*mgen2*
     &    c0ccqsfff - 8.D0*t*u**(-1)*rzm2*mgen2*d0cccmzqstsffff + 8.D0*
     &    t*mgen2*d0cccmztsusffff + 8.D0*t*mgen2*d0cccmzqstsffff + 8.D0
     &    *t**2*u**(-1)*mgen2*d0cccmzqstsffff - 8.D0/(u + t)*s**(-2)*
     &    t**(-1)*rzm2**4*b0fmzff + 8.D0/(u + t)*s**(-2)*t**(-1)*
     &    rzm2**4*b0fusff - 8.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3 + 8.D0
     &    /(u + t)*s**(-1)*t**(-1)*rzm2**3*b0fmzff - 8.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**3*b0fusff + 16.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**3*mgen2*c0cmzusfff + 8.D0/(u + t)*s**(-1)*t*
     &    rzm2**2*c0cmztsfff - 8.D0/(u + t)*s**(-1)*t*rzm2**2*c0ccusfff
     &     + 8.D0/(u + t)*s**(-1)*t**2*rzm2*c0cmzusfff - 16.D0/(u + t)*
     &    s**(-1)*t**2*rzm2*c0cmztsfff + 16.D0/(u + t)*s**(-1)*t**2*
     &    rzm2*c0ccusfff - 8.D0/(u + t)*s**(-1)*t**2*rzm2*c0cctsfff - 8.
     &    D0/(u + t)*s**(-1)*t**2*rzm2**2*d0cccmztsusffff - 8.D0/(u + t
     &    )*s**(-1)*t**3*c0cmzusfff + 8.D0/(u + t)*s**(-1)*t**3*
     &    c0cmztsfff - 8.D0/(u + t)*s**(-1)*t**3*c0ccusfff + 8.D0/(u + 
     &    t)*s**(-1)*t**3*c0cctsfff + 16.D0/(u + t)*s**(-1)*t**3*rzm2*
     &    d0cccmztsusffff - 8.D0/(u + t)*s**(-1)*t**4*d0cccmztsusffff
     &     + 8.D0/(u + t)*t**(-1)*rzm2**2 - 16.D0/(u + t)*t**(-1)*
     &    rzm2**2*mgen2*c0cmzusfff - 16.D0/(u + t)*rzm2 - 16.D0/(u + t)
     &    *rzm2*b0fmzff + 8.D0/(u + t)*rzm2*b0fusff + 8.D0/(u + t)*rzm2
     &    *b0ftsff + 8.D0/(u + t)*rzm2*mgen2*c0cmzusfff + 8.D0/(u + t)*
     &    rzm2*mgen2*c0cmztsfff + 16.D0/(u + t)*rzm2*mgen2*c0ccqsfff - 
     &    16.D0/(u + t)*t*b0fusff + 16.D0/(u + t)*t*b0ftsff + 8.D0/(u
     &     + t)*t*mgen2*c0cmzusfff - 8.D0/(u + t)*t*mgen2*c0cmztsfff + 
     &    8.D0/(u + t)*t*mgen2*c0ccusfff - 8.D0/(u + t)*t*mgen2*
     &    c0cctsfff - 8.D0/(u + t)*t*rzm2*c0cmztsfff + 8.D0/(u + t)*t*
     &    rzm2*c0ccusfff - 16.D0/(u + t)*t**2*c0cmzusfff + 8.D0/(u + t)
     &    *t**2*c0cmztsfff - 16.D0/(u + t)*t**2*c0ccusfff + 8.D0/(u + t
     &    )*t**2*c0cctsfff + 24.D0/(u + t)*t**2*mgen2*d0cccmztsusffff
     &     + 8.D0/(u + t)*t**2*rzm2*d0cccmztsusffff - 16.D0/(u + t)*
     &    t**3*d0cccmztsusffff + 8.D0/(u + t)/(u + s)*rzm2**2 - 16.D0/(
     &    u + t)/(u + s)*rzm2**2*mgen2*c0cmztsfff + 8.D0/(u + t)/(u + s
     &    )/(u + s)*rzm2**3*b0fmzff - 8.D0/(u + t)/(u + s)/(u + s)*
     &    rzm2**3*b0ftsff + 8.D0/(u + t)/(t + s)*s**(-2)*rzm2**4*
     &    b0fmzff - 8.D0/(u + t)/(t + s)*s**(-2)*rzm2**4*b0fusff + 8.D0
     &    /(u + t)/(t + s)*s**(-1)*rzm2**3 - 8.D0/(u + t)/(t + s)*
     &    s**(-1)*rzm2**3*b0fmzff + 8.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**3*b0fusff - 16.D0/(u + t)/(t + s)*s**(-1)*rzm2**3*mgen2
     &    *c0cmzusfff + 8.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**4*
     &    b0fmzff - 8.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**4*
     &    b0fusff + 8.D0/(u + s)*s**(-2)*rzm2**3*b0fmzff - 8.D0/(u + s)
     &    *s**(-2)*rzm2**3*b0ftsff - 16.D0/(u + s)*s**(-2)*t*rzm2**2*
     &    b0fmzff + 16.D0/(u + s)*s**(-2)*t*rzm2**2*b0ftsff + 8.D0/(u
     &     + s)*s**(-2)*t**2*rzm2*b0fmzff - 8.D0/(u + s)*s**(-2)*t**2*
     &    rzm2*b0ftsff + 8.D0/(u + s)*s**(-1)*rzm2**2 - 16.D0/(u + s)*
     &    s**(-1)*rzm2**2*mgen2*c0cmztsfff - 16.D0/(u + s)*s**(-1)*t*
     &    rzm2 + 32.D0/(u + s)*s**(-1)*t*rzm2*mgen2*c0cmztsfff + 8.D0/(
     &    u + s)*s**(-1)*t**2 - 16.D0/(u + s)*s**(-1)*t**2*mgen2*
     &    c0cmztsfff - 8.D0/(u + s)*t + 16.D0/(u + s)*t*mgen2*
     &    c0cmztsfff + 8.D0/(u + s)/(u + s)*s**(-1)*rzm2**3*b0fmzff - 8.
     &    D0/(u + s)/(u + s)*s**(-1)*rzm2**3*b0ftsff - 16.D0/(u + s)/(u
     &     + s)*s**(-1)*t*rzm2**2*b0fmzff + 16.D0/(u + s)/(u + s)*
     &    s**(-1)*t*rzm2**2*b0ftsff + 8.D0/(u + s)/(u + s)*s**(-1)*t**2
     &    *rzm2*b0fmzff - 8.D0/(u + s)/(u + s)*s**(-1)*t**2*rzm2*
     &    b0ftsff - 8.D0/(u + s)/(u + s)*t*rzm2*b0fmzff + 8.D0/(u + s)
     &    /(u + s)*t*rzm2*b0ftsff - 16.D0/(t + s)*s**(-2)*rzm2**3*
     &    b0fmzff + 16.D0/(t + s)*s**(-2)*rzm2**3*b0fusff + 8.D0/(t + s
     &    )*s**(-2)*u*rzm2**2*b0fmzff - 8.D0/(t + s)*s**(-2)*u*rzm2**2*
     &    b0fusff - 16.D0/(t + s)*s**(-1)*rzm2**2 + 16.D0/(t + s)*
     &    s**(-1)*rzm2**2*b0fmzff - 16.D0/(t + s)*s**(-1)*rzm2**2*
     &    b0fusff + 32.D0/(t + s)*s**(-1)*rzm2**2*mgen2*c0cmzusfff + 8.D
     &    0/(t + s)*s**(-1)*u*rzm2 - 8.D0/(t + s)*s**(-1)*u*rzm2*
     &    b0fmzff + 8.D0/(t + s)*s**(-1)*u*rzm2*b0fusff - 16.D0/(t + s)
     &    *s**(-1)*u*rzm2*mgen2*c0cmzusfff - 8.D0/(t + s)*rzm2 + 8.D0/(
     &    t + s)*rzm2*b0fmzff - 8.D0/(t + s)*rzm2*b0fusff + 16.D0/(t + 
     &    s)*rzm2*mgen2*c0cmzusfff - 16.D0/(t + s)/(t + s)*s**(-1)*
     &    rzm2**3*b0fmzff + 16.D0/(t + s)/(t + s)*s**(-1)*rzm2**3*
     &    b0fusff + 8.D0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*b0fmzff - 8.D
     &    0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*b0fusff - 8.D0/(t + s)/(t
     &     + s)*rzm2**2*b0fmzff + 8.D0/(t + s)/(t + s)*rzm2**2*b0fusff
     &     )

      qedamp(1,1,1,3) = qedamp(1,1,1,3)
     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz**(-1)*cqfactor * ( 8.D0*
     &    s**(-2)*t**2*u**(-1) - 16.D0*s**(-2)*t**2*u**(-1)*mgen2*
     &    c0cmztsfff + 8.D0*s**(-1)*t**(-1)*u - 16.D0*s**(-1)*t**(-1)*u
     &    *mgen2*c0cmzusfff + 16.D0*s**(-1)*mgen2*c0cmzusfff - 16.D0*
     &    s**(-1)*mgen2*c0cmztsfff + 16.D0*s**(-1)*mgen2*c0ccusfff - 16.
     &    D0*s**(-1)*mgen2*c0cctsfff - 8.D0*s**(-1)*t*u**(-1) + 16.D0*
     &    s**(-1)*t*u**(-1)*mgen2*c0cmztsfff + 16.D0*s**(-1)*t*mgen2*
     &    d0cccmztsusffff - 8.D0*s**(-1)*t**2*u**(-2) + 16.D0*s**(-1)*
     &    t**2*u**(-2)*mgen2*c0cmztsfff + 8.D0*t**(-1) - 16.D0*t**(-1)*
     &    mgen2*c0cmzusfff - 16.D0*u**(-1)*mgen2*c0cmzusfff + 16.D0*
     &    u**(-1)*mgen2*c0cmztsfff - 8.D0*t*u**(-2) + 16.D0*t*u**(-2)*
     &    mgen2*c0cmztsfff + 16.D0/(u + t)*mgen2*c0cmzusfff - 16.D0/(u
     &     + t)*mgen2*c0cmztsfff + 16.D0/(u + t)*mgen2*c0ccusfff - 16.D0
     &    /(u + t)*mgen2*c0cctsfff + 16.D0/(u + t)*t*mgen2*
     &    d0cccmztsusffff - 8.D0/(u + s)*s**(-2)*t**2 + 16.D0/(u + s)*
     &    s**(-2)*t**2*mgen2*c0cmztsfff + 8.D0/(u + s)*s**(-1)*t - 16.D0
     &    /(u + s)*s**(-1)*t*mgen2*c0cmztsfff + 8.D0/(t + s) - 8.D0/(t
     &     + s)*s**(-1)*u + 16.D0/(t + s)*s**(-1)*u*mgen2*c0cmzusfff - 
     &    16.D0/(t + s)*mgen2*c0cmzusfff )
      qedamp(1,1,1,3) = qedamp(1,1,1,3) + sqrt(s)*sqrt(t*u)*
     & sr2**(-1)*mz*cqfactor * ( 16.D0*s**(-3)*t**(-1)*u**(-1)*rzm2**3*
     &    b0fmzff - 16.D0*s**(-3)*t**(-1)*u**(-1)*rzm2**3*b0fusff + 32.D
     &    0*s**(-3)*t**(-1)*rzm2**2*b0fmzff - 32.D0*s**(-3)*t**(-1)*
     &    rzm2**2*b0fusff - 16.D0*s**(-3)*t**(-1)*u*rzm2*b0fmzff + 16.D0
     &    *s**(-3)*t**(-1)*u*rzm2*b0fusff + 16.D0*s**(-3)*u**(-1)*
     &    rzm2**2*b0fmzff - 16.D0*s**(-3)*u**(-1)*rzm2**2*b0ftsff - 32.D
     &    0*s**(-3)*t*u**(-1)*rzm2*b0fmzff + 32.D0*s**(-3)*t*u**(-1)*
     &    rzm2*b0ftsff + 16.D0*s**(-3)*t**2*u**(-1)*b0fmzff - 16.D0*
     &    s**(-3)*t**2*u**(-1)*b0ftsff - 8.D0*s**(-2)*t**(-2)*u**(-1)*
     &    rzm2**3*b0fmzff + 8.D0*s**(-2)*t**(-2)*u**(-1)*rzm2**3*
     &    b0fusff - 16.D0*s**(-2)*t**(-2)*rzm2**2*b0fmzff + 16.D0*
     &    s**(-2)*t**(-2)*rzm2**2*b0fusff + 8.D0*s**(-2)*t**(-2)*u*rzm2
     &    *b0fmzff - 8.D0*s**(-2)*t**(-2)*u*rzm2*b0fusff + 8.D0*s**(-2)
     &    *t**(-1)*u**(-1)*rzm2**2 + 24.D0*s**(-2)*t**(-1)*u**(-1)*
     &    rzm2**2*b0fmzff - 8.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*
     &    b0fusff - 16.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*b0ftsff - 16.D
     &    0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*mgen2*c0cmzusfff + 16.D0*
     &    s**(-2)*t**(-1)*rzm2 - 16.D0*s**(-2)*t**(-1)*rzm2*b0fmzff + 
     &    16.D0*s**(-2)*t**(-1)*rzm2*b0fusff - 32.D0*s**(-2)*t**(-1)*
     &    rzm2*mgen2*c0cmzusfff - 8.D0*s**(-2)*t**(-1)*u + 8.D0*s**(-2)
     &    *t**(-1)*u*b0fmzff - 8.D0*s**(-2)*t**(-1)*u*b0fusff + 16.D0*
     &    s**(-2)*t**(-1)*u*mgen2*c0cmzusfff - 8.D0*s**(-2)*u**(-2)*
     &    rzm2**2*b0fmzff + 8.D0*s**(-2)*u**(-2)*rzm2**2*b0ftsff + 8.D0
     &    *s**(-2)*u**(-1)*rzm2 - 16.D0*s**(-2)*u**(-1)*rzm2*b0fmzff + 
     &    16.D0*s**(-2)*u**(-1)*rzm2*b0ftsff - 16.D0*s**(-2)*u**(-1)*
     &    rzm2*mgen2*c0cmztsfff + 8.D0*s**(-2)*rzm2*c0cmztsfff - 8.D0*
     &    s**(-2)*rzm2*c0ccusfff + 16.D0*s**(-2)*t*u**(-2)*rzm2*b0fmzff
     &     - 16.D0*s**(-2)*t*u**(-2)*rzm2*b0ftsff - 16.D0*s**(-2)*t*
     &    u**(-1) + 32.D0*s**(-2)*t*u**(-1)*mgen2*c0cmztsfff + 8.D0*
     &    s**(-2)*t*c0cmzusfff - 8.D0*s**(-2)*t*c0cmztsfff + 8.D0*
     &    s**(-2)*t*c0ccusfff - 8.D0*s**(-2)*t*c0cctsfff - 8.D0*s**(-2)
     &    *t*rzm2*d0cccmztsusffff - 8.D0*s**(-2)*t**2*u**(-2)*b0fmzff
     &     + 8.D0*s**(-2)*t**2*u**(-2)*b0ftsff + 8.D0*s**(-2)*t**2*
     &    d0cccmztsusffff - 8.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**2 + 8.D0
     &    *s**(-1)*t**(-2)*u**(-1)*rzm2**2*b0fmzff - 8.D0*s**(-1)*
     &    t**(-2)*u**(-1)*rzm2**2*b0fusff + 16.D0*s**(-1)*t**(-2)*
     &    u**(-1)*rzm2**2*mgen2*c0cmzusfff - 16.D0*s**(-1)*t**(-2)*rzm2
     &     + 8.D0*s**(-1)*t**(-2)*rzm2*b0fmzff - 8.D0*s**(-1)*t**(-2)*
     &    rzm2*b0fusff + 32.D0*s**(-1)*t**(-2)*rzm2*mgen2*c0cmzusfff + 
     &    8.D0*s**(-1)*t**(-2)*u - 16.D0*s**(-1)*t**(-2)*u*mgen2*
     &    c0cmzusfff + 32.D0*s**(-1)*t**(-1)*u**(-1)*rzm2 - 16.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2*b0fmzff + 16.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rzm2*b0fusff - 32.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*
     &    mgen2*c0cmzusfff - 32.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*mgen2*
     &    c0cmztsfff - 8.D0*s**(-1)*t**(-1) - 8.D0*s**(-1)*t**(-1)*
     &    b0fmzff + 8.D0*s**(-1)*t**(-1)*b0fusff + 16.D0*s**(-1)*
     &    t**(-1)*mgen2*c0cmzusfff + 32.D0*s**(-1)*t**(-1)*mgen2*
     &    c0cmztsfff - 32.D0*s**(-1)*t**(-1)*mgen2*c0ccusfff - 8.D0*
     &    s**(-1)*u**(-2)*rzm2 + 8.D0*s**(-1)*u**(-2)*rzm2*b0fmzff - 8.D
     &    0*s**(-1)*u**(-2)*rzm2*b0ftsff + 16.D0*s**(-1)*u**(-2)*rzm2*
     &    mgen2*c0cmztsfff - 8.D0*s**(-1)*u**(-1) - 24.D0*s**(-1)*
     &    u**(-1)*b0fmzff + 24.D0*s**(-1)*u**(-1)*b0ftsff + 16.D0*
     &    s**(-1)*u**(-1)*mgen2*c0cmztsfff + 8.D0*s**(-1)*c0cmzusfff + 
     &    8.D0*s**(-1)*c0ccusfff - 40.D0*s**(-1)*mgen2*d0cccmztsusffff
     &     + 16.D0*s**(-1)*t*u**(-2) - 8.D0*s**(-1)*t*u**(-2)*b0fmzff
     &     + 8.D0*s**(-1)*t*u**(-2)*b0ftsff - 32.D0*s**(-1)*t*u**(-2)*
     &    mgen2*c0cmztsfff + 8.D0*s**(-1)*t*d0cccmztsusffff + 8.D0*
     &    t**(-2)*u**(-1)*rzm2 - 16.D0*t**(-2)*u**(-1)*rzm2*mgen2*
     &    c0cmzusfff + 8.D0*t**(-2) - 16.D0*t**(-2)*mgen2*c0cmzusfff - 
     &    32.D0*t**(-1)*u**(-1) - 16.D0*t**(-1)*u**(-1)*b0fmzff + 16.D0
     &    *t**(-1)*u**(-1)*b0ftsff + 32.D0*t**(-1)*u**(-1)*mgen2*
     &    c0cmzusfff + 16.D0*t**(-1)*u**(-1)*mgen2*c0cmztsfff + 16.D0*
     &    t**(-1)*u**(-1)*mgen2*c0ccqsfff - 8.D0*t**(-1)*mgen2*
     &    d0ccmzcqsusffff + 8.D0*u**(-2) - 16.D0*u**(-2)*mgen2*
     &    c0cmztsfff + 8.D0*u**(-1)*mgen2*d0cccmzqstsffff - 32.D0/(u + 
     &    t)*s**(-3)*t**(-1)*rzm2**3*b0fmzff + 32.D0/(u + t)*s**(-3)*
     &    t**(-1)*rzm2**3*b0fusff + 16.D0/(u + t)*s**(-2)*t**(-2)*
     &    rzm2**3*b0fmzff - 16.D0/(u + t)*s**(-2)*t**(-2)*rzm2**3*
     &    b0fusff - 16.D0/(u + t)*s**(-2)*t**(-1)*rzm2**2 + 16.D0/(u + 
     &    t)*s**(-2)*t**(-1)*rzm2**2*b0fmzff - 16.D0/(u + t)*s**(-2)*
     &    t**(-1)*rzm2**2*b0fusff + 32.D0/(u + t)*s**(-2)*t**(-1)*
     &    rzm2**2*mgen2*c0cmzusfff - 16.D0/(u + t)*s**(-2)*rzm2**2*
     &    c0cmztsfff + 16.D0/(u + t)*s**(-2)*rzm2**2*c0ccusfff - 16.D0
     &    /(u + t)*s**(-2)*t*rzm2*c0cmzusfff + 32.D0/(u + t)*s**(-2)*t*
     &    rzm2*c0cmztsfff - 32.D0/(u + t)*s**(-2)*t*rzm2*c0ccusfff + 16.
     &    D0/(u + t)*s**(-2)*t*rzm2*c0cctsfff + 16.D0/(u + t)*s**(-2)*t
     &    *rzm2**2*d0cccmztsusffff + 16.D0/(u + t)*s**(-2)*t**2*
     &    c0cmzusfff - 16.D0/(u + t)*s**(-2)*t**2*c0cmztsfff + 16.D0/(u
     &     + t)*s**(-2)*t**2*c0ccusfff - 16.D0/(u + t)*s**(-2)*t**2*
     &    c0cctsfff - 32.D0/(u + t)*s**(-2)*t**2*rzm2*d0cccmztsusffff
     &     + 16.D0/(u + t)*s**(-2)*t**3*d0cccmztsusffff + 16.D0/(u + t)
     &    *s**(-1)*t**(-2)*rzm2**2 - 16.D0/(u + t)*s**(-1)*t**(-2)*
     &    rzm2**2*b0fmzff + 16.D0/(u + t)*s**(-1)*t**(-2)*rzm2**2*
     &    b0fusff - 32.D0/(u + t)*s**(-1)*t**(-2)*rzm2**2*mgen2*
     &    c0cmzusfff + 32.D0/(u + t)*s**(-1)*t**(-1)*rzm2*b0fmzff - 32.D
     &    0/(u + t)*s**(-1)*t**(-1)*rzm2*b0fusff - 32.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2*mgen2*c0cmztsfff + 32.D0/(u + t)*s**(-1)
     &    *t**(-1)*rzm2*mgen2*c0ccusfff + 32.D0/(u + t)*s**(-1)*b0fusff
     &     - 32.D0/(u + t)*s**(-1)*b0ftsff - 32.D0/(u + t)*s**(-1)*
     &    mgen2*c0cmzusfff + 32.D0/(u + t)*s**(-1)*mgen2*c0cmztsfff - 
     &    32.D0/(u + t)*s**(-1)*mgen2*c0ccusfff + 32.D0/(u + t)*s**(-1)
     &    *mgen2*c0cctsfff - 16.D0/(u + t)*s**(-1)*rzm2*c0cmzusfff + 16.
     &    D0/(u + t)*s**(-1)*rzm2*c0cmztsfff - 32.D0/(u + t)*s**(-1)*
     &    rzm2*c0ccusfff + 64.D0/(u + t)*s**(-1)*rzm2*mgen2*
     &    d0cccmztsusffff + 32.D0/(u + t)*s**(-1)*t*c0cmzusfff - 16.D0
     &    /(u + t)*s**(-1)*t*c0cmztsfff + 32.D0/(u + t)*s**(-1)*t*
     &    c0ccusfff - 16.D0/(u + t)*s**(-1)*t*c0cctsfff - 64.D0/(u + t)
     &    *s**(-1)*t*mgen2*d0cccmztsusffff - 32.D0/(u + t)*s**(-1)*t*
     &    rzm2*d0cccmztsusffff + 32.D0/(u + t)*s**(-1)*t**2*
     &    d0cccmztsusffff - 16.D0/(u + t)*t**(-2)*rzm2 + 32.D0/(u + t)*
     &    t**(-2)*rzm2*mgen2*c0cmzusfff + 32.D0/(u + t)*t**(-1) + 16.D0
     &    /(u + t)*t**(-1)*b0fusff - 16.D0/(u + t)*t**(-1)*b0ftsff - 16.
     &    D0/(u + t)*t**(-1)*mgen2*c0cmzusfff + 16.D0/(u + t)*t**(-1)*
     &    mgen2*c0cmztsfff - 32.D0/(u + t)*t**(-1)*mgen2*c0ccusfff - 32.
     &    D0/(u + t)*t**(-1)*mgen2*c0ccqsfff + 16.D0/(u + t)*c0cmzusfff
     &     + 16.D0/(u + t)*c0ccusfff - 64.D0/(u + t)*mgen2*
     &    d0cccmztsusffff + 16.D0/(u + t)*t*d0cccmztsusffff - 16.D0/(u
     &     + t)/(u + s)*t**(-1)*rzm2 + 32.D0/(u + t)/(u + s)*t**(-1)*
     &    rzm2*mgen2*c0cmztsfff - 16.D0/(u + t)/(u + s)/(u + s)*t**(-1)
     &    *rzm2**2*b0fmzff + 16.D0/(u + t)/(u + s)/(u + s)*t**(-1)*
     &    rzm2**2*b0ftsff + 32.D0/(u + t)/(t + s)*s**(-3)*rzm2**3*
     &    b0fmzff - 32.D0/(u + t)/(t + s)*s**(-3)*rzm2**3*b0fusff + 16.D
     &    0/(u + t)/(t + s)*s**(-2)*rzm2**2 - 16.D0/(u + t)/(t + s)*
     &    s**(-2)*rzm2**2*b0fmzff + 16.D0/(u + t)/(t + s)*s**(-2)*
     &    rzm2**2*b0fusff - 32.D0/(u + t)/(t + s)*s**(-2)*rzm2**2*mgen2
     &    *c0cmzusfff + 16.D0/(u + t)/(t + s)/(t + s)*s**(-2)*rzm2**3*
     &    b0fmzff - 16.D0/(u + t)/(t + s)/(t + s)*s**(-2)*rzm2**3*
     &    b0fusff - 16.D0/(u + s)*s**(-3)*rzm2**2*b0fmzff + 16.D0/(u + 
     &    s)*s**(-3)*rzm2**2*b0ftsff + 32.D0/(u + s)*s**(-3)*t*rzm2*
     &    b0fmzff - 32.D0/(u + s)*s**(-3)*t*rzm2*b0ftsff - 16.D0/(u + s
     &    )*s**(-3)*t**2*b0fmzff + 16.D0/(u + s)*s**(-3)*t**2*b0ftsff
     &     - 16.D0/(u + s)*s**(-2)*t**(-1)*rzm2**2*b0fmzff + 16.D0/(u
     &     + s)*s**(-2)*t**(-1)*rzm2**2*b0ftsff - 8.D0/(u + s)*s**(-2)*
     &    rzm2 + 16.D0/(u + s)*s**(-2)*rzm2*b0fmzff - 16.D0/(u + s)*
     &    s**(-2)*rzm2*b0ftsff + 16.D0/(u + s)*s**(-2)*rzm2*mgen2*
     &    c0cmztsfff + 16.D0/(u + s)*s**(-2)*t - 32.D0/(u + s)*s**(-2)*
     &    t*mgen2*c0cmztsfff - 16.D0/(u + s)*s**(-1)*t**(-1)*rzm2 + 32.D
     &    0/(u + s)*s**(-1)*t**(-1)*rzm2*mgen2*c0cmztsfff + 8.D0/(u + s
     &    )*s**(-1) + 8.D0/(u + s)*s**(-1)*b0fmzff - 8.D0/(u + s)*
     &    s**(-1)*b0ftsff - 16.D0/(u + s)*s**(-1)*mgen2*c0cmztsfff - 8.D
     &    0/(u + s)/(u + s)*s**(-2)*rzm2**2*b0fmzff + 8.D0/(u + s)/(u
     &     + s)*s**(-2)*rzm2**2*b0ftsff + 16.D0/(u + s)/(u + s)*s**(-2)
     &    *t*rzm2*b0fmzff - 16.D0/(u + s)/(u + s)*s**(-2)*t*rzm2*
     &    b0ftsff - 8.D0/(u + s)/(u + s)*s**(-2)*t**2*b0fmzff + 8.D0/(u
     &     + s)/(u + s)*s**(-2)*t**2*b0ftsff - 16.D0/(u + s)/(u + s)*
     &    s**(-1)*t**(-1)*rzm2**2*b0fmzff + 16.D0/(u + s)/(u + s)*
     &    s**(-1)*t**(-1)*rzm2**2*b0ftsff + 8.D0/(u + s)/(u + s)*
     &    s**(-1)*rzm2*b0fmzff - 8.D0/(u + s)/(u + s)*s**(-1)*rzm2*
     &    b0ftsff + 8.D0/(u + s)/(u + s)*s**(-1)*t*b0fmzff - 8.D0/(u + 
     &    s)/(u + s)*s**(-1)*t*b0ftsff - 16.D0/(t + s)*s**(-3)*u**(-1)*
     &    rzm2**3*b0fmzff + 16.D0/(t + s)*s**(-3)*u**(-1)*rzm2**3*
     &    b0fusff - 32.D0/(t + s)*s**(-3)*rzm2**2*b0fmzff + 32.D0/(t + 
     &    s)*s**(-3)*rzm2**2*b0fusff + 16.D0/(t + s)*s**(-3)*u*rzm2*
     &    b0fmzff - 16.D0/(t + s)*s**(-3)*u*rzm2*b0fusff - 8.D0/(t + s)
     &    *s**(-2)*u**(-1)*rzm2**2 - 8.D0/(t + s)*s**(-2)*u**(-1)*
     &    rzm2**2*b0fmzff + 8.D0/(t + s)*s**(-2)*u**(-1)*rzm2**2*
     &    b0fusff + 16.D0/(t + s)*s**(-2)*u**(-1)*rzm2**2*mgen2*
     &    c0cmzusfff - 16.D0/(t + s)*s**(-2)*rzm2 + 16.D0/(t + s)*
     &    s**(-2)*rzm2*b0fmzff - 16.D0/(t + s)*s**(-2)*rzm2*b0fusff + 
     &    32.D0/(t + s)*s**(-2)*rzm2*mgen2*c0cmzusfff + 8.D0/(t + s)*
     &    s**(-2)*u - 8.D0/(t + s)*s**(-2)*u*b0fmzff + 8.D0/(t + s)*
     &    s**(-2)*u*b0fusff - 16.D0/(t + s)*s**(-2)*u*mgen2*c0cmzusfff
     &     - 16.D0/(t + s)*s**(-1)*u**(-1)*rzm2 + 16.D0/(t + s)*s**(-1)
     &    *u**(-1)*rzm2*b0fmzff - 16.D0/(t + s)*s**(-1)*u**(-1)*rzm2*
     &    b0fusff + 32.D0/(t + s)*s**(-1)*u**(-1)*rzm2*mgen2*c0cmzusfff
     &     + 8.D0/(t + s)*s**(-1) - 8.D0/(t + s)*s**(-1)*b0fmzff + 8.D0
     &    /(t + s)*s**(-1)*b0fusff - 16.D0/(t + s)*s**(-1)*mgen2*
     &    c0cmzusfff - 8.D0/(t + s)*u**(-1) + 8.D0/(t + s)*u**(-1)*
     &    b0fmzff - 8.D0/(t + s)*u**(-1)*b0fusff + 16.D0/(t + s)*
     &    u**(-1)*mgen2*c0cmzusfff - 8.D0/(t + s)/(t + s)*s**(-2)*
     &    u**(-1)*rzm2**3*b0fmzff + 8.D0/(t + s)/(t + s)*s**(-2)*
     &    u**(-1)*rzm2**3*b0fusff - 16.D0/(t + s)/(t + s)*s**(-2)*
     &    rzm2**2*b0fmzff + 16.D0/(t + s)/(t + s)*s**(-2)*rzm2**2*
     &    b0fusff + 8.D0/(t + s)/(t + s)*s**(-2)*u*rzm2*b0fmzff - 8.D0
     &    /(t + s)/(t + s)*s**(-2)*u*rzm2*b0fusff - 16.D0/(t + s)/(t + 
     &    s)*s**(-1)*u**(-1)*rzm2**2*b0fmzff + 16.D0/(t + s)/(t + s)*
     &    s**(-1)*u**(-1)*rzm2**2*b0fusff + 8.D0/(t + s)/(t + s)*
     &    s**(-1)*rzm2*b0fmzff - 8.D0/(t + s)/(t + s)*s**(-1)*rzm2*
     &    b0fusff - 8.D0/(t + s)/(t + s)*s**(-1)*u*b0fmzff + 8.D0/(t + 
     &    s)/(t + s)*s**(-1)*u*b0fusff )
      qedamp(1,1,1,3) = qedamp(1,1,1,3) + sqrt(s)*sqrt(t*u)*
     & sr2**(-1)*mz*cqfactor * (  - 8.D0/(t + s)/(t + s)*u**(-1)*rzm2*
     &    b0fmzff + 8.D0/(t + s)/(t + s)*u**(-1)*rzm2*b0fusff + 8.D0/(t
     &     + s)/(t + s)*b0fmzff - 8.D0/(t + s)/(t + s)*b0fusff )

      qedamp(1,1,2,1) = qedamp(1,1,2,1)
     &  + cqfactor * ( 32.D0 + 16.D0*s**(-2)*t**(-1)*rzm2**3*b0fmzff - 
     &    16.D0*s**(-2)*t**(-1)*rzm2**3*b0fusff - 8.D0*s**(-2)*t**(-1)*
     &    u*rzm2**2*b0fmzff + 8.D0*s**(-2)*t**(-1)*u*rzm2**2*b0fusff - 
     &    8.D0*s**(-2)*u**(-1)*rzm2**3*b0fmzff + 8.D0*s**(-2)*u**(-1)*
     &    rzm2**3*b0ftsff + 16.D0*s**(-2)*t*u**(-1)*rzm2**2*b0fmzff - 
     &    16.D0*s**(-2)*t*u**(-1)*rzm2**2*b0ftsff - 8.D0*s**(-2)*t**2*
     &    u**(-1)*rzm2*b0fmzff + 8.D0*s**(-2)*t**2*u**(-1)*rzm2*b0ftsff
     &     + 16.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0fmzff - 16.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0ftsff + 16.D0*s**(-1)*
     &    t**(-1)*rzm2**2 - 40.D0*s**(-1)*t**(-1)*rzm2**2*b0fmzff + 40.D
     &    0*s**(-1)*t**(-1)*rzm2**2*b0fusff - 32.D0*s**(-1)*t**(-1)*
     &    rzm2**2*mgen2*c0cmzusfff - 8.D0*s**(-1)*t**(-1)*u*rzm2 + 16.D0
     &    *s**(-1)*t**(-1)*u*rzm2*b0fmzff - 16.D0*s**(-1)*t**(-1)*u*
     &    rzm2*b0fusff + 16.D0*s**(-1)*t**(-1)*u*rzm2*mgen2*c0cmzusfff
     &     - 8.D0*s**(-1)*u**(-1)*rzm2**2 - 24.D0*s**(-1)*u**(-1)*
     &    rzm2**2*b0fmzff + 24.D0*s**(-1)*u**(-1)*rzm2**2*b0ftsff + 16.D
     &    0*s**(-1)*u**(-1)*rzm2**2*mgen2*c0cmztsfff + 16.D0*s**(-1)*t*
     &    u**(-1)*rzm2 + 8.D0*s**(-1)*t*u**(-1)*rzm2*b0fmzff - 8.D0*
     &    s**(-1)*t*u**(-1)*rzm2*b0ftsff - 32.D0*s**(-1)*t*u**(-1)*rzm2
     &    *mgen2*c0cmztsfff - 8.D0*s**(-1)*t*rzm2*c0cmztsfff + 8.D0*
     &    s**(-1)*t*rzm2*c0ccusfff - 8.D0*s**(-1)*t**2*u**(-1) + 16.D0*
     &    s**(-1)*t**2*u**(-1)*mgen2*c0cmztsfff - 8.D0*s**(-1)*t**2*
     &    c0cmzusfff + 16.D0/3.D0*s**(-1)*t**2*c0cmztsfff - 16.D0/3.D0*
     &    s**(-1)*t**2*c0ccusfff + 8.D0*s**(-1)*t**2*c0cctsfff + 8.D0*
     &    s**(-1)*t**2*rzm2*d0cccmztsusffff - 8.D0/3.D0*s**(-1)*t**3*
     &    rzm2**(-1)*c0cmzusfff + 8.D0/3.D0*s**(-1)*t**3*rzm2**(-1)*
     &    c0cmztsfff - 8.D0/3.D0*s**(-1)*t**3*rzm2**(-1)*c0ccusfff + 8.D
     &    0/3.D0*s**(-1)*t**3*rzm2**(-1)*c0cctsfff - 16.D0/3.D0*s**(-1)
     &    *t**3*d0cccmztsusffff - 8.D0/3.D0*s**(-1)*t**4*rzm2**(-1)*
     &    d0cccmztsusffff - 16.D0*t**(-1)*u**(-1)*rzm2**2*b0fmzff + 16.D
     &    0*t**(-1)*u**(-1)*rzm2**2*b0ftsff - 8.D0*t**(-1)*rzm2 + 16.D0
     &    *t**(-1)*rzm2*b0fmzff - 16.D0*t**(-1)*rzm2*b0fusff + 24.D0*
     &    t**(-1)*rzm2*mgen2*c0cmzusfff - 8.D0*t**(-1)*rzm2*mgen2*
     &    c0ccqsfff - 8.D0*t**(-1)*u*mgen2*c0cmzusfff + 8.D0*t**(-1)*u*
     &    mgen2*c0cmzqsfff - 8.D0*t**(-1)*u*mgen2*c0ccusfff + 8.D0*
     &    t**(-1)*u*mgen2*c0ccqsfff - 8.D0*t**(-1)*u*rzm2*mgen2*
     &    d0ccmzcqsusffff + 8.D0*t**(-1)*u**2*mgen2*d0ccmzcqsusffff + 8.
     &    D0*u**(-1)*rzm2 + 16.D0*u**(-1)*rzm2*b0fmzff - 16.D0*u**(-1)*
     &    rzm2*b0ftsff - 8.D0*u**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0*
     &    u**(-1)*rzm2*mgen2*c0ccqsfff - 24.D0*mgen2*c0cmzusfff - 16.D0
     &    *mgen2*c0cmztsfff + 16.D0*mgen2*c0cmzqsfff - 8.D0*mgen2*
     &    c0ccusfff - 16.D0*mgen2*c0cctsfff - 16.D0*mgen2**2*
     &    d0cccmztsusffff - 16.D0*mgen2**2*d0ccmzcqsusffff - 16.D0*
     &    mgen2**2*d0cccmzqstsffff + 8.D0*u*mgen2*d0ccmzcqsusffff - 8.D0
     &    *t*u**(-1) + 8.D0*t*u**(-1)*mgen2*c0cmztsfff + 8.D0*t*u**(-1)
     &    *mgen2*c0cmzqsfff - 8.D0*t*u**(-1)*mgen2*c0cctsfff + 8.D0*t*
     &    u**(-1)*mgen2*c0ccqsfff - 8.D0*t*u**(-1)*rzm2*mgen2*
     &    d0cccmzqstsffff + 8.D0*t*mgen2*d0cccmztsusffff + 8.D0*t*mgen2
     &    *d0cccmzqstsffff + 8.D0*t**2*u**(-1)*mgen2*d0cccmzqstsffff - 
     &    8.D0/(u + t)*s**(-2)*t**(-1)*rzm2**4*b0fmzff + 8.D0/(u + t)*
     &    s**(-2)*t**(-1)*rzm2**4*b0fusff - 8.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**3 + 24.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*
     &    b0fmzff - 24.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*b0fusff + 16.D
     &    0/(u + t)*s**(-1)*t**(-1)*rzm2**3*mgen2*c0cmzusfff + 8.D0/(u
     &     + t)*s**(-1)*t*rzm2**2*c0cmztsfff - 8.D0/(u + t)*s**(-1)*t*
     &    rzm2**2*c0ccusfff + 8.D0/(u + t)*s**(-1)*t**2*rzm2*c0cmzusfff
     &     - 16.D0/3.D0/(u + t)*s**(-1)*t**2*rzm2*c0cmztsfff + 16.D0/3.D
     &    0/(u + t)*s**(-1)*t**2*rzm2*c0ccusfff - 8.D0/(u + t)*s**(-1)*
     &    t**2*rzm2*c0cctsfff - 8.D0/(u + t)*s**(-1)*t**2*rzm2**2*
     &    d0cccmztsusffff + 8.D0/3.D0/(u + t)*s**(-1)*t**3*c0cmzusfff
     &     - 8.D0/3.D0/(u + t)*s**(-1)*t**3*c0cmztsfff + 8.D0/3.D0/(u
     &     + t)*s**(-1)*t**3*c0ccusfff - 8.D0/3.D0/(u + t)*s**(-1)*t**3
     &    *c0cctsfff + 16.D0/3.D0/(u + t)*s**(-1)*t**3*rzm2*
     &    d0cccmztsusffff + 8.D0/3.D0/(u + t)*s**(-1)*t**4*
     &    d0cccmztsusffff + 8.D0/(u + t)*t**(-1)*rzm2**2 + 16.D0/(u + t
     &    )*t**(-1)*rzm2**2*b0fusff - 16.D0/(u + t)*t**(-1)*rzm2**2*
     &    b0ftsff - 16.D0/(u + t)*t**(-1)*rzm2**2*mgen2*c0cmzusfff - 16.
     &    D0/(u + t)*rzm2 - 8.D0/(u + t)*rzm2*mgen2*c0cmzusfff + 24.D0
     &    /(u + t)*rzm2*mgen2*c0cmztsfff + 16.D0/(u + t)*rzm2*mgen2*
     &    c0ccqsfff - 8.D0/(u + t)*t*mgen2*c0cmzusfff + 8.D0/(u + t)*t*
     &    mgen2*c0cmztsfff - 8.D0/(u + t)*t*mgen2*c0ccusfff + 8.D0/(u
     &     + t)*t*mgen2*c0cctsfff - 8.D0/(u + t)*t*rzm2*c0cmztsfff + 8.D
     &    0/(u + t)*t*rzm2*c0ccusfff - 8.D0/(u + t)*t**2*c0cmzusfff + 
     &    16.D0/3.D0/(u + t)*t**2*c0cmztsfff - 16.D0/3.D0/(u + t)*t**2*
     &    c0ccusfff + 8.D0/(u + t)*t**2*c0cctsfff - 8.D0/(u + t)*t**2*
     &    mgen2*d0cccmztsusffff + 8.D0/(u + t)*t**2*rzm2*
     &    d0cccmztsusffff - 8.D0/3.D0/(u + t)*t**3*rzm2**(-1)*
     &    c0cmzusfff + 8.D0/3.D0/(u + t)*t**3*rzm2**(-1)*c0cmztsfff - 8.
     &    D0/3.D0/(u + t)*t**3*rzm2**(-1)*c0ccusfff + 8.D0/3.D0/(u + t)
     &    *t**3*rzm2**(-1)*c0cctsfff - 16.D0/3.D0/(u + t)*t**3*
     &    d0cccmztsusffff - 8.D0/3.D0/(u + t)*t**4*rzm2**(-1)*
     &    d0cccmztsusffff - 16.D0/(u + t)/(u + s)*t**(-1)*rzm2**3*
     &    b0fmzff + 16.D0/(u + t)/(u + s)*t**(-1)*rzm2**3*b0ftsff + 16.D
     &    0/(u + t)/(u + s)*rzm2**2 - 32.D0/(u + t)/(u + s)*rzm2**2*
     &    mgen2*c0cmztsfff - 16.D0/(u + t)/(u + s)*t*rzm2 + 32.D0/(u + 
     &    t)/(u + s)*t*rzm2*mgen2*c0cmztsfff + 16.D0/(u + t)/(u + s)/(u
     &     + s)*rzm2**3*b0fmzff - 16.D0/(u + t)/(u + s)/(u + s)*rzm2**3
     &    *b0ftsff - 16.D0/(u + t)/(u + s)/(u + s)*t*rzm2**2*b0fmzff + 
     &    16.D0/(u + t)/(u + s)/(u + s)*t*rzm2**2*b0ftsff + 8.D0/(u + t
     &    )/(t + s)*s**(-2)*rzm2**4*b0fmzff - 8.D0/(u + t)/(t + s)*
     &    s**(-2)*rzm2**4*b0fusff + 8.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**3 - 24.D0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fmzff + 24.D
     &    0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fusff - 16.D0/(u + t)/(t
     &     + s)*s**(-1)*rzm2**3*mgen2*c0cmzusfff + 8.D0/(u + t)/(t + s)
     &    *rzm2**2 + 16.D0/(u + t)/(t + s)*rzm2**2*b0fmzff - 16.D0/(u
     &     + t)/(t + s)*rzm2**2*b0fusff - 16.D0/(u + t)/(t + s)*rzm2**2
     &    *mgen2*c0cmzusfff - 16.D0/(u + t)/(t + s)*s*rzm2 + 32.D0/(u
     &     + t)/(t + s)*s*rzm2*mgen2*c0cmzusfff + 8.D0/(u + t)/(t + s)
     &    /(t + s)*s**(-1)*rzm2**4*b0fmzff - 8.D0/(u + t)/(t + s)/(t + 
     &    s)*s**(-1)*rzm2**4*b0fusff + 8.D0/(u + t)/(t + s)/(t + s)*
     &    rzm2**3*b0fmzff - 8.D0/(u + t)/(t + s)/(t + s)*rzm2**3*
     &    b0fusff - 16.D0/(u + t)/(t + s)/(t + s)*s*rzm2**2*b0fmzff + 
     &    16.D0/(u + t)/(t + s)/(t + s)*s*rzm2**2*b0fusff + 8.D0/(u + s
     &    )*s**(-2)*rzm2**3*b0fmzff - 8.D0/(u + s)*s**(-2)*rzm2**3*
     &    b0ftsff - 16.D0/(u + s)*s**(-2)*t*rzm2**2*b0fmzff + 16.D0/(u
     &     + s)*s**(-2)*t*rzm2**2*b0ftsff + 8.D0/(u + s)*s**(-2)*t**2*
     &    rzm2*b0fmzff - 8.D0/(u + s)*s**(-2)*t**2*rzm2*b0ftsff - 16.D0
     &    /(u + s)*s**(-1)*t**(-1)*rzm2**3*b0fmzff + 16.D0/(u + s)*
     &    s**(-1)*t**(-1)*rzm2**3*b0ftsff + 8.D0/(u + s)*s**(-1)*
     &    rzm2**2 + 24.D0/(u + s)*s**(-1)*rzm2**2*b0fmzff - 24.D0/(u + 
     &    s)*s**(-1)*rzm2**2*b0ftsff - 16.D0/(u + s)*s**(-1)*rzm2**2*
     &    mgen2*c0cmztsfff - 16.D0/(u + s)*s**(-1)*t*rzm2 - 8.D0/(u + s
     &    )*s**(-1)*t*rzm2*b0fmzff + 8.D0/(u + s)*s**(-1)*t*rzm2*
     &    b0ftsff + 32.D0/(u + s)*s**(-1)*t*rzm2*mgen2*c0cmztsfff + 8.D0
     &    /(u + s)*s**(-1)*t**2 - 16.D0/(u + s)*s**(-1)*t**2*mgen2*
     &    c0cmztsfff - 8.D0/(u + s)*rzm2 + 8.D0/(u + s)*rzm2*b0fmzff - 
     &    8.D0/(u + s)*rzm2*b0ftsff + 16.D0/(u + s)*rzm2*mgen2*
     &    c0cmztsfff + 8.D0/(u + s)*t - 16.D0/(u + s)*t*mgen2*
     &    c0cmztsfff + 8.D0/(u + s)/(u + s)*s**(-1)*rzm2**3*b0fmzff - 8.
     &    D0/(u + s)/(u + s)*s**(-1)*rzm2**3*b0ftsff - 16.D0/(u + s)/(u
     &     + s)*s**(-1)*t*rzm2**2*b0fmzff + 16.D0/(u + s)/(u + s)*
     &    s**(-1)*t*rzm2**2*b0ftsff + 8.D0/(u + s)/(u + s)*s**(-1)*t**2
     &    *rzm2*b0fmzff - 8.D0/(u + s)/(u + s)*s**(-1)*t**2*rzm2*
     &    b0ftsff - 8.D0/(u + s)/(u + s)*rzm2**2*b0fmzff + 8.D0/(u + s)
     &    /(u + s)*rzm2**2*b0ftsff + 8.D0/(u + s)/(u + s)*t*rzm2*
     &    b0fmzff - 8.D0/(u + s)/(u + s)*t*rzm2*b0ftsff - 16.D0/(t + s)
     &    *s**(-2)*rzm2**3*b0fmzff + 16.D0/(t + s)*s**(-2)*rzm2**3*
     &    b0fusff + 8.D0/(t + s)*s**(-2)*u*rzm2**2*b0fmzff - 8.D0/(t + 
     &    s)*s**(-2)*u*rzm2**2*b0fusff - 16.D0/(t + s)*s**(-1)*rzm2**2
     &     + 40.D0/(t + s)*s**(-1)*rzm2**2*b0fmzff - 40.D0/(t + s)*
     &    s**(-1)*rzm2**2*b0fusff + 32.D0/(t + s)*s**(-1)*rzm2**2*mgen2
     &    *c0cmzusfff + 8.D0/(t + s)*s**(-1)*u*rzm2 - 16.D0/(t + s)*
     &    s**(-1)*u*rzm2*b0fmzff + 16.D0/(t + s)*s**(-1)*u*rzm2*b0fusff
     &     - 16.D0/(t + s)*s**(-1)*u*rzm2*mgen2*c0cmzusfff - 32.D0/(t
     &     + s)*rzm2 + 16.D0/(t + s)*rzm2*b0fmzff - 16.D0/(t + s)*rzm2*
     &    b0fusff + 64.D0/(t + s)*rzm2*mgen2*c0cmzusfff + 16.D0/(t + s)
     &    *u - 32.D0/(t + s)*u*mgen2*c0cmzusfff - 16.D0/(t + s)/(t + s)
     &    *s**(-1)*rzm2**3*b0fmzff + 16.D0/(t + s)/(t + s)*s**(-1)*
     &    rzm2**3*b0fusff + 8.D0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*
     &    b0fmzff - 8.D0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*b0fusff - 32.
     &    D0/(t + s)/(t + s)*rzm2**2*b0fmzff + 32.D0/(t + s)/(t + s)*
     &    rzm2**2*b0fusff + 16.D0/(t + s)/(t + s)*u*rzm2*b0fmzff - 16.D0
     &    /(t + s)/(t + s)*u*rzm2*b0fusff )

      qedamp(1,1,2,2) = qedamp(1,1,2,2)
     &  + cqfactor * (  - 24.D0 - 24.D0*s**(-2)*t**(-1)*rzm2**3*b0fmzff
     &     + 24.D0*s**(-2)*t**(-1)*rzm2**3*b0fusff + 24.D0*s**(-2)*
     &    t**(-1)*u*rzm2**2*b0fmzff - 24.D0*s**(-2)*t**(-1)*u*rzm2**2*
     &    b0fusff - 8.D0*s**(-2)*t**(-1)*u**2*rzm2*b0fmzff + 8.D0*
     &    s**(-2)*t**(-1)*u**2*rzm2*b0fusff + 8.D0*s**(-2)*u**(-1)*
     &    rzm2**3*b0fmzff - 8.D0*s**(-2)*u**(-1)*rzm2**3*b0ftsff - 16.D0
     &    *s**(-2)*t*u**(-1)*rzm2**2*b0fmzff + 16.D0*s**(-2)*t*u**(-1)*
     &    rzm2**2*b0ftsff + 8.D0*s**(-2)*t**2*u**(-1)*rzm2*b0fmzff - 8.D
     &    0*s**(-2)*t**2*u**(-1)*rzm2*b0ftsff - 16.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rzm2**3*b0fmzff + 16.D0*s**(-1)*t**(-1)*u**(-1)*
     &    rzm2**3*b0ftsff - 24.D0*s**(-1)*t**(-1)*rzm2**2 + 48.D0*
     &    s**(-1)*t**(-1)*rzm2**2*b0fmzff - 48.D0*s**(-1)*t**(-1)*
     &    rzm2**2*b0fusff + 48.D0*s**(-1)*t**(-1)*rzm2**2*mgen2*
     &    c0cmzusfff + 24.D0*s**(-1)*t**(-1)*u*rzm2 - 24.D0*s**(-1)*
     &    t**(-1)*u*rzm2*b0fmzff + 24.D0*s**(-1)*t**(-1)*u*rzm2*b0fusff
     &     - 48.D0*s**(-1)*t**(-1)*u*rzm2*mgen2*c0cmzusfff - 8.D0*
     &    s**(-1)*t**(-1)*u**2 + 16.D0*s**(-1)*t**(-1)*u**2*mgen2*
     &    c0cmzusfff + 8.D0*s**(-1)*u**(-1)*rzm2**2 + 24.D0*s**(-1)*
     &    u**(-1)*rzm2**2*b0fmzff - 24.D0*s**(-1)*u**(-1)*rzm2**2*
     &    b0ftsff - 16.D0*s**(-1)*u**(-1)*rzm2**2*mgen2*c0cmztsfff + 8.D
     &    0*s**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0*s**(-1)*rzm2*mgen2*
     &    c0ccusfff - 16.D0*s**(-1)*t*u**(-1)*rzm2 - 8.D0*s**(-1)*t*
     &    u**(-1)*rzm2*b0fmzff + 8.D0*s**(-1)*t*u**(-1)*rzm2*b0ftsff + 
     &    32.D0*s**(-1)*t*u**(-1)*rzm2*mgen2*c0cmztsfff + 8.D0*s**(-1)*
     &    t*mgen2*c0cmzusfff - 8.D0*s**(-1)*t*mgen2*c0cmztsfff + 8.D0*
     &    s**(-1)*t*mgen2*c0ccusfff - 8.D0*s**(-1)*t*mgen2*c0cctsfff + 
     &    8.D0*s**(-1)*t*rzm2*c0cmztsfff - 8.D0*s**(-1)*t*rzm2*
     &    c0ccusfff - 8.D0*s**(-1)*t*rzm2*mgen2*d0cccmztsusffff + 8.D0*
     &    s**(-1)*t**2*u**(-1) - 16.D0*s**(-1)*t**2*u**(-1)*mgen2*
     &    c0cmztsfff + 8.D0*s**(-1)*t**2*c0cmzusfff - 16.D0/3.D0*
     &    s**(-1)*t**2*c0cmztsfff + 16.D0/3.D0*s**(-1)*t**2*c0ccusfff
     &     - 8.D0*s**(-1)*t**2*c0cctsfff + 8.D0*s**(-1)*t**2*mgen2*
     &    d0cccmztsusffff - 8.D0*s**(-1)*t**2*rzm2*d0cccmztsusffff + 8.D
     &    0/3.D0*s**(-1)*t**3*rzm2**(-1)*c0cmzusfff - 8.D0/3.D0*s**(-1)
     &    *t**3*rzm2**(-1)*c0cmztsfff + 8.D0/3.D0*s**(-1)*t**3*
     &    rzm2**(-1)*c0ccusfff - 8.D0/3.D0*s**(-1)*t**3*rzm2**(-1)*
     &    c0cctsfff + 16.D0/3.D0*s**(-1)*t**3*d0cccmztsusffff + 8.D0/3.D
     &    0*s**(-1)*t**4*rzm2**(-1)*d0cccmztsusffff + 16.D0*t**(-1)*
     &    u**(-1)*rzm2**2*b0fmzff - 16.D0*t**(-1)*u**(-1)*rzm2**2*
     &    b0ftsff + 16.D0*t**(-1)*rzm2 - 16.D0*t**(-1)*rzm2*b0fmzff + 
     &    16.D0*t**(-1)*rzm2*b0fusff - 32.D0*t**(-1)*rzm2*mgen2*
     &    c0cmzusfff - 8.D0*t**(-1)*u + 16.D0*t**(-1)*u*mgen2*
     &    c0cmzusfff - 8.D0*u**(-1)*rzm2 - 16.D0*u**(-1)*rzm2*b0fmzff
     &     + 16.D0*u**(-1)*rzm2*b0ftsff + 16.D0*u**(-1)*rzm2*mgen2*
     &    c0cmztsfff + 48.D0*mgen2*c0cmzusfff + 16.D0*mgen2*c0cmztsfff
     &     - 16.D0*mgen2**2*d0cccmztsusffff - 16.D0*mgen2**2*
     &    d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff + 8.D0*t*
     &    u**(-1) - 16.D0*t*u**(-1)*mgen2*c0cmztsfff + 8.D0/(u + t)*
     &    s**(-2)*t**(-1)*rzm2**4*b0fmzff - 8.D0/(u + t)*s**(-2)*
     &    t**(-1)*rzm2**4*b0fusff + 8.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2**3 - 24.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*b0fmzff + 24.D
     &    0/(u + t)*s**(-1)*t**(-1)*rzm2**3*b0fusff - 16.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2**3*mgen2*c0cmzusfff - 8.D0/(u + t)*
     &    s**(-1)*t*rzm2**2*c0cmztsfff + 8.D0/(u + t)*s**(-1)*t*rzm2**2
     &    *c0ccusfff - 8.D0/(u + t)*s**(-1)*t**2*rzm2*c0cmzusfff + 16.D0
     &    /3.D0/(u + t)*s**(-1)*t**2*rzm2*c0cmztsfff - 16.D0/3.D0/(u + 
     &    t)*s**(-1)*t**2*rzm2*c0ccusfff + 8.D0/(u + t)*s**(-1)*t**2*
     &    rzm2*c0cctsfff + 8.D0/(u + t)*s**(-1)*t**2*rzm2**2*
     &    d0cccmztsusffff - 8.D0/3.D0/(u + t)*s**(-1)*t**3*c0cmzusfff
     &     + 8.D0/3.D0/(u + t)*s**(-1)*t**3*c0cmztsfff - 8.D0/3.D0/(u
     &     + t)*s**(-1)*t**3*c0ccusfff + 8.D0/3.D0/(u + t)*s**(-1)*t**3
     &    *c0cctsfff - 16.D0/3.D0/(u + t)*s**(-1)*t**3*rzm2*
     &    d0cccmztsusffff - 8.D0/3.D0/(u + t)*s**(-1)*t**4*
     &    d0cccmztsusffff - 8.D0/(u + t)*t**(-1)*rzm2**2 - 16.D0/(u + t
     &    )*t**(-1)*rzm2**2*b0fusff + 16.D0/(u + t)*t**(-1)*rzm2**2*
     &    b0ftsff + 16.D0/(u + t)*t**(-1)*rzm2**2*mgen2*c0cmzusfff + 16.
     &    D0/(u + t)*rzm2 + 8.D0/(u + t)*rzm2*mgen2*c0cmzusfff - 24.D0
     &    /(u + t)*rzm2*mgen2*c0cmztsfff - 16.D0/(u + t)*rzm2*mgen2*
     &    c0ccqsfff + 8.D0/(u + t)*t*mgen2*c0cmzusfff - 8.D0/(u + t)*t*
     &    mgen2*c0cmztsfff + 8.D0/(u + t)*t*mgen2*c0ccusfff - 8.D0/(u
     &     + t)*t*mgen2*c0cctsfff + 8.D0/(u + t)*t*rzm2*c0cmztsfff - 8.D
     &    0/(u + t)*t*rzm2*c0ccusfff + 8.D0/(u + t)*t**2*c0cmzusfff - 
     &    16.D0/3.D0/(u + t)*t**2*c0cmztsfff + 16.D0/3.D0/(u + t)*t**2*
     &    c0ccusfff - 8.D0/(u + t)*t**2*c0cctsfff + 8.D0/(u + t)*t**2*
     &    mgen2*d0cccmztsusffff - 8.D0/(u + t)*t**2*rzm2*
     &    d0cccmztsusffff + 8.D0/3.D0/(u + t)*t**3*rzm2**(-1)*
     &    c0cmzusfff - 8.D0/3.D0/(u + t)*t**3*rzm2**(-1)*c0cmztsfff + 8.
     &    D0/3.D0/(u + t)*t**3*rzm2**(-1)*c0ccusfff - 8.D0/3.D0/(u + t)
     &    *t**3*rzm2**(-1)*c0cctsfff + 16.D0/3.D0/(u + t)*t**3*
     &    d0cccmztsusffff + 8.D0/3.D0/(u + t)*t**4*rzm2**(-1)*
     &    d0cccmztsusffff + 16.D0/(u + t)/(u + s)*t**(-1)*rzm2**3*
     &    b0fmzff - 16.D0/(u + t)/(u + s)*t**(-1)*rzm2**3*b0ftsff - 16.D
     &    0/(u + t)/(u + s)*rzm2**2 + 32.D0/(u + t)/(u + s)*rzm2**2*
     &    mgen2*c0cmztsfff + 16.D0/(u + t)/(u + s)*t*rzm2 - 32.D0/(u + 
     &    t)/(u + s)*t*rzm2*mgen2*c0cmztsfff - 16.D0/(u + t)/(u + s)/(u
     &     + s)*rzm2**3*b0fmzff + 16.D0/(u + t)/(u + s)/(u + s)*rzm2**3
     &    *b0ftsff + 16.D0/(u + t)/(u + s)/(u + s)*t*rzm2**2*b0fmzff - 
     &    16.D0/(u + t)/(u + s)/(u + s)*t*rzm2**2*b0ftsff - 8.D0/(u + t
     &    )/(t + s)*s**(-2)*rzm2**4*b0fmzff + 8.D0/(u + t)/(t + s)*
     &    s**(-2)*rzm2**4*b0fusff - 8.D0/(u + t)/(t + s)*s**(-1)*
     &    rzm2**3 + 24.D0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fmzff - 24.D
     &    0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fusff + 16.D0/(u + t)/(t
     &     + s)*s**(-1)*rzm2**3*mgen2*c0cmzusfff - 8.D0/(u + t)/(t + s)
     &    *rzm2**2 - 16.D0/(u + t)/(t + s)*rzm2**2*b0fmzff + 16.D0/(u
     &     + t)/(t + s)*rzm2**2*b0fusff + 16.D0/(u + t)/(t + s)*rzm2**2
     &    *mgen2*c0cmzusfff + 16.D0/(u + t)/(t + s)*s*rzm2 - 32.D0/(u
     &     + t)/(t + s)*s*rzm2*mgen2*c0cmzusfff - 8.D0/(u + t)/(t + s)
     &    /(t + s)*s**(-1)*rzm2**4*b0fmzff + 8.D0/(u + t)/(t + s)/(t + 
     &    s)*s**(-1)*rzm2**4*b0fusff - 8.D0/(u + t)/(t + s)/(t + s)*
     &    rzm2**3*b0fmzff + 8.D0/(u + t)/(t + s)/(t + s)*rzm2**3*
     &    b0fusff + 16.D0/(u + t)/(t + s)/(t + s)*s*rzm2**2*b0fmzff - 
     &    16.D0/(u + t)/(t + s)/(t + s)*s*rzm2**2*b0fusff - 8.D0/(u + s
     &    )*s**(-2)*rzm2**3*b0fmzff + 8.D0/(u + s)*s**(-2)*rzm2**3*
     &    b0ftsff + 16.D0/(u + s)*s**(-2)*t*rzm2**2*b0fmzff - 16.D0/(u
     &     + s)*s**(-2)*t*rzm2**2*b0ftsff - 8.D0/(u + s)*s**(-2)*t**2*
     &    rzm2*b0fmzff + 8.D0/(u + s)*s**(-2)*t**2*rzm2*b0ftsff + 16.D0
     &    /(u + s)*s**(-1)*t**(-1)*rzm2**3*b0fmzff - 16.D0/(u + s)*
     &    s**(-1)*t**(-1)*rzm2**3*b0ftsff - 8.D0/(u + s)*s**(-1)*
     &    rzm2**2 - 24.D0/(u + s)*s**(-1)*rzm2**2*b0fmzff + 24.D0/(u + 
     &    s)*s**(-1)*rzm2**2*b0ftsff + 16.D0/(u + s)*s**(-1)*rzm2**2*
     &    mgen2*c0cmztsfff + 16.D0/(u + s)*s**(-1)*t*rzm2 + 8.D0/(u + s
     &    )*s**(-1)*t*rzm2*b0fmzff - 8.D0/(u + s)*s**(-1)*t*rzm2*
     &    b0ftsff - 32.D0/(u + s)*s**(-1)*t*rzm2*mgen2*c0cmztsfff - 8.D0
     &    /(u + s)*s**(-1)*t**2 + 16.D0/(u + s)*s**(-1)*t**2*mgen2*
     &    c0cmztsfff + 8.D0/(u + s)*rzm2 - 8.D0/(u + s)*rzm2*b0fmzff + 
     &    8.D0/(u + s)*rzm2*b0ftsff - 16.D0/(u + s)*rzm2*mgen2*
     &    c0cmztsfff - 8.D0/(u + s)*t + 16.D0/(u + s)*t*mgen2*
     &    c0cmztsfff - 8.D0/(u + s)/(u + s)*s**(-1)*rzm2**3*b0fmzff + 8.
     &    D0/(u + s)/(u + s)*s**(-1)*rzm2**3*b0ftsff + 16.D0/(u + s)/(u
     &     + s)*s**(-1)*t*rzm2**2*b0fmzff - 16.D0/(u + s)/(u + s)*
     &    s**(-1)*t*rzm2**2*b0ftsff - 8.D0/(u + s)/(u + s)*s**(-1)*t**2
     &    *rzm2*b0fmzff + 8.D0/(u + s)/(u + s)*s**(-1)*t**2*rzm2*
     &    b0ftsff + 8.D0/(u + s)/(u + s)*rzm2**2*b0fmzff - 8.D0/(u + s)
     &    /(u + s)*rzm2**2*b0ftsff - 8.D0/(u + s)/(u + s)*t*rzm2*
     &    b0fmzff + 8.D0/(u + s)/(u + s)*t*rzm2*b0ftsff + 24.D0/(t + s)
     &    *s**(-2)*rzm2**3*b0fmzff - 24.D0/(t + s)*s**(-2)*rzm2**3*
     &    b0fusff - 24.D0/(t + s)*s**(-2)*u*rzm2**2*b0fmzff + 24.D0/(t
     &     + s)*s**(-2)*u*rzm2**2*b0fusff + 8.D0/(t + s)*s**(-2)*u**2*
     &    rzm2*b0fmzff - 8.D0/(t + s)*s**(-2)*u**2*rzm2*b0fusff + 24.D0
     &    /(t + s)*s**(-1)*rzm2**2 - 48.D0/(t + s)*s**(-1)*rzm2**2*
     &    b0fmzff + 48.D0/(t + s)*s**(-1)*rzm2**2*b0fusff - 48.D0/(t + 
     &    s)*s**(-1)*rzm2**2*mgen2*c0cmzusfff - 24.D0/(t + s)*s**(-1)*u
     &    *rzm2 + 24.D0/(t + s)*s**(-1)*u*rzm2*b0fmzff - 24.D0/(t + s)*
     &    s**(-1)*u*rzm2*b0fusff + 48.D0/(t + s)*s**(-1)*u*rzm2*mgen2*
     &    c0cmzusfff + 8.D0/(t + s)*s**(-1)*u**2 - 16.D0/(t + s)*
     &    s**(-1)*u**2*mgen2*c0cmzusfff + 40.D0/(t + s)*rzm2 - 24.D0/(t
     &     + s)*rzm2*b0fmzff + 24.D0/(t + s)*rzm2*b0fusff - 80.D0/(t + 
     &    s)*rzm2*mgen2*c0cmzusfff - 24.D0/(t + s)*u + 48.D0/(t + s)*u*
     &    mgen2*c0cmzusfff + 24.D0/(t + s)/(t + s)*s**(-1)*rzm2**3*
     &    b0fmzff - 24.D0/(t + s)/(t + s)*s**(-1)*rzm2**3*b0fusff - 24.D
     &    0/(t + s)/(t + s)*s**(-1)*u*rzm2**2*b0fmzff + 24.D0/(t + s)/(
     &    t + s)*s**(-1)*u*rzm2**2*b0fusff + 8.D0/(t + s)/(t + s)*
     &    s**(-1)*u**2*rzm2*b0fmzff - 8.D0/(t + s)/(t + s)*s**(-1)*u**2
     &    *rzm2*b0fusff + 40.D0/(t + s)/(t + s)*rzm2**2*b0fmzff - 40.D0
     &    /(t + s)/(t + s)*rzm2**2*b0fusff - 24.D0/(t + s)/(t + s)*u*
     &    rzm2*b0fmzff + 24.D0/(t + s)/(t + s)*u*rzm2*b0fusff )

      qedamp(1,1,2,3) = qedamp(1,1,2,3)
     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz**(-1)*cqfactor * (  - 8.D0*
     &    s**(-2)*t**2*u**(-1) + 16.D0*s**(-2)*t**2*u**(-1)*mgen2*
     &    c0cmztsfff - 16.D0/3.D0*s**(-2)*t**2*c0cmzusfff + 16.D0/3.D0*
     &    s**(-2)*t**2*c0cmztsfff - 16.D0/3.D0*s**(-2)*t**2*c0ccusfff
     &     + 16.D0/3.D0*s**(-2)*t**2*c0cctsfff - 16.D0/3.D0*s**(-2)*
     &    t**3*d0cccmztsusffff + 8.D0*s**(-1)*t**(-1)*u - 16.D0*s**(-1)
     &    *t**(-1)*u*mgen2*c0cmzusfff - 32.D0/3.D0*s**(-1)*b0fusff + 32.
     &    D0/3.D0*s**(-1)*b0ftsff + 16.D0*s**(-1)*mgen2*c0cmzusfff - 16.
     &    D0*s**(-1)*mgen2*c0cmztsfff + 16.D0*s**(-1)*mgen2*c0ccusfff
     &     - 16.D0*s**(-1)*mgen2*c0cctsfff - 8.D0*s**(-1)*t*u**(-1) + 
     &    16.D0*s**(-1)*t*u**(-1)*mgen2*c0cmztsfff - 16.D0/3.D0*s**(-1)
     &    *t*c0cmzusfff - 16.D0/3.D0*s**(-1)*t*c0ccusfff + 80.D0/3.D0*
     &    s**(-1)*t*mgen2*d0cccmztsusffff + 8.D0*s**(-1)*t**2*u**(-2)
     &     - 16.D0*s**(-1)*t**2*u**(-2)*mgen2*c0cmztsfff - 16.D0/3.D0*
     &    s**(-1)*t**2*d0cccmztsusffff + 8.D0*t**(-1) - 16.D0*t**(-1)*
     &    mgen2*c0cmzusfff - 16.D0*u**(-1) + 16.D0*u**(-1)*mgen2*
     &    c0cmzusfff + 16.D0*u**(-1)*mgen2*c0cmztsfff + 8.D0*t*u**(-2)
     &     - 16.D0*t*u**(-2)*mgen2*c0cmztsfff - 16.D0/3.D0/(u + t)*
     &    s**(-1)*t**2*c0cmzusfff + 16.D0/3.D0/(u + t)*s**(-1)*t**2*
     &    c0cmztsfff - 16.D0/3.D0/(u + t)*s**(-1)*t**2*c0ccusfff + 16.D0
     &    /3.D0/(u + t)*s**(-1)*t**2*c0cctsfff - 16.D0/3.D0/(u + t)*
     &    s**(-1)*t**3*d0cccmztsusffff - 32.D0/3.D0/(u + t)*b0fusff + 
     &    32.D0/3.D0/(u + t)*b0ftsff + 16.D0/(u + t)*mgen2*c0cmzusfff
     &     - 16.D0/(u + t)*mgen2*c0cmztsfff + 16.D0/(u + t)*mgen2*
     &    c0ccusfff - 16.D0/(u + t)*mgen2*c0cctsfff - 16.D0/3.D0/(u + t
     &    )*t*c0cmzusfff - 16.D0/3.D0/(u + t)*t*c0ccusfff + 80.D0/3.D0
     &    /(u + t)*t*mgen2*d0cccmztsusffff - 16.D0/3.D0/(u + t)*t**2*
     &    d0cccmztsusffff + 8.D0/(u + s)*s**(-2)*t**2 - 16.D0/(u + s)*
     &    s**(-2)*t**2*mgen2*c0cmztsfff + 8.D0/(u + s)*s**(-1)*t - 16.D0
     &    /(u + s)*s**(-1)*t*mgen2*c0cmztsfff - 8.D0/(t + s) - 8.D0/(t
     &     + s)*s**(-1)*u + 16.D0/(t + s)*s**(-1)*u*mgen2*c0cmzusfff + 
     &    16.D0/(t + s)*mgen2*c0cmzusfff )
      qedamp(1,1,2,3) = qedamp(1,1,2,3) + sqrt(s)*sqrt(t*u)*
     & sr2**(-1)*mz*cqfactor * (  - 16.D0*s**(-3)*t**(-1)*u**(-1)*
     &    rzm2**3*b0fmzff + 16.D0*s**(-3)*t**(-1)*u**(-1)*rzm2**3*
     &    b0fusff - 32.D0*s**(-3)*t**(-1)*rzm2**2*b0fmzff + 32.D0*
     &    s**(-3)*t**(-1)*rzm2**2*b0fusff + 16.D0*s**(-3)*t**(-1)*u*
     &    rzm2*b0fmzff - 16.D0*s**(-3)*t**(-1)*u*rzm2*b0fusff - 16.D0*
     &    s**(-3)*u**(-1)*rzm2**2*b0fmzff + 16.D0*s**(-3)*u**(-1)*
     &    rzm2**2*b0ftsff + 32.D0*s**(-3)*t*u**(-1)*rzm2*b0fmzff - 32.D0
     &    *s**(-3)*t*u**(-1)*rzm2*b0ftsff - 16.D0*s**(-3)*t**2*u**(-1)*
     &    b0fmzff + 16.D0*s**(-3)*t**2*u**(-1)*b0ftsff + 8.D0*s**(-2)*
     &    t**(-2)*u**(-1)*rzm2**3*b0fmzff - 8.D0*s**(-2)*t**(-2)*
     &    u**(-1)*rzm2**3*b0fusff + 16.D0*s**(-2)*t**(-2)*rzm2**2*
     &    b0fmzff - 16.D0*s**(-2)*t**(-2)*rzm2**2*b0fusff - 8.D0*
     &    s**(-2)*t**(-2)*u*rzm2*b0fmzff + 8.D0*s**(-2)*t**(-2)*u*rzm2*
     &    b0fusff - 8.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2 - 8.D0*s**(-2)
     &    *t**(-1)*u**(-1)*rzm2**2*b0fmzff + 8.D0*s**(-2)*t**(-1)*
     &    u**(-1)*rzm2**2*b0ftsff + 16.D0*s**(-2)*t**(-1)*u**(-1)*
     &    rzm2**2*mgen2*c0cmzusfff - 16.D0*s**(-2)*t**(-1)*rzm2 + 24.D0
     &    *s**(-2)*t**(-1)*rzm2*b0fmzff - 24.D0*s**(-2)*t**(-1)*rzm2*
     &    b0fusff + 32.D0*s**(-2)*t**(-1)*rzm2*mgen2*c0cmzusfff + 8.D0*
     &    s**(-2)*t**(-1)*u - 8.D0*s**(-2)*t**(-1)*u*b0fmzff + 8.D0*
     &    s**(-2)*t**(-1)*u*b0fusff - 16.D0*s**(-2)*t**(-1)*u*mgen2*
     &    c0cmzusfff + 8.D0*s**(-2)*u**(-2)*rzm2**2*b0fmzff - 8.D0*
     &    s**(-2)*u**(-2)*rzm2**2*b0ftsff - 8.D0*s**(-2)*u**(-1)*rzm2
     &     + 8.D0*s**(-2)*u**(-1)*rzm2*b0fmzff - 8.D0*s**(-2)*u**(-1)*
     &    rzm2*b0ftsff + 16.D0*s**(-2)*u**(-1)*rzm2*mgen2*c0cmztsfff - 
     &    16.D0*s**(-2)*rzm2*c0cmztsfff + 16.D0*s**(-2)*rzm2*c0ccusfff
     &     - 16.D0*s**(-2)*t*u**(-2)*rzm2*b0fmzff + 16.D0*s**(-2)*t*
     &    u**(-2)*rzm2*b0ftsff + 16.D0*s**(-2)*t*u**(-1) - 32.D0*
     &    s**(-2)*t*u**(-1)*mgen2*c0cmztsfff - 16.D0*s**(-2)*t*
     &    c0cmzusfff + 32.D0/3.D0*s**(-2)*t*c0cmztsfff - 32.D0/3.D0*
     &    s**(-2)*t*c0ccusfff + 16.D0*s**(-2)*t*c0cctsfff + 16.D0*
     &    s**(-2)*t*rzm2*d0cccmztsusffff + 8.D0*s**(-2)*t**2*u**(-2)*
     &    b0fmzff - 8.D0*s**(-2)*t**2*u**(-2)*b0ftsff - 32.D0/3.D0*
     &    s**(-2)*t**2*d0cccmztsusffff + 8.D0*s**(-1)*t**(-2)*u**(-1)*
     &    rzm2**2 + 8.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**2*b0fmzff + 24.D0
     &    *s**(-1)*t**(-2)*u**(-1)*rzm2**2*b0fusff - 32.D0*s**(-1)*
     &    t**(-2)*u**(-1)*rzm2**2*b0ftsff - 16.D0*s**(-1)*t**(-2)*
     &    u**(-1)*rzm2**2*mgen2*c0cctsfff + 16.D0*s**(-1)*t**(-2)*rzm2
     &     - 40.D0*s**(-1)*t**(-2)*rzm2*b0fmzff + 40.D0*s**(-1)*t**(-2)
     &    *rzm2*b0fusff - 32.D0*s**(-1)*t**(-2)*rzm2*mgen2*c0cmzusfff
     &     - 8.D0*s**(-1)*t**(-2)*u + 16.D0*s**(-1)*t**(-2)*u*b0fmzff
     &     - 16.D0*s**(-1)*t**(-2)*u*b0fusff + 16.D0*s**(-1)*t**(-2)*u*
     &    mgen2*c0cmzusfff - 16.D0*s**(-1)*t**(-1)*u**(-2)*rzm2**2*
     &    b0fmzff + 16.D0*s**(-1)*t**(-1)*u**(-2)*rzm2**2*b0ftsff - 16.D
     &    0*s**(-1)*t**(-1)*u**(-2)*rzm2**2*mgen2*c0cmzusfff + 16.D0*
     &    s**(-1)*t**(-1)*u**(-2)*rzm2**2*mgen2*c0cctsfff - 48.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2 - 80.D0/3.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rzm2*b0fmzff - 24.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*
     &    b0fusff + 152.D0/3.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*b0ftsff + 
     &    112.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*mgen2*c0cmzusfff + 32.D0*
     &    s**(-1)*t**(-1)*u**(-1)*rzm2*mgen2*c0cmztsfff + 16.D0*s**(-1)
     &    *t**(-1)*u**(-1)*rzm2*mgen2*c0ccusfff - 64.D0*s**(-1)*t**(-1)
     &    *u**(-1)*rzm2*mgen2*c0cctsfff + 16.D0*s**(-1)*t**(-1)*u**(-1)
     &    *rzm2**2*mgen2*d0cccmztsusffff - 16.D0*s**(-1)*t**(-1) + 40.D0
     &    *s**(-1)*t**(-1)*b0fmzff - 40.D0*s**(-1)*t**(-1)*b0fusff + 32.
     &    D0*s**(-1)*t**(-1)*mgen2*c0cmzusfff - 16.D0*s**(-1)*t**(-1)*
     &    mgen2*c0cmztsfff + 16.D0*s**(-1)*t**(-1)*mgen2*c0ccusfff + 8.D
     &    0*s**(-1)*u**(-2)*rzm2 + 24.D0*s**(-1)*u**(-2)*rzm2*b0fmzff
     &     - 24.D0*s**(-1)*u**(-2)*rzm2*b0ftsff + 16.D0*s**(-1)*u**(-2)
     &    *rzm2*mgen2*c0cmzusfff - 16.D0*s**(-1)*u**(-2)*rzm2*mgen2*
     &    c0cmztsfff - 16.D0*s**(-1)*u**(-2)*rzm2*mgen2*c0cctsfff + 32.D
     &    0*s**(-1)*u**(-1) + 104.D0/3.D0*s**(-1)*u**(-1)*b0fmzff - 104.
     &    D0/3.D0*s**(-1)*u**(-1)*b0ftsff - 64.D0*s**(-1)*u**(-1)*mgen2
     &    *c0cmzusfff - 48.D0*s**(-1)*u**(-1)*mgen2*c0cmztsfff - 16.D0*
     &    s**(-1)*u**(-1)*mgen2*c0ccusfff + 64.D0*s**(-1)*u**(-1)*mgen2
     &    *c0cctsfff - 16.D0*s**(-1)*u**(-1)*rzm2*mgen2*d0cccmztsusffff
     &     - 16.D0*s**(-1)*c0cmzusfff - 16.D0*s**(-1)*c0ccusfff + 72.D0
     &    *s**(-1)*mgen2*d0cccmztsusffff - 16.D0*s**(-1)*t*u**(-2) - 8.D
     &    0*s**(-1)*t*u**(-2)*b0fmzff + 8.D0*s**(-1)*t*u**(-2)*b0ftsff
     &     + 32.D0*s**(-1)*t*u**(-2)*mgen2*c0cmztsfff - 16.D0*s**(-1)*t
     &    *d0cccmztsusffff - 8.D0*t**(-2)*u**(-1)*rzm2 - 16.D0*t**(-2)*
     &    u**(-1)*rzm2*b0fmzff - 16.D0*t**(-2)*u**(-1)*rzm2*b0fusff + 
     &    32.D0*t**(-2)*u**(-1)*rzm2*b0ftsff + 16.D0*t**(-2)*u**(-1)*
     &    rzm2*mgen2*c0cctsfff - 8.D0*t**(-2) + 16.D0*t**(-2)*b0fmzff
     &     - 16.D0*t**(-2)*b0fusff + 16.D0*t**(-2)*mgen2*c0cmzusfff + 
     &    16.D0*t**(-1)*u**(-2)*rzm2*b0fmzff - 16.D0*t**(-1)*u**(-2)*
     &    rzm2*b0ftsff + 16.D0*t**(-1)*u**(-2)*rzm2*mgen2*c0cmzusfff - 
     &    16.D0*t**(-1)*u**(-2)*rzm2*mgen2*c0cctsfff + 48.D0*t**(-1)*
     &    u**(-1) + 128.D0/3.D0*t**(-1)*u**(-1)*b0fmzff - 128.D0/3.D0*
     &    t**(-1)*u**(-1)*b0ftsff - 112.D0*t**(-1)*u**(-1)*mgen2*
     &    c0cmzusfff - 16.D0*t**(-1)*u**(-1)*mgen2*c0cmztsfff - 16.D0*
     &    t**(-1)*u**(-1)*mgen2*c0ccusfff + 64.D0*t**(-1)*u**(-1)*mgen2
     &    *c0cctsfff - 16.D0*t**(-1)*u**(-1)*mgen2*c0ccqsfff - 16.D0*
     &    t**(-1)*u**(-1)*rzm2*mgen2*d0cccmztsusffff + 8.D0*t**(-1)*
     &    mgen2*d0ccmzcqsusffff - 8.D0*u**(-2) - 16.D0*u**(-2)*b0fmzff
     &     + 16.D0*u**(-2)*b0ftsff + 16.D0*u**(-2)*mgen2*c0cmztsfff - 8.
     &    D0*u**(-1)*mgen2*d0cccmzqstsffff + 32.D0/(u + t)*s**(-3)*
     &    t**(-1)*rzm2**3*b0fmzff - 32.D0/(u + t)*s**(-3)*t**(-1)*
     &    rzm2**3*b0fusff - 16.D0/(u + t)*s**(-2)*t**(-2)*rzm2**3*
     &    b0fmzff + 16.D0/(u + t)*s**(-2)*t**(-2)*rzm2**3*b0fusff + 16.D
     &    0/(u + t)*s**(-2)*t**(-1)*rzm2**2 - 32.D0/(u + t)*s**(-2)*
     &    t**(-1)*rzm2**2*b0fmzff + 32.D0/(u + t)*s**(-2)*t**(-1)*
     &    rzm2**2*b0fusff - 32.D0/(u + t)*s**(-2)*t**(-1)*rzm2**2*mgen2
     &    *c0cmzusfff + 16.D0/(u + t)*s**(-2)*rzm2**2*c0cmztsfff - 16.D0
     &    /(u + t)*s**(-2)*rzm2**2*c0ccusfff + 16.D0/(u + t)*s**(-2)*t*
     &    rzm2*c0cmzusfff - 32.D0/3.D0/(u + t)*s**(-2)*t*rzm2*
     &    c0cmztsfff + 32.D0/3.D0/(u + t)*s**(-2)*t*rzm2*c0ccusfff - 16.
     &    D0/(u + t)*s**(-2)*t*rzm2*c0cctsfff - 16.D0/(u + t)*s**(-2)*t
     &    *rzm2**2*d0cccmztsusffff + 16.D0/3.D0/(u + t)*s**(-2)*t**2*
     &    c0cmzusfff - 16.D0/3.D0/(u + t)*s**(-2)*t**2*c0cmztsfff + 16.D
     &    0/3.D0/(u + t)*s**(-2)*t**2*c0ccusfff - 16.D0/3.D0/(u + t)*
     &    s**(-2)*t**2*c0cctsfff + 32.D0/3.D0/(u + t)*s**(-2)*t**2*rzm2
     &    *d0cccmztsusffff + 16.D0/3.D0/(u + t)*s**(-2)*t**3*
     &    d0cccmztsusffff - 16.D0/(u + t)*s**(-1)*t**(-2)*rzm2**2 + 48.D
     &    0/(u + t)*s**(-1)*t**(-2)*rzm2**2*b0fmzff - 48.D0/(u + t)*
     &    s**(-1)*t**(-2)*rzm2**2*b0fusff + 16.D0/(u + t)*s**(-1)*
     &    t**(-2)*rzm2**2*mgen2*c0cmzusfff + 16.D0/(u + t)*s**(-1)*
     &    t**(-2)*rzm2**2*mgen2*c0cctsfff + 16.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2 + 32.D0/3.D0/(u + t)*s**(-1)*t**(-1)*rzm2*
     &    b0fmzff + 32.D0/(u + t)*s**(-1)*t**(-1)*rzm2*b0fusff - 128.D0/
     &    3.D0/(u + t)*s**(-1)*t**(-1)*rzm2*b0ftsff - 96.D0/(u + t)*
     &    s**(-1)*t**(-1)*rzm2*mgen2*c0cmzusfff + 32.D0/(u + t)*s**(-1)
     &    *t**(-1)*rzm2*mgen2*c0cmztsfff - 32.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2*mgen2*c0ccusfff + 64.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2*mgen2*c0cctsfff - 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2**2*
     &    mgen2*d0cccmztsusffff + 32.D0/3.D0/(u + t)*s**(-1)*b0fusff - 
     &    32.D0/3.D0/(u + t)*s**(-1)*b0ftsff - 32.D0/(u + t)*s**(-1)*
     &    mgen2*c0cmzusfff + 32.D0/(u + t)*s**(-1)*mgen2*c0cmztsfff - 
     &    32.D0/(u + t)*s**(-1)*mgen2*c0ccusfff + 32.D0/(u + t)*s**(-1)
     &    *mgen2*c0cctsfff + 16.D0/(u + t)*s**(-1)*rzm2*c0cmzusfff - 16.
     &    D0/(u + t)*s**(-1)*rzm2*c0cmztsfff + 32.D0/(u + t)*s**(-1)*
     &    rzm2*c0ccusfff - 64.D0/(u + t)*s**(-1)*rzm2*mgen2*
     &    d0cccmztsusffff - 32.D0/3.D0/(u + t)*s**(-1)*t*c0cmzusfff + 
     &    32.D0/3.D0/(u + t)*s**(-1)*t*c0cmztsfff - 16.D0/3.D0/(u + t)*
     &    s**(-1)*t*c0ccusfff + 16.D0/(u + t)*s**(-1)*t*c0cctsfff - 128.
     &    D0/3.D0/(u + t)*s**(-1)*t*mgen2*d0cccmztsusffff + 32.D0/(u + 
     &    t)*s**(-1)*t*rzm2*d0cccmztsusffff - 16.D0/3.D0/(u + t)*
     &    s**(-1)*t**2*d0cccmztsusffff + 16.D0/(u + t)*t**(-2)*rzm2 + 
     &    32.D0/(u + t)*t**(-2)*rzm2*b0fusff - 32.D0/(u + t)*t**(-2)*
     &    rzm2*b0ftsff - 16.D0/(u + t)*t**(-2)*rzm2*mgen2*c0cmzusfff - 
     &    16.D0/(u + t)*t**(-2)*rzm2*mgen2*c0cctsfff - 64.D0/(u + t)*
     &    t**(-1) - 32.D0/3.D0/(u + t)*t**(-1)*b0fmzff - 32.D0/(u + t)*
     &    t**(-1)*b0fusff + 128.D0/3.D0/(u + t)*t**(-1)*b0ftsff + 112.D0
     &    /(u + t)*t**(-1)*mgen2*c0cmzusfff + 16.D0/(u + t)*t**(-1)*
     &    mgen2*c0cmztsfff + 32.D0/(u + t)*t**(-1)*mgen2*c0ccusfff - 64.
     &    D0/(u + t)*t**(-1)*mgen2*c0cctsfff + 32.D0/(u + t)*t**(-1)*
     &    mgen2*c0ccqsfff + 16.D0/(u + t)*t**(-1)*rzm2*mgen2*
     &    d0cccmztsusffff - 16.D0/(u + t)*c0cmzusfff - 16.D0/(u + t)*
     &    c0ccusfff + 64.D0/(u + t)*mgen2*d0cccmztsusffff - 16.D0/(u + 
     &    t)*t*d0cccmztsusffff - 32.D0/(u + t)/(u + s) - 32.D0/(u + t)
     &    /(u + s)*t**(-2)*rzm2**2*b0fmzff + 32.D0/(u + t)/(u + s)*
     &    t**(-2)*rzm2**2*b0ftsff + 32.D0/(u + t)/(u + s)*t**(-1)*rzm2
     &     - 64.D0/(u + t)/(u + s)*t**(-1)*rzm2*mgen2*c0cmztsfff + 64.D0
     &    /(u + t)/(u + s)*mgen2*c0cmztsfff + 32.D0/(u + t)/(u + s)/(u
     &     + s)*t**(-1)*rzm2**2*b0fmzff - 32.D0/(u + t)/(u + s)/(u + s)
     &    *t**(-1)*rzm2**2*b0ftsff - 32.D0/(u + t)/(u + s)/(u + s)*rzm2
     &    *b0fmzff + 32.D0/(u + t)/(u + s)/(u + s)*rzm2*b0ftsff + 32.D0
     &    /(u + t)/(t + s) - 32.D0/(u + t)/(t + s)*s**(-3)*rzm2**3*
     &    b0fmzff + 32.D0/(u + t)/(t + s)*s**(-3)*rzm2**3*b0fusff - 16.D
     &    0/(u + t)/(t + s)*s**(-2)*rzm2**2 + 32.D0/(u + t)/(t + s)*
     &    s**(-2)*rzm2**2*b0fmzff - 32.D0/(u + t)/(t + s)*s**(-2)*
     &    rzm2**2*b0fusff + 32.D0/(u + t)/(t + s)*s**(-2)*rzm2**2*mgen2
     &    *c0cmzusfff - 16.D0/(u + t)/(t + s)*s**(-1)*rzm2 + 32.D0/(u
     &     + t)/(t + s)*s**(-1)*rzm2*mgen2*c0cmzusfff - 64.D0/(u + t)/(
     &    t + s)*mgen2*c0cmzusfff - 16.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-2)*rzm2**3*b0fmzff + 16.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-2)*rzm2**3*b0fusff - 16.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-1)*rzm2**2*b0fmzff + 16.D0/(u + t)/(t + s)/(t + s)*
     &    s**(-1)*rzm2**2*b0fusff + 32.D0/(u + t)/(t + s)/(t + s)*rzm2*
     &    b0fmzff - 32.D0/(u + t)/(t + s)/(t + s)*rzm2*b0fusff + 16.D0
     &    /(u + s)*s**(-3)*rzm2**2*b0fmzff - 16.D0/(u + s)*s**(-3)*
     &    rzm2**2*b0ftsff - 32.D0/(u + s)*s**(-3)*t*rzm2*b0fmzff + 32.D0
     &    /(u + s)*s**(-3)*t*rzm2*b0ftsff + 16.D0/(u + s)*s**(-3)*t**2*
     &    b0fmzff - 16.D0/(u + s)*s**(-3)*t**2*b0ftsff + 8.D0/(u + s)*
     &    s**(-2)*t**(-1)*rzm2**2*b0fmzff - 8.D0/(u + s)*s**(-2)*
     &    t**(-1)*rzm2**2*b0ftsff + 8.D0/(u + s)*s**(-2)*rzm2 - 8.D0/(u
     &     + s)*s**(-2)*rzm2*b0fmzff + 8.D0/(u + s)*s**(-2)*rzm2*
     &    b0ftsff - 16.D0/(u + s)*s**(-2)*rzm2*mgen2*c0cmztsfff - 16.D0
     &    /(u + s)*s**(-2)*t + 32.D0/(u + s)*s**(-2)*t*mgen2*c0cmztsfff
     &     - 32.D0/(u + s)*s**(-1)*t**(-2)*rzm2**2*b0fmzff )
      qedamp(1,1,2,3) = qedamp(1,1,2,3) + sqrt(s)*sqrt(t*u)*
     & sr2**(-1)*mz*cqfactor * ( 32.D0/(u + s)*s**(-1)*t**(-2)*rzm2**2*
     &    b0ftsff + 24.D0/(u + s)*s**(-1)*t**(-1)*rzm2 + 8.D0/(u + s)*
     &    s**(-1)*t**(-1)*rzm2*b0fmzff - 8.D0/(u + s)*s**(-1)*t**(-1)*
     &    rzm2*b0ftsff - 48.D0/(u + s)*s**(-1)*t**(-1)*rzm2*mgen2*
     &    c0cmztsfff - 32.D0/(u + s)*s**(-1) + 8.D0/(u + s)*s**(-1)*
     &    b0fmzff - 8.D0/(u + s)*s**(-1)*b0ftsff + 64.D0/(u + s)*
     &    s**(-1)*mgen2*c0cmztsfff + 8.D0/(u + s)/(u + s)*s**(-2)*
     &    rzm2**2*b0fmzff - 8.D0/(u + s)/(u + s)*s**(-2)*rzm2**2*
     &    b0ftsff - 16.D0/(u + s)/(u + s)*s**(-2)*t*rzm2*b0fmzff + 16.D0
     &    /(u + s)/(u + s)*s**(-2)*t*rzm2*b0ftsff + 8.D0/(u + s)/(u + s
     &    )*s**(-2)*t**2*b0fmzff - 8.D0/(u + s)/(u + s)*s**(-2)*t**2*
     &    b0ftsff + 24.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*rzm2**2*
     &    b0fmzff - 24.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*rzm2**2*
     &    b0ftsff - 32.D0/(u + s)/(u + s)*s**(-1)*rzm2*b0fmzff + 32.D0
     &    /(u + s)/(u + s)*s**(-1)*rzm2*b0ftsff + 8.D0/(u + s)/(u + s)*
     &    s**(-1)*t*b0fmzff - 8.D0/(u + s)/(u + s)*s**(-1)*t*b0ftsff + 
     &    16.D0/(t + s)*s**(-3)*u**(-1)*rzm2**3*b0fmzff - 16.D0/(t + s)
     &    *s**(-3)*u**(-1)*rzm2**3*b0fusff + 32.D0/(t + s)*s**(-3)*
     &    rzm2**2*b0fmzff - 32.D0/(t + s)*s**(-3)*rzm2**2*b0fusff - 16.D
     &    0/(t + s)*s**(-3)*u*rzm2*b0fmzff + 16.D0/(t + s)*s**(-3)*u*
     &    rzm2*b0fusff + 8.D0/(t + s)*s**(-2)*u**(-1)*rzm2**2 - 16.D0/(
     &    t + s)*s**(-2)*u**(-1)*rzm2**2*mgen2*c0cmzusfff + 16.D0/(t + 
     &    s)*s**(-2)*rzm2 - 24.D0/(t + s)*s**(-2)*rzm2*b0fmzff + 24.D0
     &    /(t + s)*s**(-2)*rzm2*b0fusff - 32.D0/(t + s)*s**(-2)*rzm2*
     &    mgen2*c0cmzusfff - 8.D0/(t + s)*s**(-2)*u + 8.D0/(t + s)*
     &    s**(-2)*u*b0fmzff - 8.D0/(t + s)*s**(-2)*u*b0fusff + 16.D0/(t
     &     + s)*s**(-2)*u*mgen2*c0cmzusfff + 24.D0/(t + s)*s**(-1)*
     &    u**(-1)*rzm2 - 24.D0/(t + s)*s**(-1)*u**(-1)*rzm2*b0fmzff + 
     &    24.D0/(t + s)*s**(-1)*u**(-1)*rzm2*b0fusff - 48.D0/(t + s)*
     &    s**(-1)*u**(-1)*rzm2*mgen2*c0cmzusfff + 16.D0/(t + s)*s**(-1)
     &     - 8.D0/(t + s)*s**(-1)*b0fmzff + 8.D0/(t + s)*s**(-1)*
     &    b0fusff - 32.D0/(t + s)*s**(-1)*mgen2*c0cmzusfff + 8.D0/(t + 
     &    s)*u**(-1) - 8.D0/(t + s)*u**(-1)*b0fmzff + 8.D0/(t + s)*
     &    u**(-1)*b0fusff - 16.D0/(t + s)*u**(-1)*mgen2*c0cmzusfff + 8.D
     &    0/(t + s)/(t + s)*s**(-2)*u**(-1)*rzm2**3*b0fmzff - 8.D0/(t
     &     + s)/(t + s)*s**(-2)*u**(-1)*rzm2**3*b0fusff + 16.D0/(t + s)
     &    /(t + s)*s**(-2)*rzm2**2*b0fmzff - 16.D0/(t + s)/(t + s)*
     &    s**(-2)*rzm2**2*b0fusff - 8.D0/(t + s)/(t + s)*s**(-2)*u*rzm2
     &    *b0fmzff + 8.D0/(t + s)/(t + s)*s**(-2)*u*rzm2*b0fusff + 24.D0
     &    /(t + s)/(t + s)*s**(-1)*u**(-1)*rzm2**2*b0fmzff - 24.D0/(t
     &     + s)/(t + s)*s**(-1)*u**(-1)*rzm2**2*b0fusff + 16.D0/(t + s)
     &    /(t + s)*s**(-1)*rzm2*b0fmzff - 16.D0/(t + s)/(t + s)*s**(-1)
     &    *rzm2*b0fusff - 8.D0/(t + s)/(t + s)*s**(-1)*u*b0fmzff + 8.D0
     &    /(t + s)/(t + s)*s**(-1)*u*b0fusff + 8.D0/(t + s)/(t + s)*
     &    u**(-1)*rzm2*b0fmzff - 8.D0/(t + s)/(t + s)*u**(-1)*rzm2*
     &    b0fusff - 8.D0/(t + s)/(t + s)*b0fmzff + 8.D0/(t + s)/(t + s)
     &    *b0fusff )

      qedamp(1,2,1,1) = qedamp(1,2,1,1)
     &  + cqfactor * ( 8.D0 - 24.D0*s**(-1)*t**(-1)*rzm2**2*b0fmzff + 
     &    24.D0*s**(-1)*t**(-1)*rzm2**2*b0fusff + 8.D0*s**(-1)*t**(-1)*
     &    u*rzm2*b0fmzff - 8.D0*s**(-1)*t**(-1)*u*rzm2*b0fusff + 8.D0*
     &    t**(-1)*rzm2*b0fmzff - 8.D0*t**(-1)*rzm2*b0fusff + 8.D0*
     &    t**(-1)*rzm2*mgen2*c0cmzusfff - 8.D0*t**(-1)*rzm2*mgen2*
     &    c0ccqsfff + 4.D0*t**(-1)*rzm2**2*c0cmzusfff - 4.D0*t**(-1)*
     &    rzm2**2*c0ccqsfff - 8.D0*t**(-1)*u*mgen2*c0cmzusfff + 8.D0*
     &    t**(-1)*u*mgen2*c0cmzqsfff - 8.D0*t**(-1)*u*mgen2*c0ccusfff
     &     + 8.D0*t**(-1)*u*mgen2*c0ccqsfff - 4.D0*t**(-1)*u*rzm2*
     &    c0cmzusfff + 4.D0*t**(-1)*u*rzm2*c0cmzqsfff - 4.D0*t**(-1)*u*
     &    rzm2*c0ccusfff + 4.D0*t**(-1)*u*rzm2*c0ccqsfff - 8.D0*t**(-1)
     &    *u*rzm2*mgen2*d0ccmzcqsusffff - 4.D0*t**(-1)*u*rzm2**2*
     &    d0ccmzcqsusffff + 8.D0*t**(-1)*u**2*mgen2*d0ccmzcqsusffff + 4.
     &    D0*t**(-1)*u**2*rzm2*d0ccmzcqsusffff + 8.D0*u**(-1)*rzm2*
     &    mgen2*c0cmztsfff - 8.D0*u**(-1)*rzm2*mgen2*c0ccqsfff - 8.D0*
     &    mgen2*c0cmzusfff + 8.D0*mgen2*c0ccusfff - 16.D0*mgen2*
     &    c0cctsfff + 16.D0*mgen2*c0ccqsfff - 16.D0*mgen2**2*
     &    d0cccmztsusffff - 16.D0*mgen2**2*d0ccmzcqsusffff - 16.D0*
     &    mgen2**2*d0cccmzqstsffff + 4.D0*rzm2*c0cmzusfff + 4.D0*rzm2*
     &    c0ccusfff - 8.D0*rzm2*mgen2*d0cccmztsusffff - 8.D0*rzm2*mgen2
     &    *d0ccmzcqsusffff - 8.D0*rzm2*mgen2*d0cccmzqstsffff + 4.D0*
     &    rzm2**2*d0ccmzcqsusffff + 8.D0*u*mgen2*d0ccmzcqsusffff - 8.D0
     &    *t*u**(-1)*mgen2*c0cmztsfff + 8.D0*t*u**(-1)*mgen2*c0cmzqsfff
     &     - 8.D0*t*u**(-1)*mgen2*c0cctsfff + 8.D0*t*u**(-1)*mgen2*
     &    c0ccqsfff - 8.D0*t*u**(-1)*rzm2*mgen2*d0cccmzqstsffff + 8.D0*
     &    t*mgen2*d0cccmztsusffff + 8.D0*t*mgen2*d0cccmzqstsffff + 8.D0
     &    *t**2*u**(-1)*mgen2*d0cccmzqstsffff + 16.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2**3*b0fmzff - 16.D0/(u + t)*s**(-1)*t**(-1)*
     &    rzm2**3*b0fusff - 16.D0/(u + t)*t**(-1)*rzm2**2*b0fmzff + 16.D
     &    0/(u + t)*t**(-1)*rzm2**2*b0fusff - 8.D0/(u + t)*rzm2 + 8.D0
     &    /(u + t)*rzm2*b0fmzff - 8.D0/(u + t)*rzm2*b0fusff + 24.D0/(u
     &     + t)*rzm2*mgen2*c0cmzusfff - 8.D0/(u + t)*rzm2*mgen2*
     &    c0cmztsfff - 4.D0/(u + t)*rzm2**2*c0cmzusfff + 4.D0/(u + t)*
     &    rzm2**2*c0ccqsfff - 8.D0/(u + t)*t*mgen2*c0cmzusfff + 8.D0/(u
     &     + t)*t*mgen2*c0cmztsfff - 8.D0/(u + t)*t*mgen2*c0ccusfff + 8.
     &    D0/(u + t)*t*mgen2*c0cctsfff - 4.D0/(u + t)*t*rzm2*c0cmzusfff
     &     - 4.D0/(u + t)*t*rzm2*c0ccusfff + 8.D0/(u + t)*t*rzm2*mgen2*
     &    d0cccmztsusffff + 8.D0/(u + t)*t*rzm2*mgen2*d0ccmzcqsusffff
     &     + 8.D0/(u + t)*t*rzm2*mgen2*d0cccmzqstsffff - 4.D0/(u + t)*t
     &    *rzm2**2*d0ccmzcqsusffff - 8.D0/(u + t)*t**2*mgen2*
     &    d0cccmztsusffff - 16.D0/(u + t)/(t + s)*s**(-1)*rzm2**3*
     &    b0fmzff + 16.D0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fusff + 8.D0
     &    /(u + t)/(t + s)*rzm2**2 - 16.D0/(u + t)/(t + s)*rzm2**2*
     &    mgen2*c0cmzusfff + 8.D0/(u + t)/(t + s)/(t + s)*rzm2**3*
     &    b0fmzff - 8.D0/(u + t)/(t + s)/(t + s)*rzm2**3*b0fusff + 24.D0
     &    /(t + s)*s**(-1)*rzm2**2*b0fmzff - 24.D0/(t + s)*s**(-1)*
     &    rzm2**2*b0fusff - 8.D0/(t + s)*s**(-1)*u*rzm2*b0fmzff + 8.D0
     &    /(t + s)*s**(-1)*u*rzm2*b0fusff - 8.D0/(t + s)*rzm2 + 8.D0/(t
     &     + s)*rzm2*b0fmzff - 8.D0/(t + s)*rzm2*b0fusff + 16.D0/(t + s
     &    )*rzm2*mgen2*c0cmzusfff - 8.D0/(t + s)/(t + s)*rzm2**2*
     &    b0fmzff + 8.D0/(t + s)/(t + s)*rzm2**2*b0fusff )

      qedamp(1,2,1,2) = qedamp(1,2,1,2)
     &  + cqfactor * (  - 8.D0 + 16.D0*s**(-1)*t**(-1)*rzm2**2*b0fmzff
     &     - 16.D0*s**(-1)*t**(-1)*rzm2**2*b0fusff + 8.D0*s**(-1)*rzm2*
     &    mgen2*c0cmztsfff - 8.D0*s**(-1)*rzm2*mgen2*c0ccusfff + 8.D0*
     &    s**(-1)*t*mgen2*c0cmzusfff - 8.D0*s**(-1)*t*mgen2*c0cmztsfff
     &     + 8.D0*s**(-1)*t*mgen2*c0ccusfff - 8.D0*s**(-1)*t*mgen2*
     &    c0cctsfff - 8.D0*s**(-1)*t*rzm2*mgen2*d0cccmztsusffff + 8.D0*
     &    s**(-1)*t**2*mgen2*d0cccmztsusffff + 8.D0*t**(-2)*u*rzm2**2*
     &    c0cmzusfff - 8.D0*t**(-2)*u*rzm2**2*c0ccqsfff - 16.D0*t**(-2)
     &    *u**2*rzm2*c0cmzusfff + 8.D0*t**(-2)*u**2*rzm2*c0cmzqsfff - 8.
     &    D0*t**(-2)*u**2*rzm2*c0ccusfff + 16.D0*t**(-2)*u**2*rzm2*
     &    c0ccqsfff - 8.D0*t**(-2)*u**2*rzm2**2*d0ccmzcqsusffff + 8.D0*
     &    t**(-2)*u**3*c0cmzusfff - 8.D0*t**(-2)*u**3*c0cmzqsfff + 8.D0
     &    *t**(-2)*u**3*c0ccusfff - 8.D0*t**(-2)*u**3*c0ccqsfff + 16.D0
     &    *t**(-2)*u**3*rzm2*d0ccmzcqsusffff - 8.D0*t**(-2)*u**4*
     &    d0ccmzcqsusffff - 16.D0*t**(-1)*rzm2*b0fmzff + 16.D0*t**(-1)*
     &    rzm2*b0fqsff + 16.D0*t**(-1)*rzm2*mgen2*c0cmzusfff - 16.D0*
     &    t**(-1)*rzm2*mgen2*c0ccqsfff + 16.D0*t**(-1)*u*b0fusff - 16.D0
     &    *t**(-1)*u*b0fqsff - 16.D0*t**(-1)*u*mgen2*c0cmzusfff + 16.D0
     &    *t**(-1)*u*mgen2*c0cmzqsfff - 16.D0*t**(-1)*u*mgen2*c0ccusfff
     &     + 16.D0*t**(-1)*u*mgen2*c0ccqsfff - 8.D0*t**(-1)*u*rzm2*
     &    c0cmzusfff + 8.D0*t**(-1)*u*rzm2*c0cmzqsfff + 16.D0*t**(-1)*u
     &    *rzm2*c0ccqsfff - 32.D0*t**(-1)*u*rzm2*mgen2*d0ccmzcqsusffff
     &     + 8.D0*t**(-1)*u**2*c0cmzusfff - 16.D0*t**(-1)*u**2*
     &    c0cmzqsfff + 8.D0*t**(-1)*u**2*c0ccusfff - 16.D0*t**(-1)*u**2
     &    *c0ccqsfff + 32.D0*t**(-1)*u**2*mgen2*d0ccmzcqsusffff + 16.D0
     &    *t**(-1)*u**2*rzm2*d0ccmzcqsusffff - 16.D0*t**(-1)*u**3*
     &    d0ccmzcqsusffff + 8.D0*b0fusff - 8.D0*b0fqsff + 16.D0*mgen2*
     &    c0cmzqsfff + 16.D0*mgen2*c0ccqsfff - 16.D0*mgen2**2*
     &    d0cccmztsusffff - 16.D0*mgen2**2*d0ccmzcqsusffff - 16.D0*
     &    mgen2**2*d0cccmzqstsffff - 8.D0*rzm2*c0cmzusfff + 4.D0*rzm2*
     &    c0cmzqsfff - 4.D0*rzm2*c0ccusfff + 8.D0*rzm2*c0ccqsfff - 4.D0
     &    *rzm2**2*d0ccmzcqsusffff + 4.D0*u*c0cmzusfff - 12.D0*u*
     &    c0cmzqsfff + 4.D0*u*c0ccusfff - 12.D0*u*c0ccqsfff + 32.D0*u*
     &    mgen2*d0ccmzcqsusffff + 8.D0*u*rzm2*d0ccmzcqsusffff - 12.D0*
     &    u**2*d0ccmzcqsusffff - 4.D0*t*c0cmzqsfff - 4.D0*t*c0ccqsfff
     &     + 8.D0*t*mgen2*d0cccmztsusffff + 8.D0*t*mgen2*
     &    d0ccmzcqsusffff + 8.D0*t*mgen2*d0cccmzqstsffff - 4.D0*t*u*
     &    d0ccmzcqsusffff - 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*
     &    b0fmzff + 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2**3*b0fusff + 16.D
     &    0/(u + t)*t**(-1)*rzm2**2*b0fmzff - 16.D0/(u + t)*t**(-1)*
     &    rzm2**2*b0fusff + 8.D0/(u + t)*rzm2 + 8.D0/(u + t)*rzm2*
     &    b0fusff - 8.D0/(u + t)*rzm2*b0fqsff - 24.D0/(u + t)*rzm2*
     &    mgen2*c0cmzusfff + 8.D0/(u + t)*rzm2*mgen2*c0cmztsfff + 4.D0
     &    /(u + t)*rzm2**2*c0cmzusfff - 4.D0/(u + t)*rzm2**2*c0ccqsfff
     &     + 8.D0/(u + t)*t*mgen2*c0cmzusfff - 8.D0/(u + t)*t*mgen2*
     &    c0cmztsfff + 8.D0/(u + t)*t*mgen2*c0ccusfff - 8.D0/(u + t)*t*
     &    mgen2*c0cctsfff + 4.D0/(u + t)*t*rzm2*c0cmzusfff + 4.D0/(u + 
     &    t)*t*rzm2*c0ccusfff - 8.D0/(u + t)*t*rzm2*mgen2*
     &    d0cccmztsusffff - 8.D0/(u + t)*t*rzm2*mgen2*d0ccmzcqsusffff
     &     - 8.D0/(u + t)*t*rzm2*mgen2*d0cccmzqstsffff + 4.D0/(u + t)*t
     &    *rzm2**2*d0ccmzcqsusffff + 8.D0/(u + t)*t**2*mgen2*
     &    d0cccmztsusffff + 16.D0/(u + t)/(t + s)*s**(-1)*rzm2**3*
     &    b0fmzff - 16.D0/(u + t)/(t + s)*s**(-1)*rzm2**3*b0fusff - 8.D0
     &    /(u + t)/(t + s)*rzm2**2 + 16.D0/(u + t)/(t + s)*rzm2**2*
     &    mgen2*c0cmzusfff - 8.D0/(u + t)/(t + s)/(t + s)*rzm2**3*
     &    b0fmzff + 8.D0/(u + t)/(t + s)/(t + s)*rzm2**3*b0fusff - 16.D0
     &    /(t + s)*s**(-1)*rzm2**2*b0fmzff + 16.D0/(t + s)*s**(-1)*
     &    rzm2**2*b0fusff + 8.D0/(t + s)*rzm2 - 16.D0/(t + s)*rzm2*
     &    mgen2*c0cmzusfff + 8.D0/(t + s)/(t + s)*rzm2**2*b0fmzff - 8.D0
     &    /(t + s)/(t + s)*rzm2**2*b0fusff )

      qedamp(1,2,1,3) = qedamp(1,2,1,3)
     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz**(-1)*cqfactor * ( 8.D0/3.D0*
     &    s**(-1)*t*c0cmzusfff - 8.D0/3.D0*s**(-1)*t*c0cmztsfff + 8.D0/
     &    3.D0*s**(-1)*t*c0ccusfff - 8.D0/3.D0*s**(-1)*t*c0cctsfff + 8.D
     &    0/3.D0*s**(-1)*t**2*d0cccmztsusffff + 8.D0/3.D0/(u + t)*t*
     &    c0cmzusfff - 8.D0/3.D0/(u + t)*t*c0cmztsfff + 8.D0/3.D0/(u + 
     &    t)*t*c0ccusfff - 8.D0/3.D0/(u + t)*t*c0cctsfff + 8.D0/3.D0/(u
     &     + t)*t**2*d0cccmztsusffff )
      qedamp(1,2,1,3) = qedamp(1,2,1,3) + sqrt(s)*sqrt(t*u)*
     & sr2**(-1)*mz*cqfactor * ( 8.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*
     &    b0fmzff - 8.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*b0fusff + 8.D0
     &    *s**(-2)*t**(-1)*rzm2*b0fmzff - 8.D0*s**(-2)*t**(-1)*rzm2*
     &    b0fusff - 16.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**2*b0fmzff + 16.D
     &    0*s**(-1)*t**(-2)*u**(-1)*rzm2**2*b0fusff - 16.D0*s**(-1)*
     &    t**(-2)*rzm2*b0fmzff + 16.D0*s**(-1)*t**(-2)*rzm2*b0fusff - 8.
     &    D0*s**(-1)*t**(-1)*u**(-1)*rzm2 + 8.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rzm2*b0fmzff - 8.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*
     &    b0fusff + 16.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*mgen2*c0cmzusfff
     &     - 8.D0*s**(-1)*t**(-1) + 16.D0*s**(-1)*t**(-1)*mgen2*
     &    c0cmzusfff + 16.D0*s**(-1)*t**(-1)*mgen2*c0cmztsfff - 16.D0*
     &    s**(-1)*t**(-1)*mgen2*c0ccusfff + 8.D0/3.D0*s**(-1)*
     &    c0cmztsfff - 8.D0/3.D0*s**(-1)*c0ccusfff - 8.D0*s**(-1)*mgen2
     &    *d0cccmztsusffff - 8.D0/3.D0*s**(-1)*t*d0cccmztsusffff + 16.D0
     &    *t**(-2)*u**(-1)*rzm2*b0fmzff - 16.D0*t**(-2)*u**(-1)*rzm2*
     &    b0fusff + 8.D0*t**(-2)*rzm2*c0cmzusfff - 8.D0*t**(-2)*rzm2*
     &    c0ccqsfff - 8.D0*t**(-2)*u*c0cmzusfff + 8.D0*t**(-2)*u*
     &    c0cmzqsfff - 8.D0*t**(-2)*u*c0ccusfff + 8.D0*t**(-2)*u*
     &    c0ccqsfff - 8.D0*t**(-2)*u*rzm2*d0ccmzcqsusffff + 8.D0*
     &    t**(-2)*u**2*d0ccmzcqsusffff + 8.D0*t**(-1)*u**(-1) - 16.D0*
     &    t**(-1)*u**(-1)*mgen2*c0cmzusfff + 16.D0*t**(-1)*u**(-1)*
     &    mgen2*c0cmztsfff - 16.D0*t**(-1)*u**(-1)*mgen2*c0ccqsfff + 8.D
     &    0*t**(-1)*c0cmzusfff + 8.D0*t**(-1)*c0ccusfff - 24.D0*t**(-1)
     &    *mgen2*d0ccmzcqsusffff + 8.D0*t**(-1)*rzm2*d0ccmzcqsusffff - 
     &    8.D0*u**(-1)*mgen2*d0cccmzqstsffff - 16.D0/(u + t)*s**(-2)*
     &    t**(-1)*rzm2**2*b0fmzff + 16.D0/(u + t)*s**(-2)*t**(-1)*
     &    rzm2**2*b0fusff + 32.D0/(u + t)*s**(-1)*t**(-2)*rzm2**2*
     &    b0fmzff - 32.D0/(u + t)*s**(-1)*t**(-2)*rzm2**2*b0fusff + 16.D
     &    0/(u + t)*s**(-1)*t**(-1)*rzm2 - 32.D0/(u + t)*s**(-1)*
     &    t**(-1)*rzm2*mgen2*c0cmzusfff - 16.D0/(u + t)*s**(-1)*t**(-1)
     &    *rzm2*mgen2*c0cmztsfff + 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2*
     &    mgen2*c0ccusfff - 16.D0/(u + t)*s**(-1)*mgen2*c0cmzusfff + 16.
     &    D0/(u + t)*s**(-1)*mgen2*c0cmztsfff - 16.D0/(u + t)*s**(-1)*
     &    mgen2*c0ccusfff + 16.D0/(u + t)*s**(-1)*mgen2*c0cctsfff - 8.D0
     &    /3.D0/(u + t)*s**(-1)*rzm2*c0cmztsfff + 8.D0/3.D0/(u + t)*
     &    s**(-1)*rzm2*c0ccusfff + 16.D0/(u + t)*s**(-1)*rzm2*mgen2*
     &    d0cccmztsusffff - 8.D0/3.D0/(u + t)*s**(-1)*t*c0cmzusfff + 8.D
     &    0/3.D0/(u + t)*s**(-1)*t*c0cmztsfff - 8.D0/3.D0/(u + t)*
     &    s**(-1)*t*c0ccusfff + 8.D0/3.D0/(u + t)*s**(-1)*t*c0cctsfff
     &     - 16.D0/(u + t)*s**(-1)*t*mgen2*d0cccmztsusffff + 8.D0/3.D0
     &    /(u + t)*s**(-1)*t*rzm2*d0cccmztsusffff - 8.D0/3.D0/(u + t)*
     &    s**(-1)*t**2*d0cccmztsusffff - 32.D0/(u + t)*t**(-2)*rzm2*
     &    b0fmzff + 32.D0/(u + t)*t**(-2)*rzm2*b0fusff - 16.D0/(u + t)*
     &    t**(-1) - 16.D0/(u + t)*t**(-1)*b0fusff + 16.D0/(u + t)*
     &    t**(-1)*b0fqsff + 48.D0/(u + t)*t**(-1)*mgen2*c0cmzusfff - 16.
     &    D0/(u + t)*t**(-1)*mgen2*c0ccusfff - 8.D0/(u + t)*t**(-1)*
     &    rzm2*c0cmzusfff + 8.D0/(u + t)*t**(-1)*rzm2*c0ccqsfff - 8.D0
     &    /(u + t)*c0cmzusfff + 8.D0/3.D0/(u + t)*c0cmztsfff - 32.D0/3.D
     &    0/(u + t)*c0ccusfff + 16.D0/(u + t)*mgen2*d0ccmzcqsusffff + 
     &    16.D0/(u + t)*mgen2*d0cccmzqstsffff - 8.D0/(u + t)*rzm2*
     &    d0ccmzcqsusffff - 8.D0/3.D0/(u + t)*t*d0cccmztsusffff + 16.D0
     &    /(u + t)/(t + s)*s**(-2)*rzm2**2*b0fmzff - 16.D0/(u + t)/(t
     &     + s)*s**(-2)*rzm2**2*b0fusff - 16.D0/(u + t)/(t + s)*s**(-1)
     &    *rzm2 + 32.D0/(u + t)/(t + s)*s**(-1)*rzm2*mgen2*c0cmzusfff
     &     - 16.D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**2*b0fmzff + 16.
     &    D0/(u + t)/(t + s)/(t + s)*s**(-1)*rzm2**2*b0fusff - 8.D0/(t
     &     + s)*s**(-2)*u**(-1)*rzm2**2*b0fmzff + 8.D0/(t + s)*s**(-2)*
     &    u**(-1)*rzm2**2*b0fusff - 8.D0/(t + s)*s**(-2)*rzm2*b0fmzff
     &     + 8.D0/(t + s)*s**(-2)*rzm2*b0fusff + 8.D0/(t + s)*s**(-1)*
     &    u**(-1)*rzm2 - 8.D0/(t + s)*s**(-1)*u**(-1)*rzm2*b0fmzff + 8.D
     &    0/(t + s)*s**(-1)*u**(-1)*rzm2*b0fusff - 16.D0/(t + s)*
     &    s**(-1)*u**(-1)*rzm2*mgen2*c0cmzusfff + 8.D0/(t + s)*s**(-1)
     &     - 16.D0/(t + s)*s**(-1)*mgen2*c0cmzusfff + 8.D0/(t + s)/(t
     &     + s)*s**(-1)*u**(-1)*rzm2**2*b0fmzff - 8.D0/(t + s)/(t + s)*
     &    s**(-1)*u**(-1)*rzm2**2*b0fusff + 8.D0/(t + s)/(t + s)*
     &    s**(-1)*rzm2*b0fmzff - 8.D0/(t + s)/(t + s)*s**(-1)*rzm2*
     &    b0fusff )

      qedamp(1,2,2,1) = qedamp(1,2,2,1)
     &  + cqfactor * (  - 8.D0 - 16.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*
     &    b0fmzff + 16.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0ftsff + 16.D
     &    0*s**(-1)*u**(-1)*rzm2**2*b0fmzff - 16.D0*s**(-1)*u**(-1)*
     &    rzm2**2*b0ftsff + 8.D0*s**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0*
     &    s**(-1)*rzm2*mgen2*c0ccusfff + 8.D0*s**(-1)*t*mgen2*
     &    c0cmzusfff - 8.D0*s**(-1)*t*mgen2*c0cmztsfff + 8.D0*s**(-1)*t
     &    *mgen2*c0ccusfff - 8.D0*s**(-1)*t*mgen2*c0cctsfff - 8.D0*
     &    s**(-1)*t*rzm2*mgen2*d0cccmztsusffff + 8.D0*s**(-1)*t**2*
     &    mgen2*d0cccmztsusffff + 16.D0*t**(-1)*u**(-1)*rzm2**2*b0fmzff
     &     - 16.D0*t**(-1)*u**(-1)*rzm2**2*b0ftsff - 16.D0*u**(-1)*rzm2
     &    *b0fmzff + 16.D0*u**(-1)*rzm2*b0fqsff + 16.D0*u**(-1)*rzm2*
     &    mgen2*c0cmztsfff - 16.D0*u**(-1)*rzm2*mgen2*c0ccqsfff + 8.D0*
     &    b0ftsff - 8.D0*b0fqsff + 16.D0*mgen2*c0cmzqsfff + 16.D0*mgen2
     &    *c0ccqsfff - 16.D0*mgen2**2*d0cccmztsusffff - 16.D0*mgen2**2*
     &    d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff - 4.D0*rzm2*
     &    c0cmztsfff + 4.D0*rzm2*c0cmzqsfff + 8.D0*rzm2*c0ccqsfff - 8.D0
     &    *rzm2*mgen2*d0cccmztsusffff - 8.D0*rzm2*mgen2*d0ccmzcqsusffff
     &     - 8.D0*rzm2*mgen2*d0cccmzqstsffff - 4.D0*u*c0cmzqsfff - 4.D0
     &    *u*c0ccqsfff + 8.D0*u*mgen2*d0cccmztsusffff + 8.D0*u*mgen2*
     &    d0ccmzcqsusffff + 8.D0*u*mgen2*d0cccmzqstsffff + 8.D0*t*
     &    u**(-2)*rzm2**2*c0cmztsfff - 8.D0*t*u**(-2)*rzm2**2*c0ccqsfff
     &     + 16.D0*t*u**(-1)*b0ftsff - 16.D0*t*u**(-1)*b0fqsff - 16.D0*
     &    t*u**(-1)*mgen2*c0cmztsfff + 16.D0*t*u**(-1)*mgen2*c0cmzqsfff
     &     - 16.D0*t*u**(-1)*mgen2*c0cctsfff + 16.D0*t*u**(-1)*mgen2*
     &    c0ccqsfff - 8.D0*t*u**(-1)*rzm2*c0cmztsfff + 8.D0*t*u**(-1)*
     &    rzm2*c0cmzqsfff + 16.D0*t*u**(-1)*rzm2*c0ccqsfff - 32.D0*t*
     &    u**(-1)*rzm2*mgen2*d0cccmzqstsffff + 4.D0*t*c0cmztsfff - 12.D0
     &    *t*c0cmzqsfff + 4.D0*t*c0cctsfff - 12.D0*t*c0ccqsfff + 32.D0*
     &    t*mgen2*d0cccmzqstsffff + 8.D0*t*rzm2*d0cccmzqstsffff - 4.D0*
     &    t*u*d0cccmzqstsffff - 16.D0*t**2*u**(-2)*rzm2*c0cmztsfff + 8.D
     &    0*t**2*u**(-2)*rzm2*c0cmzqsfff - 8.D0*t**2*u**(-2)*rzm2*
     &    c0cctsfff + 16.D0*t**2*u**(-2)*rzm2*c0ccqsfff - 8.D0*t**2*
     &    u**(-2)*rzm2**2*d0cccmzqstsffff + 8.D0*t**2*u**(-1)*
     &    c0cmztsfff - 16.D0*t**2*u**(-1)*c0cmzqsfff + 8.D0*t**2*
     &    u**(-1)*c0cctsfff - 16.D0*t**2*u**(-1)*c0ccqsfff + 32.D0*t**2
     &    *u**(-1)*mgen2*d0cccmzqstsffff + 16.D0*t**2*u**(-1)*rzm2*
     &    d0cccmzqstsffff - 12.D0*t**2*d0cccmzqstsffff + 8.D0*t**3*
     &    u**(-2)*c0cmztsfff - 8.D0*t**3*u**(-2)*c0cmzqsfff + 8.D0*t**3
     &    *u**(-2)*c0cctsfff - 8.D0*t**3*u**(-2)*c0ccqsfff + 16.D0*t**3
     &    *u**(-2)*rzm2*d0cccmzqstsffff - 16.D0*t**3*u**(-1)*
     &    d0cccmzqstsffff - 8.D0*t**4*u**(-2)*d0cccmzqstsffff - 16.D0/(
     &    u + t)*t**(-1)*rzm2**2*b0fmzff + 16.D0/(u + t)*t**(-1)*
     &    rzm2**2*b0ftsff + 8.D0/(u + t)*rzm2 + 8.D0/(u + t)*rzm2*
     &    b0ftsff - 8.D0/(u + t)*rzm2*b0fqsff + 8.D0/(u + t)*rzm2*mgen2
     &    *c0cmzusfff - 24.D0/(u + t)*rzm2*mgen2*c0cmztsfff + 4.D0/(u
     &     + t)*rzm2**2*c0cmztsfff - 4.D0/(u + t)*rzm2**2*c0ccqsfff + 8.
     &    D0/(u + t)*t*mgen2*c0cmzusfff - 8.D0/(u + t)*t*mgen2*
     &    c0cmztsfff + 8.D0/(u + t)*t*mgen2*c0ccusfff - 8.D0/(u + t)*t*
     &    mgen2*c0cctsfff - 4.D0/(u + t)*t*rzm2*c0cmztsfff - 4.D0/(u + 
     &    t)*t*rzm2*c0cctsfff + 8.D0/(u + t)*t*rzm2*mgen2*
     &    d0cccmztsusffff + 8.D0/(u + t)*t*rzm2*mgen2*d0ccmzcqsusffff
     &     + 8.D0/(u + t)*t*rzm2*mgen2*d0cccmzqstsffff - 4.D0/(u + t)*t
     &    *rzm2**2*d0cccmzqstsffff + 8.D0/(u + t)*t**2*mgen2*
     &    d0cccmztsusffff + 16.D0/(u + t)/(u + s)*t**(-1)*rzm2**3*
     &    b0fmzff - 16.D0/(u + t)/(u + s)*t**(-1)*rzm2**3*b0ftsff - 8.D0
     &    /(u + t)/(u + s)*rzm2**2 + 16.D0/(u + t)/(u + s)*rzm2**2*
     &    mgen2*c0cmztsfff - 8.D0/(u + t)/(u + s)/(u + s)*rzm2**3*
     &    b0fmzff + 8.D0/(u + t)/(u + s)/(u + s)*rzm2**3*b0ftsff + 16.D0
     &    /(u + s)*s**(-1)*t**(-1)*rzm2**3*b0fmzff - 16.D0/(u + s)*
     &    s**(-1)*t**(-1)*rzm2**3*b0ftsff - 16.D0/(u + s)*s**(-1)*
     &    rzm2**2*b0fmzff + 16.D0/(u + s)*s**(-1)*rzm2**2*b0ftsff + 8.D0
     &    /(u + s)*rzm2 - 16.D0/(u + s)*rzm2*mgen2*c0cmztsfff + 8.D0/(u
     &     + s)/(u + s)*rzm2**2*b0fmzff - 8.D0/(u + s)/(u + s)*rzm2**2*
     &    b0ftsff )

      qedamp(1,2,2,2) = qedamp(1,2,2,2)
     &  + cqfactor * ( 8.D0 + 16.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*
     &    b0fmzff - 16.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**3*b0ftsff - 24.D
     &    0*s**(-1)*u**(-1)*rzm2**2*b0fmzff + 24.D0*s**(-1)*u**(-1)*
     &    rzm2**2*b0ftsff + 8.D0*s**(-1)*t*u**(-1)*rzm2*b0fmzff - 8.D0*
     &    s**(-1)*t*u**(-1)*rzm2*b0ftsff - 16.D0*t**(-1)*u**(-1)*
     &    rzm2**2*b0fmzff + 16.D0*t**(-1)*u**(-1)*rzm2**2*b0ftsff + 8.D0
     &    *t**(-1)*rzm2*mgen2*c0cmzusfff - 8.D0*t**(-1)*rzm2*mgen2*
     &    c0ccqsfff - 8.D0*t**(-1)*u*mgen2*c0cmzusfff + 8.D0*t**(-1)*u*
     &    mgen2*c0cmzqsfff - 8.D0*t**(-1)*u*mgen2*c0ccusfff + 8.D0*
     &    t**(-1)*u*mgen2*c0ccqsfff - 8.D0*t**(-1)*u*rzm2*mgen2*
     &    d0ccmzcqsusffff + 8.D0*t**(-1)*u**2*mgen2*d0ccmzcqsusffff + 8.
     &    D0*u**(-1)*rzm2*b0fmzff - 8.D0*u**(-1)*rzm2*b0ftsff + 8.D0*
     &    u**(-1)*rzm2*mgen2*c0cmztsfff - 8.D0*u**(-1)*rzm2*mgen2*
     &    c0ccqsfff + 4.D0*u**(-1)*rzm2**2*c0cmztsfff - 4.D0*u**(-1)*
     &    rzm2**2*c0ccqsfff + 8.D0*mgen2*c0cmzusfff - 16.D0*mgen2*
     &    c0cmztsfff - 8.D0*mgen2*c0ccusfff + 16.D0*mgen2*c0ccqsfff - 
     &    16.D0*mgen2**2*d0cccmztsusffff - 16.D0*mgen2**2*
     &    d0ccmzcqsusffff - 16.D0*mgen2**2*d0cccmzqstsffff + 8.D0*u*
     &    mgen2*d0ccmzcqsusffff - 8.D0*t*u**(-1)*mgen2*c0cmztsfff + 8.D0
     &    *t*u**(-1)*mgen2*c0cmzqsfff - 8.D0*t*u**(-1)*mgen2*c0cctsfff
     &     + 8.D0*t*u**(-1)*mgen2*c0ccqsfff - 4.D0*t*u**(-1)*rzm2*
     &    c0cmztsfff + 4.D0*t*u**(-1)*rzm2*c0cmzqsfff - 4.D0*t*u**(-1)*
     &    rzm2*c0cctsfff + 4.D0*t*u**(-1)*rzm2*c0ccqsfff - 8.D0*t*
     &    u**(-1)*rzm2*mgen2*d0cccmzqstsffff - 4.D0*t*u**(-1)*rzm2**2*
     &    d0cccmzqstsffff + 8.D0*t*mgen2*d0cccmztsusffff + 8.D0*t*mgen2
     &    *d0cccmzqstsffff + 8.D0*t**2*u**(-1)*mgen2*d0cccmzqstsffff + 
     &    4.D0*t**2*u**(-1)*rzm2*d0cccmzqstsffff + 16.D0/(u + t)*
     &    t**(-1)*rzm2**2*b0fmzff - 16.D0/(u + t)*t**(-1)*rzm2**2*
     &    b0ftsff - 8.D0/(u + t)*rzm2 + 8.D0/(u + t)*rzm2*b0fmzff - 8.D0
     &    /(u + t)*rzm2*b0ftsff - 8.D0/(u + t)*rzm2*mgen2*c0cmzusfff + 
     &    24.D0/(u + t)*rzm2*mgen2*c0cmztsfff - 4.D0/(u + t)*rzm2**2*
     &    c0cmztsfff + 4.D0/(u + t)*rzm2**2*c0ccqsfff - 8.D0/(u + t)*t*
     &    mgen2*c0cmzusfff + 8.D0/(u + t)*t*mgen2*c0cmztsfff - 8.D0/(u
     &     + t)*t*mgen2*c0ccusfff + 8.D0/(u + t)*t*mgen2*c0cctsfff + 4.D
     &    0/(u + t)*t*rzm2*c0cmztsfff + 4.D0/(u + t)*t*rzm2*c0cctsfff
     &     - 8.D0/(u + t)*t*rzm2*mgen2*d0cccmztsusffff - 8.D0/(u + t)*t
     &    *rzm2*mgen2*d0ccmzcqsusffff - 8.D0/(u + t)*t*rzm2*mgen2*
     &    d0cccmzqstsffff + 4.D0/(u + t)*t*rzm2**2*d0cccmzqstsffff - 8.D
     &    0/(u + t)*t**2*mgen2*d0cccmztsusffff - 16.D0/(u + t)/(u + s)*
     &    t**(-1)*rzm2**3*b0fmzff + 16.D0/(u + t)/(u + s)*t**(-1)*
     &    rzm2**3*b0ftsff + 8.D0/(u + t)/(u + s)*rzm2**2 - 16.D0/(u + t
     &    )/(u + s)*rzm2**2*mgen2*c0cmztsfff + 8.D0/(u + t)/(u + s)/(u
     &     + s)*rzm2**3*b0fmzff - 8.D0/(u + t)/(u + s)/(u + s)*rzm2**3*
     &    b0ftsff - 16.D0/(u + s)*s**(-1)*t**(-1)*rzm2**3*b0fmzff + 16.D
     &    0/(u + s)*s**(-1)*t**(-1)*rzm2**3*b0ftsff + 24.D0/(u + s)*
     &    s**(-1)*rzm2**2*b0fmzff - 24.D0/(u + s)*s**(-1)*rzm2**2*
     &    b0ftsff - 8.D0/(u + s)*s**(-1)*t*rzm2*b0fmzff + 8.D0/(u + s)*
     &    s**(-1)*t*rzm2*b0ftsff - 8.D0/(u + s)*rzm2 + 8.D0/(u + s)*
     &    rzm2*b0fmzff - 8.D0/(u + s)*rzm2*b0ftsff + 16.D0/(u + s)*rzm2
     &    *mgen2*c0cmztsfff - 8.D0/(u + s)/(u + s)*rzm2**2*b0fmzff + 8.D
     &    0/(u + s)/(u + s)*rzm2**2*b0ftsff )

      qedamp(1,2,2,3) = qedamp(1,2,2,3)
     &  + sqrt(s)*sqrt(t*u)*sr2**(-1)*mz**(-1)*cqfactor * (  - 8.D0/3.D0
     &    *s**(-1)*t*c0cmzusfff + 8.D0/3.D0*s**(-1)*t*c0cmztsfff - 8.D0/
     &    3.D0*s**(-1)*t*c0ccusfff + 8.D0/3.D0*s**(-1)*t*c0cctsfff - 8.D
     &    0/3.D0*s**(-1)*t**2*d0cccmztsusffff - 8.D0/3.D0/(u + t)*t*
     &    c0cmzusfff + 8.D0/3.D0/(u + t)*t*c0cmztsfff - 8.D0/3.D0/(u + 
     &    t)*t*c0ccusfff + 8.D0/3.D0/(u + t)*t*c0cctsfff - 8.D0/3.D0/(u
     &     + t)*t**2*d0cccmztsusffff )
      qedamp(1,2,2,3) = qedamp(1,2,2,3) + sqrt(s)*sqrt(t*u)*
     & sr2**(-1)*mz*cqfactor * (  - 8.D0*s**(-2)*t**(-1)*u**(-1)*
     &    rzm2**2*b0fmzff + 8.D0*s**(-2)*t**(-1)*u**(-1)*rzm2**2*
     &    b0ftsff + 8.D0*s**(-2)*u**(-1)*rzm2*b0fmzff - 8.D0*s**(-2)*
     &    u**(-1)*rzm2*b0ftsff - 32.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**2*
     &    b0fmzff + 32.D0*s**(-1)*t**(-2)*u**(-1)*rzm2**2*b0ftsff - 16.D
     &    0*s**(-1)*t**(-2)*u**(-1)*rzm2**2*mgen2*c0cmzusfff + 16.D0*
     &    s**(-1)*t**(-2)*u**(-1)*rzm2**2*mgen2*c0cctsfff + 16.D0*
     &    s**(-1)*t**(-1)*u**(-2)*rzm2**2*b0fmzff - 16.D0*s**(-1)*
     &    t**(-1)*u**(-2)*rzm2**2*b0ftsff + 16.D0*s**(-1)*t**(-1)*
     &    u**(-2)*rzm2**2*mgen2*c0cmzusfff - 16.D0*s**(-1)*t**(-1)*
     &    u**(-2)*rzm2**2*mgen2*c0cctsfff + 8.D0*s**(-1)*t**(-1)*
     &    u**(-1)*rzm2 + 8.D0*s**(-1)*t**(-1)*u**(-1)*rzm2*b0fmzff - 8.D
     &    0*s**(-1)*t**(-1)*u**(-1)*rzm2*b0ftsff - 32.D0*s**(-1)*
     &    t**(-1)*u**(-1)*rzm2*mgen2*c0cmzusfff - 16.D0*s**(-1)*t**(-1)
     &    *u**(-1)*rzm2*mgen2*c0ccusfff + 32.D0*s**(-1)*t**(-1)*u**(-1)
     &    *rzm2*mgen2*c0cctsfff - 16.D0*s**(-1)*t**(-1)*u**(-1)*rzm2**2
     &    *mgen2*d0cccmztsusffff - 16.D0*s**(-1)*u**(-2)*rzm2*b0fmzff
     &     + 16.D0*s**(-1)*u**(-2)*rzm2*b0ftsff - 16.D0*s**(-1)*u**(-2)
     &    *rzm2*mgen2*c0cmzusfff + 16.D0*s**(-1)*u**(-2)*rzm2*mgen2*
     &    c0cctsfff - 8.D0*s**(-1)*u**(-1) + 32.D0*s**(-1)*u**(-1)*
     &    mgen2*c0cmzusfff + 16.D0*s**(-1)*u**(-1)*mgen2*c0ccusfff - 32.
     &    D0*s**(-1)*u**(-1)*mgen2*c0cctsfff + 16.D0*s**(-1)*u**(-1)*
     &    rzm2*mgen2*d0cccmztsusffff - 8.D0/3.D0*s**(-1)*c0cmztsfff + 8.
     &    D0/3.D0*s**(-1)*c0ccusfff - 24.D0*s**(-1)*mgen2*
     &    d0cccmztsusffff + 8.D0/3.D0*s**(-1)*t*d0cccmztsusffff + 32.D0
     &    *t**(-2)*u**(-1)*rzm2*b0fmzff - 32.D0*t**(-2)*u**(-1)*rzm2*
     &    b0ftsff + 16.D0*t**(-2)*u**(-1)*rzm2*mgen2*c0cmzusfff - 16.D0
     &    *t**(-2)*u**(-1)*rzm2*mgen2*c0cctsfff - 16.D0*t**(-1)*u**(-2)
     &    *rzm2*b0fmzff + 16.D0*t**(-1)*u**(-2)*rzm2*b0ftsff - 16.D0*
     &    t**(-1)*u**(-2)*rzm2*mgen2*c0cmzusfff + 16.D0*t**(-1)*u**(-2)
     &    *rzm2*mgen2*c0cctsfff - 8.D0*t**(-1)*u**(-1) - 16.D0*t**(-1)*
     &    u**(-1)*b0ftsff + 16.D0*t**(-1)*u**(-1)*b0fqsff + 32.D0*
     &    t**(-1)*u**(-1)*mgen2*c0cmzusfff + 16.D0*t**(-1)*u**(-1)*
     &    mgen2*c0cmztsfff + 16.D0*t**(-1)*u**(-1)*mgen2*c0ccusfff - 32.
     &    D0*t**(-1)*u**(-1)*mgen2*c0cctsfff - 16.D0*t**(-1)*u**(-1)*
     &    mgen2*c0ccqsfff - 8.D0*t**(-1)*u**(-1)*rzm2*c0cmztsfff + 8.D0
     &    *t**(-1)*u**(-1)*rzm2*c0ccqsfff + 16.D0*t**(-1)*u**(-1)*rzm2*
     &    mgen2*d0cccmztsusffff - 8.D0*t**(-1)*mgen2*d0ccmzcqsusffff + 
     &    8.D0*u**(-2)*rzm2*c0cmztsfff - 8.D0*u**(-2)*rzm2*c0ccqsfff + 
     &    8.D0*u**(-1)*c0cmztsfff + 8.D0*u**(-1)*c0cctsfff - 24.D0*
     &    u**(-1)*mgen2*d0cccmzqstsffff + 8.D0*u**(-1)*rzm2*
     &    d0cccmzqstsffff - 8.D0*t*u**(-2)*c0cmztsfff + 8.D0*t*u**(-2)*
     &    c0cmzqsfff - 8.D0*t*u**(-2)*c0cctsfff + 8.D0*t*u**(-2)*
     &    c0ccqsfff - 8.D0*t*u**(-2)*rzm2*d0cccmzqstsffff + 8.D0*t**2*
     &    u**(-2)*d0cccmzqstsffff + 16.D0/(u + t)*s**(-1)*t**(-2)*
     &    rzm2**2*mgen2*c0cmzusfff - 16.D0/(u + t)*s**(-1)*t**(-2)*
     &    rzm2**2*mgen2*c0cctsfff + 32.D0/(u + t)*s**(-1)*t**(-1)*rzm2*
     &    mgen2*c0cmzusfff - 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2*mgen2*
     &    c0cmztsfff + 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2*mgen2*
     &    c0ccusfff - 32.D0/(u + t)*s**(-1)*t**(-1)*rzm2*mgen2*
     &    c0cctsfff + 16.D0/(u + t)*s**(-1)*t**(-1)*rzm2**2*mgen2*
     &    d0cccmztsusffff + 16.D0/(u + t)*s**(-1)*mgen2*c0cmzusfff - 16.
     &    D0/(u + t)*s**(-1)*mgen2*c0cmztsfff + 16.D0/(u + t)*s**(-1)*
     &    mgen2*c0ccusfff - 16.D0/(u + t)*s**(-1)*mgen2*c0cctsfff + 8.D0
     &    /3.D0/(u + t)*s**(-1)*rzm2*c0cmztsfff - 8.D0/3.D0/(u + t)*
     &    s**(-1)*rzm2*c0ccusfff + 16.D0/(u + t)*s**(-1)*rzm2*mgen2*
     &    d0cccmztsusffff + 8.D0/3.D0/(u + t)*s**(-1)*t*c0cmzusfff - 8.D
     &    0/3.D0/(u + t)*s**(-1)*t*c0cmztsfff + 8.D0/3.D0/(u + t)*
     &    s**(-1)*t*c0ccusfff - 8.D0/3.D0/(u + t)*s**(-1)*t*c0cctsfff
     &     + 16.D0/(u + t)*s**(-1)*t*mgen2*d0cccmztsusffff - 8.D0/3.D0
     &    /(u + t)*s**(-1)*t*rzm2*d0cccmztsusffff + 8.D0/3.D0/(u + t)*
     &    s**(-1)*t**2*d0cccmztsusffff - 32.D0/(u + t)*t**(-2)*rzm2*
     &    b0fmzff + 32.D0/(u + t)*t**(-2)*rzm2*b0ftsff - 16.D0/(u + t)*
     &    t**(-2)*rzm2*mgen2*c0cmzusfff + 16.D0/(u + t)*t**(-2)*rzm2*
     &    mgen2*c0cctsfff + 16.D0/(u + t)*t**(-1) + 16.D0/(u + t)*
     &    t**(-1)*b0ftsff - 16.D0/(u + t)*t**(-1)*b0fqsff - 16.D0/(u + 
     &    t)*t**(-1)*mgen2*c0cmzusfff - 32.D0/(u + t)*t**(-1)*mgen2*
     &    c0cmztsfff - 16.D0/(u + t)*t**(-1)*mgen2*c0ccusfff + 32.D0/(u
     &     + t)*t**(-1)*mgen2*c0cctsfff + 8.D0/(u + t)*t**(-1)*rzm2*
     &    c0cmztsfff - 8.D0/(u + t)*t**(-1)*rzm2*c0ccqsfff - 16.D0/(u
     &     + t)*t**(-1)*rzm2*mgen2*d0cccmztsusffff - 32.D0/3.D0/(u + t)
     &    *c0cmztsfff + 8.D0/3.D0/(u + t)*c0ccusfff - 8.D0/(u + t)*
     &    c0cctsfff + 16.D0/(u + t)*mgen2*d0ccmzcqsusffff + 16.D0/(u + 
     &    t)*mgen2*d0cccmzqstsffff - 8.D0/(u + t)*rzm2*d0cccmzqstsffff
     &     + 8.D0/3.D0/(u + t)*t*d0cccmztsusffff + 32.D0/(u + t)/(u + s
     &    )*t**(-2)*rzm2**2*b0fmzff - 32.D0/(u + t)/(u + s)*t**(-2)*
     &    rzm2**2*b0ftsff - 16.D0/(u + t)/(u + s)*t**(-1)*rzm2 + 32.D0
     &    /(u + t)/(u + s)*t**(-1)*rzm2*mgen2*c0cmztsfff - 16.D0/(u + t
     &    )/(u + s)/(u + s)*t**(-1)*rzm2**2*b0fmzff + 16.D0/(u + t)/(u
     &     + s)/(u + s)*t**(-1)*rzm2**2*b0ftsff + 8.D0/(u + s)*s**(-2)*
     &    t**(-1)*rzm2**2*b0fmzff - 8.D0/(u + s)*s**(-2)*t**(-1)*
     &    rzm2**2*b0ftsff - 8.D0/(u + s)*s**(-2)*rzm2*b0fmzff + 8.D0/(u
     &     + s)*s**(-2)*rzm2*b0ftsff + 32.D0/(u + s)*s**(-1)*t**(-2)*
     &    rzm2**2*b0fmzff - 32.D0/(u + s)*s**(-1)*t**(-2)*rzm2**2*
     &    b0ftsff - 8.D0/(u + s)*s**(-1)*t**(-1)*rzm2 - 8.D0/(u + s)*
     &    s**(-1)*t**(-1)*rzm2*b0fmzff + 8.D0/(u + s)*s**(-1)*t**(-1)*
     &    rzm2*b0ftsff + 16.D0/(u + s)*s**(-1)*t**(-1)*rzm2*mgen2*
     &    c0cmztsfff + 8.D0/(u + s)*s**(-1) - 16.D0/(u + s)*s**(-1)*
     &    mgen2*c0cmztsfff - 8.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*
     &    rzm2**2*b0fmzff + 8.D0/(u + s)/(u + s)*s**(-1)*t**(-1)*
     &    rzm2**2*b0ftsff + 8.D0/(u + s)/(u + s)*s**(-1)*rzm2*b0fmzff
     &     - 8.D0/(u + s)/(u + s)*s**(-1)*rzm2*b0ftsff )
*}}}
      enddo
      endif

      qedamp(2,1,1,1) = qedamp(1,1,1,1)
      qedamp(2,1,1,2) = qedamp(1,1,1,2)
      qedamp(2,1,1,3) =-qedamp(1,1,1,3)
      qedamp(2,1,2,1) = qedamp(1,1,2,1)
      qedamp(2,1,2,2) = qedamp(1,1,2,2)
      qedamp(2,1,2,3) =-qedamp(1,1,2,3)
      qedamp(2,2,1,1) = qedamp(1,2,1,1)
      qedamp(2,2,1,2) = qedamp(1,2,1,2)
      qedamp(2,2,1,3) =-qedamp(1,2,1,3)
      qedamp(2,2,2,1) = qedamp(1,2,2,1)
      qedamp(2,2,2,2) = qedamp(1,2,2,2)
      qedamp(2,2,2,3) =-qedamp(1,2,2,3)

      do i = 1,2
        do j = 1,2
          do k = 1,2
            do l = 1,3
              if ((iew.eq.0).and.(iqed.eq.0)) then
                amp(i,j,k,l) = 0d0
              endif
              if ((iew.eq.1).and.(iqed.eq.0)) then
                amp(i,j,k,l) = ewcoeff*ewamp(i,j,k,l)
              endif
              if ((iew.eq.0).and.(iqed.eq.1)) then
                amp(i,j,k,l) = qedcoeff*qedamp(i,j,k,l)
              endif
              if ((iew.eq.1).and.(iqed.eq.1)) then
                amp(i,j,k,l) = ewcoeff*ewamp(i,j,k,l)+qedcoeff*qedamp(i,j,k,l)
              endif
            enddo
          enddo
        enddo
      enddo

      return
      end
